DROP DATABASE IF EXISTS tonersales;
CREATE DATABASE tonersales;
USE tonersales;

CREATE TABLE Globals (
    Name VARCHAR(255),
    Value VARCHAR(255)
);


CREATE TABLE `users` (
	`id` INT(11) NOT NULL AUTO_INCREMENT,
	`username` VARCHAR(255) NULL DEFAULT NULL,
	`email` VARCHAR(255) NULL DEFAULT NULL,
	`password` VARCHAR(255) NULL DEFAULT NULL,
	`googleId` VARCHAR(255) NULL DEFAULT NULL,
	`facebookId` VARCHAR(255) NULL DEFAULT NULL,
	`token` VARCHAR(255) NULL DEFAULT NULL,
	`role` TINYINT(4) NULL DEFAULT NULL,
	PRIMARY KEY (`id`)
)
COLLATE='latin1_swedish_ci'
ENGINE=InnoDB
AUTO_INCREMENT=4
;


CREATE TABLE `products` (
	`id` INT(11) NOT NULL AUTO_INCREMENT,
	`active` BIT(1) NULL DEFAULT NULL,
	`name` VARCHAR(255) NULL DEFAULT NULL,
	`taxid` INT(11) NULL DEFAULT NULL,
	`price` DOUBLE NULL DEFAULT NULL,
	`wprice` DOUBLE NULL DEFAULT NULL,
	`quantity` INT(11) NULL DEFAULT NULL,
	`weight` DOUBLE NULL DEFAULT NULL,
	`url` TEXT NULL DEFAULT NULL,
	`reference` VARCHAR(50) NULL DEFAULT NULL,
	`image` VARCHAR(255) NULL DEFAULT NULL,
	`pages` INT(11) NULL DEFAULT NULL,
	`printers` TEXT NULL DEFAULT NULL,
	`shortdescription` TEXT NULL DEFAULT NULL,
	`description` TEXT NULL DEFAULT NULL,
PRIMARY KEY (`id`)
)
COLLATE='latin1_swedish_ci'
ENGINE=InnoDB
AUTO_INCREMENT=1679
;



CREATE TABLE Payment_method (
    id int NOT NULL AUTO_INCREMENT,
    description VARCHAR(255),
    PRIMARY KEY(id)
    
);


CREATE TABLE Shipping_method (
    id int NOT NULL AUTO_INCREMENT,
    description VARCHAR(255),
    PRIMARY KEY(id)
);

CREATE TABLE `orders` (
	`id` INT(11) NOT NULL AUTO_INCREMENT,
	`shipping_id` INT(11) NULL DEFAULT NULL,
	`userId` INT(11) NULL DEFAULT NULL,
	`products` TEXT NULL,
	`total` DOUBLE NOT NULL,
	`payment_meth_id` INT(11) NULL DEFAULT NULL,
	PRIMARY KEY (`id`),
	INDEX `shipping_id` (`shipping_id`),
	INDEX `payment_meth_id` (`payment_meth_id`),
	INDEX `userId` (`userId`),
	CONSTRAINT `orders_ibfk_1` FOREIGN KEY (`shipping_id`) REFERENCES `shipping_method` (`id`),
	CONSTRAINT `orders_ibfk_2` FOREIGN KEY (`payment_meth_id`) REFERENCES `payment_method` (`id`),
	CONSTRAINT `orders_ibfk_3` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
)
COLLATE='latin1_swedish_ci'
ENGINE=InnoDB
;


CREATE TABLE Order_Products (
	product_id int,
	order_id int,
	FOREIGN KEY (product_id) REFERENCES Products(id),
	FOREIGN KEY (order_id) REFERENCES Orders(id)
);


INSERT INTO Users (id,username,email,password)
VALUES (1, 'admin', 'kwnstantinosxoinas@hotmail.gr', '$2a$10$peAQMFu9FSLJUT8HTnjUJu7l.lSBFFNvtTr2w.7S7..refdlZ3JAG');
INSERT INTO Users (id,username,email,password)
VALUES (2, 'nikatlas', 'nikatlas@gmail.com', '$2a$10$peAQMFu9FSLJUT8HTnjUJu7l.lSBFFNvtTr2w.7S7..refdlZ3JAG');



INSERT INTO Products (name,description,price)
VALUES ('purple toner','jp',20);

INSERT INTO Products (name,description,price)
VALUES ('diamond toner','laser',25);

INSERT INTO Products (name,description,price)
VALUES ('black toner','inkjet',50);

INSERT INTO Products (name,description,price)
VALUES ('red toner','inkjet',230);

INSERT INTO Products (name,description,price)
VALUES ('rgb toner','inkjet',150);

INSERT INTO Products (name,description,price)
VALUES ('green toner','laser',150);

INSERT INTO Products (name,description,price)
VALUES ('blue toner','laser',250);

INSERT INTO Products (name,description,price)
VALUES ('yellow toner','laser',80);

INSERT INTO Products (name,description,price)
VALUES ('black toner','inkjet',40);

INSERT INTO Products (name,description,price)
VALUES ('zouma toner','laser',25);

INSERT INTO Products (name,description,price)
VALUES ('copp toner','jp',35);

INSERT INTO Products (name,description,price)
VALUES ('shit toner','jp',75);

INSERT INTO Products (name,description,price)
VALUES ('black toner','jp',50);



-- --------------------------------------------------------
-- Host:                         127.0.0.1
-- Server version:               10.2.14-MariaDB - mariadb.org binary distribution
-- Server OS:                    Win64
-- HeidiSQL Version:             9.4.0.5125
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

-- Dumping data for table tonersales.products: ~1,647 rows (approximately)
/*!40000 ALTER TABLE `products` DISABLE KEYS */;
INSERT INTO `products` (`id`, `active`, `name`, `taxid`, `price`, `wprice`, `quantity`, `weight`, `url`, `reference`, `image`, `pages`, `printers`, `shortdescription`, `description`) VALUES
	(1, '1', ' HP CF350A (HP 130A BLACK)', 53, 12.82, 0, 106, 0.65, '-hp-cf350a-hp-130a-black', 'TS13316025**', 'http://tonersales,eu/shop/156/-hp-cf350a-hp-130a-black,jpg', 0, '0', '<p>HP Color LaserJet Pro MFP M176n, Pro MFP M177fw</p>', '<p>1300     5%     :HP Color LaserJet Pro MFP M176n, Pro MFP M177fw</p>'),
	(2, '1', ' HP CF351A (HP 130A CYAN)', 53, 12.82, 0, 109, 0.65, '-hp-cf351a-hp-130a-cyan', 'TS13316026**', 'http://tonersales,eu/shop/157/-hp-cf351a-hp-130a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Pro MFP M176n, Pro MFP M177fw</span></p>', '<p>1000     5%     :<span>HP Color LaserJet Pro MFP M176n, Pro MFP M177fw</span></p>'),
	(3, '1', ' HP CF352A (HP 130A YELLOW)', 53, 12.82, 0, 109, 0.65, '0', 'TS13316027**', '0', 0, '0', '<div id="short_description_block">', '0'),
	(4, '1', ' HP CF353A (HP 130A MAGENTA)', 53, 12.82, 0, 109, 0.65, '0', 'TS13316028**', '0', 0, '0', '<div id="short_description_block">', '0'),
	(5, '1', ' HP Q2612A (HP 12A BLACK)', 53, 8.9, 0, 168, 0.65, '-hp-q2612a-hp-12a-black', 'TSRH190B', 'http://tonersales,eu/shop/1538/-hp-q2612a-hp-12a-black,jpg', 0, '0', '<p>HP LaserJet 102n nw, M1005mfp, 1015, 1022, 3015, 3050, 3055, 1010, 1018, 1022n, 3020, 3050z, M1319, 1012, 1020, 1022nw, 3030, 3052, M1319f</p>', '<p>2000     5%     : HP LaserJet 102n nw, M1005mfp, 1015, 1022, 3015, 3050, 3055, 1010, 1018, 1022n, 3020, 3050z, M1319, 1012, 1020, 1022nw, 3030, 3052, M1319f</p>'),
	(6, '1', ' HP Q2612X (HP 12X BLACK)', 53, 11.63, 0, 118, 0.65, '-hp-q2612x-hp-12x-black', 'TSRC158B', 'http://tonersales,eu/shop/113/-hp-q2612x-hp-12x-black,jpg', 0, '0', '<p>HP LaserJet M1005mfp, 1015, 1022, 3015, 3050, 3055, 1010, 1018, 1022n, 3020, 3050z, M1319, 1012, 1020, 1022nw, 3030, 3052, M1319f</p>', '<p>3000     5%     :HP LaserJet M1005mfp, 1015, 1022, 3015, 3050, 3055, 1010, 1018, 1022n, 3020, 3050z, M1319, 1012, 1020, 1022nw, 3030, 3052, M1319f</p>'),
	(7, '1', ' HP CE278A (HP 78A BLACK)', 53, 9.8, 0, 137, 0.65, '-hp-ce278a-hp-78a-black', 'TSRH278B', 'http://tonersales,eu/shop/136/-hp-ce278a-hp-78a-black,jpg', 0, '0', '<p>HP LaserJet P1566, P1567, P1568, P1569, P1606, 1560, P1606dn, P1607dn, P1608dn, P1609dn, M1530, M1536dnf, M1537dnf, M1538dnf, M1539dnf</p>', '<p>2500     5%     :HP LaserJet P1566, P1567, P1568, P1569, P1606, 1560, P1606dn, P1607dn, P1608dn, P1609dn, M1530, M1536dnf, M1537dnf, M1538dnf, M1539dnf</p>'),
	(8, '1', ' HP CE285A (HP 85A BLACK)', 53, 8.39, 0, 192, 0.65, '-hp-ce285a-hp-85a-black', 'TS13310790AR', 'http://tonersales,eu/shop/2213/-hp-ce285a-hp-85a-black,jpg', 0, '0', '<p>HP LaserJet M1130, M1132, P1102, Pro P1102W, Pro M1212nf, Pro M1214, M1210, M1212nf, Pro M1132, Pro P1102, Pro M1217nfw, P1100, P1101</p>', '<p>1600     5%     : HP LaserJetM1130, M1132, P1102, Pro P1102W, Pro M1212nf, Pro M1214, M1210, M1212nf, Pro M1132, Pro P1102, Pro M1217nfw, P1100, P1101</p>'),
	(9, '1', ' HP CF283A (HP 83A BLACK)', 53, 7.66, 0, 194, 0.65, '-hp-cf283a-hp-83a-black', 'TS13315927**', 'http://tonersales,eu/shop/138/-hp-cf283a-hp-83a-black,jpg', 0, '0', '<p>HP LaserJet Pro M125A, M125RA, M127, M127FP, M225 MFP, M125NW, M125NRW, M127FW, M128FN, M125R, M126, M127FN, M201</p>', '<p>1500     5%     : HP LaserJet ProM125A, M125RA, M127, M127FP, M225 MFP, M125NW, M125NRW, M127FW, M128FN, M125R, M126, M127FN, M201</p>'),
	(10, '1', ' HP C3906A (HP 06A BLACK)', 0, 18.77, 0, 110, 0.65, '-hp-c3906a-hp-06a-black', 'TSRH112B', 'http://tonersales,eu/shop/308/-hp-c3906a-hp-06a-black,jpg', 0, '0', '<p>HP LaserJet 5L/5ML/6L/6LSE/6LXI/6PSE/6PSI/3100/3150</p>', '<p>2500     5%     :HP LaserJet 5L/5ML/6L/6LSE/6LXI/6PSE/6PSI/3100/3150</p>'),
	(11, '1', ' HP C4092A (HP 92A BLACK)', 53, 10.56, 0, 105, 0.65, '-hp-c4092a-hp-92a-black', 'TSRH137B', 'http://tonersales,eu/shop/119/-hp-c4092a-hp-92a-black,jpg', 0, '0', '<p>HP LaserJet 1100, 1100axi, 3200m, 1100a, 1100se, 1100ase, 3200</p>', '<p>2500     5%     : HP LaserJet1100, 1100axi, 3200m, 1100a, 1100se, 1100ase, 3200</p>'),
	(12, '1', ' HP Q5949A (HP 49A BLACK)', 53, 10.32, 0, 110, 0.65, '-hp-q5949a-hp-49a-black', 'TSRH244AB', 'http://tonersales,eu/shop/125/-hp-q5949a-hp-49a-black,jpg', 0, '0', '<p>HP LaserJet 1320, 1320tn, 1160le, 1320n, 1320nw, 3390, 1320t, 1160, 3392</p>', '<p>3000     5%     :HP LaserJet 1320, 1320tn, 1160le, 1320n, 1320nw, 3390, 1320t, 1160, 3392</p>'),
	(13, '1', ' HP CF280A (HP 80A BLACK)', 53, 10.4, 0, 203, 0.65, '-hp-cf280a-hp-80a-black', 'TSRH504B', 'http://tonersales,eu/shop/122/-hp-cf280a-hp-80a-black,jpg', 0, '0', '<p>HP LaserJet Pro M401a, Pro M401dn, Pro M425dn, Pro M401dw, Pro M425dw, Pro M401d, Pro 400 M401dw, Pro M401dne, Pro M401n</p>', '<p>2700     5%     :HP LaserJet Pro M401a, Pro M401dn, Pro M425dn, Pro M401dw, Pro M425dw, Pro M401d, Pro 400 M401dw, Pro M401dne, Pro M401n</p>'),
	(14, '1', ' HP CF283X (HP 83X BLACK)', 53, 13.49, 0, 168, 0.65, '-hp-cf283x-hp-83x-black', 'TS13318303AR', 'http://tonersales,eu/shop/98/-hp-cf283x-hp-83x-black,jpg', 0, '0', '<p>HP LaserJet Pro M125A, M125RA, M127, M127FP, M225 MFP, M125NW, M125NRW, M127FW, M128FN, M125R, M126, M127FN, M201</p>', '<p>2500     5%     : HP LaserJet ProM125A, M125RA, M127, M127FP, M225 MFP, M125NW, M125NRW, M127FW, M128FN, M125R, M126, M127FN, M201</p>'),
	(15, '1', ' HP CE310A (HP 126A BLACK)', 53, 7.98, 0, 106, 0.65, '-hp-ce310a-hp-126a-black', 'TSRH310ABK', 'http://tonersales,eu/shop/1/-hp-ce310a-hp-126a-black,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</span></p>', '<p>1000     5%     :<span>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</span></p>'),
	(16, '1', ' HP CE311A (HP 126A CYAN)', 53, 7.98, 0, 109, 0.65, '-hp-ce311a-hp-126a-cyan', 'TSRH311ACY', 'http://tonersales,eu/shop/1947/-hp-ce311a-hp-126a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</span></p>', '<p>1000     5%     :<span>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</span></p>'),
	(17, '1', ' HP CE312A (HP 126A YELLOW)', 53, 7.98, 0, 109, 0.65, '-hp-ce312a-hp-126a-yellow', 'TSRH312AYL', 'http://tonersales,eu/shop/7/-hp-ce312a-hp-126a-yellow,jpg', 0, '0', '<p>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</p>', '<p>1000     5%     :HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</p>'),
	(18, '1', ' HP CE313A (HP 126A MAGENTA)', 53, 7.98, 0, 110, 0.65, '-hp-ce313a-hp-126a-magenta', 'TSRH313AMG', 'http://tonersales,eu/shop/10/-hp-ce313a-hp-126a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</span></p>', '<p>1000     5%     :<span>HP Color LaserJet Pro CP1025, Pro 100M175a, Pro 100 M175nw, Pro CP1012, Pro CP1025nw, Pro M275</span></p>'),
	(23, '1', ' HP Q2613A (HP 13A BLACK)', 53, 9.44, 0, 103, 0.65, '-hp-q2613a-hp-13a-black', 'TS13310062', 'http://tonersales,eu/shop/115/-hp-q2613a-hp-13a-black,jpg', 0, '0', '<p>HP LaserJet 1300, 1300xi, 1300n, 1300t</p>', '<p>2500     5%     : HP LaserJet1300, 1300xi, 1300n, 1300t</p>'),
	(24, '1', ' HP Q5949X (HP 49X BLACK)', 53, 13.66, 0, 116, 0.65, '-hp-q5949x-hp-49x-black', 'TSRH244B', 'http://tonersales,eu/shop/127/-hp-q5949x-hp-49x-black,jpg', 0, '0', '<p>HP LaserJet 1320, 1320tn, 3392, 1320n, 1320nw, 1320t, 3390</p>', '<p>7000     5%     :HP LaserJet 1320, 1320tn, 3392, 1320n, 1320nw, 1320t, 3390</p>'),
	(25, '1', ' CANON CRG119/319II/519H/719H', 53, 13.8, 0, 123, 0.65, '#NAME?', 'TSRH505B', 'http://tonersales,eu/shop/100/-canon-crg119319ii519h719h,jpg', 0, '0', '<p>CANON i-SENSYS LBP 6300/6650/MF5870dn</p>', '<p>6500     5%     :CANON i-SENSYS LBP 6300/6650/MF5870dn</p>'),
	(26, '1', ' HP CF280X (HP 80X BLACK)', 53, 13.8, 0, 105, 0.65, '-hp-cf280x-hp-80x-black', 'TS13315110', 'http://tonersales,eu/shop/101/-hp-cf280x-hp-80x-black,jpg', 0, '0', '<p>HP LaserJet Pro M401a, Pro M401dn, Pro M425dn, Pro M401dw, Pro M425dw, Pro M401d, Pro 400 M401dw, Pro M401dne, Pro M401n</p>', '<p>6800     5%     :HP LaserJet Pro M401a, Pro M401dn, Pro M425dn, Pro M401dw, Pro M425dw, Pro M401d, Pro 400 M401dw, Pro M401dne, Pro M401n</p>'),
	(27, '1', ' HP C4191A (HP 4500 BLACK)', 0, 21.79, 0, 1, 0.65, '-hp-c4191a-hp-4500-black', 'TSRH150B', 'http://tonersales,eu/shop/307/-hp-c4191a-hp-4500-black,jpg', 0, '0', '<p>HP Color LaserJet 4500 , 4500N , 4500DN , 4550 , 4550N , 4550DN , 4550HDN</p>', '<p>9000     5%     : HP Color LaserJet 4500 , 4500N , 4500DN , 4550 , 4550N , 4550DN , 4550HDN</p>'),
	(28, '1', ' HP Q2624X (HP 24X BLACK)', 53, 12.01, 0, 112, 0.65, '-hp-q2624x-hp-24x-black', 'TSRH188B', 'http://tonersales,eu/shop/117/-hp-q2624x-hp-24x-black,jpg', 0, '0', '<p><span>HP LaserJet 1150/1150N</span></p>', '<p>4000     5%     :<span>HP LaserJet 1150/1150N</span></p>'),
	(29, '1', ' HP CB541A (HP 125A CYAN)', 53, 11.69, 0, 111, 0.65, '-hp-cb541a-hp-125a-cyan', 'TSTRHF13C', 'http://tonersales,eu/shop/28/-hp-cb541a-hp-125a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet CM1017 MFP, CM1312 MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</span></p>', '<p>1400     5%     :<span>HP Color LaserJet CM1017 MFP, CM1312 MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</span></p>'),
	(30, '1', ' HP CB542A (HP 125A YELLOW)', 53, 11.69, 0, 111, 0.65, '-hp-cb542a-hp-125a-yellow', 'TSTRHF14Y', 'http://tonersales,eu/shop/30/-hp-cb542a-hp-125a-yellow,jpg', 0, '0', '<p>HP Color LaserJet CM1017 MFP, CM1312 MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</p>', '<p>1400     5%     : HP Color LaserJet CM1017 MFP, CM1312 MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</p>'),
	(31, '1', ' HP CB543A (HP 125A MAGENTA)', 53, 11.69, 0, 111, 0.65, '-hp-cb543a-hp-125a-magenta', 'TSTRHF15M', 'http://tonersales,eu/shop/32/-hp-cb543a-hp-125a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet CM1017 MFP, CM1312 MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</span></p>', '<p>1400     5%     :<span>HP Color LaserJet CM1017 MFP, CM1312 MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</span></p>'),
	(32, '1', ' HP CB540A (HP 125A BLACK)', 53, 11.53, 0, 108, 0.65, '-hp-cb540a-hp-125a-black', 'TSTRHF12B', 'http://tonersales,eu/shop/26/-hp-cb540a-hp-125a-black,jpg', 0, '0', '<p>HP Color LaserJet CM1017MFP, CM1312MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</p>', '<p>2200     5%     : HP color LaserJetCM1017MFP, CM1312MFP, CP1515n, CM1312nfi, CP1518ni, CP1510, CP1210, CP1213, CP1214, CP1215, CP1216</p>'),
	(33, '1', ' HP C4149A BK', 0, 25.93, 0, 1, 0.65, 'hp-c4149a-bk', 'TSRH169B', 'http://tonersales,eu/shop/305/hp-c4149a-bk,jpg', 0, '0', '<p>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</p>', '<p>11000     5%     : HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</p>'),
	(34, '1', ' HP 92274A (HP 74A BLACK)', 0, 27.6, 0, 104, 0.65, '-hp-92274a-hp-74a-black', 'TSRH106B', 'http://tonersales,eu/shop/309/-hp-92274a-hp-74a-black,jpg', 0, '0', '<p>HP LaserJet 4L, 4LC, 4P, 4M, 4MP</p>', '<p>3350     5%     : HP LaserJet 4L, 4LC, 4P, 4M, 4MP</p>'),
	(37, '1', ' HP Q3960A (HP 122A BLACK)', 53, 31.16, 0, 1, 0.65, '0', 'TSRH239B', '0', 0, '0', '<div id="short_description_block">', '0'),
	(38, '1', ' HP Q3961A (HP 122A CYAN)', 53, 26.15, 0, 1, 0.65, '-hp-q3961a-hp-122a-cyan', 'TSRH240C', 'http://tonersales,eu/shop/1959/-hp-q3961a-hp-122a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet 2550, 2550N, 2550L, 2800, 2820, 2550LN, 2830, 2840</span></p>', '<p>4000     5%     :<span>HP Color LaserJet 2550, 2550N, 2550L, 2800, 2820, 2550LN, 2830, 2840</span></p>'),
	(39, '1', ' HP Q3962A (HP 122A YELLOW)', 53, 26.15, 0, 1, 0.65, '-hp-q3962a-hp-122a-yellow', 'TSRH241Y', 'http://tonersales,eu/shop/144/-hp-q3962a-hp-122a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet 2550, 2550N, 2550L, 2800, 2820, 2550LN, 2830, 2840</span></p>', '<p>4000     5%     :<span>HP Color LaserJet 2550, 2550N, 2550L, 2800, 2820, 2550LN, 2830, 2840</span></p>'),
	(40, '1', ' HP Q3963A (HP 122A MAGENTA)', 53, 26.15, 0, 1, 0.65, '-hp-q3963a-hp-122a-magenta', 'TSRH242M', 'http://tonersales,eu/shop/146/-hp-q3963a-hp-122a-magenta,jpg', 0, '0', '<p>HP Color LaserJet 2550, 2550N, 2550L, 2800, 2820, 2550LN, 2830, 2840</p>', '<p>4000     5%     :HP Color LaserJet 2550, 2550N, 2550L, 2800, 2820, 2550LN, 2830, 2840</p>'),
	(41, '1', ' HP Q6000A (HP 124A BLACK)', 53, 18.39, 0, 102, 0.65, '-hp-q6000a-hp-124a-black', 'TSRH275B', 'http://tonersales,eu/shop/50/-hp-q6000a-hp-124a-black,jpg', 0, '0', '<p><span>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</span></p>', '<p>2500     5%     :<span>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</span></p>'),
	(42, '1', ' HP Q6001A (HP 124A CYAN)', 53, 18.39, 0, 103, 0.65, '-hp-q6001a-hp-124a-cyan', 'TSRH276C', 'http://tonersales,eu/shop/52/-hp-q6001a-hp-124a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</span></p>', '<p>2000     5%     :<span>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</span></p>'),
	(43, '1', ' HP Q6002A (HP 124A YELLOW)', 53, 18.39, 0, 103, 0.65, '-hp-q6002a-hp-124a-yellow', 'TSRH277Y', 'http://tonersales,eu/shop/2292/-hp-q6002a-hp-124a-yellow,jpg', 0, '0', '<p>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</p>', '<p>2000     5%     :HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</p>'),
	(44, '1', ' HP Q6003A (HP 124A MAGENTA)', 53, 18.39, 0, 102, 0.65, '-hp-q6003a-hp-124a-magenta', 'TSRH278M', 'http://tonersales,eu/shop/56/-hp-q6003a-hp-124a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</span></p>', '<p>2000     5%     :<span>HP Color LaserJet 1600, 2605, 2605dtn, CM1017, 2600n, 2605dn, 2650, CM1015</span></p>'),
	(45, '1', ' HP CC530A (HP 304A BLACK)', 53, 12.78, 0, 114, 0.65, '-hp-cc530a-hp-304a-black', 'TSRH500B', 'http://tonersales,eu/shop/1957/-hp-cc530a-hp-304a-black,jpg', 0, '0', '<p>HP Color LaserJet CP2020 , CP2025 , CP2025n , CP2025dn , CP2025x , CM2320 Canon imageCLASS MF8330C , MF8350Cdn , MF8550 Canon i-SENSYS LBP-7200Cdn</p>', '<p>3500     5%     : HP Color LaserJet CP2020 , CP2025 , CP2025n , CP2025dn , CP2025x , CM2320 Canon imageCLASS MF8330C , MF8350Cdn , MF8550 Canon i-SENSYS LBP-7200Cdn</p>'),
	(46, '1', ' HP CC531A (HP 304A CYAN)', 53, 12.74, 0, 122, 0.65, '-hp-cc531a-hp-304a-cyan', 'TSRH501C', 'http://tonersales,eu/shop/1898/-hp-cc531a-hp-304a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet CM2320fxi, CP2020, CP2020dn, CP2020d, CP2020nf, CM2320n, CM2320, CP2025dn, CP2025n, CP2025, CP2025nf, CP2025fxi, CP2125, CM2320nf, CP2025x, CM2320nf, CP2125dn, CP2125n, CP2125nf, CM2320fxi, CM2320dn, CP2720fxi</span></p>', '<p><span>2800     5%     :</span><span>HP Color LaserJet CM2320fxi, CP2020, CP2020dn, CP2020d, CP2020nf, CM2320n, CM2320, CP2025dn, CP2025n, CP2025, CP2025nf, CP2025fxi, CP2125, CM2320nf, CP2025x, CM2320nf, CP2125dn, CP2125n, CP2125nf, CM2320fxi, CM2320dn, CP2720fxi</span></p>'),
	(47, '1', ' HP CC532A (HP 304A YELLOW)', 53, 12.74, 0, 121, 0.65, '-hp-cc532a-hp-304a-yellow', 'TSRH502Y', 'http://tonersales,eu/shop/1954/-hp-cc532a-hp-304a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet CM2320fxi, CP2020, CP2020dn, CP2020d, CP2020nf, CM2320n, CM2320, CP2025dn, CP2025n, CP2025, CP2025nf, CP2025fxi, CP2125, CM2320nf, CP2025x, CM2320nf, CP2125dn, CP2125n, CP2125nf, CM2320fxi, CM2320dn, CP2720fxi</span></p>', '<p><span>2800     5%     :</span><span>HP Color LaserJet CM2320fxi, CP2020, CP2020dn, CP2020d, CP2020nf, CM2320n, CM2320, CP2025dn, CP2025n, CP2025, CP2025nf, CP2025fxi, CP2125, CM2320nf, CP2025x, CM2320nf, CP2125dn, CP2125n, CP2125nf, CM2320fxi, CM2320dn, CP2720fxi</span></p>'),
	(48, '1', ' HP CC533A (HP 304A MAGENTA)', 53, 12.74, 0, 120, 0.65, '-hp-cc533a-hp-304a-magenta', 'TSRH503M', 'http://tonersales,eu/shop/1952/-hp-cc533a-hp-304a-magenta,jpg', 0, '0', '<p>HP Color LaserJet CM2320fxi, CP2020, CP2020dn, CP2020d, CP2020nf, CM2320n, CM2320, CP2025dn, CP2025n, CP2025, CP2025nf, CP2025fxi, CP2125, CM2320nf, CP2025x, CM2320nf, CP2125dn, CP2125n, CP2125nf, CM2320fxi, CM2320dn, CP2720fxi</p>', '<p><span>2800     5%     :</span>HP Color LaserJet CM2320fxi, CP2020, CP2020dn, CP2020d, CP2020nf, CM2320n, CM2320, CP2025dn, CP2025n, CP2025, CP2025nf, CP2025fxi, CP2125, CM2320nf, CP2025x, CM2320nf, CP2125dn, CP2125n, CP2125nf, CM2320fxi, CM2320dn, CP2720fxi</p>'),
	(49, '1', ' HP CE410X (HP 305X BLACK)', 53, 15.32, 0, 116, 0.65, '-hp-ce410x-hp-305x-black', 'TSTRHF63B', 'http://tonersales,eu/shop/1956/-hp-ce410x-hp-305x-black,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</span></p>', '<p><span>4000     5%     :HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</span></p>'),
	(50, '1', ' HP CE411A (HP 305A CYAN)', 53, 14.27, 0, 118, 0.65, '-hp-ce411a-hp-305a-cyan', 'TSTHCE411A', 'http://tonersales,eu/shop/1900/-hp-ce411a-hp-305a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</span></p>', '<p><span>2600     5%     :HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</span></p>'),
	(51, '1', ' HP CE412A (HP 305A YELLOW)', 53, 14.27, 0, 118, 0.65, '-hp-ce412a-hp-305a-yellow', 'TSTHCE412A', 'http://tonersales,eu/shop/1951/-hp-ce412a-hp-305a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</span></p>', '<p><span>2600     5%     :HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</span></p>'),
	(52, '1', ' HP CE413A (HP 305A MAGENTA)', 53, 14.27, 0, 117, 0.65, '-hp-ce413a-hp-305a-magenta', 'TSTHCE413A', 'http://tonersales,eu/shop/1950/-hp-ce413a-hp-305a-magenta,jpg', 0, '0', '<p>HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</p>', '<p>2600     5%     :HP Color LaserJet Pro M351a, Pro 400 M451nw, Pro 400 M451dw, Pro 400 M475dw, Pro M375nw, Pro 400 M451dn, Pro 400 M475dn</p>'),
	(54, '1', ' HP CE255X (HP 55X BLACK)', 53, 24.19, 0, 104, 0.65, '-hp-ce255x-hp-55x-black', 'TSRH255B', 'http://tonersales,eu/shop/133/-hp-ce255x-hp-55x-black,jpg', 0, '0', '<p>HP LaserJet Enterprise P3015, Enterprise P3015dn, Enterprise M525c, Enterprise 500 M525f, Pro M521dw, Enterprise P3010, Enterprise P3015d, Enterprise P3015x, Enterprise 500 M525dn, Pro M521dn</p>', '<p>12500     5%     :HP LaserJet Enterprise P3015, Enterprise P3015dn, Enterprise M525c, Enterprise 500 M525f, Pro M521dw, Enterprise P3010, Enterprise P3015d, Enterprise P3015x, Enterprise 500 M525dn, Pro M521dn</p>'),
	(55, '1', ' HP CF381A (HP 312A CYAN)', 53, 20.08, 0, 102, 0.65, '-hp-cf381a-hp-312a-cyan', 'TS13315936**', 'http://tonersales,eu/shop/59/-hp-cf381a-hp-312a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</span></p>', '<p><span>2700     5%     :HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</span></p>'),
	(56, '1', ' HP CF382A (HP 312A YELLOW)', 53, 20.08, 0, 102, 0.65, '-hp-cf382a-hp-312a-yellow', 'TS13315937**', 'http://tonersales,eu/shop/60/-hp-cf382a-hp-312a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</span></p>', '<p><span>2700     5%     :HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</span></p>'),
	(57, '1', ' HP CF383A (HP 312A MAGENTA)', 53, 20.08, 0, 102, 0.65, '-hp-cf383a-hp-312a-magenta', 'TS13315938**', 'http://tonersales,eu/shop/61/-hp-cf383a-hp-312a-magenta,jpg', 0, '0', '<p>HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</p>', '<p>2700     5%     :HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</p>'),
	(58, '1', ' HP 92298X (HP 98X BLACK)', 0, 32.02, 0, 1, 0.65, '-hp-92298x-hp-98x-black', 'TSRH136B', 'http://tonersales,eu/shop/1033/-hp-92298x-hp-98x-black,jpg', 0, '0', '<p>HP LaserJet 5 , 5M , 5N , 5se , 4 , 4M , 4M plus , 4 plus</p>', '<p>8800     5%     : HP LaserJet 5 , 5M , 5N , 5se , 4 , 4M , 4M plus , 4 plus</p>'),
	(59, '1', ' HP Q2610A (HP 10A BLACK)', 53, 18.95, 0, 104, 0.65, '0', 'TSRH206B', '0', 0, '0', '<p>HP LaserJet 2300, 2300dn, 2300dtn, 3090, 2300n, 2300L, 3092</p>', '0'),
	(60, '1', ' HP C3903A JUMBO', 0, 32.13, 0, 1, 0.65, 'hp-c3903a-jumbo', 'TSRH111B', 'http://tonersales,eu/shop/1034/hp-c3903a-jumbo,jpg', 0, '0', '<p>HP LaserJet 5P , 5MP , 6P , 6MP , 6PSE , 6PXI , 6PSI , 6RE</p>', '<p>6000     5%     : HP LaserJet 5P , 5MP , 6P , 6MP , 6PSE , 6PXI , 6PSI , 6RE</p>'),
	(62, '1', ' HP CF380X (HP 312X BLACK)', 53, 21.77, 0, 102, 0.65, '-hp-cf380x-hp-312x-black', 'TS13315935**', 'http://tonersales,eu/shop/58/-hp-cf380x-hp-312x-black,jpg', 0, '0', '<p><span>HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</span></p>', '<p>4400     5%     :HP Color LaserJet Pro MFP M476dn, Pro MFP M476dw, Pro MFP M476nw</p>'),
	(63, '1', ' HP Q6511X (HP 11X BLACK)', 53, 25.4, 0, 102, 0.65, '-hp-q6511x-hp-11x-black', 'TSRH265B', 'http://tonersales,eu/shop/129/-hp-q6511x-hp-11x-black,jpg', 0, '0', '<p>HP LaserJet 2410, 2420d, 2430n, 2430dtn, 2420, 2420dn, 2430t, 2420n, 2430, 2430tn</p>', '<p>12000     5%     :HP LaserJet 2410, 2420d, 2430n, 2430dtn, 2420, 2420dn, 2430t, 2420n, 2430, 2430tn</p>'),
	(64, '1', ' HP Q7551X (HP 51X BLACK)', 53, 22.77, 0, 103, 0.65, '-hp-q7551x-hp-51x-black', 'TSRH332B', 'http://tonersales,eu/shop/132/-hp-q7551x-hp-51x-black,jpg', 0, '0', '<p>HP LaserJet M302, M3027, M3035xs, P3005dn, M302mfp, M3027x, P3005, P3005n, M3035, P3005d, P3005x</p>', '<p>13000     5%     : HP LaserJetM302, M3027, M3035xs, P3005dn, M302mfp, M3027x, P3005, P3005n, M3035, P3005d, P3005x</p>'),
	(65, '1', ' HP C8061X, C4127X', 0, 39.51, 0, 1, 0.65, '-hp-c8061x-c4127x', 'TSRH132B', 'http://tonersales,eu/shop/306/-hp-c8061x-c4127x,jpg', 0, '0', '<p>HP LaserJet 4100 , 4100n , 4100tn , 4100dtn , 4100mfp HP LaserJet 4000 , 4000t , 4000n , 4000tn , 4050 , 4050n</p>', '<p>10000     5%     : HP LaserJet 4100 , 4100n , 4100tn , 4100dtn , 4100mfp HP LaserJet 4000 , 4000t , 4000n , 4000tn , 4050 , 4050n</p>'),
	(66, '1', ' HP MT-604B 8937802', 0, 42.26, 0, 1, 0.65, '-hp-mt-604b-8937802', 'TS13100042', 'http://tonersales,eu/shop/1071/-hp-mt-604b-8937802,jpg', 0, '0', '<p>Hewlett Packard LJ 9055MFP , 9065MFP</p>', '<p>47500     5%     : Hewlett Packard LJ 9055MFP , 9065MFP</p>'),
	(67, '1', ' HP Q7516A (HP 16A BLACK)', 53, 45.95, 0, 106, 0.65, '-hp-q7516a-hp-16a-black', 'TSRH334B', 'http://tonersales,eu/shop/131/-hp-q7516a-hp-16a-black,jpg', 0, '0', '<p>HP LaserJet 5200 , 5200tn , 5200dtn</p>', '<p>12000     5%     : HP LaserJet 5200 , 5200tn , 5200dtn</p>'),
	(68, '1', ' HP C4192A (HP 4500 CYAN)', 0, 21.79, 0, 1, 0.65, '-hp-c4192a-hp-4500-cyan', 'TSRH151C', 'http://tonersales,eu/shop/310/-hp-c4192a-hp-4500-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet 4500 , 4500N , 4500DN , 4550 , 4550N , 4550DN , 4550HDN</span></p>', '<p>6000     5%     :<span>HP Color LaserJet 4500 , 4500N , 4500DN , 4550 , 4550N , 4550DN , 4550HDN</span></p>'),
	(69, '1', ' HP C4193A (HP 4500 MAGENTA)', 0, 21.79, 0, 1, 0.65, '0', 'TSRH152M', '0', 0, '0', '<div id="short_description_block">', '0'),
	(70, '1', ' HP C4194A (HP 4500 YELLOW)', 0, 21.79, 0, 1, 0.65, '-hp-c4194a-hp-4500-yellow', 'TSRH153Y', 'http://tonersales,eu/shop/312/-hp-c4194a-hp-4500-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet 4500 , 4500N , 4500DN , 4550 , 4550N , 4550DN , 4550HDN</span></p>', '<p>6000     5%     :<span>HP Color LaserJet 4500 , 4500N , 4500DN , 4550 , 4550N , 4550DN , 4550HDN</span></p>'),
	(71, '1', ' HP Q2670A BLACK', 0, 57.75, 0, 1, 0.65, '#NAME?', 'TSRH226B', 'http://tonersales,eu/shop/313/-hp-q2670a-black,jpg', 0, '0', '<p>HP Color LaserJet 3500, 3500n, 3550, 3550n, 3700, 3700n, 3700dn, 3700dtn</p>', '<p>6000     5%     :HP Color LaserJet 3500, 3500n, 3550, 3550n, 3700, 3700n, 3700dn, 3700dtn</p>'),
	(72, '1', ' HP Q2671A CYAN', 0, 57.75, 0, 1, 0.65, '0', 'TSRH227C', '0', 0, '0', '<div id="short_description_block">', '0'),
	(73, '1', ' HP Q2672A YELLOW', 0, 57.75, 0, 1, 0.65, '0', 'TSRH228Y', '0', 0, '0', '<p>HP Color LaserJet 3500, 3500n, 3550, 3550n, 3700, 3700n, 3700dn, 3700dtn</p>', '0'),
	(74, '1', ' HP Q2673A MAGENTA', 0, 57.75, 0, 1, 0.65, '0', 'TSRH229M', '0', 0, '0', '<p>HP Color LaserJet 3500, 3500n, 3550, 3550n, 3700, 3700n, 3700dn, 3700dtn</p>', '0'),
	(75, '1', ' HP Q7570A (HP 70A BLACK)', 0, 47.13, 0, 1, 0.65, '-hp-q7570a-hp-70a-black', 'TSRH348B', 'http://tonersales,eu/shop/317/-hp-q7570a-hp-70a-black,jpg', 0, '0', '<p>HP LaserJet M5025 mfp, M5035x mfp, M5035 mfp, M5035xs mfp</p>', '<p>15000     5%     :HP LaserJet M5025 mfp, M5035x mfp, M5035 mfp, M5035xs mfp</p>'),
	(76, '1', ' HP C4129X (HP 29X BLACK)', 0, 48.15, 0, 106, 0.65, '-hp-c4129x-hp-29x-black', 'TSRH144B', 'http://tonersales,eu/shop/318/-hp-c4129x-hp-29x-black,jpg', 0, '0', '<p>HP LaserJet 5000, 5000gn, 5100dtn, 5000n, 5100, 5000dn, 5100tn</p>', '<p>10000     5%     :HP LaserJet 5000, 5000gn, 5100dtn, 5000n, 5100, 5000dn, 5100tn</p>'),
	(77, '1', ' HP Q2681A CYAN', 0, 48.47, 0, 1, 0.65, '#NAME?', 'TSRH321C', 'http://tonersales,eu/shop/319/-hp-q2681a-cyan,jpg', 0, '0', '<p>HP Color LaserJet 3700 Series</p>', '<p>6000     5%     : HP Color LaserJet 3700 Series</p>'),
	(78, '1', ' HP Q2682A YELLOW', 0, 48.47, 0, 1, 0.65, '#NAME?', 'TSRH322Y', 'http://tonersales,eu/shop/320/-hp-q2682a-yellow,jpg', 0, '0', '<p>HP Color LaserJet 3700 Series</p>', '<p>6000     5%     : HP Color LaserJet 3700 Series</p>'),
	(79, '1', ' HP Q2683A MAGENTA', 0, 48.47, 0, 1, 0.65, '#NAME?', 'TSRH323M', 'http://tonersales,eu/shop/321/-hp-q2683a-magenta,jpg', 0, '0', '<p>HP Color LaserJet 3700 Series</p>', '<p>6000     5%     : HP Color LaserJet 3700 Series</p>'),
	(80, '1', ' HP CF400X (HP 201X BLACK)', 53, 23.79, 0, 103, 0.65, '-hp-cf400x-hp-201x-black', 'TS13318394**', 'http://tonersales,eu/shop/62/-hp-cf400x-hp-201x-black,jpg', 0, '0', '<p>HP Color LaserJet Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</p>', '<p>2800     5%     : HP Color LaserJetM252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</p>'),
	(81, '1', ' HP CF401X (HP 201X CYAN)', 53, 23.79, 0, 103, 0.65, '-hp-cf401x-hp-201x-cyan', 'TS13318395**', 'http://tonersales,eu/shop/68/-hp-cf401x-hp-201x-cyan,jpg', 0, '0', '<p>HP Color LaserJet<span>Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</span></p>', '<p>2300     5%     : HP Color LaserJet<span>Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</span></p>'),
	(82, '1', ' HP CF402X (HP 201X YELLOW)', 0, 29.5, 0, 103, 0.65, '-hp-cf402x-hp-201x-yellow', 'TS13318396**', 'http://tonersales,eu/shop/69/-hp-cf402x-hp-201x-yellow,jpg', 0, '0', '<p>HP Color LaserJet<span>Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</span></p>', '<p>2300     5%     : HP Color LaserJet<span>Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</span></p>'),
	(83, '1', ' HP CF403X (HP 201X MAGENTA)', 53, 23.79, 0, 103, 0.65, '-hp-cf403x-hp-201x-magenta', 'TS13318397**', 'http://tonersales,eu/shop/2257/-hp-cf403x-hp-201x-magenta,jpg', 0, '0', '<p>HP Color LaserJet<span>Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</span></p>', '<p>2300     5%     : HP Color LaserJet<span>Pro M252n, ProM252dw, Pro M274n, ProMFP M277n, ProMFP M277dw</span></p>'),
	(84, '1', ' HP Q6470A (HP 501A BLACK)', 0, 50.3, 0, 1, 0.65, '-hp-q6470a-hp-501a-black', 'TSRH293B', 'http://tonersales,eu/shop/284/-hp-q6470a-hp-501a-black,jpg', 0, '0', '<p>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</p>', '<p>6000     5%     :HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</p>'),
	(85, '1', ' HP CE251A (HP 504A CYAN)', 53, 28.95, 0, 103, 0.65, '-hp-ce251a-hp-504a-cyan', 'TSRH397C', 'http://tonersales,eu/shop/44/-hp-ce251a-hp-504a-cyan,jpg', 0, '0', '<p>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</p>', '<p>7000     5%     : HP Color LaserJetCP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</p>'),
	(86, '1', ' HP CE252A (HP 504A YELLOW)', 53, 28.95, 0, 103, 0.65, '-hp-ce252a-hp-504a-yellow', 'TSRH398Y', 'http://tonersales,eu/shop/46/-hp-ce252a-hp-504a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</span></p>', '<p>7000     5%     :<span>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</span></p>'),
	(87, '1', ' HP CE253A (HP 504A MAGENTA)', 53, 28.95, 0, 102, 0.65, '-hp-ce253a-hp-504a-magenta', 'TSRH399M', 'http://tonersales,eu/shop/1961/-hp-ce253a-hp-504a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</span></p>', '<p>7000     5%     :<span>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</span></p>'),
	(88, '1', ' HP CE401A (HP 507A CYAN)', 0, 39.9, 0, 103, 0.65, '-hp-ce401a-hp-507a-cyan', 'TSTRHE39C', 'http://tonersales,eu/shop/36/-hp-ce401a-hp-507a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</span></p>', '<p>6000     5%     :<span>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</span></p>'),
	(89, '1', ' HP CE402A (HP 507A YELLOW)', 0, 39.9, 0, 102, 0.65, '-hp-ce402a-hp-507a-yellow', 'TSTRHE40Y', 'http://tonersales,eu/shop/38/-hp-ce402a-hp-507a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</span></p>', '<p>6000     5%     :<span>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</span></p>'),
	(90, '1', ' HP CE403A (HP 507A MAGENTA)', 0, 39.9, 0, 103, 0.65, '-hp-ce403a-hp-507a-magenta', 'TSTRHE41M', 'http://tonersales,eu/shop/41/-hp-ce403a-hp-507a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</span></p>', '<p>6000     5%     :<span>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</span></p>'),
	(91, '1', ' HP Q6471A (HP 501A CYAN)', 0, 50.92, 0, 1, 0.65, '-hp-q6471a-hp-501a-cyan', 'TSRH294C', 'http://tonersales,eu/shop/285/-hp-q6471a-hp-501a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</span></p>', '<p>4000     5%     :<span>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</span></p>'),
	(92, '1', ' HP Q6472A (HP 501A YELLOW)', 0, 50.92, 0, 1, 0.65, '-hp-q6472a-hp-501a-yellow', 'TSRH295Y', 'http://tonersales,eu/shop/287/-hp-q6472a-hp-501a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</span></p>', '<p>4000     5%     :<span>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</span></p>'),
	(93, '1', ' HP Q6473A (HP 501A MAGENTA)', 0, 50.92, 0, 1, 0.65, '-hp-q6473a-hp-501a-magenta', 'TSRH296M', 'http://tonersales,eu/shop/2293/-hp-q6473a-hp-501a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</span></p>', '<p>4000     5%     :<span>HP Color LaserJet 3600, 3600n, 3600dn, 3800n, 3800dn, 3800dtn, CP3505, CP3505n, CP3505dn, CP3505x</span></p>'),
	(94, '1', ' HP Q7581A (HP 3800 CYAN)', 0, 57.5, 0, 1, 0.65, '#NAME?', 'TSRH302C', 'http://tonersales,eu/shop/1904/-hp-q7581a-hp-3800-cyan,jpg', 0, '0', '<p>HP Color LaserJet 3800 , 3800N , 3800DN , 3800DTN , CP3505 , 3505N , 3505DN</p>', '<p>6000     5%     : HP Color LaserJet 3800 , 3800N , 3800DN , 3800DTN , CP3505 , 3505N , 3505DN</p>'),
	(95, '1', ' HP Q7582A (HP 3800 YELLOW)', 0, 57.5, 0, 1, 0.65, '#NAME?', 'TSRH303Y', 'http://tonersales,eu/shop/1902/-hp-q7582a-hp-3800-yellow,jpg', 0, '0', '<p>HP Color LaserJet 3800 , 3800N , 3800DN , 3800DTN , CP3505 , 3505N , 3505DN</p>', '<p>6000     5%     : HP Color LaserJet 3800 , 3800N , 3800DN , 3800DTN , CP3505 , 3505N , 3505DN</p>'),
	(96, '1', ' HP Q7583A (HP 3800 MAGENTA)', 0, 57.5, 0, 1, 0.65, '#NAME?', 'TSRH304M', 'http://tonersales,eu/shop/1903/-hp-q7583a-hp-3800-magenta,jpg', 0, '0', '<p>HP Color LaserJet 3800 , 3800N , 3800DN , 3800DTN , CP3505 , 3505N , 3505DN</p>', '<p>6000     5%     : HP Color LaserJet 3800 , 3800N , 3800DN , 3800DTN , CP3505 , 3505N , 3505DN</p>'),
	(97, '1', ' HP Q5942A (HP 42A BLACK)', 53, 30.65, 0, 106, 0.65, '-hp-q5942a-hp-42a-black', 'TSRH324B', 'http://tonersales,eu/shop/124/-hp-q5942a-hp-42a-black,jpg', 0, '0', '<p>HP LaserJet 4240n, 4250, 4250dtn, 4350n, 4350dtnsl, 4250n, 4250dtnsl, 4350tn, 4250tn, 4350, 4350dtn</p>', '<p>10000     5%     : HP LaserJet4240n, 4250, 4250dtn, 4350n, 4350dtnsl, 4250n, 4250dtnsl, 4350tn, 4250tn, 4350, 4350dtn</p>'),
	(98, '1', ' HP C9720A BLACK', 0, 56.36, 0, 1, 0.65, '-hp-c9720a-black', 'TSRH178B', 'http://tonersales,eu/shop/2294/-hp-c9720a-black,jpg', 0, '0', '<p>HP Color LaserJet 4600 , 4650 Series</p>', '<p>9000     5%     : HP Color LaserJet 4600 , 4650 Series</p>'),
	(99, '1', ' HP C9721A CYAN', 0, 56.36, 0, 1, 0.65, '-hp-c9721a-cyan', 'TSRH179C', 'http://tonersales,eu/shop/327/-hp-c9721a-cyan,jpg', 0, '0', '<p>HP Color LaserJet 4600 , 4650 Series</p>', '<p>8000     5%     : HP Color LaserJet 4600 , 4650 Series</p>'),
	(100, '1', ' HP C9722A YELLOW', 0, 56.36, 0, 1, 0.65, '-hp-c9722a-yellow', 'TSRH180Y', 'http://tonersales,eu/shop/328/-hp-c9722a-yellow,jpg', 0, '0', '<p>HP Color LaserJet 4600 , 4650 Series</p>', '<p>8000     5%     : HP Color LaserJet 4600 , 4650 Series</p>'),
	(101, '1', ' HP C9723A MAGENTA', 0, 56.36, 0, 1, 0.65, '-hp-c9723a-magenta', 'TSRH181M', 'http://tonersales,eu/shop/329/-hp-c9723a-magenta,jpg', 0, '0', '<p>HP Color LaserJet 4600 , 4650 Series</p>', '<p>8000     5%     : HP Color LaserJet 4600 , 4650 Series</p>'),
	(102, '1', ' HP Q7560A BLACK', 0, 56.36, 0, 1, 0.65, '#NAME?', 'TSRH312B', 'http://tonersales,eu/shop/330/-hp-q7560a-black,jpg', 0, '0', '<p>HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>', '<p>6500     5%     : HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>'),
	(103, '1', ' HP Q7561A CYAN', 0, 56.36, 0, 1, 0.65, '#NAME?', 'TSRH313C', 'http://tonersales,eu/shop/331/-hp-q7561a-cyan,jpg', 0, '0', '<p>HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>', '<p>3500     5%     : HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>'),
	(104, '1', ' HP Q7562A YELLOW', 0, 56.36, 0, 1, 0.65, '#NAME?', 'TSRH314Y', 'http://tonersales,eu/shop/332/-hp-q7562a-yellow,jpg', 0, '0', '<p>HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>', '<p>3500     5%     : HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>'),
	(105, '1', ' HP Q7563A MAGENTA', 0, 56.36, 0, 1, 0.65, '#NAME?', 'TSRH315M', 'http://tonersales,eu/shop/333/-hp-q7563a-magenta,jpg', 0, '0', '<p>HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>', '<p>3500     5%     : HP Color LaserJet 2700 , 3000 , 3000N , 3000DN , 3000DTN</p>'),
	(106, '1', ' HP CE390A (HP 90A BLACK)', 53, 45.82, 0, 1, 0.65, '-hp-ce390a-hp-90a-black', 'TSTRH532B', 'http://tonersales,eu/shop/1901/-hp-ce390a-hp-90a-black,jpg', 0, '0', '<p>HP LaserJet Enterprise M4555, Enterprise M4555fskm, Enterprise 600 M601n, Enterprise 600 M602n, Enterprise 600 M602x, Enterprise 600 M603dn, Enterprise M4555f, Enterprise M4555h, Enterprise M601dn, Enterprise 600 M602dn, Enterprise 600 M603n, Enterprise 600 M603x</p>', '<p>10000     5%     :HP LaserJet Enterprise M4555, Enterprise M4555fskm, Enterprise 600 M601n, Enterprise 600 M602n, Enterprise 600 M602x, Enterprise 600 M603dn, Enterprise M4555f, Enterprise M4555h, Enterprise M601dn, Enterprise 600 M602dn, Enterprise 600 M603n, Enterprise 600 M603x</p>'),
	(107, '1', ' HP CE250X (HP 504X BLACK)', 53, 34.9, 0, 101, 0.65, '-hp-ce250x-hp-504x-black', 'TSRH396B', 'http://tonersales,eu/shop/42/-hp-ce250x-hp-504x-black,jpg', 0, '0', '<p><span>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</span></p>', '<p>10500     5%     :<span>HP Color LaserJet CP3520, CM3530, CP3525dn, CM3530fs, CP3525n, CP3525, CP3530</span></p>'),
	(108, '1', ' HP CE400X (HP 507X BLACK)', 0, 39.9, 0, 102, 0.65, '-hp-ce400x-hp-507x-black', 'TSTRHE37B', 'http://tonersales,eu/shop/1963/-hp-ce400x-hp-507x-black,jpg', 0, '0', '<p>HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</p>', '<p>11000     5%     :HP Color LaserJet Enterprise 500 M575d, Enterprise M575, Enterprise 500 M551dn, Pro 500 M570dn, Enterprise 500 M575f, Enterprise M551n, Enterprise M551xh, Pro 500 M570dw</p>'),
	(109, '1', ' HP CB380A BK', 0, 63.3, 0, 1, 0.65, 'hp-cb380a-bk', 'TSRH380B', 'http://tonersales,eu/shop/335/hp-cb380a-bk,jpg', 0, '0', '<p><span>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</span></p>', '<p>16500     5%     :<span>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</span></p>'),
	(110, '1', ' HP CB381A CY', 0, 63.3, 0, 1, 0.65, '#NAME?', 'TSRH381A', 'http://tonersales,eu/shop/336/-hp-cb381a-cy,jpg', 0, '0', '<p>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</p>', '<p>21000     5%     :HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</p>'),
	(111, '1', ' HP CB382A YL', 0, 63.3, 0, 1, 0.65, 'hp-cb382a-yl', 'TSRH382A', 'http://tonersales,eu/shop/337/hp-cb382a-yl,jpg', 0, '0', '<p><span>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</span></p>', '<p>21000     5%     :<span>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</span></p>'),
	(112, '1', ' HP CB383A MG', 0, 63.3, 0, 1, 0.65, 'hp-cb383a-mg', 'TSRH383A', 'http://tonersales,eu/shop/338/hp-cb383a-mg,jpg', 0, '0', '<p><span>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</span></p>', '<p>21000     5%     :<span>HP Color LaserJet CP6015X, 6015DE, 6015XH, 6015DN, CM6030, 6040</span></p>'),
	(113, '1', ' HP CB400A BK', 0, 65.18, 0, 1, 0.65, 'hp-cb400a-bk', 'TSRH368B', 'http://tonersales,eu/shop/1908/hp-cb400a-bk,jpg', 0, '0', '<p>HP Color LaserJet CP4005 , 4005N , 4005DN</p>', '<p>7500     5%     : HP Color LaserJet CP4005 , 4005N , 4005DN</p>'),
	(114, '1', ' HP CB401A CY', 0, 65.18, 0, 1, 0.65, 'hp-cb401a-cy', 'TSRH369C', 'http://tonersales,eu/shop/1907/hp-cb401a-cy,jpg', 0, '0', '<p>HP Color LaserJet CP4005 , 4005N , 4005DN</p>', '<p>7500     5%     : HP Color LaserJet CP4005 , 4005N , 4005DN</p>'),
	(115, '1', ' HP CB402A YL', 0, 65.18, 0, 1, 0.65, 'hp-cb402a-yl', 'TSRH370Y', 'http://tonersales,eu/shop/1905/hp-cb402a-yl,jpg', 0, '0', '<p>HP Color LaserJet CP4005 , 4005N , 4005DN</p>', '<p>7500     5%     : HP Color LaserJet CP4005 , 4005N , 4005DN</p>'),
	(116, '1', ' HP CB403A MG', 0, 65.18, 0, 1, 0.65, 'hp-cb403a-mg', 'TSRH371M', 'http://tonersales,eu/shop/1906/hp-cb403a-mg,jpg', 0, '0', '<p>HP Color LaserJet CP4005 , 4005N , 4005DN</p>', '<p>7500     5%     : HP Color LaserJet CP4005 , 4005N , 4005DN</p>'),
	(117, '1', ' HP CE261A (HP 648A CYAN)', 0, 65.41, 0, 102, 0.65, '-hp-ce261a-hp-648a-cyan', 'TSRH585C', 'http://tonersales,eu/shop/343/-hp-ce261a-hp-648a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</span></p>', '<p>11000     5%     :<span>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</span></p>'),
	(118, '1', ' HP CE262A (HP 648A YELLOW)', 0, 65.41, 0, 102, 0.65, '-hp-ce262a-hp-648a-yellow', 'TSRH586Y', 'http://tonersales,eu/shop/344/-hp-ce262a-hp-648a-yellow,jpg', 0, '0', '<p>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</p>', '<p>11000     5%     :HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</p>'),
	(119, '1', ' HP CE263A (HP 648A MAGENTA)', 0, 65.41, 0, 102, 0.65, '-hp-ce263a-hp-648a-magenta', 'TSRH587M', 'http://tonersales,eu/shop/1036/-hp-ce263a-hp-648a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</span></p>', '<p>11000     5%     :<span>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</span></p>'),
	(120, '1', ' HP CF321A (653A CYAN)', 53, 62.1, 0, 1, 0.65, '-hp-cf321a-653a-cyan', 'TS13318315**', 'http://tonersales,eu/shop/153/-hp-cf321a-653a-cyan,jpg', 0, '0', '<p>HP Color LaserJet Enterprise MFP M680</p>', '<p>16500     5%     : HP Color LaserJet Enterprise MFP M680</p>'),
	(121, '1', ' HP CF322A (653A YELLOW)', 53, 62.1, 0, 1, 0.65, '-hp-cf322a-653a-yellow', 'TS13318316**', 'http://tonersales,eu/shop/154/-hp-cf322a-653a-yellow,jpg', 0, '0', '<p>HP Color LaserJet Enterprise MFP M680</p>', '<p>16500     5%     : HP Color LaserJet Enterprise MFP M680</p>'),
	(122, '1', ' HP CF323A (653A MAGENTA)', 53, 62.1, 0, 1, 0.65, '-hp-cf323a-653a-magenta', 'TS13318317**', 'http://tonersales,eu/shop/155/-hp-cf323a-653a-magenta,jpg', 0, '0', '<p>HP Color LaserJet Enterprise MFP M680</p>', '<p>16500     5%     : HP Color LaserJet Enterprise MFP M680</p>'),
	(123, '1', ' HP Q5950A (HP 643A BLACK)', 53, 55.9, 0, 1, 0.65, '-hp-q5950a-hp-643a-black', 'TSRH349B', 'http://tonersales,eu/shop/148/-hp-q5950a-hp-643a-black,jpg', 0, '0', '<p><span>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</span></p>', '<p>11000     5%     :<span>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</span></p>'),
	(124, '1', ' HP Q5951A (HP 643A CYAN)', 53, 55.9, 0, 1, 0.65, '-hp-q5951a-hp-643a-cyan', 'TSRH350C', 'http://tonersales,eu/shop/149/-hp-q5951a-hp-643a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</span></p>', '<p>10000     5%     :<span>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</span></p>'),
	(125, '1', ' HP Q5952A (HP 643A YELLOW)', 53, 55.9, 0, 1, 0.65, '-hp-q5952a-hp-643a-yellow', 'TSRH351Y', 'http://tonersales,eu/shop/150/-hp-q5952a-hp-643a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</span></p>', '<p>10000     5%     :<span>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</span></p>'),
	(126, '1', ' HP Q5953A (HP 643A MAGENTA)', 0, 69.32, 0, 1, 0.65, '-hp-q5953a-hp-643a-magenta', 'TSRH352M', 'http://tonersales,eu/shop/151/-hp-q5953a-hp-643a-magenta,jpg', 0, '0', '<p>HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</p>', '<p>10000     5%     :HP Color LaserJet 4700, 4700dtn, 4700ph+, 4700dn, 4700n</p>'),
	(127, '1', ' HP CC364X (HP 64X BLACK)', 53, 37.02, 0, 102, 0.65, '-hp-cc364x-hp-64x-black', 'TSTRHE09B', 'http://tonersales,eu/shop/135/-hp-cc364x-hp-64x-black,jpg', 0, '0', '<p>HP LaserJet P4015dn, P4015x, P4515x, P4015n, P4515n, P4515xm, P4015tn, P4515tn</p>', '<p>24000     5%     : HP LaserJetP4015dn, P4015x, P4515x, P4015n, P4515n, P4515xm, P4015tn, P4515tn</p>'),
	(128, '1', ' HP CE260X (HP 649X)', 0, 49, 0, 102, 0.65, '-hp-ce260x-hp-649x', 'TSRH584B', 'http://tonersales,eu/shop/345/-hp-ce260x-hp-649x,jpg', 0, '0', '<p><span>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</span></p>', '<p>17,000     5%     :<span>HP Color LaserJet CP4025n, CP4525n, CP4520n, CP4025dn, CP4525dn, CP4520dn, CP4525, CP4525xh</span></p>'),
	(129, '1', ' HP CF031A (HP 646A CYAN)', 0, 71.1, 0, 1, 0.65, '-hp-cf031a-hp-646a-cyan', 'TSTRHE43C', 'http://tonersales,eu/shop/346/-hp-cf031a-hp-646a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet CM4540 MFP</span></p>', '<p>12500     5%     :<span>HP Color LaserJet CM4540 MFP</span></p>'),
	(130, '1', ' HP CF032A (HP 646A YELLOW)', 0, 71.1, 0, 1, 0.65, '-hp-cf032a-hp-646a-yellow', 'TSTRHE44Y', 'http://tonersales,eu/shop/347/-hp-cf032a-hp-646a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet CM4540 MFP</span></p>', '<p>12500     5%     :<span>HP Color LaserJet CM4540 MFP</span></p>'),
	(131, '1', ' HP CF033A (HP 646A MAGENTA)', 0, 71.1, 0, 1, 0.65, '-hp-cf033a-hp-646a-magenta', 'TSTRHE45M', 'http://tonersales,eu/shop/348/-hp-cf033a-hp-646a-magenta,jpg', 0, '0', '<p>HP Color LaserJet CM4540 MFP</p>', '<p>12500     5%     :HP Color LaserJet CM4540 MFP</p>'),
	(132, '1', ' HP C9730A (HP 645A BLACK)', 0, 72.52, 0, 1, 0.65, '-hp-c9730a-hp-645a-black', 'TSRH214B', 'http://tonersales,eu/shop/350/-hp-c9730a-hp-645a-black,jpg', 0, '0', '<p><span>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</span></p>', '<p>13000     5%     :<span>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</span></p>'),
	(133, '1', ' HP C9731A (HP 645A CYAN)', 0, 72.52, 0, 1, 0.65, '-hp-c9731a-hp-645a-cyan', 'TSRH215C', 'http://tonersales,eu/shop/2295/-hp-c9731a-hp-645a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</span></p>', '<p>12000     5%     :<span>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</span></p>'),
	(134, '1', ' HP C9732A (HP 645A YELLOW)', 0, 72.52, 0, 1, 0.65, '-hp-c9732a-hp-645a-yellow', 'TSRH216Y', 'http://tonersales,eu/shop/352/-hp-c9732a-hp-645a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</span></p>', '<p>12000     5%     :<span>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</span></p>'),
	(135, '1', ' HP C9733A (HP 645A MAGENTA)', 0, 72.52, 0, 1, 0.65, '-hp-c9733a-hp-645a-magenta', 'TSRH217M', 'http://tonersales,eu/shop/353/-hp-c9733a-hp-645a-magenta,jpg', 0, '0', '<p>HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</p>', '<p>12000     5%     :HP Color LaserJet 5500, 5500hdn, 5550dn, 5500dn, 5550n, 5550dtn, 5500dtn, 5550</p>'),
	(136, '1', ' HP C4150A CY', 0, 73.44, 0, 1, 0.65, 'hp-c4150a-cy', 'TSRH170C', 'http://tonersales,eu/shop/1912/hp-c4150a-cy,jpg', 0, '0', '<p><span>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</span></p>', '<p>8500     5%     :<span>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</span></p>'),
	(137, '1', ' HP C4151A MG', 0, 73.44, 0, 1, 0.65, 'hp-c4151a-mg', 'TSRH171M', 'http://tonersales,eu/shop/1910/hp-c4151a-mg,jpg', 0, '0', '<p><span>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</span></p>', '<p>8500     5%     :<span>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</span></p>'),
	(138, '1', ' HP C4152A YL', 0, 73.44, 0, 1, 0.65, 'hp-c4152a-yl', 'TSRH172Y', 'http://tonersales,eu/shop/1911/hp-c4152a-yl,jpg', 0, '0', '<p><span>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</span></p>', '<p>8500     5%     :<span>HP Color LaserJet 8500 , 8500DN , 8500N , 8550 , 8550GN , 8550MFP , 8550N</span></p>'),
	(139, '1', ' HP C4182X JUMBO', 1, 74.96, 0, 1, 0.65, 'hp-c4182x-jumbo', 'TSRH149B', 'http://tonersales,eu/shop/357/hp-c4182x-jumbo,jpg', 0, '0', 'HP LaserJet 8100 , 8100DN , 8100MFP , 8100N , 8150 , 8150HN , 8150MFP , 8150N', '32000     5%               :  HP LaserJet 8100 , 8100DN , 8100MFP , 8100N , 8150 , 8150HN , 8150MFP , 8150N'),
	(140, '1', ' HP CF214X (HP 14X BLACK)', 53, 37.02, 0, 102, 0.65, '0', 'TSTRHE70B', '0', 0, '0', '<p>HP LaserJet Enterprise 700 M712, M712xh, MFP M712z, M712n, MFP M712dn, M712nd, MFP M712f, MFP M725z, MFP M725dn</p>', '0'),
	(141, '1', ' HP CF331A CY', 0, 76.59, 0, 1, 0.65, 'hp-cf331a-cy', 'TS13315942**', 'http://tonersales,eu/shop/359/hp-cf331a-cy,jpg', 0, '0', '<p>HP Color LaserJet M651n , M651dn</p>', '<p>15000     5%     : HP Color LaserJet M651n , M651dn</p>'),
	(142, '1', ' HP CF332A YL', 0, 76.59, 0, 1, 0.65, 'hp-cf332a-yl', 'TS13315943**', 'http://tonersales,eu/shop/360/hp-cf332a-yl,jpg', 0, '0', '<p>HP Color LaserJet M651n , M651dn</p>', '<p>15000     5%     : HP Color LaserJet M651n , M651dn</p>'),
	(143, '1', ' HP CF333A MG', 1, 76.59, 0, 1, 0.65, 'hp-cf333a-mg', 'TS13315944**', 'http://tonersales,eu/shop/361/hp-cf333a-mg,jpg', 0, '0', 'HP Color LaserJet M651n , M651dn', '15000     5%               :  HP Color LaserJet M651n , M651dn'),
	(144, '1', ' HP CF281X (HP 81X BLACK)', 53, 33.87, 0, 1, 0.65, '-hp-cf281x-hp-81x-black', 'TS13318373**', 'http://tonersales,eu/shop/1406/-hp-cf281x-hp-81x-black,jpg', 0, '0', '<p>HP LaserJet Enterprise M604N, M604DN, M605N, M605DN, M605X, FLOW MFP M630H, M606DN, M606X, M630DN, M630F, M630H, FLOW MFP M630Z</p>', '<p>25000     5%     :HP LaserJet Enterprise M604N, M604DN, M605N, M605DN, M605X, FLOW MFP M630H, M606DN, M606X, M630DN, M630F, M630H, FLOW MFP M630Z</p>'),
	(145, '1', ' HP CF320A (653A BLACK)', 53, 67.74, 0, 1, 0.65, '-hp-cf320a-653a-black', 'TS13315941**', 'http://tonersales,eu/shop/152/-hp-cf320a-653a-black,jpg', 0, '0', '<p>HP Color LaserJet Enterprise M651n , M651dn , MFP M680</p>', '<p>11500     5%     : HP Color LaserJet Enterprise M651n , M651dn , MFP M680</p>'),
	(146, '1', ' HP CF330X BK', 0, 80.45, 0, 1, 0.65, 'hp-cf330x-bk', 'TS13315940**', 'http://tonersales,eu/shop/349/hp-cf330x-bk,jpg', 0, '0', '<p>HP Color LaserJet M651n , M651dn</p>', '<p>20500     5%     : HP Color LaserJet M651n , M651dn</p>'),
	(147, '1', ' HP CE264X (HP 646X BLACK)', 0, 80.63, 0, 1, 0.65, '-hp-ce264x-hp-646x-black', 'TSTRHE42B', 'http://tonersales,eu/shop/1909/-hp-ce264x-hp-646x-black,jpg', 0, '0', '<p><span>HP Color LaserJet CM4540 MFP</span></p>', '<p>17000     5%     :<span>HP Color LaserJet CM4540 MFP</span></p>'),
	(148, '1', ' HP C3909A JUMBO', 0, 99.19, 0, 1, 0.65, 'hp-c3909a-jumbo', 'TSRH117B', 'http://tonersales,eu/shop/363/hp-c3909a-jumbo,jpg', 0, '0', '<p>HP LaserJet 5Si , 5SiMX , 5SiMOPIER , 5SiNX , 8000N</p>', '<p>25000     5%     : HP LaserJet 5Si , 5SiMX , 5SiMOPIER , 5SiNX , 8000N</p>'),
	(149, '1', ' HP CE740A BK', 1, 127.62, 0, 1, 0.65, 'hp-ce740a-bk', 'TSTRH597B', 'http://tonersales,eu/shop/364/hp-ce740a-bk,jpg', 0, '0', 'HP Color LaserJet CP5225 , 5225n , 5225dn', '7000     5%               :  HP Color LaserJet CP5225 , 5225n , 5225dn'),
	(150, '1', ' HP CE340A BK', 0, 128.42, 0, 1, 0.65, 'hp-ce340a-bk', 'TSTRHE94B', 'http://tonersales,eu/shop/365/hp-ce340a-bk,jpg', 0, '0', '<p>HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+</p>', '<p>13500     5%     : HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+</p>'),
	(151, '1', ' HP CE341A CY', 0, 128.42, 0, 1, 0.65, 'hp-ce341a-cy', 'TSTRHE95C', 'http://tonersales,eu/shop/366/hp-ce341a-cy,jpg', 0, '0', '<p>HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+</p>', '<p>16000     5%     : HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+</p>'),
	(152, '1', ' HP CE342A YL', 0, 128.42, 0, 1, 0.65, 'hp-ce342a-yl', 'TSTRHE96Y', 'http://tonersales,eu/shop/367/hp-ce342a-yl,jpg', 0, '0', '<p>HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+</p>', '<p>16000     5%     : HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+</p>'),
	(153, '1', ' HP CE343A MG', 1, 128.42, 0, 1, 0.65, 'hp-ce343a-mg', 'TSTRHE97M', 'http://tonersales,eu/shop/368/hp-ce343a-mg,jpg', 0, '0', 'HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+', '16000     5%               :  HP LaserJet Enterprise 700 color MFP 775dn , M775f , M775z , M775z+'),
	(154, '1', ' HP CE741A CY', 1, 133.74, 0, 1, 0.65, 'hp-ce741a-cy', 'TSTRH598C', 'http://tonersales,eu/shop/369/hp-ce741a-cy,jpg', 0, '0', 'HP Color LaserJet CP5225 , 5225n , 5225dn', '7300     5%               :  HP Color LaserJet CP5225 , 5225n , 5225dn'),
	(155, '1', ' HP CE742A YL', 0, 133.74, 0, 1, 0.65, 'hp-ce742a-yl', 'TSTRH599Y', 'http://tonersales,eu/shop/370/hp-ce742a-yl,jpg', 0, '0', '<p>HP Color LaserJet CP5225 , 5225n , 5225dn</p>', '<p>7300     5%     : HP Color LaserJet CP5225 , 5225n , 5225dn</p>'),
	(156, '1', ' HP CE743A MG', 0, 133.74, 0, 1, 0.65, 'hp-ce743a-mg', 'TSTRH600M', 'http://tonersales,eu/shop/371/hp-ce743a-mg,jpg', 0, '0', '<p>HP Color LaserJet CP5225 , 5225n , 5225dn</p>', '<p>7300     5%     : HP Color LaserJet CP5225 , 5225n , 5225dn</p>'),
	(157, '1', ' HP C8543X BK (HP 43X BLACK)', 0, 97.5, 0, 103, 0.65, '-hp-c8543x-bk-hp-43x-black', 'TSRH272B', 'http://tonersales,eu/shop/372/-hp-c8543x-bk-hp-43x-black,jpg', 0, '0', '<p>HP LaserJet 9000 , 9000DN , 9000HNS , 9000N , 9040 , 9040DN , 9040N , 9050 , 9050DN , 9050N , 9000L MFP , 9040MFP , 9050MFP</p>', '<p>32000     5%     : HP LaserJet 9000 , 9000DN , 9000HNS , 9000N , 9040 , 9040DN , 9040N , 9050 , 9050DN , 9050N , 9000L MFP , 9040MFP , 9050MFP</p>'),
	(158, '1', ' HP CF325X', 0, 158.89, 0, 1, 0.65, 'hp-cf325x', 'TS13315939**', 'http://tonersales,eu/shop/1072/hp-cf325x,jpg', 0, '0', '<p>HP LaserJet Enterprise M806dn , M830 , M803z , M806x</p>', '<p>35400     5%     : HP LaserJet Enterprise M806dn , M830 , M803z , M806x</p>'),
	(159, '1', ' BROTHER TN8000/TN300/TN200/TN250 BK', 0, 9.5, 0, 107, 0.65, '#NAME?', 'TSFB003B', 'http://tonersales,eu/shop/1039/-brother-tn8000tn300tn200tn250-bk,jpg', 0, '0', '<p><span>BROTHER MFC-8300, BROTHER MFC-8500, BROTHER MFC-8600, BROTHER MFC-8700, BROTHER MFC-9600, BROTHER MFC-9650, BROTHER MFC-9660N, BROTHER MFC-9700, BROTHER MFC-9750, BROTHER MFC-9760, BROTHER MFC-9800, BROTHER MFC-9870N, BROTHER MFC-9800, BROTHER MFC-9880, BROTHER MFC-P2500, IntelliFax-4100, IntelliFax-4100e, IntelliFax-4750, IntelliFax-4750E, IntelliFax-5750, IntelliFax-5750E</span></p>', '<p>2000     5%     :<span>BROTHER MFC-8300, BROTHER MFC-8500, BROTHER MFC-8600, BROTHER MFC-8700, BROTHER MFC-9600, BROTHER MFC-9650, BROTHER MFC-9660N, BROTHER MFC-9700, BROTHER MFC-9750, BROTHER MFC-9760, BROTHER MFC-9800, BROTHER MFC-9870N, BROTHER MFC-9800, BROTHER MFC-9880, BROTHER MFC-P2500, IntelliFax-4100, IntelliFax-4100e, IntelliFax-4750, IntelliFax-4750E, IntelliFax-5750, IntelliFax-5750E</span></p>'),
	(161, '1', ' BROTHER TN2120/TN360', 0, 16.84, 0, 112, 0.65, '#NAME?', 'TSFB216B', 'http://tonersales,eu/shop/1073/-brother-tn2120tn360,jpg', 0, '0', '<p>Brother DCP7030 , DCP7040 , DCP7045N , Brother HL2140 , HL2150N , HL2170W , Brother MFC7320 , MFC7340 , MFC7345 , MFC7440N , MFC7450 , MFC7840W</p>', '<p>2600     5%     : Brother DCP7030 , DCP7040 , DCP7045N , Brother HL2140 , HL2150N , HL2170W , Brother MFC7320 , MFC7340 , MFC7345 , MFC7440N , MFC7450 , MFC7840W</p>'),
	(162, '1', ' BROTHER TN1000 , TN1030 , TN1050 , TN1075', 53, 14.44, 0, 104, 0.65, 'brother-tn1000-tn1030-tn1050-tn1075', 'TS13317700**', 'http://tonersales,eu/shop/241/brother-tn1000-tn1030-tn1050-tn1075,jpg', 0, '0', '<p>Brother HL 1110, HL 1110E, DCP 1510, MFC 1813, MFC 1910W, HL 1112, HL 1212, DCP 1512R, DCP 1518, MFC 1818, HL 1118, HL 1112E, DCP 1610, DCP 1511, DCP 1612W, MFC 1810</p>', '<p>1500     5%     : BrotherHL 1110, HL 1110E, DCP 1510, MFC 1813, MFC 1910W, HL 1112, HL 1212, DCP 1512R, DCP 1518, MFC 1818, HL 1118, HL 1112E, DCP 1610, DCP 1511, DCP 1612W, MFC 1810</p>'),
	(163, '1', ' BROTHER TN2320', 0, 18.84, 0, 112, 0.65, '#NAME?', 'TSTFB338B', 'http://tonersales,eu/shop/1074/-brother-tn2320,jpg', 0, '0', '<p>Brother HL-L2300D , HLL2320D , HLL2340DW , HLL2360DN , HLL2361 , HLL2365DW , HLL2380 , Brother DCPL2500D , DCPL2520DW , DCPL2540DN , DCPL2560DW , Brother MFCL2700DW , MFCL2700DN, MFCL2703DW , MFCL2720DW , MFCL2740DW , MFCL2741DW</p>', '<p>2600     5%     : Brother HL-L2300D , HLL2320D , HLL2340DW , HLL2360DN , HLL2361 , HLL2365DW , HLL2380 , Brother DCPL2500D , DCPL2520DW , DCPL2540DN , DCPL2560DW , Brother MFCL2700DW , MFCL2700DN, MFCL2703DW , MFCL2720DW , MFCL2740DW , MFCL2741DW</p>'),
	(164, '1', ' BROTHER TN326 BK (HY)', 0, 21.31, 0, 1, 0.65, 'brother-tn326-bk-hy', 'TS13316436**', 'http://tonersales,eu/shop/1075/brother-tn326-bk-hy,jpg', 0, '0', '<p>BROTHER HL-L8250CDN , L8350CDW , L8350CDWT BROTHER DCP-L8400CDN , L8450CDW BROTHER MFC-L8600CDW , L8650CDW , L8850CDW</p>', '<p>4000     5%     : BROTHER HL-L8250CDN , L8350CDW , L8350CDWT BROTHER DCP-L8400CDN , L8450CDW BROTHER MFC-L8600CDW , L8650CDW , L8850CDW</p>'),
	(165, '1', ' BROTHER TN329 , TN900 BK', 0, 21.31, 0, 1, 0.65, 'brother-tn329-tn900-bk', 'TS13317715**', 'http://tonersales,eu/shop/1076/brother-tn329-tn900-bk,jpg', 0, '0', '<p>BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>', '<p>6000     5%     : BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>'),
	(166, '1', ' BROTHER TN2220/TN450/TN2200/TN2010', 53, 13.91, 0, 122, 0.65, '#NAME?', 'TSFB251B', 'http://tonersales,eu/shop/240/-brother-tn2220tn450tn2200tn2010,jpg', 0, '0', '<p>Brother HL2240, HL2250DN, MFC7860DW, DCP7070DW, HL2240D, HL2270DW, MFC7360N, DCP7060D, HL2240L, MFC7460DN, DCP7065DN, FAX 2840/2940</p>', '<p>2600     5%     :Brother HL2240, HL2250DN, MFC7860DW, DCP7070DW, HL2240D, HL2270DW, MFC7360N, DCP7060D, HL2240L, MFC7460DN, DCP7065DN, FAX 2840/2940</p>'),
	(167, '1', ' BROTHER TN3170, TN3130, TN580', 53, 10.81, 0, 102, 0.65, '#NAME?', 'TSFB226B', 'http://tonersales,eu/shop/246/-brother-tn3170-tn3130-tn580,jpg', 0, '0', '<p><span>BROTHER DCP 8060, BROTHER DCP 8065DN ,BROTHER MFC 8460N, BROTHER MFC 8660DN ,BROTHER MFC 8860DN, BROTHER MFC 8870DWDCP 8080DN, BROTHER DCP 8085DN, BROTHER MFC 8370 ,BROTHER MFC 8480DN,BROTHER MFC 8680DN,BROTHER MFC 8880DN, BROTHER MFC 8890DW,BROTHER BROHL 5340D, BROTHER 5350DN, BROTHER 5350DNLT, BROTHER 5370DW, BROTHER 5370DWT, BROTHER 5380DN, BROTHER HL 5240, BROTHER HL 5250DN, BROTHER HL 5250DNT , BROTHER HL 5270DN, BROTHER HL 5280DW</span></p>', '<p>7000     5%     :<span>BROTHER DCP 8060, BROTHER DCP 8065DN ,BROTHER MFC 8460N, BROTHER MFC 8660DN ,BROTHER MFC 8860DN, BROTHER MFC 8870DWDCP 8080DN, BROTHER DCP 8085DN, BROTHER MFC 8370 ,BROTHER MFC 8480DN,BROTHER MFC 8680DN,BROTHER MFC 8880DN, BROTHER MFC 8890DW,BROTHER BROHL 5340D, BROTHER 5350DN, BROTHER 5350DNLT, BROTHER 5370DW, BROTHER 5370DWT, BROTHER 5380DN, BROTHER HL 5240, BROTHER HL 5250DN, BROTHER HL 5250DNT , BROTHER HL 5270DN, BROTHER HL 5280DW</span></p>'),
	(168, '1', ' BROTHER TN7600 (High Volume)', 0, 23.86, 0, 1, 0.65, '#NAME?', 'TS13310857**', 'http://tonersales,eu/shop/1044/-brother-tn7600-high-volume,jpg', 0, '0', '<p>Brother HL1630 , HL1640 , HL1650 , HL1670 , HL1820 , HL1850 , HL1870 , HL5030 , HL5040 , HL5050 , HL5070 , MFC8420 , MFC8820 , MFC8825 , MFC8920 , DCP8020 , DCP8025</p>', '<p>6500     5%     : Brother HL1630 , HL1640 , HL1650 , HL1670 , HL1820 , HL1850 , HL1870 , HL5030 , HL5040 , HL5050 , HL5070 , MFC8420 , MFC8820 , MFC8825 , MFC8920 , DCP8020 , DCP8025</p>'),
	(169, '1', ' BROTHER TN6600, TN460, TN560, TN570, TN3060 BLACK', 0, 19.9, 0, 114, 0.65, '#NAME?', 'TSFB209B', 'http://tonersales,eu/shop/1078/-brother-tn6600-tn460-tn560-tn570-tn3060-black,jpg', 0, '0', '<p><span>BROTHER</span>INTELLIFAX 4750E, 4100, 5750E, DCP1200/1400, HL1430, HL1420, HL1270N, HL1450, HL1440, HL1030, HL1230, HL1240, HL1250, HL1470N, HL1220, MFCP2500/2600, MFC6750, MFC8300, MFC8600, MFC9660N, MFC9760, MFC9870, MFC9650, MFC9800, MFC8700CP, MFC9750, MFC9700, MFC9860, MFC9660, MFC8500, MFC9850, MFC9880N, MFC8700</p>', '<p>6000     5%     :<span>BROTHERINTELLIFAX 4750E, 4100, 5750E, DCP1200/1400, HL1430, HL1420, HL1270N, HL1450, HL1440, HL1030, HL1230, HL1240, HL1250, HL1470N, HL1220, MFCP2500/2600, MFC6750, MFC8300, MFC8600, MFC9660N, MFC9760, MFC9870, MFC9650, MFC9800, MFC8700CP, MFC9750, MFC9700, MFC9860, MFC9660, MFC8500, MFC9850, MFC9880N, MFC8700</span></p>'),
	(170, '1', ' BROTHER TN4100', 0, 24.09, 0, 1, 0.65, 'brother-tn4100', 'TSRB020B', 'http://tonersales,eu/shop/1079/brother-tn4100,jpg', 0, '0', '<p>Brother HL6050 , HL6050D , HL6050DN , HL6050DW</p>', '<p>7500     5%     : Brother HL6050 , HL6050D , HL6050DN , HL6050DW</p>'),
	(171, '1', ' BROTHER TN3380', 0, 20.5, 0, 102, 0.65, 'brother-tn3380', 'TSTFB273B', 'http://tonersales,eu/shop/1080/brother-tn3380,jpg', 0, '0', '<p>Brother HL-5440D, HL-5450DN, HL-5450DNT, HL-5470DW, HL-5470DWT, HL-6180DW, HL-6180DWT, MFC-8510DN, MFC-8520DN, MFC-8710DW, MFC-8810DW, MFC-8910DW, MFC-8950DWT, DCP-8110DN, DCP-8150DN, DCP-8155DN, DCP-8250DN</p>', '<p>8000     5%     : BrotherHL-5440D, HL-5450DN, HL-5450DNT, HL-5470DW, HL-5470DWT, HL-6180DW, HL-6180DWT, MFC-8510DN, MFC-8520DN, MFC-8710DW, MFC-8810DW, MFC-8910DW, MFC-8950DWT, DCP-8110DN, DCP-8150DN, DCP-8155DN, DCP-8250DN</p>'),
	(172, '1', ' BROTHER TN210, TN230 BK', 0, 18.87, 0, 105, 0.65, '#NAME?', 'TSTFB235B', 'http://tonersales,eu/shop/1094/-brother-tn210-tn230-bk,jpg', 0, '0', '<p>Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>', '<p>2200     5%     : Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>'),
	(173, '1', ' BROTHER TN210, TN230 CY', 0, 18.87, 0, 102, 0.65, '#NAME?', 'TSTFB236C', 'http://tonersales,eu/shop/1092/-brother-tn210-tn230-cy,jpg', 0, '0', '<p>Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>', '<p>1400     5%     : Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>'),
	(174, '1', ' BROTHER TN210, TN230 YL', 0, 18.87, 0, 102, 0.65, '#NAME?', 'TSTFB237Y', 'http://tonersales,eu/shop/1093/-brother-tn210-tn230-yl,jpg', 0, '0', '<p>Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>', '<p>1400     5%     : Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>'),
	(175, '1', ' BROTHER TN210, TN230 MG', 0, 18.87, 0, 102, 0.65, '#NAME?', 'TSTFB238M', 'http://tonersales,eu/shop/1091/-brother-tn210-tn230-mg,jpg', 0, '0', '<p>Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>', '<p>1400     5%     : Brother HL3040CN , HL3070CW , MFC9010CN , MFC9120CN , MFC9320CN , DCP9010CN</p>'),
	(176, '1', ' BROTHER TN241 BK', 53, 15.24, 0, 102, 0.65, '#NAME?', 'TSTFB279B', 'http://tonersales,eu/shop/242/-brother-tn241-bk,jpg', 0, '0', '<p>Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>', '<p>2500     5%     : Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>'),
	(177, '1', ' BROTHER  TN245 CY', 53, 15.32, 0, 102, 0.65, '#NAME?', 'TSTFB298C', 'http://tonersales,eu/shop/243/-brother-tn245-cy,jpg', 0, '0', '<p>Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>', '<p>2200     5%     : Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>'),
	(178, '1', ' BROTHER TN245 YL', 53, 15.32, 0, 102, 0.65, '#NAME?', 'TSTFB299Y', 'http://tonersales,eu/shop/244/-brother-tn245-yl,jpg', 0, '0', '<p>Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>', '<p>2200     5%     : Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>'),
	(179, '1', ' BROTHER TN245 MG', 53, 15.32, 0, 102, 0.65, '#NAME?', 'TSTFB300M', 'http://tonersales,eu/shop/245/-brother-tn245-mg,jpg', 0, '0', '<p>Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>', '<p>2200     5%     : Brother HL-3140CW , 3150CDW , 3150CDN , 3170CDW ,MFC-9130CW , 9140CDN , 9330CDW , 9340CDW ,DCP-9020CDW , 9020CDN</p>'),
	(180, '1', ' BROTHER TN326 CY (HY)', 1, 28.41, 0, 1, 0.65, '0', 'TS13316437**', '0', 0, '0', 'BROTHER HL-L8250CDN , L8350CDW , L8350CDWT', '0'),
	(181, '1', ' BROTHER TN326 YL (HY)', 0, 28.41, 0, 1, 0.65, 'brother-tn326-yl-hy', 'TS13316438**', 'http://tonersales,eu/shop/1082/brother-tn326-yl-hy,jpg', 0, '0', '<p>BROTHER HL-L8250CDN , L8350CDW , L8350CDWT BROTHER DCP-L8400CDN , L8450CDW BROTHER MFC-L8600CDW , L8650CDW , L8850CDW</p>', '<p>3500     5%     : BROTHER HL-L8250CDN , L8350CDW , L8350CDWT BROTHER DCP-L8400CDN , L8450CDW BROTHER MFC-L8600CDW , L8650CDW , L8850CDW</p>'),
	(182, '1', ' BROTHER TN326 MG (HY)', 0, 28.41, 0, 1, 0.65, 'brother-tn326-mg-hy', 'TS13316439**', 'http://tonersales,eu/shop/1083/brother-tn326-mg-hy,jpg', 0, '0', '<p>BROTHER HL-L8250CDN , L8350CDW , L8350CDWT BROTHER DCP-L8400CDN , L8450CDW BROTHER MFC-L8600CDW , L8650CDW , L8850CDW</p>', '<p>3500     5%     : BROTHER HL-L8250CDN , L8350CDW , L8350CDWT BROTHER DCP-L8400CDN , L8450CDW BROTHER MFC-L8600CDW , L8650CDW , L8850CDW</p>'),
	(183, '1', ' BROTHER TN329 , TN900 CY', 0, 28.41, 0, 1, 0.65, 'brother-tn329-tn900-cy', 'TS13317716**', 'http://tonersales,eu/shop/1084/brother-tn329-tn900-cy,jpg', 0, '0', '<p>BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>', '<p>6000     5%     : BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>'),
	(184, '1', ' BROTHER TN329 , TN900 MG', 0, 28.41, 0, 1, 0.65, 'brother-tn329-tn900-mg', 'TS13317717**', 'http://tonersales,eu/shop/1086/brother-tn329-tn900-mg,jpg', 0, '0', '<p>BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>', '<p>6000     5%     : BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>'),
	(185, '1', ' BROTHER TN329 , TN900 YL', 0, 28.41, 0, 1, 0.65, 'brother-tn329-tn900-yl', 'TS13317718**', 'http://tonersales,eu/shop/1085/brother-tn329-tn900-yl,jpg', 0, '0', '<p>BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>', '<p>6000     5%     : BROTHER HL-L9200CDWT BROTHER MFC-L8850CD , L9550CDWT BROTHER DCP-L8450CDW</p>'),
	(186, '1', ' BROTHER TN310 BK', 0, 29.31, 0, 1, 0.65, 'brother-tn310-bk', 'TSTFB246B', 'http://tonersales,eu/shop/1087/brother-tn310-bk,jpg', 0, '0', '<p>Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)</p>', '<p>2500     5%     : Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)</p>'),
	(187, '1', ' BROTHER TN310 CY', 1, 29.31, 0, 1, 0.65, 'brother-tn310-cy', 'TSTFB247C', 'http://tonersales,eu/shop/1088/brother-tn310-cy,jpg', 0, '0', 'Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)', '1500     5%               :  Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)'),
	(188, '1', ' BROTHER TN310 YL', 0, 29.31, 0, 1, 0.65, 'brother-tn310-yl', 'TSTFB248Y', 'http://tonersales,eu/shop/1089/brother-tn310-yl,jpg', 0, '0', '<p>Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)</p>', '<p>1500     5%     : Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)</p>'),
	(189, '1', ' BROTHER TN310 MG', 0, 29.31, 0, 1, 0.65, 'brother-tn310-mg', 'TSTFB249M', 'http://tonersales,eu/shop/1090/brother-tn310-mg,jpg', 0, '0', '<p>Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)</p>', '<p>1500     5%     : Brother HL-4140CN , 4150CDN , 4570CDW , 4570CDWT , DCP-9055CDN , 9270CDN , MFC-9460CDN , 9465CDN , 9560CDW , 9970CDW(Worldwide)</p>'),
	(190, '1', ' BROTHER TN135 , 115 , 155 , 175 (HY) BK', 0, 33, 0, 1, 0.65, 'brother-tn135-115-155-175-hy-bk', 'TSFB103B', 'http://tonersales,eu/shop/1095/brother-tn135-115-155-175-hy-bk,jpg', 0, '0', '<p>Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>', '<p>5000     5%     : Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>'),
	(191, '1', ' BROTHER TN135 , 115 , 155 , 175(HY) CY', 0, 33, 0, 1, 0.65, 'brother-tn135-115-155-175hy-cy', 'TSFB104C', 'http://tonersales,eu/shop/1096/brother-tn135-115-155-175hy-cy,jpg', 0, '0', '<p>Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>', '<p>4000     5%     : Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>'),
	(192, '1', ' BROTHER TN135 , 115 , 155 , 175(HY) YL', 0, 33, 0, 1, 0.65, 'brother-tn135-115-155-175hy-yl', 'TSFB105Y', 'http://tonersales,eu/shop/1098/brother-tn135-115-155-175hy-yl,jpg', 0, '0', '<p>Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>', '<p>4000     5%     : Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>'),
	(193, '1', ' BROTHER TN135 , 115 , 155 , 175(HY) MG', 0, 33, 0, 1, 0.65, 'brother-tn135-115-155-175hy-mg', 'TSFB106M', 'http://tonersales,eu/shop/1097/brother-tn135-115-155-175hy-mg,jpg', 0, '0', '<p>Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>', '<p>4000     5%     : Brother HL4040CN , HL4050CDN , HL4070CDW; Brother DCP9040CN , DCP9045CDN; Brother MFC9440CN , MFC9450CDN , MFC9840CDW</p>'),
	(194, '1', ' BROTHER TN325 BLACK', 0, 28, 0, 103, 0.65, '#NAME?', 'TSTFB259B', 'http://tonersales,eu/shop/1099/-brother-tn325-black,jpg', 0, '0', '<p>Brother HL4140CN, HL4150CDN, HL4570CDW, HL 4570CDWT, MFC 9460CDN, MFC9465CDN, MFC9560CDW, MFC 9970CDW, DCP 9055CDN</p>', '<p>6000     5%     :Brother HL4140CN, HL4150CDN, HL4570CDW, HL 4570CDWT, MFC 9460CDN, MFC9465CDN, MFC9560CDW, MFC 9970CDW, DCP 9055CDN</p>'),
	(195, '1', ' BROTHER TN325 CYAN', 0, 28, 0, 103, 0.65, '#NAME?', 'TSTFB260C', 'http://tonersales,eu/shop/2221/-brother-tn325-cyan,jpg', 0, '0', '<p><span>Brother HL4140CN, HL4150CDN, HL4570CDW, HL 4570CDWT, MFC 9460CDN, MFC9465CDN, MFC9560CDW, MFC 9970CDW, DCP 9055CDN</span></p>', '<p>3500     5%     :<span>Brother HL4140CN, HL4150CDN, HL4570CDW, HL 4570CDWT, MFC 9460CDN, MFC9465CDN, MFC9560CDW, MFC 9970CDW, DCP 9055CDN</span></p>'),
	(196, '1', ' BROTHER TN325 YELLOW', 0, 28, 0, 103, 0.65, '#NAME?', 'TSTFB261Y', 'http://tonersales,eu/shop/2223/-brother-tn325-yellow,jpg', 0, '0', '<p><span>Brother HL4140CN, HL4150CDN, HL4570CDW, HL 4570CDWT, MFC 9460CDN, MFC9465CDN, MFC9560CDW, MFC 9970CDW, DCP 9055CDN</span></p>', '<p>3500     5%     :<span>Brother HL4140CN, HL4150CDN, HL4570CDW, HL 4570CDWT, MFC 9460CDN, MFC9465CDN, MFC9560CDW, MFC 9970CDW, DCP 9055CDN</span></p>'),
	(197, '1', ' BROTHER TN325 MAGENTA', 0, 28, 0, 103, 0.65, '0', 'TSTFB262M', '0', 0, '0', '<div id="short_description_block">', '0'),
	(198, '1', ' BROTHER TN04 BK', 0, 42.46, 0, 1, 0.65, 'brother-tn04-bk', 'TSRB100B', 'http://tonersales,eu/shop/1106/brother-tn04-bk,jpg', 0, '0', '<p>Brother HL-2700CN , MFC-9420CN</p>', '<p>10000     5%     : Brother HL-2700CN , MFC-9420CN</p>'),
	(199, '1', ' BROTHER TN04 CY', 0, 42.46, 0, 1, 0.65, 'brother-tn04-cy', 'TSRB101C', 'http://tonersales,eu/shop/1107/brother-tn04-cy,jpg', 0, '0', '<p>Brother HL-2700CN , MFC-9420CN</p>', '<p>6600     5%     : Brother HL-2700CN , MFC-9420CN</p>'),
	(200, '1', ' BROTHER TN04 MG', 0, 42.46, 0, 1, 0.65, 'brother-tn04-mg', 'TSRB102M', 'http://tonersales,eu/shop/1108/brother-tn04-mg,jpg', 0, '0', '<p>Brother HL-2700CN , MFC-9420CN</p>', '<p>6600     5%     : Brother HL-2700CN , MFC-9420CN</p>'),
	(201, '1', ' BROTHER TN04 YL', 1, 42.46, 0, 1, 0.65, 'brother-tn04-yl', 'TSRB103Y', 'http://tonersales,eu/shop/1109/brother-tn04-yl,jpg', 0, '0', 'Brother HL-2700CN , MFC-9420CN', '6600     5%               :  Brother HL-2700CN , MFC-9420CN'),
	(202, '1', ' BROTHER TN1700', 0, 63.12, 0, 1, 0.65, '#NAME?', 'TSTN1700', 'http://tonersales,eu/shop/1110/-brother-tn1700,jpg', 0, '0', '<p>Brother HL-8050N , HL8050</p>', '<p>17000     5%     : Brother HL-8050N , HL8050</p>'),
	(204, '1', ' SAMSUNG CLP-300 BK (CLP-K300 , ELS)', 1, 8.83, 0, 1, 0.65, 'samsung-clp-300-bk-clp-k300-els', 'TSFS225B', 'http://tonersales,eu/shop/486/samsung-clp-300-bk-clp-k300-els,jpg', 0, '0', 'SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN', '2000     5%               :  SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN'),
	(205, '1', ' SAMSUNG CLP-300 CY (CLP-C300 , ELS)', 0, 8.83, 0, 1, 0.65, 'samsung-clp-300-cy-clp-c300-els', 'TSFS226C', 'http://tonersales,eu/shop/487/samsung-clp-300-cy-clp-c300-els,jpg', 0, '0', '<p>SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN</p>', '<p>1000     5%     : SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN</p>'),
	(206, '1', ' SAMSUNG CLP-300 YL (CLP-Y300 , ELS)', 1, 8.83, 0, 1, 0.65, 'samsung-clp-300-yl-clp-y300-els', 'TSFS227Y', 'http://tonersales,eu/shop/488/samsung-clp-300-yl-clp-y300-els,jpg', 0, '0', 'SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN', '1000     5%               :  SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN'),
	(207, '1', ' SAMSUNG CLP-300 MG (CLP-M300 , ELS)', 0, 8.83, 0, 1, 0.65, 'samsung-clp-300-mg-clp-m300-els', 'TSFS228M', 'http://tonersales,eu/shop/489/samsung-clp-300-mg-clp-m300-els,jpg', 0, '0', '<p>SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN</p>', '<p>1000     5%     : SAMSUNG CLP-300 , 300N SAMSUNG CLX-2160 , 2160N , 2161K , 2161NK , 3160N , 3160FN</p>'),
	(208, '1', ' SAMSUNG CLP-350 BK', 0, 13.72, 0, 104, 0.65, 'samsung-clp-350-bk', 'TSFS328B', 'http://tonersales,eu/shop/490/samsung-clp-350-bk,jpg', 0, '0', '<p>Samsung CLP-350N</p>', '<p>4000     5%     : Samsung CLP-350N</p>'),
	(209, '1', ' SAMSUNG CLP-350 CY', 0, 13.72, 0, 104, 0.65, 'samsung-clp-350-cy', 'TSFS329C', 'http://tonersales,eu/shop/491/samsung-clp-350-cy,jpg', 0, '0', '<p>Samsung CLP-350N</p>', '<p>2000     5%     : Samsung CLP-350N</p>'),
	(210, '1', ' SAMSUNG CLP-350 MG', 0, 13.72, 0, 104, 0.65, 'samsung-clp-350-mg', 'TSFS330M', 'http://tonersales,eu/shop/492/samsung-clp-350-mg,jpg', 0, '0', '<p>Samsung CLP-350N</p>', '<p>2000     5%     : Samsung CLP-350N</p>'),
	(211, '1', ' SAMSUNG CLP-350 YL', 0, 13.72, 0, 102, 0.65, 'samsung-clp-350-yl', 'TSFS331Y', 'http://tonersales,eu/shop/493/samsung-clp-350-yl,jpg', 0, '0', '<p>Samsung CLP-350N</p>', '<p>2000     5%     : Samsung CLP-350N</p>'),
	(212, '1', ' SAMSUNG SCX-4100 , ML-1510 , 1710', 53, 16.43, 0, 101, 0.65, 'samsung-scx-4100-ml-1510-1710', 'TSFS364B2', 'http://tonersales,eu/shop/168/samsung-scx-4100-ml-1510-1710,jpg', 0, '0', '<p>SAMSUNG ML-1500 , 1755 , 1745 SAMSUNG SCX-4100 LEXMARK X215</p>', '<p>3000     5%     : SAMSUNG ML-1500 , 1755 , 1745 SAMSUNG SCX-4100 LEXMARK X215</p>'),
	(213, '1', ' SAMSUNG ML-1610/ML-2010/SCX4521', 53, 15.53, 0, 119, 0.65, '-samsung-ml-1610ml-2010scx4521', 'TSFS237B', 'http://tonersales,eu/shop/166/-samsung-ml-1610ml-2010scx4521,jpg', 0, '0', '<p>Samsung ML-1610/1615/1620/1625, ML-2010/2015/2020, SCX-4321/4521</p>', '<p>3000     5%     : Samsung ML1610/1615/1620/1625, ML2010/2015/2020, SCX4321/4521</p>'),
	(214, '1', ' SAMSUNG ML-1710 ,  SF-D560RA', 53, 16.43, 0, 50, 0.65, 'universal-samsung-ml-1710-sf-d560ra', 'TSFS364B', 'http://tonersales,eu/shop/169/universal-samsung-ml-1710-sf-d560ra,jpg', 0, '0', '<p>Samsung ML1500 , ML1510 , ML1520 , 1520P , ML1755 , ML1710 , ML1740 , ML1745 , ML1750 Samsung SCX4016 , SCX4100 , SCX4116 , SCX4216 , 4216F Xerox Workcentre PE16 Xerox WorkCentre PE114E Xerox 3115 , 3116 , 3120 , 3121 , 3130 Samsung SF560R , 560RC , SF565RN , Lexmark X215</p>', '<p>3000     5%     : Samsung ML1500 , ML1510 , ML1520 , 1520P , ML1755 , ML1710 , ML1740 , ML1745 , ML1750 Samsung SCX4016 , SCX4100 , SCX4116 , SCX4216 , 4216F Xerox Workcentre PE16 Xerox WorkCentre PE114E Xerox 3115 , 3116 , 3120 , 3121 , 3130 Samsung SF560R , 560RC , SF565RN , Lexmark X215</p>'),
	(215, '1', ' SAMSUNG SCX-4623 ,  ML-1910 (D105L ,  D1052L) HY', 53, 15.26, 0, 136, 0.65, 'samsung-scx-4623-ml-1910-d105l-d1052l-hy', 'TSFS1910B', 'http://tonersales,eu/shop/173/samsung-scx-4623-ml-1910-d105l-d1052l-hy,jpg', 0, '0', '<p>SAMSUNG ML-1910 , 1915 , 2525 , 2525W , , 2540 , 2545 , 2580N SAMSUNG SCX-4600 , 4623F , 4623FN , SF-650 , SF-650 P , SF-655R</p>', '<p>2500     5%     : SAMSUNG ML-1910 , 1915 , 2525 , 2525W , , 2540 , 2545 , 2580N SAMSUNG SCX-4600 , 4623F , 4623FN , SF-650 , SF-650 P , SF-655R</p>'),
	(216, '1', ' SAMSUNG SCX-4200 BK (SCX-D4200A)', 1, 22.04, 0, 1, 0.65, 'samsung-scx-4200-bk-scx-d4200a', 'TSFS215B', 'http://tonersales,eu/shop/494/samsung-scx-4200-bk-scx-d4200a,jpg', 0, '0', 'Samsung SCX-4200', '3000     5%               :  Samsung SCX-4200'),
	(217, '1', ' SAMSUNG ML-1660 , 1665 (D104S , D1042S)', 53, 12.1, 0, 122, 0.65, '#NAME?', 'TSFS1660B', 'http://tonersales,eu/shop/88/-samsung-ml-1660-1665-d104s-d1042s,jpg', 0, '0', '<p>ML1660 , 1665 , 1670 , 1675 , 1860 , 1865 , 1865W , SAMSUNG SCX-3200 , 3201 , 3205 , 3210 , 3217 , 3218</p>', '<p>1500     5%     : ML1660 , 1665 , 1670 , 1675 , 1860 , 1865 , 1865W , SAMSUNG SCX-3200 , 3201 , 3205 , 3210 , 3217 , 3218</p>'),
	(218, '1', ' SAMSUNG SCX-4300 BK', 53, 17.11, 0, 106, 0.65, 'samsung-scx-4300-bk', 'TSFS340B', 'http://tonersales,eu/shop/90/samsung-scx-4300-bk,jpg', 0, '0', '<p>Samsung SCX4300 MLTD109S</p>', '<p>2000     5%     : Samsung SCX4300 MLTD109S</p>'),
	(219, '1', ' SAMSUNG CLP-310 BK K4092S', 53, 15.21, 0, 1, 0.65, 'samsung-clp-310-bk-k4092s', 'TSFS310B', 'http://tonersales,eu/shop/194/samsung-clp-310-bk-k4092s,jpg', 0, '0', '<p>Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>', '<p>1500     5%     : Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>'),
	(220, '1', ' SAMSUNG CLP-310 CY C4092S', 53, 15.73, 0, 1, 0.65, 'samsung-clp-310-cy-c4092s', 'TSFS310C', 'http://tonersales,eu/shop/195/samsung-clp-310-cy-c4092s,jpg', 0, '0', '<p>Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>', '<p>1000     5%     : Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>'),
	(221, '1', ' SAMSUNG CLP-310 YL Y4092S', 53, 15.73, 0, 1, 0.65, 'samsung-clp-310-yl-y4092s', 'TSFS310Y', 'http://tonersales,eu/shop/196/samsung-clp-310-yl-y4092s,jpg', 0, '0', '<p>Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>', '<p>1000     5%     : Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>'),
	(222, '1', ' SAMSUNG CLP-310 MG M4092S', 53, 15.73, 0, 1, 0.65, 'samsung-clp-310-mg-m4092s', 'TSFS310M', 'http://tonersales,eu/shop/197/samsung-clp-310-mg-m4092s,jpg', 0, '0', '<p>Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>', '<p>1000     5%     : Samsung CLP310N , 315 , CLX3170 , 3175 , 3175K , 3175FNK</p>'),
	(223, '1', ' SAMSUNG CLP-320 BK K4072S', 53, 15.21, 0, 1, 0.65, 'samsung-clp-320-bk-k4072s', 'TSFS320B', 'http://tonersales,eu/shop/190/samsung-clp-320-bk-k4072s,jpg', 0, '0', '<p>SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>', '<p>1500     5%     : SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>'),
	(224, '1', ' SAMSUNG CLP-320 CY K4072S', 53, 15.21, 0, 1, 0.65, 'samsung-clp-320-cy-k4072s', 'TSFS320C', 'http://tonersales,eu/shop/191/samsung-clp-320-cy-k4072s,jpg', 0, '0', '<p>SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>', '<p>1000     5%     : SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>'),
	(225, '1', ' SAMSUNG CLP-320 MG K4072S', 53, 15.21, 0, 1, 0.65, 'samsung-clp-320-mg-k4072s', 'TSFS320M', 'http://tonersales,eu/shop/192/samsung-clp-320-mg-k4072s,jpg', 0, '0', '<p>SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>', '<p>1000     5%     : SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>'),
	(226, '1', ' SAMSUNG CLP-320 YL K4072S', 53, 15.21, 0, 1, 0.65, 'samsung-clp-320-yl-k4072s', 'TSFS320Y', 'http://tonersales,eu/shop/193/samsung-clp-320-yl-k4072s,jpg', 0, '0', '<p>SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>', '<p>1000     5%     : SAMSUNG CLP320 , 325 , 320N , 325W CLX31085 , 3185FN , 3180</p>'),
	(227, '1', ' SAMSUNG SCX-4725 BK', 1, 24.94, 0, 1, 0.65, 'samsung-scx-4725-bk', 'TSFS223B', 'http://tonersales,eu/shop/495/samsung-scx-4725-bk,jpg', 0, '0', 'Samsung SCX-4725F , 4725FN', '3000     5%               :  Samsung SCX-4725F , 4725FN'),
	(228, '1', ' SAMSUNG ML-1210D3 UNV BK (SF5100 , ML4300 , ML1210)', 53, 17.12, 0, 1, 0.65, 'samsung-ml-1210d3-unv-bk-sf5100-ml4300-ml1210', 'TSFS203B', 'http://tonersales,eu/shop/496/samsung-ml-1210d3-unv-bk-sf5100-ml4300-ml1210,jpg', 0, '0', '<p>Samsung ML-1010 , 1020M , 1210 , 1220M , 1250 , 1430 ,SF-515 , 530 , 531P , 535E ,SF-5100 , 5100P ,Msys-5100p ,ML-808 Xerox Phaser 3110 , 3210 , WorkCentre Pro 580 Lexmark E210</p>', '<p>3000     5%     : Samsung ML-1010 , 1020M , 1210 , 1220M , 1250 , 1430 ,SF-515 , 530 , 531P , 535E ,SF-5100 , 5100P ,Msys-5100p ,ML-808 Xerox Phaser 3110 , 3210 , WorkCentre Pro 580 Lexmark E210</p>'),
	(229, '1', ' SAMSUNG MLT-D101S ML-2160', 53, 11.85, 0, 130, 0.65, 'samsung-mlt-d101s-ml-2160', 'TS1331370540', 'http://tonersales,eu/shop/82/samsung-mlt-d101s-ml-2160,jpg', 0, '0', '<p>ML-2160 , ML-2162 , ML-2165 , Ml-2165W , ML-2168 SCX-3400 , SCX-3400F , SCX-3405 , SCX-3405F , SCX-3405FW , SCX-3405W SF-760P</p>', '<p>1500     5%     : ML-2160 , ML-2162 , ML-2165 , Ml-2165W , ML-2168 SCX-3400 , SCX-3400F , SCX-3405 , SCX-3405F , SCX-3405FW , SCX-3405W SF-760P</p>'),
	(230, '1', ' SAMSUNG ML-2250 UNV BK (ML-2250D5)', 0, 25.9, 0, 1, 0.65, 'samsung-ml-2250-unv-bk-ml-2250d5', 'TSFS206B', 'http://tonersales,eu/shop/497/samsung-ml-2250-unv-bk-ml-2250d5,jpg', 0, '0', '<p>Samsung ML-2250 , 2251N , 2251NP , 2252W Dell 1600 , 1600N</p>', '<p>5000     5%     : Samsung ML-2250 , 2251N , 2251NP , 2252W Dell 1600 , 1600N</p>'),
	(231, '1', ' SAMSUNG ML-2850 BK HY', 53, 20.36, 0, 102, 0.65, 'samsung-ml-2850-bk-hy', 'TSRS034B', 'http://tonersales,eu/shop/175/samsung-ml-2850-bk-hy,jpg', 0, '0', '<p>Samsung ML-2850D , ML-2851ND</p>', '<p>5000     5%     : Samsung ML-2850D , ML-2851ND</p>'),
	(232, '1', ' SAMSUNG SCX-4720 HY BK', 0, 26.48, 0, 1, 0.65, 'samsung-scx-4720-hy-bk', 'TSFS221B', 'http://tonersales,eu/shop/498/samsung-scx-4720-hy-bk,jpg', 0, '0', '<p>Samsung SCX-4520 , 4720F , 4720FN , 4720</p>', '<p>5000     5%     : Samsung SCX-4520 , 4720F , 4720FN , 4720</p>'),
	(233, '1', ' SAMSUNG MLT-D103L (High Volume)', 53, 21.7, 0, 103, 0.65, 'samsung-mlt-d103l-high-volume', 'TS1331378940', 'http://tonersales,eu/shop/89/samsung-mlt-d103l-high-volume,jpg', 0, '0', '<p>SAMSUNG ML-2950 , ML-2951ND , ML-2955 scx-4726 , SCX-4728FD , SCX-4729FD , SCX-4729FW , SCX-4705 , SCX-4727 , SCX-4728 , SCX-4729</p>', '<p>2500     5%     : SAMSUNG ML-2950 , ML-2951ND , ML-2955 scx-4726 , SCX-4728FD , SCX-4729FD , SCX-4729FW , SCX-4705 , SCX-4727 , SCX-4728 , SCX-4729</p>'),
	(234, '1', ' SAMSUNG ML-3050B BK (HY)', 1, 28.37, 0, 1, 0.65, 'samsung-ml-3050b-bk-hy', 'TSRS027B', 'http://tonersales,eu/shop/500/samsung-ml-3050b-bk-hy,jpg', 0, '0', 'Samsung ML-3050 , 3051N , 3051ND , ML-D3050B', '8000     5%               :  Samsung ML-3050 , 3051N , 3051ND , ML-D3050B'),
	(235, '1', ' SAMSUNG MLT-D111S', 53, 12.86, 0, 144, 0.65, 'samsung-mlt-d111s', 'TS13315646**', 'http://tonersales,eu/shop/84/samsung-mlt-d111s,jpg', 0, '0', '<p>SAMSUNG Xpress M2020 , M2020W , M2022 , M2022W , M2070 , M2070W , M2070F , M2070FW , M2026</p>', '<p>1,000     5%     : SAMSUNG Xpress M2020 , M2020W , M2022 , M2022W , M2070 , M2070W , M2070F , M2070FW , M2026</p>'),
	(236, '1', ' SAMSUNG ML-D3470B', 0, 29.5, 0, 101, 0.65, 'samsung-ml-d3470b', 'TSRS044B', 'http://tonersales,eu/shop/87/samsung-ml-d3470b,jpg', 0, '0', '<p>SAMSUNG ML3470 , 3470D , ML3470ND , 3471 , 3471D , 3471ND , 3472 , 3475</p>', '<p>10000     5%     : SAMSUNG ML3470 , 3470D , ML3470ND , 3471 , 3471D , 3471ND , 3472 , 3475</p>'),
	(237, '1', ' SAMSUNG SCX-4824 MLT-D2092L HY', 53, 21.48, 0, 1, 0.65, 'samsung-scx-4824-mlt-d2092l-hy', 'TSFS4824B', 'http://tonersales,eu/shop/174/samsung-scx-4824-mlt-d2092l-hy,jpg', 0, '0', '<p>SCX4824 , SCX-4825 , SCX-4826 , SCX-4828FN , SCX-4829 , ML-2855</p>', '<p>5000     5%     : SCX4824 , SCX-4825 , SCX-4826 , SCX-4828FN , SCX-4829 , ML-2855</p>'),
	(238, '1', ' SAMSUNG ML-3310 ,  ML-3710 ,  SCX-4833 ,  5637 ,  5737 MLT-D205L', 1, 30.87, 0, 1, 0.65, 'samsung-ml-3310-ml-3710-scx-4833-5637-5737-mlt-d205l', 'TS13313755**', 'http://tonersales,eu/shop/499/samsung-ml-3310-ml-3710-scx-4833-5637-5737-mlt-d205l,jpg', 0, '0', 'Samsung SCX4833FD , 4833FR , 4933 , 5637FR , 5737FW , 4835FD , 4835FR , 5639FR , 5739FW , ML3310D , 3310ND , 3710N , 3710D , 3710ND , 3710DW', '5000     5%               :  Samsung SCX4833FD , 4833FR , 4933 , 5637FR , 5737FW , 4835FD , 4835FR , 5639FR , 5739FW , ML3310D , 3310ND , 3710N , 3710D , 3710ND , 3710DW'),
	(239, '1', ' SAMSUNG MLT-D117S', 53, 29.41, 0, 106, 0.65, '#NAME?', 'TS13315614', 'http://tonersales,eu/shop/176/-samsung-mlt-d117s,jpg', 0, '0', '<p>Samsung SCX-4650F , 4650N , 4652F , 4655F , 4655FN</p>', '<p>2500     5%     : Samsung SCX-4650F , 4650N , 4652F , 4655F , 4655FN</p>'),
	(240, '1', ' SAMSUNG MLT-D111L', 0, 17.9, 0, 126, 0.65, 'samsung-mlt-d111l', 'TS', 'http://tonersales,eu/shop/501/samsung-mlt-d111l,jpg', 0, '0', '<p>SAMSUNG Xpress M2020 , M2020W , M2022 , M2022W , M2070 , M2070W , M2070F , M2070FW , M2026</p>', '<p>1800     5%     : SAMSUNG Xpress M2020 , M2020W , M2022 , M2022W , M2070 , M2070W , M2070F , M2070FW , M2026</p>'),
	(241, '1', ' SAMSUNG SCX-D5530 BK', 1, 32.26, 0, 1, 0.65, 'samsung-scx-d5530-bk', 'TSRS046B', 'http://tonersales,eu/shop/502/samsung-scx-d5530-bk,jpg', 0, '0', 'Samsung SCX-5530FN , SCX-5330N', '8000     5%               :  Samsung SCX-5530FN , SCX-5330N'),
	(242, '1', ' SAMSUNG CLT-K406S', 53, 22.22, 0, 109, 0.65, 'samsung-clt-k406s', 'TS13315231**', 'http://tonersales,eu/shop/64/samsung-clt-k406s,jpg', 0, '0', '<p>SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>', '<p>1500     5%     : SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>'),
	(243, '1', ' SAMSUNG CLT-C406S', 53, 22.22, 0, 114, 0.65, 'samsung-clt-c406s', 'TS13315232**', 'http://tonersales,eu/shop/65/samsung-clt-c406s,jpg', 0, '0', '<p>SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>', '<p>1000     5%     : SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>'),
	(244, '1', ' SAMSUNG CLT-Y406S', 53, 22.22, 0, 113, 0.65, 'samsung-clt-y406s', 'TS13315233**', 'http://tonersales,eu/shop/67/samsung-clt-y406s,jpg', 0, '0', '<p>SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>', '<p>1000     5%     : SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>'),
	(245, '1', ' SAMSUNG CLT-M406S', 53, 22.22, 0, 115, 0.65, 'samsung-clt-m406s', 'TS13315234**', 'http://tonersales,eu/shop/66/samsung-clt-m406s,jpg', 0, '0', '<p>SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>', '<p>1000     5%     : SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>'),
	(246, '1', ' SAMSUNG SCX-5635 , ML-3475 (D208L)', 0, 33.13, 0, 101, 0.65, '#NAME?', 'TSFS5635BK', 'http://tonersales,eu/shop/503/-samsung-scx-5635-ml-3475-d208l,jpg', 0, '0', '<p>SAMSUNG ML-1635 , 3475 , 3475D , 3475ND SCX-5635FNK , 5635FN , 5635HN , 5835</p>', '<p>10000     5%     : SAMSUNG ML-1635 , 3475 , 3475D , 3475ND SCX-5635FNK , 5635FN , 5635HN , 5835</p>'),
	(247, '1', ' SAMSUNG ML-3710 ,  SCX-5637 ,  5737 MLT-D205E Extra High Volume', 1, 33.82, 0, 1, 0.65, 'samsung-ml-3710-scx-5637-5737-mlt-d205e-extra-high-volume', 'TS13313765**', 'http://tonersales,eu/shop/504/samsung-ml-3710-scx-5637-5737-mlt-d205e-extra-high-volume,jpg', 0, '0', 'SAMSUNG ML-3710 , SCX-5637 , 5737', '10000     5%               :  SAMSUNG ML-3710 , SCX-5637 , 5737'),
	(248, '1', ' SAMSUNG ML-1630 BK (ML-D1630A)', 1, 34.2, 0, 1, 0.65, 'samsung-ml-1630-bk-ml-d1630a', 'TSFS326B', 'http://tonersales,eu/shop/505/samsung-ml-1630-bk-ml-d1630a,jpg', 0, '0', 'Samsung ML-1630 , SCX-4500', '2500     5%               :  Samsung ML-1630 , SCX-4500'),
	(249, '1', ' SAMSUNG MLT-D116L', 53, 13.71, 0, 130, 0.65, 'samsung-mlt-d116l', 'TS13315619**', 'http://tonersales,eu/shop/83/samsung-mlt-d116l,jpg', 0, '0', '<p>SAMSUNG M2625 , M2626D , M2675 , M2676N , M2676FH , M2825 , M2826ND , M2835 , M2875 , M2876HN , M2885</p>', '<p>3000     5%     : SAMSUNG M2625 , M2626D , M2675 , M2676N , M2676FH , M2825 , M2826ND , M2835 , M2875 , M2876HN , M2885</p>'),
	(250, '1', ' SAMSUNG MLT-D305L (High Volume)', 0, 38.6, 0, 1, 0.65, '#NAME?', 'TS13315215**', 'http://tonersales,eu/shop/506/-samsung-mlt-d305l-high-volume,jpg', 0, '0', '<p>SAMSUNG ML-3750D , 3750ND</p>', '<p>15000     5%     : SAMSUNG ML-3750D , 3750ND</p>'),
	(251, '1', ' SAMSUNG ML-6060 BK', 0, 38.7, 0, 1, 0.65, 'samsung-ml-6060-bk', 'TSRS029B', 'http://tonersales,eu/shop/507/samsung-ml-6060-bk,jpg', 0, '0', '<p>Samsung ML-1440 , 1450 , 1451N , 6040 , 6060 , 6060N , 6060S , IBM InfoPrint 12 , NEC SuperScript 1400 , Xerox Docuprint P1210</p>', '<p>6000     5%     : Samsung ML-1440 , 1450 , 1451N , 6040 , 6060 , 6060N , 6060S , IBM InfoPrint 12 , NEC SuperScript 1400 , Xerox Docuprint P1210</p>'),
	(252, '1', ' SAMSUNG ML-2150 BK', 0, 44.77, 0, 1, 0.65, 'samsung-ml-2150-bk', 'TSRS019B', 'http://tonersales,eu/shop/508/samsung-ml-2150-bk,jpg', 0, '0', '<p>Samsung ML-2150 , 2151N , 2152W , ML-2550 , 2551N , 2552W (ML-2550DA , 10K)</p>', '<p>8000     5%     : Samsung ML-2150 , 2151N , 2152W , ML-2550 , 2551N , 2552W (ML-2550DA , 10K)</p>'),
	(253, '1', ' SAMSUNG CLT-K504S , ELS Black toner', 53, 36.95, 0, 1, 0.65, '#NAME?', 'TS13315267**', 'http://tonersales,eu/shop/178/-samsung-clt-k504s-els-black-toner,jpg', 0, '0', '<p>SAMSUNG CLP-415 SAMSUNG CLX-4195</p>', '<p>2500     5%     : SAMSUNG CLP-415 SAMSUNG CLX-4195</p>'),
	(254, '1', ' SAMSUNG CLT-C504S , ELS Cyan toner', 53, 36.95, 0, 1, 0.65, '-samsung-clt-c504s-els-cyan-toner', 'TS13315268**', 'http://tonersales,eu/shop/179/-samsung-clt-c504s-els-cyan-toner,jpg', 0, '0', '<p>SAMSUNG CLP-415 SAMSUNG CLX-4195</p>', '<p>1800     5%     : SAMSUNG CLP-415 SAMSUNG CLX-4195</p>'),
	(255, '1', ' SAMSUNG CLT-M504S , ELS magenta toner', 53, 36.95, 0, 1, 0.65, '#NAME?', 'TS13315269**', 'http://tonersales,eu/shop/180/-samsung-clt-m504s-els-magenta-toner,jpg', 0, '0', '<p>SAMSUNG CLP-415 SAMSUNG CLX-4195</p>', '<p>1800     5%     : SAMSUNG CLP-415 SAMSUNG CLX-4195</p>'),
	(256, '1', ' SAMSUNG CLT-Y504S , ELS Yellow toner', 53, 36.95, 0, 1, 0.65, '#NAME?', 'TS13315270**', 'http://tonersales,eu/shop/181/-samsung-clt-y504s-els-yellow-toner,jpg', 0, '0', '<p>SAMSUNG CLP-415 SAMSUNG CLX-4195</p>', '<p>1800     5%     : SAMSUNG CLP-415 SAMSUNG CLX-4195</p>'),
	(257, '1', ' SAMSUNG MLT-D204L High Volume', 53, 37.5, 0, 103, 0.65, 'samsung-mlt-d204l-high-volume', 'TS13315625**', 'http://tonersales,eu/shop/177/samsung-mlt-d204l-high-volume,jpg', 0, '0', '<p>SAMSUNG ProXpress SL-M3325 , M3375 , M3825 , M3875 , M4025 , M4075</p>', '<p>5000     5%     : SAMSUNG ProXpress SL-M3325 , M3375 , M3825 , M3875 , M4025 , M4075</p>'),
	(258, '1', ' SAMSUNG CLT-K5082L BK HY', 53, 45.89, 0, 1, 0.65, 'samsung-clt-k5082l-bk-hy', 'TS13315209**', 'http://tonersales,eu/shop/186/samsung-clt-k5082l-bk-hy,jpg', 0, '0', '<p>SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>', '<p>5000     5%     : SAMSUNG CLP-620ND , CLP-670ND CLX-6220FX , CLX-6250FX</p>'),
	(259, '1', ' SAMSUNG ML-3560 BK HY', 0, 54.91, 0, 1, 0.65, 'samsung-ml-3560-bk-hy', 'TSRS030B', 'http://tonersales,eu/shop/511/samsung-ml-3560-bk-hy,jpg', 0, '0', '<p>Samsung ML-3560D , 3560DN</p>', '<p>12000     5%     : Samsung ML-3560D , 3560DN</p>'),
	(260, '1', ' SAMSUNG CLT-C5082L CY HY', 53, 45.89, 0, 102, 0.65, 'samsung-clt-c5082l-cy-hy', 'TS13315210**', 'http://tonersales,eu/shop/187/samsung-clt-c5082l-cy-hy,jpg', 0, '0', '<p>SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>', '<p>4000     5%     : SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>'),
	(261, '1', ' SAMSUNG CLT-M5082L MG HY', 53, 45.89, 0, 1, 0.65, 'samsung-clt-m5082l-mg-hy', 'TS13315211**', 'http://tonersales,eu/shop/188/samsung-clt-m5082l-mg-hy,jpg', 0, '0', '<p>SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>', '<p>4000     5%     : SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>'),
	(262, '1', ' SAMSUNG CLT-Y5082L YL HY', 53, 45.89, 0, 1, 0.65, 'samsung-clt-y5082l-yl-hy', 'TS13315212**', 'http://tonersales,eu/shop/189/samsung-clt-y5082l-yl-hy,jpg', 0, '0', '<p>SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>', '<p>4000     5%     : SAMSUNG CLP-620ND , CLP-670N CLX-6220FX , CLX-6250FX</p>'),
	(263, '1', ' SAMSUNG MLT-D204E Extra High Volume', 53, 41.18, 0, 101, 0.65, 'samsung-mlt-d204e-extra-high-volume', 'TS13315626**', 'http://tonersales,eu/shop/2050/samsung-mlt-d204e-extra-high-volume,jpg', 0, '0', '<p>SAMSUNG ProXpress SL-M3825 , M3875 , M4025 , M4075</p>', '<p>10000     5%     : SAMSUNG ProXpress SL-M3825 , M3875 , M4025 , M4075</p>'),
	(264, '1', ' SAMSUNG CLT-C505L CYAN', 0, 56.54, 0, 1, 0.65, '-samsung-clt-c505l-cyan', 'TSTFS791C', 'http://tonersales,eu/shop/2049/-samsung-clt-c505l-cyan,jpg', 0, '0', '<p>Samsung SL-C2620DW , C2670FW</p>', '<p>3500     5%     : Samsung SL-C2620DW , C2670FW</p>'),
	(265, '1', ' SAMSUNG CLT-Y505L YELLOW', 0, 56.54, 0, 1, 0.65, '#NAME?', 'TSTFS792Y', 'http://tonersales,eu/shop/2047/-samsung-clt-y505l-yellow,jpg', 0, '0', '<p>Samsung SL-C2620DW , C2670FW</p>', '<p>3500     5%     : Samsung SL-C2620DW , C2670FW</p>'),
	(266, '1', ' SAMSUNG CLT-M505L MAGENTA', 0, 56.54, 0, 1, 0.65, '#NAME?', 'TSTFS793M', 'http://tonersales,eu/shop/2048/-samsung-clt-m505l-magenta,jpg', 0, '0', '<p>Samsung SL-C2620DW , C2670FW</p>', '<p>3500     5%     : Samsung SL-C2620DW , C2670FW</p>'),
	(267, '1', ' SAMSUNG CLT-K505L BLACK', 0, 59.11, 0, 1, 0.65, '#NAME?', 'TSTFS790B', 'http://tonersales,eu/shop/2046/-samsung-clt-k505l-black,jpg', 0, '0', '<p>Samsung SL-C2620DW , C2670FW</p>', '<p>6000     5%     : Samsung SL-C2620DW , C2670FW</p>'),
	(268, '1', ' SAMSUNG MLT-D204U Ultra High Volume', 1, 59.31, 0, 1, 0.65, 'samsung-mlt-d204u-ultra-high-volume', 'TS13315633**', 'http://tonersales,eu/shop/517/samsung-mlt-d204u-ultra-high-volume,jpg', 0, '0', 'SAMSUNG ProXpress SL-M4025  , M4075', '15000     5%               :  SAMSUNG ProXpress SL-M4025  , M4075'),
	(269, '1', ' SAMSUNG CLT-K506L', 53, 39.95, 0, 1, 0.65, 'samsung-clt-k506l', 'TS13315263**', 'http://tonersales,eu/shop/182/samsung-clt-k506l,jpg', 0, '0', '<p>SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>', '<p>6000     5%     : SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>'),
	(270, '1', ' SAMSUNG CLT-C506L', 53, 39.95, 0, 1, 0.65, 'samsung-clt-c506l', 'TS13315264**', 'http://tonersales,eu/shop/183/samsung-clt-c506l,jpg', 0, '0', '<p>SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>', '<p>3500     5%     : SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>'),
	(271, '1', ' SAMSUNG CLT-M506L', 53, 39.95, 0, 1, 0.65, 'samsung-clt-m506l', 'TS13315265**', 'http://tonersales,eu/shop/184/samsung-clt-m506l,jpg', 0, '0', '<p>SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>', '<p>3500     5%     : SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>'),
	(272, '1', ' SAMSUNG CLT-Y506L', 53, 39.95, 0, 1, 0.65, 'samsung-clt-y506l', 'TS13315266**', 'http://tonersales,eu/shop/185/samsung-clt-y506l,jpg', 0, '0', '<p>SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>', '<p>3500     5%     : SAMSUNG CLP-680 , 680DW , 680DN SAMSUNG CLX-6260FR , 6260FD , 6260FW , 6260ND , 6260NR</p>'),
	(273, '1', ' SAMSUNG CLP-510 BK HY (CLP-510D7K)', 0, 60.13, 0, 1, 0.65, 'samsung-clp-510-bk-hy-clp-510d7k', 'TSFS250B', 'http://tonersales,eu/shop/2043/samsung-clp-510-bk-hy-clp-510d7k,jpg', 0, '0', '<p>Samsung CLP-510 , CLP-510N</p>', '<p>7000     5%     : Samsung CLP-510 , CLP-510N</p>'),
	(274, '1', ' SAMSUNG CLP-510 CY HY (CLP-510D5C , ELS)', 0, 60.13, 0, 1, 0.65, 'samsung-clp-510-cy-hy-clp-510d5c-els', 'TSFS251C', 'http://tonersales,eu/shop/2042/samsung-clp-510-cy-hy-clp-510d5c-els,jpg', 0, '0', '<p>Samsung CLP-510 , CLP-510N</p>', '<p>5000     5%     : Samsung CLP-510 , CLP-510N</p>'),
	(275, '1', ' SAMSUNG CLP-510 MG HY (CLP-510D5M , ELS)', 0, 60.13, 0, 1, 0.65, 'samsung-clp-510-mg-hy-clp-510d5m-els', 'TSFS252M', 'http://tonersales,eu/shop/2044/samsung-clp-510-mg-hy-clp-510d5m-els,jpg', 0, '0', '<p>Samsung CLP-510 , CLP-510N</p>', '<p>5000     5%     : Samsung CLP-510 , CLP-510N</p>'),
	(276, '1', ' SAMSUNG CLP-510 YL HY (CLP-510D5Y , ELS)', 0, 60.13, 0, 1, 0.65, 'samsung-clp-510-yl-hy-clp-510d5y-els', 'TSFS253Y', 'http://tonersales,eu/shop/2045/samsung-clp-510-yl-hy-clp-510d5y-els,jpg', 0, '0', '<p>Samsung CLP-510 , CLP-510N</p>', '<p>5000     5%     : Samsung CLP-510 , CLP-510N</p>'),
	(277, '1', ' SAMSUNG CLT-K6092S BK', 0, 60.18, 0, 1, 0.65, 'samsung-clt-k6092s-bk', 'TS13315259**', 'http://tonersales,eu/shop/522/samsung-clt-k6092s-bk,jpg', 0, '0', '<p>SAMSUNG CLP-770ND , CLP-775ND</p>', '<p>7000     5%     : SAMSUNG CLP-770ND , CLP-775ND</p>'),
	(278, '1', ' SAMSUNG CLT-C6092S CY', 1, 60.18, 0, 1, 0.65, 'samsung-clt-c6092s-cy', 'TS13315260**', 'http://tonersales,eu/shop/523/samsung-clt-c6092s-cy,jpg', 0, '0', 'SAMSUNG CLP-770ND  ,  CLP-775ND', '7000     5%               :  SAMSUNG CLP-770ND  ,  CLP-775ND'),
	(279, '1', ' SAMSUNG CLT-M6092S MG', 0, 60.18, 0, 1, 0.65, 'samsung-clt-m6092s-mg', 'TS13315261**', 'http://tonersales,eu/shop/524/samsung-clt-m6092s-mg,jpg', 0, '0', '<p>SAMSUNG CLP-770ND , CLP-775ND</p>', '<p>7000     5%     : SAMSUNG CLP-770ND , CLP-775ND</p>'),
	(280, '1', ' SAMSUNG CLT-Y6092S YL', 0, 60.18, 0, 1, 0.65, 'samsung-clt-y6092s-yl', 'TS13315262**', 'http://tonersales,eu/shop/525/samsung-clt-y6092s-yl,jpg', 0, '0', '<p>SAMSUNG CLP-770ND , CLP-775ND</p>', '<p>7000     5%     : SAMSUNG CLP-770ND , CLP-775ND</p>'),
	(281, '1', ' SAMSUNG MLT-D203L', 0, 62.04, 0, 101, 0.65, '#NAME?', 'TS13315622**', 'http://tonersales,eu/shop/86/-samsung-mlt-d203l,jpg', 0, '0', '<p>SAMSUNG ProXpress SL-M3320 , M3370 , M3820 , M3870 , M4020 , M4070</p>', '<p>5000     5%     : SAMSUNG ProXpress SL-M3320 , M3370 , M3820 , M3870 , M4020 , M4070</p>'),
	(282, '1', ' SAMSUNG MLT-D307E (Extra High Volume)', 0, 62.46, 0, 1, 0.65, '#NAME?', 'TS13315258**', 'http://tonersales,eu/shop/526/-samsung-mlt-d307e-extra-high-volume,jpg', 0, '0', '<p>Samsung ML-4510ND , ml-5010ND , ml-5015ND</p>', '<p>20000     5%     : Samsung ML-4510ND , ml-5010ND , ml-5015ND</p>'),
	(283, '1', ' SAMSUNG ML-D4550B BK', 1, 63.12, 0, 1, 0.65, 'samsung-ml-d4550b-bk', 'TSRS033B', 'http://tonersales,eu/shop/527/samsung-ml-d4550b-bk,jpg', 0, '0', 'Samsung ML-4550 , ML-4551 , ML-4050 Series', '20000     5%               :  Samsung ML-4550 , ML-4551 , ML-4050 Series'),
	(284, '1', ' SAMSUNG CLP-K660 Black (High Capacity)', 0, 66.99, 0, 1, 0.65, '#NAME?', 'TSTRS073B', 'http://tonersales,eu/shop/2041/-samsung-clp-k660-black-high-capacity,jpg', 0, '0', '<p>Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>', '<p>5500     5%     : Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>'),
	(285, '1', ' SAMSUNG CLP-C660 Cyan (High Capacity)', 0, 66.99, 0, 1, 0.65, '#NAME?', 'TSTRS074C', 'http://tonersales,eu/shop/2038/-samsung-clp-c660-cyan-high-capacity,jpg', 0, '0', '<p>Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>', '<p>5000     5%     : Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>'),
	(286, '1', ' SAMSUNG CLP-M660 Magenta (High Capacity)', 0, 66.99, 0, 1, 0.65, '#NAME?', 'TSTRS075M', 'http://tonersales,eu/shop/2040/-samsung-clp-m660-magenta-high-capacity,jpg', 0, '0', '<p>Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>', '<p>5000     5%     : Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>'),
	(287, '1', ' SAMSUNG CLP-Y660 Yellow (High Capacity)', 0, 66.99, 0, 1, 0.65, '#NAME?', 'TSTRS076Y', 'http://tonersales,eu/shop/2039/-samsung-clp-y660-yellow-high-capacity,jpg', 0, '0', '<p>Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>', '<p>5000     5%     : Samsung CLP-610ND , CLP-660N , 660ND , CLX-6200 , CLX-6210FX , CLX-6240</p>'),
	(288, '1', ' SAMSUNG MLT-D203E', 0, 67.04, 0, 1, 0.65, '#NAME?', 'TS13315623**', 'http://tonersales,eu/shop/532/-samsung-mlt-d203e,jpg', 0, '0', '<p>SAMSUNG ProXpress SL-M3820 , M3870 , M4020 , M4070</p>', '<p>10000     5%     : SAMSUNG ProXpress SL-M3820 , M3870 , M4020 , M4070</p>'),
	(289, '1', ' SAMSUNG MLT-D203U', 0, 73.64, 0, 1, 0.65, '#NAME?', 'TS13315632**', 'http://tonersales,eu/shop/533/-samsung-mlt-d203u,jpg', 0, '0', '<p>SAMSUNG ProXpress SL-M4020 , M4070</p>', '<p>15000     5%     : SAMSUNG ProXpress SL-M4020 , M4070</p>'),
	(290, '1', ' SAMSUNG MLT-D309L HY', 0, 92.02, 0, 1, 0.65, '#NAME?', 'TS13315669**', 'http://tonersales,eu/shop/534/-samsung-mlt-d309l-hy,jpg', 0, '0', '<p>SAMSUNG ML-5510N , 5510ND , ML-6510ND</p>', '<p>30000     5%     : SAMSUNG ML-5510N , 5510ND , ML-6510ND</p>'),
	(291, '1', ' CANON NP1215 (NPG-1) 1372A005 , 002', 0, 10.93, 0, 1, 0.65, 'canon-np1215-npg-1-1372a005-002', 'TSFC001B**A', 'http://tonersales,eu/shop/602/canon-np1215-npg-1-1372a005-002,jpg', 0, '0', '<p>Canon NP1015 , 1215 , 1215s , 1218 , 1318 , 1510 , 1520 , 1530 , 1550 , 1820 , 2010 , 2020 , 2120 , 6020 , 6115 , 6116 , 6216 , 6220 , 6221 , 6226 , 6317 , 6318 , 6416 , 6320</p>', '<p>3800     5%     : Canon NP1015 , 1215 , 1215s , 1218 , 1318 , 1510 , 1520 , 1530 , 1550 , 1820 , 2010 , 2020 , 2120 , 6020 , 6115 , 6116 , 6216 , 6220 , 6221 , 6226 , 6317 , 6318 , 6416 , 6320</p>'),
	(293, '1', ' CANON CRG 725', 53, 8.91, 0, 115, 0.65, '#NAME?', 'TS13310790AR', 'http://tonersales,eu/shop/97/-canon-crg-725,jpg', 0, '0', '<p>CANON LBP6000, LBP6018, LBP6020, MF3010, MF3100</p>', '<p>1600     5%     : CANON LBP6000, LBP6018, LBP6020, MF3010, MF3100</p>'),
	(294, '1', ' CANON NP6012 (NPG-11) BK', 0, 13.97, 0, 1, 0.65, 'canon-np6012-npg-11-bk', 'TSFC102B', 'http://tonersales,eu/shop/603/canon-np6012-npg-11-bk,jpg', 0, '0', '<p>Canon NP6012 , 6012F , 6112 , 6312 , 6212 , 6412 , 6512 , 6612 , 7120 , 7130 Olivetti Lexikon COPIA 8512</p>', '<p>5000     5%     : Canon NP6012 , 6012F , 6112 , 6312 , 6212 , 6412 , 6512 , 6612 , 7120 , 7130 Olivetti Lexikon COPIA 8512</p>'),
	(295, '1', ' CANON IR2016 , IR1600 (EXV14 , EXV5 , NPG-28) HY GPR-18 0384B006', 53, 11.46, 0, 1, 0.65, 'canon-ir2016-ir1600-exv14-exv5-npg-28-hy-gpr-18-0384b006', 'TSFC129B', 'http://tonersales,eu/shop/165/canon-ir2016-ir1600-exv14-exv5-npg-28-hy-gpr-18-0384b006,jpg', 0, '0', '<p>Canon IR1600 , IR1610F , IR2000 , IR2010F , IR2016 , 2016i , IR2018 , 2018i , IR2020 , 2020i , IR2022 , 2022i , IR2025i , IR2030i , IR2318L , IR2420</p>', '<p>8300     5%     : Canon IR1600 , IR1610F , IR2000 , IR2010F , IR2016 , 2016i , IR2018 , 2018i , IR2020 , 2020i , IR2022 , 2022i , IR2025i , IR2030i , IR2318L , IR2420</p>'),
	(296, '1', ' CANON NP6016 (NPG-9) BK', 0, 15.24, 0, 1, 0.65, 'canon-np6016-npg-9-bk', 'TSFC103B', 'http://tonersales,eu/shop/605/canon-np6016-npg-9-bk,jpg', 0, '0', '<p>Canon NP6016 , 6218 , 6521 , 6621 Olivetti Lexikon COPIA 8021 Triumph-Adler TA3021</p>', '<p>7600     5%     : Canon NP6016 , 6218 , 6521 , 6621 Olivetti Lexikon COPIA 8021 Triumph-Adler TA3021</p>'),
	(297, '1', ' CANON NP6030 (NPG-7 , NPG-13) 1377A003', 0, 15.24, 0, 1, 0.65, 'canon-np6030-npg-7-npg-13-1377a003', 'TSFC100B', 'http://tonersales,eu/shop/606/canon-np6030-npg-7-npg-13-1377a003,jpg', 0, '0', '<p>Canon NP6025 , 6030 , 6330 ,NP6028 , 6035 , 6230</p>', '<p>10000     5%     : Canon NP6025 , 6030 , 6330 ,NP6028 , 6035 , 6230</p>'),
	(298, '1', ' CANON NP7163 C-EXV6 , NPG-15', 0, 15.35, 0, 1, 0.65, 'canon-np7163-c-exv6-npg-15', 'TSFC130B', 'http://tonersales,eu/shop/607/canon-np7163-c-exv6-npg-15,jpg', 0, '0', '<p>Canon NP7160 , 7161 , 7163 , 7164 , 7210 , 7214</p>', '<p>7600     5%     : Canon NP7160 , 7161 , 7163 , 7164 , 7210 , 7214</p>'),
	(299, '1', ' CANON IR1210 (C-EXV7)', 0, 15.35, 0, 1, 0.65, 'canon-ir1210-c-exv7', 'TSFC126B', 'http://tonersales,eu/shop/609/canon-ir1210-c-exv7,jpg', 0, '0', '<p>Canon IR1200 , IR1210 , IR1230 , IR1237N , IR1270 , IR1310 , IR1330 , IR1370F , IR1510 , IR1530 , IR1630 , IR1670</p>', '<p>5300     5%     : Canon IR1200 , IR1210 , IR1230 , IR1237N , IR1270 , IR1310 , IR1330 , IR1370F , IR1510 , IR1530 , IR1630 , IR1670</p>'),
	(300, '1', ' CANON CRG-137, 337, 737', 53, 7.66, 0, 115, 0.65, '#NAME?', 'TS13315927**', 'http://tonersales,eu/shop/139/-canon-crg-137-337-737,jpg', 0, '0', '<p>Canon i-SENSYS MF211w , MF212w , MF216n , MF217w , MF226dn , MF229dw</p>', '<p>1500     5%     : Canon i-SENSYS MF211w , MF212w , MF216n , MF217w , MF226dn , MF229dw</p>'),
	(301, '1', ' CANON CRG-737, CANON 337', 0, 15.59, 0, 1, 0.65, '#NAME?', 'TS', 'http://tonersales,eu/shop/610/-canon-crg-737-canon-337,jpg', 0, '0', '<p>Canon i-SENSYS MF-211 , MF-212W , MF-216N , MF-217W , MF-226DN , MF-229DW</p>', '<p>2400     5%     : Canon i-SENSYS MF-211 , MF-212W , MF-216N , MF-217W , MF-226DN , MF-229DW</p>'),
	(302, '1', ' CANON 104 , FX9 , FX10', 53, 8.9, 0, 104, 0.65, '#NAME?', 'TSRH190B', 'http://tonersales,eu/shop/2220/-canon-104-fx9-fx10,jpg', 0, '0', '<p>Canon L100, L160, L200, MF4010, MF4110, MF4130, MF4132, MF4330D, MF4380D, MF4690, L120, L90, L95, MF4018, MF4120, MF4140, MF4340D, MF4370D, MF4660PL, LBP2900, L140, PCD440, PCD450, MF4150, MF4122, MF4270, MF4320D, MF4350D, MF4690PL, LBP3000</p>', '<p>2000     5%     :Canon L100, L160, L200, MF4010, MF4110, MF4130, MF4132, MF4330D, MF4380D, MF4690, L120, L90, L95, MF4018, MF4120, MF4140, MF4340D, MF4370D, MF4660PL, LBP2900, L140, PCD440, PCD450, MF4150, MF4122, MF4270, MF4320D, MF4350D, MF4690PL, LBP3000</p>'),
	(303, '1', ' CANON IR400 (GPR-2) C-EXV43', 0, 18.66, 0, 1, 0.65, 'canon-ir400-gpr-2-c-exv43', 'TSFC121B', 'http://tonersales,eu/shop/611/canon-ir400-gpr-2-c-exv43,jpg', 0, '0', '<p>Canon IR330 , IR400 , IR500</p>', '<p>10000     5%     : Canon IR330 , IR400 , IR500</p>'),
	(304, '1', ' CANON CRG308/508/708, CRG315/715', 53, 9.8, 0, 50, 0.65, '#ERROR!', 'TSRH244AB', 'http://tonersales,eu/shop/126/-canon-crg308508708-crg315715,jpg', 0, '0', '<p>Canon LBP3300/3360, LBP3310/3370</p>', '<p>2500     5%     :Canon LBP3300/3360, LBP3310/3370</p>'),
	(306, '1', ' CANON CRG128/328/728/326/726', 53, 10.6, 0, 50, 0.65, '#ERROR!', 'TSRH278B', 'http://tonersales,eu/shop/137/-canon-crg128328728326726,jpg', 0, '0', '<p>CANONimage class MF 4400, 4410, 4420, 4120, 4412, 4452, 4450, 4550, 4570, D520</p>', '<p>2500     5%     :CANONimage class MF 4400, 4410, 4420, 4120, 4412, 4452, 4450, 4550, 4570, D520</p>'),
	(307, '1', ' CANON CRG-337, 737', 53, 13.49, 0, 50, 0.65, '#NAME?', 'TS13318303AR', 'http://tonersales,eu/shop/99/-canon-crg-337-737,jpg', 0, '0', '<p>Canon i-SENSYS MF211w , MF212w , MF216n , MF217w , MF226dn , MF229dw</p>', '<p>2500     5%     : Canon i-SENSYS MF211w , MF212w , MF216n , MF217w , MF226dn , MF229dw</p>'),
	(308, '1', ' CANON CRG329/729/129 BLACK', 53, 12.82, 0, 101, 0.65, '#ERROR!', 'TSRH310ABK', 'http://tonersales,eu/shop/3/-canon-crg329729129-black,jpg', 0, '0', '<p><span>CANON LBP 7010C/7018C</span></p>', '<p>1000     5%     :<span>CANON LBP 7010C/7018C</span></p>'),
	(309, '1', ' CANON CRG329/729/129 CYAN', 53, 12.82, 0, 101, 0.65, '#ERROR!', 'TSRH311ACY', 'http://tonersales,eu/shop/1948/-canon-crg329729129-cyan,jpg', 0, '0', '<p>CANON LBP 7010C/7018C</p>', '<p>1000     5%     : CANON LBP 7010C/7018C</p>'),
	(310, '1', ' CANON CRG329/729/129 YELLOW', 53, 12.82, 0, 105, 0.65, '#ERROR!', 'TSRH312AYL', 'http://tonersales,eu/shop/9/-canon-crg329729129-yellow,jpg', 0, '0', '<p>CANON LBP 7010C/7018C</p>', '<p>1000     5%     : CANON LBP 7010C/7018C</p>'),
	(311, '1', ' CANON CRG329/729/129 MAGENTA', 53, 12.82, 0, 105, 0.65, '#ERROR!', 'TSRH313AMG', 'http://tonersales,eu/shop/12/-canon-crg329729129-magenta,jpg', 0, '0', '<p>CANON LBP 7010C/7018C</p>', '<p>1000     5%     : CANON LBP 7010C/7018C</p>'),
	(312, '1', ' CANON FX3  1557A003', 0, 18.84, 0, 115, 0.65, 'canon-fx3-1557a003', 'TSRC116B', 'http://tonersales,eu/shop/608/canon-fx3-1557a003,jpg', 0, '0', '<p>Canon FAX-L75 , L200 , L220 , L240 , L250 , L260 , L280 , L290 , L295 , L300 , L350 , L2050 , L2060 , L3500 , L4000 , L4500 Canon Laser Class 1100 , 2200 , 2060 , 4000 , 4500 Canon Multipass L60 , L90 , L6000</p>', '<p>2700     5%     : Canon FAX-L75 , L200 , L220 , L240 , L250 , L260 , L280 , L290 , L295 , L300 , L350 , L2050 , L2060 , L3500 , L4000 , L4500 Canon Laser Class 1100 , 2200 , 2060 , 4000 , 4500 Canon Multipass L60 , L90 , L6000</p>'),
	(313, '1', ' CANON EP26 , EP27 , X25 , CART UNV 8489A002', 0, 18.84, 0, 112, 0.65, 'canon-ep26-ep27-x25-cart-unv-8489a002', 'TSRC147B', 'http://tonersales,eu/shop/612/canon-ep26-ep27-x25-cart-unv-8489a002,jpg', 0, '0', '<p>Canon Laser Shot LBP1840 , LBP2140 , LBP3100 , LBP3200 , LBP3225 , LBP4418K Canon imageCLASS MF3100 , MF3110 , MF3220 , MF3240 , MF5630 , MF5650 , MF5730 , MF5750 , MF5770 Canon LaserBase MF3228</p>', '<p>2500     5%     : Canon Laser Shot LBP1840 , LBP2140 , LBP3100 , LBP3200 , LBP3225 , LBP4418K Canon imageCLASS MF3100 , MF3110 , MF3220 , MF3240 , MF5630 , MF5650 , MF5730 , MF5750 , MF5770 Canon LaserBase MF3228</p>'),
	(314, '1', ' CANON GP-200 (GP-215) 1388A002', 1, 18.84, 0, 1, 0.65, 'canon-gp-200-gp-215-1388a002', 'TSFC122B', 'http://tonersales,eu/shop/613/canon-gp-200-gp-215-1388a002,jpg', 0, '0', 'Canon GP200 , 200F , 211 , 215 , 216 , 220 , 225 , 285 , 334 , 335 , 405 ,IR200 , 210 , 210S , 210N', '8000     5%               :  Canon GP200 , 200F , 211 , 215 , 216 , 220 , 225 , 285 , 334 , 335 , 405 ,IR200 , 210 , 210S , 210N'),
	(315, '1', ' CANON NP3025  , NP3000 BK 2PC 1363A003', 0, 18.84, 0, 1, 0.65, 'canon-np3025-np3000-bk-2pc-1363a003', 'TSFC006B**A', 'http://tonersales,eu/shop/2147/canon-np3025-np3000-bk-2pc-1363a003,jpg', 0, '0', '<p>Canon NP3000 , 3025 , 3025F , 3225 , 3225F , 3525 , 3525F , 3525EF , 3725 , 3725F , 3725EF</p>', '<p>5000     5%     : Canon NP3000 , 3025 , 3025F , 3225 , 3225F , 3525 , 3525F , 3525EF , 3725 , 3725F , 3725EF</p>'),
	(316, '1', ' CANON NP3825 BK 2PC', 1, 18.84, 0, 1, 0.65, 'canon-np3825-bk-2pc', 'TSFC109B**A', 'http://tonersales,eu/shop/615/canon-np3825-bk-2pc,jpg', 0, '0', 'Canon NP3325 , 3825 , 3825II', '7000     5%               :  Canon NP3325 , 3825 , 3825II'),
	(317, '1', ' CANON NP4050 (NPG-4) BK', 1, 18.84, 0, 1, 0.65, 'canon-np4050-npg-4-bk', 'TSFC004B', 'http://tonersales,eu/shop/616/canon-np4050-npg-4-bk,jpg', 0, '0', 'Canon NP4030 , 4050 , 4080 , 6241 Olivetti Lexikon COPIA 8040', '15000     5%               :  Canon NP4030 , 4050 , 4080 , 6241 Olivetti Lexikon COPIA 8040'),
	(318, '1', ' CANON IR1018 ( C-EXV18) 0386B002', 1, 18.84, 0, 1, 0.65, 'canon-ir1018-c-exv18-0386b002', 'TSFC131B', 'http://tonersales,eu/shop/617/canon-ir1018-c-exv18-0386b002,jpg', 0, '0', 'IR1018 , 1018J , IR1019 , IR1022A , 1022F , 1022I , 1022iF , IR1023 , 1023N , 1023iF , IR1024', '8400     5%               :  IR1018 , 1018J , IR1019 , IR1022A , 1022F , 1022I , 1022iF , IR1023 , 1023N , 1023iF , IR1024'),
	(320, '1', ' CANON FX8', 53, 12.9, 0, 122, 0.65, '#NAME?', 'TSRC145B', 'http://tonersales,eu/shop/161/-canon-fx8,jpg', 0, '0', '<p>Canon D300, D360, L380, L400, MF3240, D320, D383, L380S, 310, D340, L170, L390, 510</p>', '<p>3500     5%     : CanonD300, D360, L380, L400, MF3240, D320, D383, L380S, 310, D340, L170, L390, 510</p>'),
	(322, '1', ' CANON EP22', 53, 13.11, 0, 50, 0.65, '#NAME?', 'TSRH137B', 'http://tonersales,eu/shop/120/-canon-ep22,jpg', 0, '0', '<p>Canon LB200, LBP250, LBP810, LBP350, LBP1110, LB800, LBP1120, LBP5585, PHOTOCOPIER P420, PHOTOCOPIER LBP P420</p>', '<p>2500     5%     :Canon LB200, LBP250, LBP810, LBP350, LBP1110, LB800, LBP1120, LBP5585, PHOTOCOPIER P420, PHOTOCOPIER LBP P420</p>'),
	(323, '1', ' HP Q7553X (HP 53X BLACK)', 53, 13.66, 0, 103, 0.65, '-hp-q7553x-hp-53x-black', 'TSRH244B', 'http://tonersales,eu/shop/2288/-hp-q7553x-hp-53x-black,jpg', 0, '0', '<p>HP LaserJet 2012, P2014, P2015, P2015dn, M2727nfs, 2013, P2014d, P2015n, P2015x, P2014dn, P2015d, M2727nf</p>', '<p>7000     5%     :HP LaserJet 2012, P2014, P2015, P2015dn, M2727nfs, 2013, P2014d, P2015n, P2015x, P2014dn, P2015d, M2727nf</p>'),
	(324, '1', ' CANON CRG119/319II/519H/719H', 53, 10.32, 0, 50, 0.65, '#NAME?', 'TSRH505B', 'http://tonersales,eu/shop/102/-canon-crg119319ii519h719h,jpg', 0, '0', '<p><span>CANON i-SENSYS LBP 6300/6650/MF5870dn</span></p>', '<p>2100     5%     :CANON i-SENSYS LBP 6300/6650/MF5870dn</p>'),
	(325, '1', ' HP CE505X (HP 05X BLACK)', 53, 13.8, 0, 105, 0.65, '-hp-ce505x-hp-05x-black', 'TS13315110', 'http://tonersales,eu/shop/2289/-hp-ce505x-hp-05x-black,jpg', 0, '0', '<p>HP LaserJet P2050, P2053d, P2054, P2055d, P2055x, P2055dn, P2056d, P2057n</p>', '<p>6800     5%     :HP LaserJet P2050, P2053d, P2054, P2055d, P2055x, P2055dn, P2056d, P2057n</p>'),
	(326, '1', ' CANON IR2200 C-EXV3 GPR-6 6647A002', 53, 19.35, 0, 1, 0.65, 'canon-ir2200-c-exv3-gpr-6-6647a002', 'TSFC123B', 'http://tonersales,eu/shop/164/canon-ir2200-c-exv3-gpr-6-6647a002,jpg', 0, '0', '<p>Canon IR2200 , IR2220N , 2220I , IR2800 , IR3300 , IR3320N , 3320I , IR3300E , 3300EN</p>', '<p>15000     5%     : Canon IR2200 , IR2220N , 2220I , IR2800 , IR3300 , IR3320N , 3320I , IR3300E , 3300EN</p>'),
	(327, '1', ' CANON 1510A002AA , EP-83', 0, 21.79, 0, 1, 0.65, '-canon-1510a002aa-ep-83', 'TSRH150B', 'http://tonersales,eu/shop/2148/-canon-1510a002aa-ep-83,jpg', 0, '0', '<p>Canon LBP-2040 , 2050</p>', '<p>9000     5%     : Canon LBP-2040, 2050</p>'),
	(328, '1', ' CANON EP25', 53, 12.01, 0, 50, 0.65, '#NAME?', 'TSRH188B', 'http://tonersales,eu/shop/118/-canon-ep25,jpg', 0, '0', '<p>CANON LBP-1210</p>', '<p>4000     5%     :CANON LBP-1210</p>'),
	(329, '1', ' CANON FX2', 1, 23.56, 0, 1, 0.65, 'canon-fx2', 'TSTRC115B', 'http://tonersales,eu/shop/618/canon-fx2,jpg', 0, '0', 'Canon Fax L500 , L550 , L600 , Canon LaserClass 5000 , 5500 , 7000 , 7100 , 7500 , 7700', '3350     5%               :  Canon Fax L500 , L550 , L600 , Canon LaserClass 5000 , 5500 , 7000 , 7100 , 7500 , 7700'),
	(330, '1', ' CANON C-EXV33 GPR-35 Toner Copier', 0, 23.56, 0, 1, 0.65, '-canon-c-exv33-gpr-35-toner-copier', 'TS13310263', 'http://tonersales,eu/shop/619/-canon-c-exv33-gpr-35-toner-copier,jpg', 0, '0', '<p>CANON IR2520 , 2520i , IR2525 , 2525i , IR2530 , 2530i</p>', '<p>14600     5%     : CANON IR2520 , 2520i , IR2525 , 2525i , IR2530 , 2530i</p>'),
	(331, '1', ' CANON EP-87 BLACK', 53, 31.16, 0, 1, 0.65, '#NAME?', 'TSRH239B', 'http://tonersales,eu/shop/141/-canon-ep-87-black,jpg', 0, '0', '<p>Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>', '<p>5000     5%     :Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>'),
	(332, '1', ' CANON EP-87 CYAN', 53, 26.15, 0, 1, 0.65, '#NAME?', 'TSRH240C', 'http://tonersales,eu/shop/1960/-canon-ep-87-cyan,jpg', 0, '0', '<p>Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>', '<p>4000     5%     :Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>'),
	(333, '1', ' CANON EP-87 YELLOW', 53, 26.15, 0, 1, 0.65, '#NAME?', 'TSRH241Y', 'http://tonersales,eu/shop/145/-canon-ep-87-yellow,jpg', 0, '0', '<p>Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>', '<p>4000     5%     :Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>'),
	(334, '1', ' CANON EP-87 MAGENTA', 53, 26.15, 0, 1, 0.65, '#NAME?', 'TSRH242M', 'http://tonersales,eu/shop/147/-canon-ep-87-magenta,jpg', 0, '0', '<p>Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>', '<p>4000     5%     : Canon LBP 2410, LBP 5200, ImageClass MF8180C</p>'),
	(335, '1', ' CANON 716/416/731 CYAN', 53, 16.05, 0, 50, 0.65, '#NAME?', 'TSTRHF13C', 'http://tonersales,eu/shop/29/-canon-716416731-cyan,jpg', 0, '0', '<p><span>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080Cw</span></p>', '<p>1400     5%     :<span>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080Cw</span></p>'),
	(336, '1', ' CANON 716/416/731 YELLOW', 53, 13.23, 0, 50, 0.65, '0', 'TSTRHF14Y', '0', 0, '0', '<p>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080Cw</p>', '0'),
	(337, '1', ' CANON 716/416/731 MAGENTA', 53, 16.05, 0, 50, 0.65, '#NAME?', 'TSTRHF15M', 'http://tonersales,eu/shop/33/-canon-716416731-magenta,jpg', 0, '0', '<p><span>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080CW</span></p>', '<p>1400     5%     :<span>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080CW</span></p>'),
	(338, '1', ' CANON 716/416/731 BLACK', 53, 13.23, 0, 50, 0.65, '#NAME?', 'TSTRHF12B', 'http://tonersales,eu/shop/27/-canon-716416731-black,jpg', 0, '0', '<p><span>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080CW</span></p>', '<p><span><span>2200     5%     :</span>CANON i-SENSYS LBP8030, i-SENSYS LBP5050, i-SENSYS MF8030Cn, i-SENSYS MF8040CN, i-SENSYS LBP8030CN,i -SENSYS LBP5050N, i-SENSYS MF8050Cn, i-SENSYS MF8080CW</span></p>'),
	(339, '1', ' CANON CRG118/318/718 BLACK', 53, 18.81, 0, 50, 0.65, '#NAME?', 'TSRH500B', 'http://tonersales,eu/shop/1958/-canon-crg118318718-black,jpg', 0, '0', '<p><span>Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</span></p>', '<p><span>2800     5%     :Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</span></p>'),
	(340, '1', ' CANON CRG118/318/718 CYAN', 53, 17.7, 0, 50, 0.65, '#NAME?', 'TSRH501C', 'http://tonersales,eu/shop/1899/-canon-crg118318718-cyan,jpg', 0, '0', '<p><span>Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</span></p>', '<p><span>2800     5%     :Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</span></p>'),
	(341, '1', ' CANON CRG118/318/718 YELLOW', 53, 17.7, 0, 50, 0.65, '#NAME?', 'TSRH502Y', 'http://tonersales,eu/shop/1955/-canon-crg118318718-yellow,jpg', 0, '0', '<p><span>Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</span></p>', '<p><span>2800     5%     :Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</span></p>'),
	(342, '1', ' CANON CRG118/318/718 MAGENTA', 53, 17.7, 0, 50, 0.65, '#NAME?', 'TSRH503M', 'http://tonersales,eu/shop/1953/-canon-crg118318718-magenta,jpg', 0, '0', '<p>Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</p>', '<p>2800     5%     :Canon imageCLASS MF8330C, MF8350Cdn, MF8550 Canon i-SENSYS LBP-7200Cdn</p>'),
	(344, '1', ' CANON E30 ,  E31 ,  E40 1491A003', 53, 24.15, 0, 115, 0.65, 'canon-e30-e31-e40-1491a003', 'TSRC140B', 'http://tonersales,eu/shop/162/canon-e30-e31-e40-1491a003,jpg', 0, '0', '<p>Canon FC100 , FC108 , FC120 , FC128 , FC200 , FC200S , FC204 , FC204S , FC206 , FC208 , FC210 , FC220 , FC224 , FC226 , FC228 , FC230 , FC298 , FC300 , FC310 , FC320 , FC325 , FC330 , FC330L , FC336 , FC400 , FC 420 , FC430 , FC530 , FC550 Canon PC300 , PC310 , PC320 , PC325 , PC330 , PC400 , PC420 , PC430 , PC530 , PC550 , PC710 , PC720 , PC740 , PC745 , PC750 , PC760 , PC770 , PC780 , PC790 , PC795 , PC860 , PC880 , PC890 , PC920 , PC921 , PC950 , PC980</p>', '<p>3000     5%     : Canon FC100 , FC108 , FC120 , FC128 , FC200 , FC200S , FC204 , FC204S , FC206 , FC208 , FC210 , FC220 , FC224 , FC226 , FC228 , FC230 , FC298 , FC300 , FC310 , FC320 , FC325 , FC330 , FC330L , FC336 , FC400 , FC 420 , FC430 , FC530 , FC550 Canon PC300 , PC310 , PC320 , PC325 , PC330 , PC400 , PC420 , PC430 , PC530 , PC550 , PC710 , PC720 , PC740 , PC745 , PC750 , PC760 , PC770 , PC780 , PC790 , PC795 , PC860 , PC880 , PC890 , PC920 , PC921 , PC950 , PC980</p>'),
	(345, '1', ' CANON IR2270 (EXV11 , EXV12 , NPG-25) 9629A002', 1, 28.29, 0, 13, 0.65, 'canon-ir2270-exv11-exv12-npg-25-9629a002', 'TSFC128B', 'http://tonersales,eu/shop/620/canon-ir2270-exv11-exv12-npg-25-9629a002,jpg', 0, '0', 'Canon IR2270 , IR2870 , IR2230 , IR2830 , IR3025 , IR3225 , IR3530 , IR3570 , IR4570 , IR3035 , 3035N , IR3045 , 3045N , IR3235', '24000     5%               :  Canon IR2270 , IR2870 , IR2230 , IR2830 , IR3025 , IR3225 , IR3530 , IR3570 , IR4570 , IR3035 , 3035N , IR3045 , 3045N , IR3235'),
	(346, '1', ' CANON C-EXV32 GPR-34 2786B002', 0, 28.29, 0, 1, 0.65, '-canon-c-exv32-gpr-34-2786b002', 'TS11500100', 'http://tonersales,eu/shop/621/-canon-c-exv32-gpr-34-2786b002,jpg', 0, '0', '<p>Canon iR2535 , IR2545</p>', '<p>19000     5%     : Canon iR2535 , IR2545</p>'),
	(347, '1', ' CANON C-EXV37', 0, 28.29, 0, 1, 0.65, '-canon-c-exv37', 'TS11500110', 'http://tonersales,eu/shop/695/-canon-c-exv37,jpg', 0, '0', '<p>Canon IR1730 , ir1740 , ir1750</p>', '<p>15100     5%     : Canon IR1730 , ir1740 , ir1750</p>'),
	(349, '1', ' CANON 707 BLACK', 53, 20, 0, 50, 0.65, '#NAME?', 'TSRH275B', 'http://tonersales,eu/shop/51/-canon-707-black,jpg', 0, '0', '<p>Canon LBP 5000, LBP 5100</p>', '<p>2500     5%     :Canon LBP 5000, LBP 5100</p>'),
	(350, '1', ' CANON 707 CYAN', 53, 20, 0, 50, 0.65, '#NAME?', 'TSRH276C', 'http://tonersales,eu/shop/53/-canon-707-cyan,jpg', 0, '0', '<p>Canon LBP 5000, LBP 5100</p>', '<p>2000     5%     :Canon LBP 5000, LBP 5100</p>'),
	(351, '1', ' CANON 707 YELLOW', 53, 20, 0, 50, 0.65, '#NAME?', 'TSRH277Y', 'http://tonersales,eu/shop/55/-canon-707-yellow,jpg', 0, '0', '<p>Canon LBP 5000, LBP 5100</p>', '<p>2000     5%     :Canon LBP 5000, LBP 5100</p>'),
	(352, '1', ' CANON 707 MAGENTA', 53, 20, 0, 50, 0.65, '#NAME?', 'TSRH278M', 'http://tonersales,eu/shop/57/-canon-707-magenta,jpg', 0, '0', '<p>Canon LBP 5000, LBP 5100</p>', '<p>2000     5%     : Canon LBP 5000, LBP 5100</p>'),
	(353, '1', ' CANON 724H', 53, 24.19, 0, 50, 0.65, '-canon-724h', 'TSRH255B', 'http://tonersales,eu/shop/134/-canon-724h,jpg', 0, '0', '<p>CANON i-SENSYS LBP6750dn/LBP6780x/MF512x/MF515</p>', '<p>12500     5%     :CANON i-SENSYS LBP6750dn/LBP6780x/MF512x/MF515</p>'),
	(354, '1', ' CANON EP-VX JUMBO', 0, 32.13, 0, 1, 0.65, '#NAME?', 'TSRH111B', 'http://tonersales,eu/shop/375/-canon-ep-vx-jumbo,jpg', 0, '0', '<p>Canon LaserClass 9000</p>', '<p>6000     5%     : Canon LaserClass 9000</p>'),
	(355, '1', ' CANON FX7  7621A002', 1, 33, 0, 1, 0.65, 'canon-fx7-7621a002', 'TSRC132B', 'http://tonersales,eu/shop/622/canon-fx7-7621a002,jpg', 0, '0', 'Canon LaserClass LC710 , LC720i , LC730i ,Canon FAX-L2000 , FAX-L2000IP', '4500     5%               :  Canon LaserClass LC710 , LC720i , LC730i ,Canon FAX-L2000 , FAX-L2000IP'),
	(356, '1', ' CANON 106 , CANON 706 0264B002', 0, 33, 0, 1, 0.65, 'canon-106-canon-706-0264b002', 'TSRC161B', 'http://tonersales,eu/shop/623/canon-106-canon-706-0264b002,jpg', 0, '0', '<p>Canon imageCLASS MF6540 , MF6590 , MF6595 , MF6595CX , MF6530 , MF6550 , MF6560 , 6580 ,i-SENSYS MF6530 , MF6540PL , MF6550 , MF6560PL , MF6580PL</p>', '<p>5000     5%     : Canon imageCLASS MF6540 , MF6590 , MF6595 , MF6595CX , MF6530 , MF6550 , MF6560 , 6580 ,i-SENSYS MF6530 , MF6540PL , MF6550 , MF6560PL , MF6580PL</p>'),
	(357, '1', ' CANON NP6045 (NPG-14) 1385A001', 0, 33, 0, 1, 0.65, 'canon-np6045-npg-14-1385a001', 'TSFC117B', 'http://tonersales,eu/shop/2146/canon-np6045-npg-14-1385a001,jpg', 0, '0', '<p>Canon NP6045 , 6545 , 6551 , 6560 , 6251 , 6260</p>', '<p>30000     5%     : Canon NP6045 , 6545 , 6551 , 6560 , 6251 , 6260</p>'),
	(358, '1', ' CANON NP6050 (NPG-10) BK', 0, 33, 0, 1, 0.65, 'canon-np6050-npg-10-bk', 'TSFC118B', 'http://tonersales,eu/shop/626/canon-np6050-npg-10-bk,jpg', 0, '0', '<p>Canon NP6050</p>', '<p>30000     5%     : Canon NP6050</p>'),
	(359, '1', ' HP C4096A (HP 96A BLACK)', 53, 16.05, 0, 1, 0.65, '-hp-c4096a-hp-96a-black', 'TSRH139B', 'http://tonersales,eu/shop/121/-hp-c4096a-hp-96a-black,jpg', 0, '0', '<p>HP LaserJet 2000dtn, 2100, 2100tn, 2200dn, C7063a, 2000dt, 2100m, 2200, 2200dse, C7061a, 2100se, 2200d, 2200dt, C7058a, C7059a</p>', '<p>5000     5%     : HP LaserJet2000dtn, 2100, 2100tn, 2200dn, C7063a, 2000dt, 2100m, 2200, 2200dse, C7061a, 2100se, 2200d, 2200dt, C7058a, C7059a</p>'),
	(360, '1', ' CANON 710H (0986B001 BLACK)', 0, 31.5, 0, 50, 0.65, '-canon-710h-0986b001-black', 'TSRH265B', 'http://tonersales,eu/shop/130/-canon-710h-0986b001-black,jpg', 0, '0', '<p>Canon LBP 3460, LBP 3410</p>', '<p>12000     5%     : Canon LBP 3460,LBP3 410</p>'),
	(361, '1', ' CANON FX-6 1559A003', 0, 37.7, 0, 1, 0.65, 'canon-fx-6-1559a003', 'TSRC143B', 'http://tonersales,eu/shop/630/canon-fx-6-1559a003,jpg', 0, '0', '<p>Canon LaserClass 3170 , 3170MS , 3175 , 3175MS , LC1000 , L1000</p>', '<p>5000     5%     : Canon LaserClass 3170 , 3170MS , 3175 , 3175MS , LC1000 , L1000</p>'),
	(362, '1', ' CANON EP-52X', 0, 39.51, 0, 1, 0.65, '-canon-ep-52x', 'TSRH132B', 'http://tonersales,eu/shop/373/-canon-ep-52x,jpg', 0, '0', '<p>Canon Laser Shot LBP470 , LBP1000 , LBP1310 , LBP1760</p>', '<p>10000     5%     : Canon Laser Shot LBP470 , LBP1000 , LBP1310 , LBP1760</p>'),
	(363, '1', ' CANON 1509A002AA , EP-83', 0, 21.79, 0, 1, 0.65, '-canon-1509a002aa-ep-83', 'TSRH151C', 'http://tonersales,eu/shop/374/-canon-1509a002aa-ep-83,jpg', 0, '0', '<p>Canon LBP-2040 , 2050</p>', '<p>6000     5%     : Canon LBP-2040 , 2050</p>'),
	(364, '1', ' CANON 1508A002AA , EP-83', 0, 21.79, 0, 1, 0.65, '-canon-1508a002aa-ep-83', 'TSRH152M', 'http://tonersales,eu/shop/378/-canon-1508a002aa-ep-83,jpg', 0, '0', '<p>Canon LBP-2040 , 2050</p>', '<p>6000     5%     : Canon LBP-2040 , 2050</p>'),
	(365, '1', ' CANON 1507A002AA , EP-83', 0, 21.79, 0, 1, 0.65, '-canon-1507a002aa-ep-83', 'TSRH153Y', 'http://tonersales,eu/shop/379/-canon-1507a002aa-ep-83,jpg', 0, '0', '<p>Canon LBP-2040 , 2050</p>', '<p>6000     5%     : Canon LBP-2040 , 2050</p>'),
	(366, '1', ' CANON IR5000 C-EXV1', 0, 47.13, 0, 1, 0.65, 'canon-ir5000-c-exv1', 'TSFC108B', 'http://tonersales,eu/shop/625/canon-ir5000-c-exv1,jpg', 0, '0', '<p>Canon IR5000 , 5000i , IR6000 , 6000I , IR4600N , IR5020i , IR6020i Danka Infotec IS1050 , IS1060</p>', '<p>33000     5%     : Canon IR5000 , 5000i , IR6000 , 6000I , IR4600N , IR5020i , IR6020i Danka Infotec IS1050 , IS1060</p>'),
	(367, '1', ' CANON IRC2880 c-exv21 CY GPR-23', 0, 47.51, 0, 1, 0.65, 'canon-irc2880-c-exv21-cy-gpr-23', 'TSTFC148C', 'http://tonersales,eu/shop/2144/canon-irc2880-c-exv21-cy-gpr-23,jpg', 0, '0', '<p>Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>', '<p>14000     5%     : Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>'),
	(368, '1', ' CANON IRC2880 c-exv21 YL GPR-23', 0, 47.51, 0, 1, 0.65, 'canon-irc2880-c-exv21-yl-gpr-23', 'TSTFC149Y', 'http://tonersales,eu/shop/2143/canon-irc2880-c-exv21-yl-gpr-23,jpg', 0, '0', '<p>Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>', '<p>14000     5%     : Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>'),
	(369, '1', ' CANON IRC2880 c-exv21 MG GPR-23', 0, 47.51, 0, 1, 0.65, 'canon-irc2880-c-exv21-mg-gpr-23', 'TSTFC150M', 'http://tonersales,eu/shop/2145/canon-irc2880-c-exv21-mg-gpr-23,jpg', 0, '0', '<p>Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>', '<p>14000     5%     : Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>'),
	(370, '1', ' CANON EP-62', 0, 48.15, 0, 105, 0.65, '#NAME?', 'TSRH144B', 'http://tonersales,eu/shop/380/-canon-ep-62,jpg', 0, '0', '<p>Canon FP-300 Micrographics/FP-400 Micrographics/CG-160F/ImageCLASS 2200/2210/2220/2250/LBP-1610/1620/1810/1820/62X/840/850/870/880/910</p>', '<p>10000     5%     :Canon FP-300 Micrographics/FP-400 Micrographics/CG-160F/ImageCLASS 2200/2210/2220/2250/LBP-1610/1620/1810/1820/62X/840/850/870/880/910</p>'),
	(371, '1', ' CANON GP605 (C-EXV4)', 0, 49.58, 0, 1, 0.65, 'canon-gp605-c-exv4', 'TSFC107B', 'http://tonersales,eu/shop/631/canon-gp605-c-exv4,jpg', 0, '0', '<p>Canon GP555 , 605 , 605P , IR60 , 550 , 600 , 7200 , 105 , 8070 , 8500 , IR105 , IR8070 , IR8500</p>', '<p>33000     5%     : Canon GP555 , 605 , 605P , IR60 , 550 , 600 , 7200 , 105 , 8070 , 8500 , IR105 , IR8070 , IR8500</p>'),
	(372, '1', ' CANON 1660B001AA (CRG-111BLACK )', 0, 50.3, 0, 1, 0.65, '-canon-1660b001aa-crg-111black-', 'TSRH293B', 'http://tonersales,eu/shop/286/-canon-1660b001aa-crg-111black-,jpg', 0, '0', '<p>Canon ImageRunner LBP-5300</p>', '<p>6000     5%     :Canon ImageRunner LBP-5300</p>'),
	(373, '1', ' CANON CRG723/GPR29 CYAN', 53, 29.9, 0, 50, 0.65, '#NAME?', 'TSRH397C', 'http://tonersales,eu/shop/45/-canon-crg723gpr29-cyan,jpg', 0, '0', '<p>CANON LBP 7700C, 7750Cdn</p>', '<p>7000     5%     : CANON LBP 7700C, 7750Cdn</p>'),
	(374, '1', ' CANON CRG723/GPR29 YELLOW', 53, 29.9, 0, 50, 0.65, '#NAME?', 'TSRH398Y', 'http://tonersales,eu/shop/47/-canon-crg723gpr29-yellow,jpg', 0, '0', '<p>CANON LBP 7700C, 7750Cdn</p>', '<p>7000     5%     : CANON LBP 7700C, 7750Cdn</p>'),
	(375, '1', ' CANON CRG723/GPR29 MAGENTA', 53, 29.9, 0, 50, 0.65, '#NAME?', 'TSRH399M', 'http://tonersales,eu/shop/1962/-canon-crg723gpr29-magenta,jpg', 0, '0', '<p>CANON LBP 7700C, 7750Cdn</p>', '<p>7000     5%     : CANON LBP 7700C, 7750Cdn</p>'),
	(376, '1', ' CANON 6262B012 (332 CYAN)', 0, 50.87, 0, 50, 0.65, '-canon-6262b012-332-cyan', 'TSTRHE39C', 'http://tonersales,eu/shop/37/-canon-6262b012-332-cyan,jpg', 0, '0', '<p>Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>', '<p>6000     5%     : Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>'),
	(377, '1', ' CANON 6260B012 (332 YELLOW)', 0, 50.87, 0, 50, 0.65, '-canon-6260b012-332-yellow', 'TSTRHE40Y', 'http://tonersales,eu/shop/39/-canon-6260b012-332-yellow,jpg', 0, '0', '<p>Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>', '<p>6000     5%     : Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>'),
	(378, '1', ' CANON 6261B012 (332 MAGENTA)', 0, 50.87, 0, 50, 0.65, '-canon-6261b012-332-magenta', 'TSTRHE41M', 'http://tonersales,eu/shop/40/-canon-6261b012-332-magenta,jpg', 0, '0', '<p>Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>', '<p>6000     5%     : Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>'),
	(379, '1', ' CANON C-EXV34 BLACK 3782B002 GPR-36', 0, 51.13, 0, 1, 0.65, 'canon-c-exv34-black-3782b002-gpr-36', 'TS11500106', 'http://tonersales,eu/shop/632/canon-c-exv34-black-3782b002-gpr-36,jpg', 0, '0', '<p>CANON IR Advance C2020 , C2025 , C2030 , C2035</p>', '<p>23000     5%     : CANON IR Advance C2020 , C2025 , C2030 , C2035</p>'),
	(380, '1', ' CANON C-EXV38 , GPR-42', 0, 52.79, 0, 1, 0.65, '-canon-c-exv38-gpr-42', 'TS11500128', 'http://tonersales,eu/shop/633/-canon-c-exv38-gpr-42,jpg', 0, '0', '<p>Canon IR Advance IR4045 , I , IR4051 , I</p>', '<p>34200     5%     : Canon IR Advance IR4045 , I , IR4051 , I</p>'),
	(381, '1', ' CANON C-EXV39 , GPR-43', 0, 52.79, 0, 1, 0.65, '-canon-c-exv39-gpr-43', 'TS11500127', 'http://tonersales,eu/shop/634/-canon-c-exv39-gpr-43,jpg', 0, '0', '<p>Canon IR Advance IR4025 , I , IR4035 , I</p>', '<p>30200     5%     : Canon IR Advance IR4025 , I , IR4035 , I</p>'),
	(382, '1', ' CANON 1659B001AA ( CRG-111CYAN )', 0, 57.5, 0, 1, 0.65, '-canon-1659b001aa-crg-111cyan-', 'TSRH302C', 'http://tonersales,eu/shop/381/-canon-1659b001aa-crg-111cyan-,jpg', 0, '0', '<p>Canon LBP-5400 , LBP-5360</p>', '<p>6000     5%     : Canon LBP-5400 , LBP-5360</p>'),
	(383, '1', ' CANON 1657B001AA ( CRG-111 YELLOW )', 0, 57.5, 0, 1, 0.65, '-canon-1657b001aa-crg-111-yellow-', 'TSRH303Y', 'http://tonersales,eu/shop/382/-canon-1657b001aa-crg-111-yellow-,jpg', 0, '0', '<p>Canon LBP-5400 , LBP-5360</p>', '<p>6000     5%     : Canon LBP-5400 , LBP-5360</p>'),
	(384, '1', ' CANON 1658B001AA ( CRG-111 MAGENTA )', 0, 57.5, 0, 1, 0.65, '-canon-1658b001aa-crg-111-magenta-', 'TSRH304M', 'http://tonersales,eu/shop/383/-canon-1658b001aa-crg-111-magenta-,jpg', 0, '0', '<p>Canon LBP-5400 , LBP-5360</p>', '<p>6000     5%     : Canon LBP-5400 , LBP-5360</p>'),
	(385, '1', ' CANON IRC2880 c-exv21 BK GPR-23', 0, 54.11, 0, 1, 0.65, 'canon-irc2880-c-exv21-bk-gpr-23', 'TSTFC147B', 'http://tonersales,eu/shop/2142/canon-irc2880-c-exv21-bk-gpr-23,jpg', 0, '0', '<p>Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>', '<p>26000     5%     : Canon imageRUNNER C2380i , C2550 , 2550F , 2880 , 2880F , 2880i , 3080 , 3080F , 3080i , 3380 , 3380F , 3380i , 3480 , 3480i , 3580 , 3580i , 3880</p>'),
	(386, '1', ' CANON 6825A004AA (EP-85) BLACK', 0, 56.36, 0, 1, 0.65, '-canon-6825a004aa-ep-85-black', 'TSRH178B', 'http://tonersales,eu/shop/384/-canon-6825a004aa-ep-85-black,jpg', 0, '0', '<p>Canon LBP-2510, imageCLASS C2500/EP-85</p>', '<p>9000     5%     :Canon LBP-2510, imageCLASS C2500/EP-85</p>'),
	(387, '1', ' CANON 6824A004AA (EP-85) CYAN', 0, 56.36, 0, 1, 0.65, '-canon-6824a004aa-ep-85-cyan', 'TSRH179C', 'http://tonersales,eu/shop/385/-canon-6824a004aa-ep-85-cyan,jpg', 0, '0', '<p>Canon LBP-2510, imageCLASS C2500/EP-85</p>', '<p>8000     5%     :Canon LBP-2510, imageCLASS C2500/EP-85</p>'),
	(388, '1', ' CANON 6822A004AA (EP-85) YELLOW', 0, 56.36, 0, 1, 0.65, '-canon-6822a004aa-ep-85-yellow', 'TSRH180Y', 'http://tonersales,eu/shop/386/-canon-6822a004aa-ep-85-yellow,jpg', 0, '0', '<p>Canon LBP-2510, imageCLASS C2500/EP-85</p>', '<p>8000     5%     :Canon LBP-2510, imageCLASS C2500/EP-85</p>'),
	(389, '1', ' CANON 6823A004AA (EP-85) MAGENTA', 0, 56.36, 0, 1, 0.65, '-canon-6823a004aa-ep-85-magenta', 'TSRH181M', 'http://tonersales,eu/shop/387/-canon-6823a004aa-ep-85-magenta,jpg', 0, '0', '<p>Canon LBP-2510, imageCLASS C2500/EP-85</p>', '<p>8000     5%     : Canon LBP-2510, imageCLASS C2500/EP-85</p>'),
	(390, '1', ' CANON GP160 EP62', 0, 56.55, 0, 1, 0.65, 'canon-gp160-ep62', 'TSRC136B', 'http://tonersales,eu/shop/645/canon-gp160-ep62,jpg', 0, '0', '<p>Canon GP160 , 160F , 160PF Olivetti Lexikon COPIA 9916</p>', '<p>10000     5%     : Canon GP160 , 160F , 160PF Olivetti Lexikon COPIA 9916</p>'),
	(391, '1', ' CANON CRG723/GPR29 BLACK', 53, 34.9, 0, 50, 0.65, '#NAME?', 'TSRH396B', 'http://tonersales,eu/shop/43/-canon-crg723gpr29-black,jpg', 0, '0', '<p>CANON LBP 7700C, 7750Cdn</p>', '<p>10500     5%     : CANON LBP 7700C, 7750Cdn</p>'),
	(392, '1', ' CANON 6264B012 (332 BLACK)', 0, 43.28, 0, 50, 0.65, '-canon-6264b012-332-black', 'TSTRHE37B', 'http://tonersales,eu/shop/1964/-canon-6264b012-332-black,jpg', 0, '0', '<p>Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>', '<p>11000     5%     : Canon Laser Shot LBP7780Cx Canon imageclass LBP7780Cx Canon imageclass LBP7780Cdn Canon i-SENSYS LBP7780Cx</p>'),
	(393, '1', ' CANON C-EXV34 Cyan Toner 3783B002 GPR-36', 0, 61.26, 0, 1, 0.65, '-canon-c-exv34-cyan-toner-3783b002-gpr-36', 'TS11500109', 'http://tonersales,eu/shop/636/-canon-c-exv34-cyan-toner-3783b002-gpr-36,jpg', 0, '0', '<p>CANON IR Advance C2020 , C2025 , C2030 , C2035</p>', '<p>19000     5%     : CANON IR Advance C2020 , C2025 , C2030 , C2035</p>'),
	(394, '1', ' CANON C-EXV34 Magenta 3784B002 GPR-36', 0, 61.26, 0, 1, 0.65, '-canon-c-exv34-magenta-3784b002-gpr-36', 'TS11500108', 'http://tonersales,eu/shop/2140/-canon-c-exv34-magenta-3784b002-gpr-36,jpg', 0, '0', '<p>CANON IR Advance C2020 , C2025 , C2030 , C2035</p>', '<p>19000     5%     : CANON IR Advance C2020 , C2025 , C2030 , C2035</p>'),
	(395, '1', ' CANON C-EXV34 Yellow 3785B002 GPR-36', 0, 61.26, 0, 1, 0.65, '-canon-c-exv34-yellow-3785b002-gpr-36', 'TS11500107', 'http://tonersales,eu/shop/2138/-canon-c-exv34-yellow-3785b002-gpr-36,jpg', 0, '0', '<p>CANON IR Advance C2020 , C2025 , C2030 , C2035</p>', '<p>19000     5%     : CANON IR Advance C2020 , C2025 , C2030 , C2035</p>'),
	(396, '1', ' CANON C-EXV8 BLACK 7629A002 GPR-36', 0, 61.26, 0, 1, 0.65, 'canon-c-exv8-black-7629a002-gpr-36', 'TS11550013', 'http://tonersales,eu/shop/639/canon-c-exv8-black-7629a002-gpr-36,jpg', 0, '0', '<p>CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950</p>', '<p>25000     5%     : CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950</p>'),
	(397, '1', ' CANON C-EXV13 GPR-17 0279B002', 0, 61.27, 0, 1, 0.65, '-canon-c-exv13-gpr-17-0279b002', 'TS11500092', 'http://tonersales,eu/shop/2141/-canon-c-exv13-gpr-17-0279b002,jpg', 0, '0', '<p>CANON IR5070 , IR5570 , IR6570</p>', '<p>33000     5%     : CANON IR5070 , IR5570 , IR6570</p>'),
	(398, '1', ' CANON C-EXV15 0387B002', 0, 61.27, 0, 1, 0.65, '-canon-c-exv15-0387b002', 'TS11500094', 'http://tonersales,eu/shop/641/-canon-c-exv15-0387b002,jpg', 0, '0', '<p>Canon IR7086 , ir7095 , ir7105</p>', '<p>47000     5%     : Canon IR7086 , ir7095 , ir7105</p>'),
	(399, '1', ' CANON C- EXV22 , GPR-24 1872B002', 0, 61.27, 0, 1, 0.65, '-canon-c-exv22-gpr-24-1872b002', 'TS11500093', 'http://tonersales,eu/shop/642/-canon-c-exv22-gpr-24-1872b002,jpg', 0, '0', '<p>Canon IR5050 , IR5055 , IR5065 , IR5075</p>', '<p>33000     5%     : Canon IR5050 , IR5055 , IR5065 , IR5075</p>'),
	(400, '1', ' CANON C-EXV8 CYAN 7628A002', 0, 71.59, 0, 1, 0.65, 'canon-c-exv8-cyan-7628a002', 'TS11550016', 'http://tonersales,eu/shop/643/canon-c-exv8-cyan-7628a002,jpg', 0, '0', '<p>CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950</p>', '<p>25000     5%     : CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950</p>'),
	(401, '1', ' CANON C-EXV8 MAGENTA 7627A002', 1, 71.59, 0, 1, 0.65, 'canon-c-exv8-magenta-7627a002', 'TS11550015', 'http://tonersales,eu/shop/644/canon-c-exv8-magenta-7627a002,jpg', 0, '0', 'CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950', '25000     5%               :  CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950'),
	(402, '1', ' CANON C-EXV8 YELLOW 7626A002', 0, 71.59, 0, 1, 0.65, 'canon-c-exv8-yellow-7626a002', 'TS11550014', 'http://tonersales,eu/shop/646/canon-c-exv8-yellow-7626a002,jpg', 0, '0', '<p>CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950</p>', '<p>25000     5%     : CANON IR CLC-2620 ,CLC-3200 ,CLC-3220 ,CLC-950</p>'),
	(403, '1', ' CANON 6830A004AA (EP-86 BLACK)', 0, 72.52, 0, 1, 0.65, '-canon-6830a004aa-ep-86-black', 'TSRH214B', 'http://tonersales,eu/shop/388/-canon-6830a004aa-ep-86-black,jpg', 0, '0', '<p>Canon LBP-2710, LBP-2810</p>', '<p>13000     5%     : Canon LBP-2710, LBP-2810</p>'),
	(404, '1', ' CANON 6829A004AA (EP-86 CYAN)', 0, 72.52, 0, 1, 0.65, '-canon-6829a004aa-ep-86-cyan', 'TSRH215C', 'http://tonersales,eu/shop/2136/-canon-6829a004aa-ep-86-cyan,jpg', 0, '0', '<p>Canon LBP-2710, LBP-2810</p>', '<p>12000     5%     : Canon LBP-2710, LBP-2810</p>'),
	(405, '1', ' CANON 6827A004AA (EP-86 YELLOW)', 0, 72.52, 0, 1, 0.65, '-canon-6827a004aa-ep-86-yellow', 'TSRH216Y', 'http://tonersales,eu/shop/2135/-canon-6827a004aa-ep-86-yellow,jpg', 0, '0', '<p>Canon LBP-2710, LBP-2810</p>', '<p>12000     5%     : Canon LBP-2710, LBP-2810</p>'),
	(406, '1', ' CANON 6828A004AA (EP-86 MAGENTA)', 0, 72.52, 0, 1, 0.65, '-canon-6828a004aa-ep-86-magenta', 'TSRH217M', 'http://tonersales,eu/shop/391/-canon-6828a004aa-ep-86-magenta,jpg', 0, '0', '<p>Canon LBP-2710, LBP-2810</p>', '<p>12000     5%     : Canon LBP-2710, LBP-2810</p>'),
	(407, '1', ' CANON 1517A002AA (EP-82 CYAN)', 0, 73.44, 0, 1, 0.65, '-canon-1517a002aa-ep-82-cyan', 'TSRH170C', 'http://tonersales,eu/shop/392/-canon-1517a002aa-ep-82-cyan,jpg', 0, '0', '<p>Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</p>', '<p>8500     5%     :Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</p>'),
	(408, '1', ' CANON 1518A002AA (EP-82 MAGENTA)', 0, 73.44, 0, 1, 0.65, '-canon-1518a002aa-ep-82-magenta', 'TSRH171M', 'http://tonersales,eu/shop/393/-canon-1518a002aa-ep-82-magenta,jpg', 0, '0', '<p><span>Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</span></p>', '<p>8500     5%     :<span>Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</span></p>'),
	(409, '1', ' CANON 1517A002AA (EP-82 YELLOW)', 0, 73.44, 0, 1, 0.65, '-canon-1517a002aa-ep-82-yellow', 'TSRH172Y', 'http://tonersales,eu/shop/394/-canon-1517a002aa-ep-82-yellow,jpg', 0, '0', '<p><span>Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</span></p>', '<p>8500     5%     :<span>Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</span></p>'),
	(410, '1', ' CANON 1520A002AA (EP-82 BLACK)', 0, 73.44, 0, 1, 0.65, '-canon-1520a002aa-ep-82-black', 'TSRH169B', 'http://tonersales,eu/shop/2137/-canon-1520a002aa-ep-82-black,jpg', 0, '0', '<p>Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</p>', '<p>11000     5%     : Canon LBP-2160 , 2200 , 2260 , 2260N , 2260PS , 2260PS 2 , 2300 , 2360 , PIXEL CP-660 , 680</p>'),
	(411, '1', ' CANON C-EXV29 IRC5030 Cyan', 0, 87.53, 0, 1, 0.65, '-canon-c-exv29-irc5030-cyan', 'TSTFC182C', 'http://tonersales,eu/shop/647/-canon-c-exv29-irc5030-cyan,jpg', 0, '0', '<p>Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>', '<p>27000     5%     : Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>'),
	(412, '1', ' CANON C-EXV29 IRC5030 YELLOW', 0, 87.53, 0, 1, 0.65, '-canon-c-exv29-irc5030-yellow', 'TSTFC183Y', 'http://tonersales,eu/shop/648/-canon-c-exv29-irc5030-yellow,jpg', 0, '0', '<p>Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>', '<p>27000     5%     : Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>'),
	(413, '1', ' CANON C-EXV29 IRC5030 Magenta', 0, 87.53, 0, 1, 0.65, '-canon-c-exv29-irc5030-magenta', 'TSTFC184M', 'http://tonersales,eu/shop/649/-canon-c-exv29-irc5030-magenta,jpg', 0, '0', '<p>Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>', '<p>27000     5%     : Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>'),
	(414, '1', ' CANON C-EXV29 IRC5030 Black', 0, 96.38, 0, 1, 0.65, '-canon-c-exv29-irc5030-black', 'TSTFC181B', 'http://tonersales,eu/shop/650/-canon-c-exv29-irc5030-black,jpg', 0, '0', '<p>Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>', '<p>36000     5%     : Canon ImageRUNNER ADVANCE IRC-5030 , 5030i , IRC-5035 , 5035i , IRC-5235 , IRC-5240</p>'),
	(415, '1', ' CANON EP-W (R74-6003-100)', 0, 99.19, 0, 1, 0.65, '#NAME?', 'TSRH117B', 'http://tonersales,eu/shop/397/-canon-ep-w-r74-6003-100,jpg', 0, '0', '<p>Canon LBP-2460 MAC QMS 2425 , 2425 EX , 2605 ,LBP-WX IBM 4324 , 24 , 24PS</p>', '<p>25000     5%     : Canon LBP-2460 MAC QMS 2425 , 2425 EX , 2605 ,LBP-WX IBM 4324 , 24 , 24PS</p>'),
	(416, '1', ' EPSON M1400 HY C13S050652 , C13S050651', 53, 9.68, 0, 1, 0.65, 'epson-m1400-hy-c13s050652-c13s050651', 'TSTFE045B', 'http://tonersales,eu/shop/292/epson-m1400-hy-c13s050652-c13s050651,jpg', 0, '0', '<p>Epson AcuLaser M1400 , MX14 , MX14NF</p>', '<p>2200     5%     : Epson AcuLaser M1400 , MX14 , MX14NF</p>'),
	(417, '1', ' EPSON C1700 HY CY C13S050613', 53, 8.68, 0, 105, 0.65, 'epson-c1700-hy-cy-c13s050613', 'TSTFE047C', 'http://tonersales,eu/shop/295/epson-c1700-hy-cy-c13s050613,jpg', 0, '0', '<p>Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>', '<p>1400     5%     : Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>'),
	(418, '1', ' EPSON C1700 HY YL C13S050611', 53, 8.68, 0, 105, 0.65, 'epson-c1700-hy-yl-c13s050611', 'TSTFE048Y', 'http://tonersales,eu/shop/296/epson-c1700-hy-yl-c13s050611,jpg', 0, '0', '<p>Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>', '<p>1400     5%     : Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>'),
	(419, '1', ' EPSON C1700 HY MG C13S050612', 53, 8.68, 0, 105, 0.65, 'epson-c1700-hy-mg-c13s050612', 'TSTFE049M', 'http://tonersales,eu/shop/294/epson-c1700-hy-mg-c13s050612,jpg', 0, '0', '<p>Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>', '<p>1400     5%     : Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>'),
	(420, '1', ' EPSON C1700 HY BK C13S050614', 53, 8.68, 0, 105, 0.65, 'epson-c1700-hy-bk-c13s050614', 'TSTFE046B', 'http://tonersales,eu/shop/297/epson-c1700-hy-bk-c13s050614,jpg', 0, '0', '<p>Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>', '<p>2000     5%     : Epson AcuLaser C1700 , C1750N , C1750W , CX17 , CX17NF , CX17WF</p>'),
	(421, '1', ' EPSON M200 , MX200 [C13S050709 , C13S050710 C13S050711(Return Toner)]', 0, 16.56, 0, 1, 0.65, 'epson-m200-mx200-c13s050709-c13s050710-c13s050711return-toner-', 'TSFEM200', 'http://tonersales,eu/shop/825/epson-m200-mx200-c13s050709-c13s050710-c13s050711return-toner-,jpg', 0, '0', '<p>Epson AL-M200 , AL-MX200</p>', '<p>2500     5%     : Epson AL-M200 , AL-MX200</p>'),
	(422, '1', ' EPSON M2300 , M2400 HY S050582 C13S050584', 0, 12.5, 0, 112, 0.65, 'epson-m2300-m2400-hy-s050582-c13s050584', 'TSFE042B', 'http://tonersales,eu/shop/826/epson-m2300-m2400-hy-s050582-c13s050584,jpg', 0, '0', '<p>Epson AcuLaser Aculaser M2300 , M2300D , M2400D , M2300DN , M2300DTN , M2300DT , M2400DN , M2400DTN , 2400 , Aculaser MX20DN , 20DNF , 20 , 20Dtnf , MX20</p>', '<p>8000     5%     : Epson AcuLaser Aculaser M2300 , M2300D , M2400D , M2300DN , M2300DTN , M2300DT , M2400DN , M2400DTN , 2400 , Aculaser MX20DN , 20DNF , 20 , 20Dtnf , MX20</p>'),
	(423, '1', ' EPSON M2000 C13S050435 , C13S050439 HY', 0, 12.5, 0, 101, 0.65, 'epson-m2000-c13s050435-c13s050439-hy', 'TSFE023B', 'http://tonersales,eu/shop/827/epson-m2000-c13s050435-c13s050439-hy,jpg', 0, '0', '<p>Epson AcuLaser M2000D , M2000DT , M2000DN , M2000DTN , M2010D , M2010DN</p>', '<p>8000     5%     : Epson AcuLaser M2000D , M2000DT , M2000DN , M2000DTN , M2010D , M2010DN</p>'),
	(424, '1', ' EPSON C2900 HY CY C13S050629', 0, 20.98, 0, 1, 0.65, 'epson-c2900-hy-cy-c13s050629', 'TSTFE052C', 'http://tonersales,eu/shop/828/epson-c2900-hy-cy-c13s050629,jpg', 0, '0', '<p>Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>', '<p>2500     5%     : Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>'),
	(425, '1', ' EPSON C2900 HY YL C13S050627', 0, 20.98, 0, 1, 0.65, 'epson-c2900-hy-yl-c13s050627', 'TSTFE053Y', 'http://tonersales,eu/shop/829/epson-c2900-hy-yl-c13s050627,jpg', 0, '0', '<p>Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>', '<p>2500     5%     : Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>'),
	(426, '1', ' EPSON C2900 HY MG C13S050628', 0, 20.98, 0, 1, 0.65, 'epson-c2900-hy-mg-c13s050628', 'TSTFE054M', 'http://tonersales,eu/shop/830/epson-c2900-hy-mg-c13s050628,jpg', 0, '0', '<p>Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>', '<p>2500     5%     : Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>'),
	(427, '1', ' EPSON C2900 HY BK C13S050630', 0, 20.98, 0, 1, 0.65, 'epson-c2900-hy-bk-c13s050630', 'TSTFE051B', 'http://tonersales,eu/shop/831/epson-c2900-hy-bk-c13s050630,jpg', 0, '0', '<p>Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>', '<p>3000     5%     : Epson AcuLaser C2900n , C2900dn , CX29nf , CX29dnf</p>'),
	(428, '1', ' EPSON CX-21N BK (C13S050319) HY', 1, 24.29, 0, 1, 0.65, 'epson-cx-21n-bk-c13s050319-hy', 'TSFE019B', 'http://tonersales,eu/shop/832/epson-cx-21n-bk-c13s050319-hy,jpg', 0, '0', 'Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT', '4000     5%               :  Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT'),
	(429, '1', ' EPSON CX-21N CY (C13S050318) HY', 0, 24.29, 0, 1, 0.65, 'epson-cx-21n-cy-c13s050318-hy', 'TSFE020C', 'http://tonersales,eu/shop/833/epson-cx-21n-cy-c13s050318-hy,jpg', 0, '0', '<p>Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT</p>', '<p>4000     5%     : Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT</p>'),
	(430, '1', ' EPSON CX-21N YL (C13S050316) HY', 0, 24.29, 0, 1, 0.65, 'epson-cx-21n-yl-c13s050316-hy', 'TSFE021Y', 'http://tonersales,eu/shop/834/epson-cx-21n-yl-c13s050316-hy,jpg', 0, '0', '<p>Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT</p>', '<p>4000     5%     : Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT</p>'),
	(431, '1', ' EPSON CX-21N MG (C13S050317) HY', 0, 24.29, 0, 1, 0.65, 'epson-cx-21n-mg-c13s050317-hy', 'TSFE022M', 'http://tonersales,eu/shop/835/epson-cx-21n-mg-c13s050317-hy,jpg', 0, '0', '<p>Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT</p>', '<p>4000     5%     : Epson AcuLaser CX21N , CX21NC , CX21NF , CX21NFC , CX21NFT , CX21NFCT</p>'),
	(432, '1', ' EPSON C1100 BK (C13S050190) HY', 0, 24.29, 0, 101, 0.65, 'epson-c1100-bk-c13s050190-hy', 'TSFE011B', 'http://tonersales,eu/shop/2054/epson-c1100-bk-c13s050190-hy,jpg', 0, '0', '<p>Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>', '<p>4000     5%     : Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>'),
	(433, '1', ' EPSON C1100 HY CY (C13S050189)', 0, 24.29, 0, 101, 0.65, 'epson-c1100-hy-cy-c13s050189', 'TSFE012C', 'http://tonersales,eu/shop/2051/epson-c1100-hy-cy-c13s050189,jpg', 0, '0', '<p>Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>', '<p>4000     5%     : Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>'),
	(434, '1', ' EPSON C1100 HY YL (C13S050187)', 0, 24.29, 0, 101, 0.65, 'epson-c1100-hy-yl-c13s050187', 'TSFE013Y', 'http://tonersales,eu/shop/2052/epson-c1100-hy-yl-c13s050187,jpg', 0, '0', '<p>Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>', '<p>4000     5%     : Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>'),
	(435, '1', ' EPSON C1100 HY MG (C13S050188)', 0, 24.29, 0, 101, 0.65, 'epson-c1100-hy-mg-c13s050188', 'TSFE014M', 'http://tonersales,eu/shop/2053/epson-c1100-hy-mg-c13s050188,jpg', 0, '0', '<p>Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>', '<p>4000     5%     : Epson AcuLaser C1100 , C1100N , CX11N , CX11NF , CX11NFC</p>'),
	(436, '1', ' EPSON EPL-5700 , EPL-5900 BK (S050087 , S050010)', 0, 24.43, 0, 101, 0.65, 'epson-epl-5700-epl-5900-bk-s050087-s050010', 'TSRE002B', 'http://tonersales,eu/shop/840/epson-epl-5700-epl-5900-bk-s050087-s050010,jpg', 0, '0', '<p>Epson EPL-5700 , 5700L , 5800 , 5800L , 5900 , 5900L , 6100 , 6100L</p>', '<p>6000     5%     : Epson EPL-5700 , 5700L , 5800 , 5800L , 5900 , 5900L , 6100 , 6100L</p>'),
	(437, '1', ' EPSON EPL-6200 SY (C13S050167)', 0, 28.43, 0, 1, 0.65, 'epson-epl-6200-sy-c13s050167', 'TSTFE009B', 'http://tonersales,eu/shop/290/epson-epl-6200-sy-c13s050167,jpg', 0, '0', '<p>Epson EPL-6200 , 6200N , 6200L</p>', '<p>3000     5%     : Epson EPL-6200 , 6200N , 6200L</p>'),
	(438, '1', ' EPSON C900 , MIN 2350 (QMS2300) BK (1710517-005)', 1, 34.75, 0, 1, 0.65, 'epson-c900-min-2350-qms2300-bk-1710517-005', 'TSRE005B', 'http://tonersales,eu/shop/841/epson-c900-min-2350-qms2300-bk-1710517-005,jpg', 0, '0', 'Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series', '4500     5%               :  Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series'),
	(439, '1', ' EPSON C900 , MIN 2350 (QMS2300) YL (1710517-004)', 0, 34.75, 0, 1, 0.65, 'epson-c900-min-2350-qms2300-yl-1710517-004', 'TSRE006Y', 'http://tonersales,eu/shop/842/epson-c900-min-2350-qms2300-yl-1710517-004,jpg', 0, '0', '<p>Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>', '<p>4500     5%     : Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>'),
	(440, '1', ' EPSON C900 , MIN 2350 (QMS2300) MG (1710517-003)', 1, 34.75, 0, 1, 0.65, 'epson-c900-min-2350-qms2300-mg-1710517-003', 'TSRE007M', 'http://tonersales,eu/shop/843/epson-c900-min-2350-qms2300-mg-1710517-003,jpg', 0, '0', 'Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series', '4500     5%               :  Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series'),
	(441, '1', ' EPSON C900 , MIN 2350 (QMS2300) CY (1710517-004)', 1, 34.75, 0, 1, 0.65, 'epson-c900-min-2350-qms2300-cy-1710517-004', 'TSRE008C', 'http://tonersales,eu/shop/844/epson-c900-min-2350-qms2300-cy-1710517-004,jpg', 0, '0', 'Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series', '4500     5%               :  Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series'),
	(442, '1', ' EPSON EPL-6200 HY (C13S050166)', 53, 26.36, 0, 1, 0.65, '-epson-epl-6200-hy-c13s050166', 'TSFEA02B', 'http://tonersales,eu/shop/291/-epson-epl-6200-hy-c13s050166,jpg', 0, '0', '<p>Epson EPL-6200 , 6200N</p>', '<p>6000     5%     : Epson EPL-6200 , 6200N</p>'),
	(443, '1', ' EPSON C1600 HY BK S050557', 0, 35.52, 0, 1, 0.65, 'epson-c1600-hy-bk-s050557', 'TSFEC1600B', 'http://tonersales,eu/shop/845/epson-c1600-hy-bk-s050557,jpg', 0, '0', '<p>epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF</p>', '<p>2700     5%     : epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF</p>'),
	(444, '1', ' EPSON C1600 HY CY S050556', 0, 35.52, 0, 1, 0.65, 'epson-c1600-hy-cy-s050556', 'TSFEC1600C', 'http://tonersales,eu/shop/846/epson-c1600-hy-cy-s050556,jpg', 0, '0', '<p>epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF</p>', '<p>2700     5%     : epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF</p>'),
	(445, '1', ' EPSON C1600 HY YL S050554', 0, 35.52, 0, 1, 0.65, 'epson-c1600-hy-yl-s050554', 'TSFEC1600Y', 'http://tonersales,eu/shop/847/epson-c1600-hy-yl-s050554,jpg', 0, '0', '<p>epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF</p>', '<p>2700     5%     : epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF</p>'),
	(446, '1', ' EPSON C1600 HY MG S050555', 1, 35.52, 0, 1, 0.65, 'epson-c1600-hy-mg-s050555', 'TSFEC1600M', 'http://tonersales,eu/shop/848/epson-c1600-hy-mg-s050555,jpg', 0, '0', 'epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF', '2700     5%               :  epson C1600 , CX16 , CX16NF , CX16DNF , CX16DTNF'),
	(447, '1', ' EPSON M300 C13S050689 HY', 0, 37.7, 0, 1, 0.65, '-epson-m300-c13s050689-hy', 'TSTFE061B', 'http://tonersales,eu/shop/849/-epson-m300-c13s050689-hy,jpg', 0, '0', '<p>Eposn AL-M300 , AL-MX300</p>', '<p>10000     5%     : Eposn AL-M300 , AL-MX300</p>'),
	(448, '1', ' EPSON M1200 BK HY C13S050523 , C13S050521', 0, 35.96, 0, 1, 0.65, 'epson-m1200-bk-hy-c13s050523-c13s050521', 'TSFEC1200B', 'http://tonersales,eu/shop/850/epson-m1200-bk-hy-c13s050523-c13s050521,jpg', 0, '0', '<p>EPSON AL-M1200</p>', '<p>3200     5%     : EPSON AL-M1200</p>'),
	(449, '1', ' EPSON M400 C13S050699 , C13S050697', 0, 65.99, 0, 1, 0.65, '-epson-m400-c13s050699-c13s050697', 'TS13313457**', 'http://tonersales,eu/shop/851/-epson-m400-c13s050699-c13s050697,jpg', 0, '0', '<p>EPSON WorkForce AL-M400DN</p>', '<p>23700     5%     : EPSON WorkForce AL-M400DN</p>'),
	(450, '1', ' EPSON EPL-N3000 SO51111 C13S051111', 0, 69.32, 0, 1, 0.65, 'epson-epl-n3000-so51111-c13s051111', 'TS13313453**', 'http://tonersales,eu/shop/852/epson-epl-n3000-so51111-c13s051111,jpg', 0, '0', '<p>EPL-N3000 , EPL-N3000D , EPL-N3000DT , EPL-N3000DTS , EPL-3000T</p>', '<p>17000     5%     : EPL-N3000 , EPL-N3000D , EPL-N3000DT , EPL-N3000DTS , EPL-3000T</p>'),
	(451, '1', ' EPSON C2800 HY BK C13S051165', 0, 80.79, 0, 1, 0.65, 'epson-c2800-hy-bk-c13s051165', 'TSTRE020B', 'http://tonersales,eu/shop/2058/epson-c2800-hy-bk-c13s051165,jpg', 0, '0', '<p>Epson Aculaser C2800N , C2800DN , C2800DTN</p>', '<p>8000     5%     : Epson Aculaser C2800N , C2800DN , C2800DTN</p>'),
	(452, '1', ' EPSON C2800 HY CY C13S051164', 0, 80.79, 0, 1, 0.65, 'epson-c2800-hy-cy-c13s051164', 'TSTRE021C', 'http://tonersales,eu/shop/2057/epson-c2800-hy-cy-c13s051164,jpg', 0, '0', '<p>Epson Aculaser C2800N , C2800DN , C2800DTN</p>', '<p>6000     5%     : Epson Aculaser C2800N , C2800DN , C2800DTN</p>'),
	(453, '1', ' EPSON C2800 HY MG C13S051163', 0, 80.79, 0, 1, 0.65, 'epson-c2800-hy-mg-c13s051163', 'TSTRE022M', 'http://tonersales,eu/shop/2056/epson-c2800-hy-mg-c13s051163,jpg', 0, '0', '<p>Epson Aculaser C2800N , C2800DN , C2800DTN</p>', '<p>6000     5%     : Epson Aculaser C2800N , C2800DN , C2800DTN</p>'),
	(454, '1', ' EPSON C2800 HY YL C13S051162', 0, 80.79, 0, 1, 0.65, 'epson-c2800-hy-yl-c13s051162', 'TSTRE023Y', 'http://tonersales,eu/shop/2055/epson-c2800-hy-yl-c13s051162,jpg', 0, '0', '<p>Epson Aculaser C2800N , C2800DN , C2800DTN</p>', '<p>6000     5%     : Epson Aculaser C2800N , C2800DN , C2800DTN</p>'),
	(455, '1', ' EPSON C3800 HY BK C13S051127', 0, 82.84, 0, 1, 0.65, 'epson-c3800-hy-bk-c13s051127', 'TSTRE024B', 'http://tonersales,eu/shop/2062/epson-c3800-hy-bk-c13s051127,jpg', 0, '0', '<p>Epson Aculaser C3800N , C3800DN , C3800DTN</p>', '<p>9500     5%     : Epson Aculaser C3800N , C3800DN , C3800DTN</p>'),
	(456, '1', ' EPSON C3800 HY CY C13S051126', 0, 82.84, 0, 1, 0.65, 'epson-c3800-hy-cy-c13s051126', 'TSTRE025C', 'http://tonersales,eu/shop/2061/epson-c3800-hy-cy-c13s051126,jpg', 0, '0', '<p>Epson Aculaser C3800N , C3800DN , C3800DTN</p>', '<p>9000     5%     : Epson Aculaser C3800N , C3800DN , C3800DTN</p>'),
	(457, '1', ' EPSON C3800 HY MG C13S051125', 0, 82.84, 0, 1, 0.65, 'epson-c3800-hy-mg-c13s051125', 'TSTRE026M', 'http://tonersales,eu/shop/2059/epson-c3800-hy-mg-c13s051125,jpg', 0, '0', '<p>Epson Aculaser C3800N , C3800DN , C3800DTN</p>', '<p>9000     5%     : Epson Aculaser C3800N , C3800DN , C3800DTN</p>'),
	(458, '1', ' EPSON C3800 HY YL C13S051124', 0, 82.84, 0, 1, 0.65, 'epson-c3800-hy-yl-c13s051124', 'TSTRE027Y', 'http://tonersales,eu/shop/2060/epson-c3800-hy-yl-c13s051124,jpg', 0, '0', '<p>Epson Aculaser C3800N , C3800DN , C3800DTN</p>', '<p>9000     5%     : Epson Aculaser C3800N , C3800DN , C3800DTN</p>'),
	(459, '1', ' EPSON C13S051170 M4000', 0, 94.31, 0, 1, 0.65, '-epson-c13s051170-m4000', 'TS13313447**', 'http://tonersales,eu/shop/861/-epson-c13s051170-m4000,jpg', 0, '0', '<p>AL-M4000DN , AL-M4000DTN , AL-M4000N , AL-M4000TN</p>', '<p>20000     5%     : AL-M4000DN , AL-M4000DTN , AL-M4000N , AL-M4000TN</p>'),
	(460, '1', ' OKI 4W BK (09002390)', 1, 5.27, 0, 1, 0.65, 'oki-4w-bk-09002390', 'TSFO004B', 'http://tonersales,eu/shop/1111/oki-4w-bk-09002390,jpg', 0, '0', 'OKI Page 4W , 4M , Office 44 , OLYMPIA OF806 , Lanier Fax 4050', '1000     5%               :  OKI Page 4W , 4M , Office 44 , OLYMPIA OF806 , Lanier Fax 4050'),
	(461, '1', ' OKI 8W BK TYPE 6', 0, 5.82, 0, 1, 0.65, 'oki-8w-bk-type-6', 'TSFO102B', 'http://tonersales,eu/shop/1112/oki-8w-bk-type-6,jpg', 0, '0', '<p>OKI Office 84 , 86 , 87 ,Page 6P , 6W , 8P , 8W , 8Z , Lanier Fax 1450</p>', '<p>1500     5%     : OKI Office 84 , 86 , 87 ,Page 6P , 6W , 8P , 8W , 8Z , Lanier Fax 1450</p>'),
	(462, '1', ' OKI 10EX BK', 0, 6.6, 0, 1, 0.65, 'oki-10ex-bk', 'TSFO101B', 'http://tonersales,eu/shop/1113/oki-10ex-bk,jpg', 0, '0', '<p>OKI Page 10 , 10EX , 10I , 10N , 12 , 12EX , 12I , 12N , 14EX , 14EXS , 14I , 14N</p>', '<p>2500     5%     : OKI Page 10 , 10EX , 10I , 10N , 12 , 12EX , 12I , 12N , 14EX , 14EXS , 14I , 14N</p>'),
	(463, '1', ' OKI 400E BK (09002395)', 0, 6.78, 0, 1, 0.65, 'oki-400e-bk-09002395', 'TSFO002B', 'http://tonersales,eu/shop/1114/oki-400e-bk-09002395,jpg', 0, '0', '<p>OL 400E , 410E , 400W , 600E , 610E , 810E OKIPAGE 6E , 6EX OKIFAX 1000 , 1050 , 2200 , 2350 , 2400 , 2600 , 5200 , 5000 KONICA Fax 9660 , 9750 , 9760 , 9765 , 9820MFP ,NASHUATEC OF 1000 , 220 , 2400 , 2600 ,OKI Fax 1000 , 1050MFP , 2200 , 2350MFP , 2400 , 2450MFP , 2600 , 5050 , 5200 , 5250 , 5300 , 5300+ , 5400 , 5500 , 5600 , 5600PLUS , 5650 , 5680I-FAX DIGITAL</p>', '<p>2000     5%     : OL 400E , 410E , 400W , 600E , 610E , 810E OKIPAGE 6E , 6EX OKIFAX 1000 , 1050 , 2200 , 2350 , 2400 , 2600 , 5200 , 5000 KONICA Fax 9660 , 9750 , 9760 , 9765 , 9820MFP ,NASHUATEC OF 1000 , 220 , 2400 , 2600 ,OKI Fax 1000 , 1050MFP , 2200 , 2350MFP , 2400 , 2450MFP , 2600 , 5050 , 5200 , 5250 , 5300 , 5300+ , 5400 , 5500 , 5600 , 5600PLUS , 5650 , 5680I-FAX DIGITAL</p>'),
	(464, '1', ' OKI B4100/4200/4250/4300/4350 BK (01103402)', 53, 5.89, 0, 110, 0.65, '#ERROR!', 'TSFO103B', 'http://tonersales,eu/shop/223/-oki-b41004200425043004350-bk-01103402,jpg', 0, '0', '<p>OKI B4000, B4100, B4300, B4200, B4350, B4250, B4500</p>', '<p>2000     5%     :OKI B4000, B4100, B4300, B4200, B4350, B4250, B4500</p>'),
	(465, '1', ' OKI 14EX BK', 1, 8.85, 0, 1, 0.65, 'oki-14ex-bk', 'TSFO100B', 'http://tonersales,eu/shop/1115/oki-14ex-bk,jpg', 0, '0', 'OKI Page 14EX , 14EXS , 14I , 14N , type 8', '4000     5%               :  OKI Page 14EX , 14EXS , 14I , 14N , type 8'),
	(466, '1', ' OKI B410 BK (43979102)', 53, 6.53, 0, 117, 0.65, 'oki-b410-bk-43979102', 'TSFO161B', 'http://tonersales,eu/shop/209/oki-b410-bk-43979102,jpg', 0, '0', '<p>OKI B400, B410, MB460, B420, B430, MB470, MB440, MB480</p>', '<p>3500     5%     : OKIB400, B410, MB460, B420, B430, MB470, MB440, MB480</p>'),
	(467, '1', ' OKI B2200 BK (43640302)', 0, 9.96, 0, 1, 0.65, 'oki-b2200-bk-43640302', 'TSFO130B', 'http://tonersales,eu/shop/1116/oki-b2200-bk-43640302,jpg', 0, '0', '<p>OKI B2200 , B2200n , B2400 , B2400n</p>', '<p>2000     5%     : OKI B2200 , B2200n , B2400 , B2400n</p>'),
	(468, '1', ' OKI B4400/4500/4550/4600 BK (43502302)', 53, 7.74, 0, 110, 0.65, '#ERROR!', 'TSFO121B', 'http://tonersales,eu/shop/224/-oki-b4400450045504600-bk-43502302,jpg', 0, '0', '<p>OKI B4400, B4600, B4500, B4550</p>', '<p>3000     5%     : OKIB4400, B4600, B4500, B4550</p>'),
	(469, '1', ' OKI B430/MB460/470 BK', 53, 8.95, 0, 105, 0.65, '#NAME?', 'TSFO162B', 'http://tonersales,eu/shop/210/-oki-b430mb460470-bk,jpg', 0, '0', '<p><span>OKI</span>B420, MB460, B430, MB470, MB440, MB480</p>', '<p>7000     5%     :OKIB420, MB460, B430, MB470, MB440, MB480</p>'),
	(470, '1', ' OKI B4350/4300 BK', 53, 11.69, 0, 105, 0.65, '#NAME?', 'TSFO104B', 'http://tonersales,eu/shop/211/-oki-b43504300-bk,jpg', 0, '0', '<p>OKI B4300 , B4350 Series</p>', '<p>6000     5%     : OKI B4300 , B4350 Series</p>'),
	(471, '1', ' OKI B4600 BK 43502002', 0, 14.46, 0, 105, 0.65, 'oki-b4600-bk-43502002', 'TSFO122B', 'http://tonersales,eu/shop/1117/oki-b4600-bk-43502002,jpg', 0, '0', '<p>OKI B4600 , B4600N</p>', '<p>7000     5%     : OKI B4600 , B4600N</p>'),
	(472, '1', ' OKI B401, MB451, MB441 BK 44992402', 53, 9.76, 0, 111, 0.65, '#NAME?', 'TSTFO237B', 'http://tonersales,eu/shop/208/-oki-b401-mb451-mb441-bk-44992402,jpg', 0, '0', '<p>OKI B401d, MB451, B401dn, MB451w, MB441</p>', '<p>2500     5%     :OKI B401d, MB451, B401dn, MB451w, MB441</p>'),
	(473, '1', ' OKI B411, 431 44574702 SY', 53, 9.52, 0, 110, 0.65, '#NAME?', 'TSTFO197B', 'http://tonersales,eu/shop/212/-oki-b411-431-44574702-sy,jpg', 0, '0', '<p>OKI B411d, B431dn, MB471w MFP, B411dn, MB461 MFP, MB491 MFP, B431d, MB471 MFP</p>', '<p>3000     5%     : OKI B411d, B431dn, MB471w MFP, B411dn, MB461 MFP, MB491 MFP, B431d, MB471 MFP</p>'),
	(474, '1', ' OKI C3300, 3400, 3450 BK', 0, 18.1, 0, 102, 0.65, '0', 'TSFO133B', '0', 0, '0', '<p><span>OKI C3300/3300N/3400/3400N/</span></p>', '0'),
	(475, '1', ' OKI C3300, 3400, 3450 CY', 0, 18.1, 0, 102, 0.65, '0', 'TSFO134C', '0', 0, '0', '<p><span>OKI C3300/3300N/3400/3400N/</span></p>', '0'),
	(476, '1', ' OKI C3300, 3400, 3450 YL', 0, 18.1, 0, 102, 0.65, '0', 'TSFO135Y', '0', 0, '0', '<p><span>OKI C3300/3300N/3400/3400N/</span></p>', '0'),
	(477, '1', ' OKI C3300, 3400, 3450 MG', 0, 18.1, 0, 102, 0.65, '0', 'TSFO136M', '0', 0, '0', '<p><span>OKI C3300/3300N/3400/3400N/</span></p>', '0'),
	(478, '1', ' OKI C5600 , C5700 CY', 0, 20.23, 0, 102, 0.65, '#NAME?', 'TSFO187C', 'http://tonersales,eu/shop/1915/-oki-c5600-c5700-cy,jpg', 0, '0', '<p>OKIDATA C5600 , C5700</p>', '<p>2000     5%     :<span>Okidata C5600, Okidata C5600n, Okidata C5700, Okidata C5700ndn</span></p>'),
	(479, '1', ' OKI C5600 , C5700 YL', 0, 20.23, 0, 104, 0.65, '#NAME?', 'TSFO188Y', 'http://tonersales,eu/shop/1914/-oki-c5600-c5700-yl,jpg', 0, '0', '<p>OKIDATA C5600 , C5700</p>', '<p>2000     5%     :<span>Okidata C5600, Okidata C5600n, Okidata C5700, Okidata C5700ndn</span></p>'),
	(480, '1', ' OKI C5600 , C5700 MG', 0, 20.23, 0, 104, 0.65, '#NAME?', 'TSFO189M', 'http://tonersales,eu/shop/1916/-oki-c5600-c5700-mg,jpg', 0, '0', '<p>OKIDATA C5600 , C5700</p>', '<p>2000     5%     :<span></span><span>Okidata C5600, Okidata C5600n, Okidata C5700, Okidata C5700ndn</span></p>'),
	(481, '1', ' OKI MC851 (44059168) BK', 0, 26.04, 0, 1, 0.65, 'oki-mc851-44059168-bk', 'TS44059168', 'http://tonersales,eu/shop/1125/oki-mc851-44059168-bk,jpg', 0, '0', '<p>OKI MC851 , MC861</p>', '<p>7000     5%     : OKI MC851 , MC861</p>'),
	(482, '1', ' OKI C301 , C321 CY 44973535', 0, 16.75, 0, 1, 0.65, 'oki-c301-c321-cy-44973535', 'TSTFO227C', 'http://tonersales,eu/shop/1922/oki-c301-c321-cy-44973535,jpg', 0, '0', '<p>OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>', '<p>1500     5%     : OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>'),
	(483, '1', ' OKI C301 , C321 YL 44973533', 0, 16.75, 0, 101, 0.65, 'oki-c301-c321-yl-44973533', 'TSTFO228Y', 'http://tonersales,eu/shop/1918/oki-c301-c321-yl-44973533,jpg', 0, '0', '<p>OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>', '<p>1500     5%     : OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>'),
	(484, '1', ' OKI C301 , C321 MG 44973534', 0, 16.75, 0, 1, 0.65, 'oki-c301-c321-mg-44973534', 'TSTFO229M', 'http://tonersales,eu/shop/1917/oki-c301-c321-mg-44973534,jpg', 0, '0', '<p>OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>', '<p>1500     5%     : OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>'),
	(485, '1', ' OKI C310, C330, C510, C530 CYAN 44469706', 53, 10.56, 0, 105, 0.65, '#NAME?', 'TSTFO218C', 'http://tonersales,eu/shop/214/-oki-c310-c330-c510-c530-cyan-44469706,jpg', 0, '0', '<p><span>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</span></p>', '<p>2000     5%     :<span>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</span></p>'),
	(486, '1', ' OKI C310, C330, C510, C530 YELLOW 44469704', 53, 10.56, 0, 105, 0.65, '#NAME?', 'TSTFO219Y', 'http://tonersales,eu/shop/215/-oki-c310-c330-c510-c530-yellow-44469704,jpg', 0, '0', '<p><span>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</span></p>', '<p>2000     5%     :<span>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</span></p>'),
	(487, '1', ' OKI C310, C330, C510, C530 MAGENTA 44469705', 53, 10.56, 0, 105, 0.65, '#NAME?', 'TSTFO220M', 'http://tonersales,eu/shop/217/-oki-c310-c330-c510-c530-magenta-44469705,jpg', 0, '0', '<p><span>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</span></p>', '<p>2000     5%     :<span>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</span></p>'),
	(488, '1', ' OKI B431 BK', 53, 22.18, 0, 111, 0.65, '#NAME?', 'TSTFO198B', 'http://tonersales,eu/shop/222/-oki-b431-bk,jpg', 0, '0', '<p>OKI B431dn, MB471w MFP, MB461 MFP, MB491 MFP, B431d, MB471 MFP</p>', '<p>10000     5%     : OKIB431dn, MB471w MFP, MB461 MFP, MB491 MFP, B431d, MB471 MFP</p>'),
	(489, '1', ' OKI MB461 , MB471 44574802', 0, 30.44, 0, 1, 0.65, 'oki-mb461-mb471-44574802', 'TSTFO235B', 'http://tonersales,eu/shop/1126/oki-mb461-mb471-44574802,jpg', 0, '0', '<p>OKI B431 , MB461 , MB471 , MB491</p>', '<p>10000     5%     : OKI B431 , MB461 , MB471 , MB491</p>'),
	(490, '1', ' OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510 BK', 53, 15.32, 0, 102, 0.65, '#NAME?', 'TSFO117B', 'http://tonersales,eu/shop/200/-oki-c3100-3000-3200-5100-5150-5200-5300-5400-5510-bk,jpg', 0, '0', '<p>OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510</p>', '<p>3000     5%     : OKIC3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510</p>'),
	(492, '1', ' OKI C510, C530, MC561 CYAN 44469724', 53, 14.96, 0, 110, 0.65, '#NAME?', 'TSTFO222C', 'http://tonersales,eu/shop/213/-oki-c510-c530-mc561-cyan-44469724,jpg', 0, '0', '<p><span>OKI C510, 530, MC561</span></p>', '<p>5000     5%     :<span>OKI C510, 530, MC561</span></p>'),
	(493, '1', ' OKI C510, C530, MC561 YELLOW 44469722', 53, 14.96, 0, 110, 0.65, '#NAME?', 'TSTFO223Y', 'http://tonersales,eu/shop/216/-oki-c510-c530-mc561-yellow-44469722,jpg', 0, '0', '<p><span>OKI C510, 530, MC561</span></p>', '<p>5000     5%     :<span>OKI C510, 530, MC561</span></p>'),
	(494, '1', ' OKI C510, C530, MC561 MAGENTA 44469723', 53, 14.96, 0, 110, 0.65, '#NAME?', 'TSTFO224M', 'http://tonersales,eu/shop/218/-oki-c510-c530-mc561-magenta-44469723,jpg', 0, '0', '<p><span>OKI C510, 530, MC561</span></p>', '<p>5000     5%     :<span>OKI C510, 530, MC561</span></p>'),
	(495, '1', ' OKI C5900 CY (43324423)', 0, 35.17, 0, 1, 0.65, 'oki-c5900-cy-43324423', 'TSFO191C', 'http://tonersales,eu/shop/1128/oki-c5900-cy-43324423,jpg', 0, '0', '<p>OKIDATA C5800 , C5900</p>', '<p>6000     5%     : OKIDATA C5800 , C5900</p>'),
	(496, '1', ' OKI C5900 YL (43324421)', 0, 35.17, 0, 1, 0.65, 'oki-c5900-yl-43324421', 'TSFO192Y', 'http://tonersales,eu/shop/1129/oki-c5900-yl-43324421,jpg', 0, '0', '<p>OKIDATA C5800 , C5900</p>', '<p>6000     5%     : OKIDATA C5800 , C5900</p>'),
	(497, '1', ' OKI C5900 MG (43324422)', 0, 35.17, 0, 1, 0.65, 'oki-c5900-mg-43324422', 'TSFO193M', 'http://tonersales,eu/shop/1130/oki-c5900-mg-43324422,jpg', 0, '0', '<p>OKIDATA C5800 , C5900</p>', '<p>6000     5%     : OKIDATA C5800 , C5900</p>'),
	(498, '1', ' OKI C5650 , 5750 CY (43872307)', 53, 16.33, 0, 1, 0.65, 'oki-c5650-5750-cy-43872307', 'TSFO142C', 'http://tonersales,eu/shop/204/oki-c5650-5750-cy-43872307,jpg', 0, '0', '<p>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</p>', '<p>2000     5%     :OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</p>'),
	(499, '1', ' OKI C5650 , 5750 YL (43872305)', 53, 16.33, 0, 1, 0.65, 'oki-c5650-5750-yl-43872305', 'TSFO143Y', 'http://tonersales,eu/shop/205/oki-c5650-5750-yl-43872305,jpg', 0, '0', '<p><span>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</span></p>', '<p>2000     5%     :<span>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</span></p>'),
	(500, '1', ' OKI C5650 , 5750 MG (43872306)', 53, 16.33, 0, 1, 0.65, 'oki-c5650-5750-mg-43872306', 'TSFO144M', 'http://tonersales,eu/shop/206/oki-c5650-5750-mg-43872306,jpg', 0, '0', '<p><span>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</span></p>', '<p>2000     5%     :<span>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</span></p>'),
	(501, '1', ' OKI C5850, C5950 CYAN', 0, 30.8, 0, 102, 0.65, '#NAME?', 'TSFO146C', 'http://tonersales,eu/shop/1919/-oki-c5850-c5950-cyan,jpg', 0, '0', '<p><span>OKI C5850, C5950</span></p>', '<p>6000     5%     :<span>OKI C5850, C5950</span></p>'),
	(502, '1', ' OKI C5850, C5950 YELLOW', 0, 30.8, 0, 1, 0.65, '#NAME?', 'TSFO147Y', 'http://tonersales,eu/shop/1920/-oki-c5850-c5950-yellow,jpg', 0, '0', '<p><span>OKI C5850, C5950</span></p>', '<p>6000     5%     :<span>OKI C5850, C5950</span></p>'),
	(503, '1', ' OKI C5850, C5950 MAGENTA', 0, 30.8, 0, 102, 0.65, '0', 'TSFO148M', '0', 0, '0', '<div id="short_description_block">', '0'),
	(504, '1', ' OKI C5900 BK (43324424)', 0, 36.41, 0, 1, 0.65, 'oki-c5900-bk-43324424', 'TSFO190B', 'http://tonersales,eu/shop/1923/oki-c5900-bk-43324424,jpg', 0, '0', '<p>OKIDATA C5800 , C5900</p>', '<p>8000     5%     : OKIDATA C5800 , C5900</p>'),
	(505, '1', ' OKI C301 , C321 BK 44973536', 0, 16.75, 0, 1, 0.65, 'oki-c301-c321-bk-44973536', 'TSTFO226B', 'http://tonersales,eu/shop/1921/oki-c301-c321-bk-44973536,jpg', 0, '0', '<p>OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>', '<p>2200     5%     : OKI C301 , C321 , c322 , C310dn , C330dn , C510dn , C530dn , MC351dn , MC361dn , MC561dn , MC352 , MC362dn , MC562dn , C511dn , C531dn , MC332dn , MC342dn</p>'),
	(506, '1', ' OKI C8600 (43487712) BK', 0, 37.2, 0, 1, 0.65, 'oki-c8600-43487712-bk', 'TS43487712', 'http://tonersales,eu/shop/1927/oki-c8600-43487712-bk,jpg', 0, '0', '<p>OKI C8600 , C8800</p>', '<p>6000     5%     : OKI C8600 , C8800</p>'),
	(507, '1', ' OKI C8600 (43487711) CY', 0, 37.2, 0, 1, 0.65, 'oki-c8600-43487711-cy', 'TS43487711', 'http://tonersales,eu/shop/1928/oki-c8600-43487711-cy,jpg', 0, '0', '<p>OKI C8600 , C8800</p>', '<p>6000     5%     : OKI C8600 , C8800</p>'),
	(508, '1', ' OKI C8600 (43487710) MG', 0, 37.2, 0, 1, 0.65, 'oki-c8600-43487710-mg', 'TS43487710', 'http://tonersales,eu/shop/1926/oki-c8600-43487710-mg,jpg', 0, '0', '<p>OKI C8600 , C8800</p>', '<p>6000     5%     : OKI C8600 , C8800</p>'),
	(509, '1', ' OKI C8600 (43487709) YL', 0, 37.2, 0, 1, 0.65, 'oki-c8600-43487709-yl', 'TS43487709', 'http://tonersales,eu/shop/1925/oki-c8600-43487709-yl,jpg', 0, '0', '<p>OKI C8600 , C8800</p>', '<p>6000     5%     : OKI C8600 , C8800</p>'),
	(510, '1', ' OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510 C', 53, 15.32, 0, 102, 0.65, '0', 'TSFO118C', '0', 0, '0', '<div id="short_description_block">', '0'),
	(511, '1', ' OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510 Y', 53, 15.32, 0, 102, 0.65, '#NAME?', 'TSFO119Y', 'http://tonersales,eu/shop/202/-oki-c3100-3000-3200-5100-5150-5200-5300-5400-5510-y,jpg', 0, '0', '<p><span>OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510</span></p>', '<p>3000     5%     :OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510</p>'),
	(512, '1', ' OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510 MG', 53, 15.32, 0, 102, 0.65, '#NAME?', 'TSFO120M', 'http://tonersales,eu/shop/203/-oki-c3100-3000-3200-5100-5150-5200-5300-5400-5510-mg,jpg', 0, '0', '<p>OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510</p>', '<p>3000     5%     : OKI C3100, 3000, 3200, 5100, 5150, 5200, 5300, 5400, 5510</p>'),
	(513, '1', ' OKI C5650 , 5750 BK (43865708) (13872308)', 53, 16.33, 0, 1, 0.65, 'oki-c5650-5750-bk-43865708-13872308', 'TSFO141B', 'http://tonersales,eu/shop/207/oki-c5650-5750-bk-43865708-13872308,jpg', 0, '0', '<p><span>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</span></p>', '<p>8000     5%     :<span>OKI C5650, C5750, C5650N, C5750N, C5650DN, C5750DN</span></p>'),
	(514, '1', ' OKI C5850, C5950 BLACK', 0, 30.8, 0, 102, 0.65, '#NAME?', 'TSFO145B', 'http://tonersales,eu/shop/1143/-oki-c5850-c5950-black,jpg', 0, '0', '<p>OKI C5850, C5950</p>', '<p>8000     5%     :OKI C5850, C5950</p>'),
	(515, '1', ' OKI C310, C330, C510, C530 BK 44469803', 53, 10.87, 0, 105, 0.65, '#NAME?', 'TSTFO217B', 'http://tonersales,eu/shop/1913/-oki-c310-c330-c510-c530-bk-44469803,jpg', 0, '0', '<p>OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</p>', '<p>3500     5%     :OKI C300, C310DN, C330DN, C331DN, MC561DN, MC561CDTN, C500, C510DN, C511DN, C530DN, C531DN, MC562DN, MC351DN, MC352DN, MC361DN, MC362DN, MC562DNW</p>'),
	(516, '1', ' OKI C510, C530, MC561 BLACK 44469804', 56, 16.63, 0, 110, 0.65, '#NAME?', 'TSTFO221B', 'http://tonersales,eu/shop/1929/-oki-c510-c530-mc561-black-44469804,jpg', 0, '0', '<p>OKI C510, 530, MC561</p>', '<p>5000     5%     : OKI C510, 530, MC561</p>'),
	(517, '1', ' OKI MC851 (44059167) CY', 0, 38.19, 0, 1, 0.65, 'oki-mc851-44059167-cy', 'TS44059167', 'http://tonersales,eu/shop/1144/oki-mc851-44059167-cy,jpg', 0, '0', '<p>OKI MC851 , MC861</p>', '<p>7300     5%     : OKI MC851 , MC861</p>'),
	(518, '1', ' OKI MC851 (44059165) YL', 0, 38.19, 0, 1, 0.65, 'oki-mc851-44059165-yl', 'TS44059165', 'http://tonersales,eu/shop/1145/oki-mc851-44059165-yl,jpg', 0, '0', '<p>OKI MC851 , MC861</p>', '<p>7300     5%     : OKI MC851 , MC861</p>'),
	(519, '1', ' OKI MC851 (44059166) MG', 0, 38.19, 0, 1, 0.65, 'oki-mc851-44059166-mg', 'TS44059166', 'http://tonersales,eu/shop/1146/oki-mc851-44059166-mg,jpg', 0, '0', '<p>OKI MC851 , MC861</p>', '<p>7300     5%     : OKI MC851 , MC861</p>'),
	(521, '1', ' OKI C110 HY BK 44250724', 1, 33.45, 0, 1, 0.65, 'oki-c110-hy-bk-44250724', 'TSFO110B', 'http://tonersales,eu/shop/1148/oki-c110-hy-bk-44250724,jpg', 0, '0', 'OKI C110 , C130 , MC160', '2500     5%               :  OKI C110 , C130 , MC160'),
	(522, '1', ' OKI C110 HY CY 44250723', 1, 33.45, 0, 1, 0.65, 'oki-c110-hy-cy-44250723', 'TSFO110C', 'http://tonersales,eu/shop/1149/oki-c110-hy-cy-44250723,jpg', 0, '0', 'OKI C110 , C130 , MC160', '2500     5%               :  OKI C110 , C130 , MC160'),
	(523, '1', ' OKI C110 HY YL 44250721', 0, 33.45, 0, 1, 0.65, 'oki-c110-hy-yl-44250721', 'TSFO110Y', 'http://tonersales,eu/shop/1150/oki-c110-hy-yl-44250721,jpg', 0, '0', '<p>OKI C110 , C130 , MC160</p>', '<p>2500     5%     : OKI C110 , C130 , MC160</p>'),
	(524, '1', ' OKI C110 HY MG 44250722', 1, 33.45, 0, 1, 0.65, 'oki-c110-hy-mg-44250722', 'TSFO110M', 'http://tonersales,eu/shop/1151/oki-c110-hy-mg-44250722,jpg', 0, '0', 'OKI C110 , C130 , MC160', '2500     5%               :  OKI C110 , C130 , MC160'),
	(525, '1', ' OKI C530 BK 7K 7000 ', 53, 32.68, 0, 1, 0.65, 'oki-c530-bk-7k-7000-', 'TSTFO234B', 'http://tonersales,eu/shop/1931/oki-c530-bk-7k-7000-,jpg', 0, '0', '<p>OKI C510dn , C530dn , MC561dn , MC562dn , C511dn , C531dn</p>', '<p>7000     5%     : OKI C510dn , C530dn , MC561dn , MC562dn , C511dn , C531dn</p>'),
	(526, '1', ' OKI C831 (44844508) BK', 0, 35.51, 0, 1, 0.65, 'oki-c831-44844508-bk', 'TS44059108', 'http://tonersales,eu/shop/1930/oki-c831-44844508-bk,jpg', 0, '0', '<p>OKI C831 , C841</p>', '<p>10000     5%     : OKI C831 , C841</p>'),
	(527, '1', ' OKI C610 CY 44315307', 0, 40.57, 0, 1, 0.65, 'oki-c610-cy-44315307', 'TSTFO205C', 'http://tonersales,eu/shop/1933/oki-c610-cy-44315307,jpg', 0, '0', '<p>oki C610 , C610N , C610DN , C610DTN</p>', '<p>6000     5%     : oki C610 , C610N , C610DN , C610DTN</p>'),
	(528, '1', ' OKI C610 YL 44315305', 0, 40.57, 0, 1, 0.65, 'oki-c610-yl-44315305', 'TSTFO206Y', 'http://tonersales,eu/shop/1934/oki-c610-yl-44315305,jpg', 0, '0', '<p>oki C610 , C610N , C610DN , C610DTN</p>', '<p>6000     5%     : oki C610 , C610N , C610DN , C610DTN</p>'),
	(529, '1', ' OKI C610 MG 44315306', 0, 40.57, 0, 1, 0.65, 'oki-c610-mg-44315306', 'TSTFO207M', 'http://tonersales,eu/shop/1932/oki-c610-mg-44315306,jpg', 0, '0', '<p>oki C610 , C610N , C610DN , C610DTN</p>', '<p>6000     5%     : oki C610 , C610N , C610DN , C610DTN</p>'),
	(530, '1', ' OK C711 , C710 BK', 0, 52.57, 0, 102, 0.65, '#NAME?', 'TSTFO208B', 'http://tonersales,eu/shop/1935/-ok-c711-c710-bk,jpg', 0, '0', '<p>OKI C710dn, C710dtn, C710n, C711</p>', '<p>11000     5%     : OKIC710dn, C710dtn, C710n, C711</p>'),
	(531, '1', ' OK C711 , C710 CY', 0, 52.57, 0, 102, 0.65, '#NAME?', 'TSTFO209C', 'http://tonersales,eu/shop/1938/-ok-c711-c710-cy,jpg', 0, '0', '<p><span>OKI C710dn, C710dtn, C710n, C711</span></p>', '<p>11500     5%     : OKI<span>C710dn, C710dtn, C710n, C711</span></p>'),
	(532, '1', ' OK C711 , C710 YL', 0, 52.57, 0, 102, 0.65, '#NAME?', 'TSTFO210Y', 'http://tonersales,eu/shop/1937/-ok-c711-c710-yl,jpg', 0, '0', '<p><span>OKI C710dn, C710dtn, C710n, C711</span></p>', '<p>11500     5%     :<span>OKI C710dn, C710dtn, C710n, C711</span></p>'),
	(533, '1', ' OK C711 , C710 MG', 0, 52.57, 0, 102, 0.65, '0', 'TSTFO211M', '0', 0, '0', '<div id="short_description_block">', '0'),
	(534, '1', ' OKI C801 ,  C821 (44643004) BK', 1, 42.61, 0, 1, 0.65, 'oki-c801-c821-44643004-bk', 'TS13314229**', 'http://tonersales,eu/shop/1160/oki-c801-c821-44643004-bk,jpg', 0, '0', 'OKI C801 , C821', '7000     5%               :  OKI C801 , C821'),
	(535, '1', ' OKI C801 ,  C821 (44643003) CY', 1, 42.61, 0, 1, 0.65, 'oki-c801-c821-44643003-cy', 'TS13314230**', 'http://tonersales,eu/shop/1161/oki-c801-c821-44643003-cy,jpg', 0, '0', 'OKI C801 , C821', '7300     5%               :  OKI C801 , C821'),
	(536, '1', ' OKI C801 ,  C821 (44643001) YL', 0, 42.61, 0, 1, 0.65, 'oki-c801-c821-44643001-yl', 'TS13314232**', 'http://tonersales,eu/shop/1162/oki-c801-c821-44643001-yl,jpg', 0, '0', '<p>OKI C801 , C821</p>', '<p>7300     5%     : OKI C801 , C821</p>'),
	(537, '1', ' OKI C801 ,  C821 (44643002) MG', 0, 42.61, 0, 1, 0.65, 'oki-c801-c821-44643002-mg', 'TS13314231**', 'http://tonersales,eu/shop/1163/oki-c801-c821-44643002-mg,jpg', 0, '0', '<p>OKI C801 , C821</p>', '<p>7300     5%     : OKI C801 , C821</p>'),
	(538, '1', ' OKI C610 BK 44315308', 1, 42.64, 0, 1, 0.65, 'oki-c610-bk-44315308', 'TSTFO204B', 'http://tonersales,eu/shop/1165/oki-c610-bk-44315308,jpg', 0, '0', 'oki C610 , C610N , C610DN , C610DTN', '8000     5%               :  oki C610 , C610N , C610DN , C610DTN'),
	(539, '1', ' OKI C831 (44844507) CY', 0, 49.71, 0, 1, 0.65, 'oki-c831-44844507-cy', 'TS44059107', 'http://tonersales,eu/shop/1940/oki-c831-44844507-cy,jpg', 0, '0', '<p>OKI C831 , C841</p>', '<p>10000     5%     : OKI C831 , C841</p>'),
	(540, '1', ' OKI C831 (44844506) MG', 0, 49.71, 0, 1, 0.65, 'oki-c831-44844506-mg', 'TS44059106', 'http://tonersales,eu/shop/1941/oki-c831-44844506-mg,jpg', 0, '0', '<p>OKI C831 , C841</p>', '<p>10000     5%     : OKI C831 , C841</p>'),
	(541, '1', ' OKI C831 (44844505) YL', 0, 49.71, 0, 1, 0.65, 'oki-c831-44844505-yl', 'TS44059105', 'http://tonersales,eu/shop/1939/oki-c831-44844505-yl,jpg', 0, '0', '<p>OKI C831 , C841</p>', '<p>10000     5%     : OKI C831 , C841</p>'),
	(542, '1', ' OKI B2500 , 2520 , 2540 09004391', 1, 51.13, 0, 1, 0.65, 'oki-b2500-2520-2540-09004391', 'TS13314057', 'http://tonersales,eu/shop/1169/oki-b2500-2520-2540-09004391,jpg', 0, '0', 'OKI B2500MFP , B2520MFP , B2540MFP OKIOFFICE 2530 OKIFAX2510', '4000     5%               :  OKI B2500MFP , B2520MFP , B2540MFP OKIOFFICE 2530 OKIFAX2510'),
	(543, '1', ' OKI MB260 , 280 , 290 (01240001)', 0, 51.58, 0, 1, 0.65, 'oki-mb260-280-290-01240001', 'TS13314059', 'http://tonersales,eu/shop/1968/oki-mb260-280-290-01240001,jpg', 0, '0', '<p>OKI MB260 , MB280 , MB290</p>', '<p>5000     5%     : OKI MB260 , MB280 , MB290</p>'),
	(544, '1', ' OKI C9600 ,  C9800 (42918916) BK', 0, 59.77, 0, 1, 0.65, 'oki-c9600-c9800-42918916-bk', 'TS13314019', 'http://tonersales,eu/shop/1946/oki-c9600-c9800-42918916-bk,jpg', 0, '0', '<p>OKI C9600 , C9650 , C9800 , C9850</p>', '<p>15000     5%     : OKI C9600 , C9650 , C9800 , C9850</p>'),
	(545, '1', ' OKI C9600 ,  C9800 (42918915) CY', 0, 59.77, 0, 1, 0.65, 'oki-c9600-c9800-42918915-cy', 'TS13314020', 'http://tonersales,eu/shop/1944/oki-c9600-c9800-42918915-cy,jpg', 0, '0', '<p>OKI C9600 , C9650 , C9800 , C9850</p>', '<p>15000     5%     : OKI C9600 , C9650 , C9800 , C9850</p>'),
	(546, '1', ' OKI C9600 ,  C9800 (42918913) YL', 0, 59.77, 0, 1, 0.65, 'oki-c9600-c9800-42918913-yl', 'TS13314021', 'http://tonersales,eu/shop/1942/oki-c9600-c9800-42918913-yl,jpg', 0, '0', '<p>OKI C9600 , C9650 , C9800 , C9850</p>', '<p>15000     5%     : OKI C9600 , C9650 , C9800 , C9850</p>'),
	(547, '1', ' OKI C9600 ,  C9800 (42918914) MG', 0, 59.77, 0, 1, 0.65, 'oki-c9600-c9800-42918914-mg', 'TS13314022', 'http://tonersales,eu/shop/1945/oki-c9600-c9800-42918914-mg,jpg', 0, '0', '<p>OKI C9600 , C9650 , C9800 , C9850</p>', '<p>15000     5%     : OKI C9600 , C9650 , C9800 , C9850</p>'),
	(548, '1', ' OKI B6200', 53, 46.25, 0, 111, 0.65, '#NAME?', 'TS13314033', 'http://tonersales,eu/shop/199/-oki-b6200,jpg', 0, '0', '<p>OKI B6200, B6250, B6300, B6200N, B6250N, B6300N, B6200DN, B6250DN, B6300DN</p>', '<p>10000     5%     :OKI B6200, B6250, B6300, B6200N, B6250N, B6300N, B6200DN, B6250DN, B6300DN</p>'),
	(549, '1', ' OKI C810 ,  C830 (44059108) BK', 0, 62.02, 0, 1, 0.65, 'oki-c810-c830-44059108-bk', 'TS13314035', 'http://tonersales,eu/shop/1177/oki-c810-c830-44059108-bk,jpg', 0, '0', '<p>OKI C810 , C830</p>', '<p>8000     5%     : OKI C810 , C830</p>'),
	(550, '1', ' OKI C810 ,  C830 (44059107) CY', 0, 62.02, 0, 1, 0.65, 'oki-c810-c830-44059107-cy', 'TS13314036', 'http://tonersales,eu/shop/1178/oki-c810-c830-44059107-cy,jpg', 0, '0', '<p>OKI C810 , C830</p>', '<p>8000     5%     : OKI C810 , C830</p>'),
	(551, '1', ' OKI C810 ,  C830 (44059106) MG', 1, 62.02, 0, 1, 0.65, 'oki-c810-c830-44059106-mg', 'TS13314037', 'http://tonersales,eu/shop/1179/oki-c810-c830-44059106-mg,jpg', 0, '0', 'OKI C810 , C830', '8000     5%               :  OKI C810 , C830'),
	(552, '1', ' OKI C810 ,  C830 (44059105) YL', 1, 62.02, 0, 1, 0.65, 'oki-c810-c830-44059105-yl', 'TS13314038', 'http://tonersales,eu/shop/1180/oki-c810-c830-44059105-yl,jpg', 0, '0', 'OKI C810 , C830', '8000     5%               :  OKI C810 , C830'),
	(553, '1', ' OKI C822 (44844616) BK', 0, 71.01, 0, 1, 0.65, 'oki-c822-44844616-bk', 'TS44844616', 'http://tonersales,eu/shop/1970/oki-c822-44844616-bk,jpg', 0, '0', '<p>OKI C822dn , C822n</p>', '<p>7000     5%     : OKI C822dn , C822n</p>'),
	(554, '1', ' OKI C822 (44844615) CY', 0, 71.01, 0, 1, 0.65, 'oki-c822-44844615-cy', 'TS44844615', 'http://tonersales,eu/shop/1969/oki-c822-44844615-cy,jpg', 0, '0', '<p>OKI C822dn , C822n</p>', '<p>7300     5%     : OKI C822dn , C822n</p>'),
	(555, '1', ' OKI C822 (44844613) YL', 0, 71.01, 0, 1, 0.65, 'oki-c822-44844613-yl', 'TS44844613', 'http://tonersales,eu/shop/1971/oki-c822-44844613-yl,jpg', 0, '0', '<p>OKI C822dn , C822n</p>', '<p>7300     5%     : OKI C822dn , C822n</p>'),
	(556, '1', ' OKI C822 (44844614) MG', 0, 71.01, 0, 1, 0.65, 'oki-c822-44844614-mg', 'TS44844614', 'http://tonersales,eu/shop/1972/oki-c822-44844614-mg,jpg', 0, '0', '<p>OKI C822dn , C822n</p>', '<p>7300     5%     : OKI C822dn , C822n</p>'),
	(557, '1', ' Oki B6100 (9004058)', 0, 78.37, 0, 1, 0.65, 'oki-b6100-9004058', 'TS13317339**', 'http://tonersales,eu/shop/1185/oki-b6100-9004058,jpg', 0, '0', '<p>Oki B6100</p>', '<p>15000     5%     : Oki B6100</p>'),
	(558, '1', ' OKI B710 01279001', 53, 72.34, 0, 1, 0.65, 'oki-b710-01279001', 'TSokb710', 'http://tonersales,eu/shop/225/oki-b710-01279001,jpg', 0, '0', '<p>OKI B710 , B720 , B730</p>', '<p>15000     5%     : OKI B710 , B720 , B730</p>'),
	(559, '1', ' OKI B730 (01279201)', 0, 85.23, 0, 1, 0.65, 'oki-b730-01279201', 'TS13318269**', 'http://tonersales,eu/shop/1186/oki-b730-01279201,jpg', 0, '0', '<p>OKI B730N , B730DN</p>', '<p>26000     5%     : OKI B730N , B730DN</p>'),
	(560, '1', ' XEROX 6110 BK (106R01274)', 0, 9.59, 0, 1, 0.65, 'xerox-6110-bk-106r01274', 'TSFX133B', 'http://tonersales,eu/shop/699/xerox-6110-bk-106r01274,jpg', 0, '0', '<p>Xerox Phaser 6110 , 6110MFP</p>', '<p>2000     5%     : Xerox Phaser 6110 , 6110MFP</p>'),
	(561, '1', ' XEROX 6110 CY (106R01271)', 0, 9.59, 0, 101, 0.65, 'xerox-6110-cy-106r01271', 'TSFX134C', 'http://tonersales,eu/shop/700/xerox-6110-cy-106r01271,jpg', 0, '0', '<p>Xerox Phaser 6110 , 6110MFP</p>', '<p>1000     5%     : Xerox Phaser 6110 , 6110MFP</p>'),
	(562, '1', ' XEROX 6110 YL (106R01273)', 0, 9.59, 0, 101, 0.65, 'xerox-6110-yl-106r01273', 'TSFX135Y', 'http://tonersales,eu/shop/701/xerox-6110-yl-106r01273,jpg', 0, '0', '<p>Xerox Phaser 6110 , 6110MFP</p>', '<p>1000     5%     : Xerox Phaser 6110 , 6110MFP</p>'),
	(563, '1', ' XEROX 6110 MG (106R01272)', 0, 9.59, 0, 101, 0.65, 'xerox-6110-mg-106r01272', 'TSFX136M', 'http://tonersales,eu/shop/702/xerox-6110-mg-106r01272,jpg', 0, '0', '<p>Xerox Phaser 6110 , 6110MFP</p>', '<p>1000     5%     : Xerox Phaser 6110 , 6110MFP</p>'),
	(564, '1', ' XEROX 6125 BK (106R01334)', 53, 8, 0, 101, 0.65, 'xerox-6125-bk-106r01334', 'TSFX176B', 'http://tonersales,eu/shop/703/xerox-6125-bk-106r01334,jpg', 0, '0', '<p>Xerox 6125 , 6125N</p>', '<p>2000     5%     : Xerox 6125 , 6125N</p>'),
	(565, '1', ' XEROX 6125 CY (106R01331)', 53, 8, 0, 101, 0.65, 'xerox-6125-cy-106r01331', 'TSFX177C', 'http://tonersales,eu/shop/704/xerox-6125-cy-106r01331,jpg', 0, '0', '<p>Xerox 6125 , 6125N</p>', '<p>1000     5%     : Xerox 6125 , 6125N</p>'),
	(566, '1', ' XEROX 6125 YL (106R01333)', 53, 8, 0, 101, 0.65, 'xerox-6125-yl-106r01333', 'TSFX178Y', 'http://tonersales,eu/shop/705/xerox-6125-yl-106r01333,jpg', 0, '0', '<p>Xerox 6125 , 6125N</p>', '<p>1000     5%     : Xerox 6125 , 6125N</p>'),
	(567, '1', ' XEROX 6125 MG (106R01332)', 53, 8, 0, 101, 0.65, 'xerox-6125-mg-106r01332', 'TSFX179M', 'http://tonersales,eu/shop/706/xerox-6125-mg-106r01332,jpg', 0, '0', '<p>Xerox 6125 , 6125N</p>', '<p>1000     5%     : Xerox 6125 , 6125N</p>'),
	(568, '1', ' XEROX 6130 BK (106R01281)', 53, 7.01, 0, 1, 0.65, 'xerox-6130-bk-106r01281', 'TSFX156B', 'http://tonersales,eu/shop/264/xerox-6130-bk-106r01281,jpg', 0, '0', '<p>Xerox 6130 , 6130N</p>', '<p>2500     5%     : Xerox 6130 , 6130N</p>'),
	(569, '1', ' XEROX 6130 CY (106R01278)', 53, 7.01, 0, 1, 0.65, 'xerox-6130-cy-106r01278', 'TSFX157C', 'http://tonersales,eu/shop/265/xerox-6130-cy-106r01278,jpg', 0, '0', '<p>Xerox 6130 , 6130N</p>', '<p>1900     5%     : Xerox 6130 , 6130N</p>'),
	(570, '1', ' XEROX 6130 YL (106R01280)', 53, 7.01, 0, 1, 0.65, 'xerox-6130-yl-106r01280', 'TSFX158Y', 'http://tonersales,eu/shop/266/xerox-6130-yl-106r01280,jpg', 0, '0', '<p>Xerox 6130 , 6130N</p>', '<p>1900     5%     : Xerox 6130 , 6130N</p>'),
	(571, '1', ' XEROX 6130 MG (106R01279)', 53, 7.01, 0, 1, 0.65, 'xerox-6130-mg-106r01279', 'TSFX159M', 'http://tonersales,eu/shop/268/xerox-6130-mg-106r01279,jpg', 0, '0', '<p>Xerox 6130 , 6130N</p>', '<p>1900     5%     : Xerox 6130 , 6130N</p>'),
	(572, '1', ' XEROX 6128 BK 106R01455', 1, 9.96, 0, 1, 0.65, 'xerox-6128-bk-106r01455', 'TSFX198B', 'http://tonersales,eu/shop/707/xerox-6128-bk-106r01455,jpg', 0, '0', 'Xerox Phaser 6128 MFP', '3100     5%               :  Xerox Phaser 6128 MFP'),
	(573, '1', ' XEROX 6128 CY 106R01452', 0, 9.96, 0, 1, 0.65, 'xerox-6128-cy-106r01452', 'TSFX199C', 'http://tonersales,eu/shop/708/xerox-6128-cy-106r01452,jpg', 0, '0', '<p>Xerox Phaser 6128 MFP</p>', '<p>2500     5%     : Xerox Phaser 6128 MFP</p>'),
	(574, '1', ' XEROX 6128 YL 106R01454', 1, 9.96, 0, 1, 0.65, 'xerox-6128-yl-106r01454', 'TSFX200Y', 'http://tonersales,eu/shop/709/xerox-6128-yl-106r01454,jpg', 0, '0', 'Xerox Phaser 6128 MFP', '2500     5%               :  Xerox Phaser 6128 MFP'),
	(575, '1', ' XEROX 6128 MG 106R01453', 1, 9.96, 0, 1, 0.65, 'xerox-6128-mg-106r01453', 'TSFX201M', 'http://tonersales,eu/shop/710/xerox-6128-mg-106r01453,jpg', 0, '0', 'Xerox Phaser 6128 MFP', '2500     5%               :  Xerox Phaser 6128 MFP'),
	(576, '1', ' XEROX 3010 ,  3040 ,  3045 (106R02182)', 0, 11.04, 0, 110, 0.65, 'xerox-3010-3040-3045-106r02182', 'TS13313148**', 'http://tonersales,eu/shop/2015/xerox-3010-3040-3045-106r02182,jpg', 0, '0', '<p>Xerox Phaser 3010 , 3045 , 3040V , 3045NI , 3045B</p>', '<p>2300     5%     : Xerox Phaser 3010 , 3045 , 3040V , 3045NI , 3045B</p>'),
	(577, '1', ' XEROX 6140 BK 106R01480', 0, 11.1, 0, 1, 0.65, 'xerox-6140-bk-106r01480', 'TSFX6140B', 'http://tonersales,eu/shop/712/xerox-6140-bk-106r01480,jpg', 0, '0', '<p>xerox Phaser 6140N</p>', '<p>2600     5%     : xerox Phaser 6140N</p>'),
	(578, '1', ' XEROX 6140 CY 106R01477', 0, 11.1, 0, 1, 0.65, 'xerox-6140-cy-106r01477', 'TSFX6140C', 'http://tonersales,eu/shop/713/xerox-6140-cy-106r01477,jpg', 0, '0', '<p>xerox Phaser 6140N</p>', '<p>2000     5%     : xerox Phaser 6140N</p>'),
	(579, '1', ' XEROX 6140 YL 106R01479', 0, 11.1, 0, 1, 0.65, 'xerox-6140-yl-106r01479', 'TSFX6140Y', 'http://tonersales,eu/shop/714/xerox-6140-yl-106r01479,jpg', 0, '0', '<p>xerox Phaser 6140N</p>', '<p>2000     5%     : xerox Phaser 6140N</p>'),
	(580, '1', ' XEROX 6140 MG 106R01478', 1, 11.1, 0, 1, 0.65, 'xerox-6140-mg-106r01478', 'TSFX6140M', 'http://tonersales,eu/shop/715/xerox-6140-mg-106r01478,jpg', 0, '0', 'xerox Phaser 6140N', '2000     5%               :  xerox Phaser 6140N'),
	(581, '1', ' XEROX 6000, 6010, 6015 BK', 53, 8.79, 0, 110, 0.65, '#NAME?', 'TSTFX331B', 'http://tonersales,eu/shop/260/-xerox-6000-6010-6015-bk,jpg', 0, '0', '<p>Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>', '<p>2000     5%     : Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>'),
	(582, '1', ' XEROX 6000, 6010, 6015 CY', 53, 8.79, 0, 110, 0.65, '#NAME?', 'TSTFX332C', 'http://tonersales,eu/shop/261/-xerox-6000-6010-6015-cy,jpg', 0, '0', '<p>Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>', '<p>1000     5%     : Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>'),
	(583, '1', ' XEROX 6000, 6010, 6015 MG', 53, 8.79, 0, 110, 0.65, '#NAME?', 'TSTFX333M', 'http://tonersales,eu/shop/267/-xerox-6000-6010-6015-mg,jpg', 0, '0', '<p>Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>', '<p>1000     5%     : Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>'),
	(584, '1', ' XEROX 6000, 6010, 6015 YL', 53, 8.79, 0, 110, 0.65, '#NAME?', 'TSTFX334Y', 'http://tonersales,eu/shop/263/-xerox-6000-6010-6015-yl,jpg', 0, '0', '<p>Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>', '<p>1000     5%     : Xerox Phaser 6000 , 6010 , 6015 , WorkCentre 6015</p>'),
	(585, '1', ' XEROX 6500 HY CY 106R01594', 1, 13.34, 0, 1, 0.65, 'xerox-6500-hy-cy-106r01594', 'TSTFX317C', 'http://tonersales,eu/shop/716/xerox-6500-hy-cy-106r01594,jpg', 0, '0', 'Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN', '2500     5%               :  Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN'),
	(586, '1', ' XEROX 6500 HY MG 106R01595', 0, 13.34, 0, 1, 0.65, 'xerox-6500-hy-mg-106r01595', 'TSTFX318M', 'http://tonersales,eu/shop/717/xerox-6500-hy-mg-106r01595,jpg', 0, '0', '<p>Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN</p>', '<p>2500     5%     : Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN</p>'),
	(587, '1', ' XEROX 6500 HY YL 106R01596', 0, 13.34, 0, 1, 0.65, 'xerox-6500-hy-yl-106r01596', 'TSTFX319Y', 'http://tonersales,eu/shop/718/xerox-6500-hy-yl-106r01596,jpg', 0, '0', '<p>Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN</p>', '<p>2500     5%     : Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN</p>'),
	(588, '1', ' XEROX 5020 ,  5016 106R01277', 0, 13.87, 0, 102, 0.65, 'xerox-5020-5016-106r01277', 'TS13315454**', 'http://tonersales,eu/shop/720/xerox-5020-5016-106r01277,jpg', 0, '0', '<p>XEROX WorkCentre 5020 , 5016</p>', '<p>5000     5%     : XEROX WorkCentre 5020 , 5016</p>'),
	(589, '1', ' XEROX 6500 BK 106R01597', 0, 14.28, 0, 101, 0.65, 'xerox-6500-bk-106r01597', 'TSTFX316B', 'http://tonersales,eu/shop/719/xerox-6500-bk-106r01597,jpg', 0, '0', '<p>Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN</p>', '<p>3000     5%     : Xerox Phaser 6500N , 6500DN , Work Centre 6505N , 6505DN</p>'),
	(590, '1', ' BROTHER TN350 ,  TN2000 ,  TN2025 ,  TN2050', 0, 19.95, 0, 125, 0.65, 'brother-tn350-tn2000-tn2025-tn2050', 'TSFB206B', 'http://tonersales,eu/shop/1537/brother-tn350-tn2000-tn2025-tn2050,jpg', 0, '0', '<p>BROTHER DCP7010/DCP7010L/DCP7020/DCP7025/BROTHER Fax2820/FAX2910/Fax2920/BROTHER HL2030/HL2035/HL2037/HL2040/HL2045/HL2050/HL2070/HL2070N/HL2500/BROTHER MFC7220/MFC7225N/MFC7420/MFC7820N,Xerox Docuprint 203A , 204A</p>', '<p>4500     5%     : BROTHER DCP7010/DCP7010L/DCP7020/DCP7025/<br />BROTHER Fax2820/FAX2910/Fax2920/BROTHER HL2030/HL2035/HL2037/HL2040/HL2045/HL2050/HL2070/HL2070N/HL2500/<br />BROTHER MFC7220/MFC7225N/MFC7420/MFC7820N,Xerox Docuprint 203A , 204A</p>'),
	(591, '1', ' XEROX 6020 ,  6025 (106R02759) BK', 0, 17.04, 0, 101, 0.65, 'xerox-6020-6025-106r02759-bk', 'TS13318609**', 'http://tonersales,eu/shop/722/xerox-6020-6025-106r02759-bk,jpg', 0, '0', '<p>XEROX Phaser 6020 , 6022 XEROX WorkCentre 6025 , 6027</p>', '<p>2000     5%     : XEROX Phaser 6020 , 6022 XEROX WorkCentre 6025 , 6027</p>'),
	(592, '1', ' XEROX 6020 ,  6025 (106R02756) CY', 1, 17.04, 0, 13, 0.65, '0', 'TS13318610**', '0', 0, '0', 'XEROX Phaser 6020 , 6022', '0'),
	(593, '1', ' XEROX 6020 ,  6025 (106R02758) YL', 0, 17.04, 0, 13, 0.65, 'xerox-6020-6025-106r02758-yl', 'TS13318611**', 'http://tonersales,eu/shop/724/xerox-6020-6025-106r02758-yl,jpg', 0, '0', '<p>XEROX Phaser 6020 , 6022 XEROX WorkCentre 6025 , 6027</p>', '<p>1000     5%     : XEROX Phaser 6020 , 6022 XEROX WorkCentre 6025 , 6027</p>'),
	(594, '1', ' XEROX 6020 ,  6025 (106R02757) MG', 0, 17.04, 0, 13, 0.65, 'xerox-6020-6025-106r02757-mg', 'TS13318612**', 'http://tonersales,eu/shop/725/xerox-6020-6025-106r02757-mg,jpg', 0, '0', '<p>XEROX Phaser 6020 , 6022 XEROX WorkCentre 6025 , 6027</p>', '<p>1000     5%     : XEROX Phaser 6020 , 6022 XEROX WorkCentre 6025 , 6027</p>'),
	(595, '1', ' XEROX ML-1710 ,  SF-D560RA BK', 53, 16.43, 0, 50, 0.65, '#NAME?', 'TSFS364B', 'http://tonersales,eu/shop/170/-xerox-ml-1710-sf-d560ra-bk,jpg', 0, '0', '<p>Samsung ML-1510 , 1520 , 1520P , 1710 , 1740 , 1750 , SCX-4016 , 4116 , 4216 , 4216F , SF-560 , 565P , 750 , 755P , 560R , 565PR , MSYS 750 , 755P Xerox Phaser 3130 , 3120 , 3115 , 3116 , 3121 ,WorkCentre PE16 Ricoh AC104</p>', '<p>3000     5%     : Samsung ML-1510 , 1520 , 1520P , 1710 , 1740 , 1750 , SCX-4016 , 4116 , 4216 , 4216F , SF-560 , 565P , 750 , 755P , 560R , 565PR , MSYS 750 , 755P Xerox Phaser 3130 , 3120 , 3115 , 3116 , 3121 ,WorkCentre PE16 Ricoh AC104</p>'),
	(596, '1', ' XEROX PE220 BK (13R621)', 0, 18.85, 0, 1, 0.65, 'xerox-pe220-bk-13r621', 'TSFX103B', 'http://tonersales,eu/shop/726/xerox-pe220-bk-13r621,jpg', 0, '0', '<p>XEROX WorkCentre PE220 , Phaser 3117 , 3122 , 3124 , 3125</p>', '<p>3000     5%     : XEROX WorkCentre PE220 , Phaser 3117 , 3122 , 3124 , 3125</p>'),
	(597, '1', ' XEROX 3200 (113R00730)', 53, 15.32, 0, 101, 0.65, 'xerox-3200-113r00730', 'TSFX146B', 'http://tonersales,eu/shop/167/xerox-3200-113r00730,jpg', 0, '0', '<p>XEROX Phaser 3200 , 3117 , 3122 , 3124 , 3125</p>', '<p>3000     5%     : XEROX Phaser 3200 , 3117 , 3122 , 3124 , 3125</p>'),
	(598, '1', ' XEROX 3140 ,  3155 ,  3160 108R00909', 0, 22.23, 0, 1, 0.65, 'xerox-3140-3155-3160-108r00909', 'TSFX3140BK', 'http://tonersales,eu/shop/727/xerox-3140-3155-3160-108r00909,jpg', 0, '0', '<p>XEROX Phaser 3140 , 3155 , 3160</p>', '<p>2500     5%     : XEROX Phaser 3140 , 3155 , 3160</p>'),
	(599, '1', ' XEROX 7100 (106R02605) BK', 0, 33.35, 0, 12, 0.65, 'xerox-7100-106r02605-bk', 'TS13317458**', 'http://tonersales,eu/shop/728/xerox-7100-106r02605-bk,jpg', 0, '0', '<p>XEROX Phaser 7100</p>', '<p>5000     5%     : XEROX Phaser 7100</p>'),
	(600, '1', ' XEROX 7100 (106R02599) CY', 0, 33.35, 0, 1, 0.65, 'xerox-7100-106r02599-cy', 'TS13317459**', 'http://tonersales,eu/shop/729/xerox-7100-106r02599-cy,jpg', 0, '0', '<p>XEROX Phaser 7100</p>', '<p>4500     5%     : XEROX Phaser 7100</p>'),
	(601, '1', ' XEROX 7100 (106R02600) MG', 0, 33.35, 0, 0, 0.65, 'xerox-7100-106r02600-mg', 'TS13317460**', 'http://tonersales,eu/shop/730/xerox-7100-106r02600-mg,jpg', 0, '0', '<p>XEROX Phaser 7100</p>', '<p>4500     5%     : XEROX Phaser 7100</p>'),
	(602, '1', ' XEROX 7100 (106R02601) YL', 0, 33.35, 0, 0, 0.65, 'xerox-7100-106r02601-yl', 'TS13317461**', 'http://tonersales,eu/shop/731/xerox-7100-106r02601-yl,jpg', 0, '0', '<p>XEROX Phaser 7100</p>', '<p>4500     5%     : XEROX Phaser 7100</p>'),
	(603, '1', ' XEROX M118 (006R01179)', 0, 25.68, 0, 1, 0.65, 'xerox-m118-006r01179', 'TS13313151**', 'http://tonersales,eu/shop/732/xerox-m118-006r01179,jpg', 0, '0', '<p>XEROX WorkCentre M118 , 118I , CopyCentre C118</p>', '<p>11000     5%     : XEROX WorkCentre M118 , 118I , CopyCentre C118</p>'),
	(604, '1', ' XEROX 3119 BK (13R00625)', 0, 27.81, 0, 1, 0.65, 'xerox-3119-bk-13r00625', 'TSFX145B', 'http://tonersales,eu/shop/733/xerox-3119-bk-13r00625,jpg', 0, '0', '<p>XEROX WorkCentre 3119 , PE16</p>', '<p>3000     5%     : XEROX WorkCentre 3119 , PE16</p>'),
	(605, '1', ' XEROX 6600 106R02232 Black HY', 0, 27.81, 0, 1, 0.65, 'xerox-6600-106r02232-black-hy', 'TSTFX375B', 'http://tonersales,eu/shop/734/xerox-6600-106r02232-black-hy,jpg', 0, '0', '<p>XEROX PHASER 6600V , DN , 6600V , N , XEROX WORKCENTRE 6605DN , 6605N</p>', '<p>8000     5%     : XEROX PHASER 6600V , DN , 6600V , N , XEROX WORKCENTRE 6605DN , 6605N</p>'),
	(606, '1', ' XEROX 6600 106R02229 Cyan HY', 0, 27.81, 0, 1, 0.65, 'xerox-6600-106r02229-cyan-hy', 'TSTFX376C', 'http://tonersales,eu/shop/735/xerox-6600-106r02229-cyan-hy,jpg', 0, '0', '<p>XEROX PHASER 6600V , DN , 6600V , N , XEROX WORKCENTRE 6605DN , 6605N</p>', '<p>6000     5%     : XEROX PHASER 6600V , DN , 6600V , N , XEROX WORKCENTRE 6605DN , 6605N</p>'),
	(607, '1', ' XEROX 6600 106R02230 Magenta HY', 1, 27.81, 0, 1, 0.65, 'xerox-6600-106r02230-magenta-hy', 'TSTFX377M', 'http://tonersales,eu/shop/736/xerox-6600-106r02230-magenta-hy,jpg', 0, '0', 'XEROX PHASER 6600V , DN ,  6600V , N , XEROX WORKCENTRE 6605DN , 6605N', '6000     5%               :  XEROX PHASER 6600V , DN ,  6600V , N , XEROX WORKCENTRE 6605DN , 6605N'),
	(608, '1', ' XEROX 6600 106R02231 Yellow HY', 0, 27.81, 0, 1, 0.65, 'xerox-6600-106r02231-yellow-hy', 'TSTFX378Y', 'http://tonersales,eu/shop/737/xerox-6600-106r02231-yellow-hy,jpg', 0, '0', '<p>XEROX PHASER 6600V , DN , 6600V , N , XEROX WORKCENTRE 6605DN , 6605N</p>', '<p>6000     5%     : XEROX PHASER 6600V , DN , 6600V , N , XEROX WORKCENTRE 6605DN , 6605N</p>'),
	(609, '1', ' Xerox dc12 006R90280 Black', 0, 29.23, 0, 1, 0.65, 'xerox-dc12-006r90280-black', 'TSDC-12K', 'http://tonersales,eu/shop/738/xerox-dc12-006r90280-black,jpg', 0, '0', '<p>Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>', '<p>17500     5%     : Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>'),
	(610, '1', ' XEROX PE120 BK HY (13R00606)', 53, 28.71, 0, 1, 0.65, 'xerox-pe120-bk-hy-13r00606', 'TSFX120B', 'http://tonersales,eu/shop/278/xerox-pe120-bk-hy-13r00606,jpg', 0, '0', '<p>Xerox WorkCentre PE120 , PE120i</p>', '<p>5000     5%     : Xerox WorkCentre PE120 , PE120i</p>'),
	(611, '1', ' XEROX 3210 ,  3220 (106R01485)106R01500', 53, 24.26, 0, 105, 0.65, 'xerox-3210-3220-106r01485106r01500', 'TS13313136**', 'http://tonersales,eu/shop/274/xerox-3210-3220-106r01485106r01500,jpg', 0, '0', '<p>XEROX WorkCentre 3210 , 3220</p>', '<p>4100    5%     : XEROX WorkCentre 3210 , 3220</p>'),
	(612, '1', ' XEROX 3300 BK HY 106R01412', 0, 29.96, 0, 105, 0.65, 'xerox-3300-bk-hy-106r01412', 'TSRXO27B', 'http://tonersales,eu/shop/739/xerox-3300-bk-hy-106r01412,jpg', 0, '0', '<p>Xerox Phaser 3300MFP</p>', '<p>8000     5%     : Xerox Phaser 3300MFP</p>'),
	(613, '1', ' XEROX 3635 (108R00795)', 0, 29.96, 0, 1, 0.65, 'xerox-3635-108r00795', 'TS13313109', 'http://tonersales,eu/shop/740/xerox-3635-108r00795,jpg', 0, '0', '<p>XEROX Phaser 3635 MPF</p>', '<p>10000     5%     : XEROX Phaser 3635 MPF</p>'),
	(614, '1', ' XEROX 3250 BK HY ( 106R01374 )', 53, 20.71, 0, 108, 0.65, 'xerox-3250-bk-hy-106r01374-', 'TSRX024B', 'http://tonersales,eu/shop/275/xerox-3250-bk-hy-106r01374-,jpg', 0, '0', '<p>Xerox Phaser 3250D , 3250DN , 3250B , 3250N</p>', '<p>5000     5%     : Xerox Phaser 3250D , 3250DN , 3250B , 3250N</p>'),
	(615, '1', ' XEROX 6360 SY CY 106R01218', 0, 30.25, 0, 1, 0.65, 'xerox-6360-sy-cy-106r01218', 'TSTFX304C', 'http://tonersales,eu/shop/2018/xerox-6360-sy-cy-106r01218,jpg', 0, '0', '<p>Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>', '<p>5000     5%     : Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>'),
	(616, '1', ' XEROX 6360 SY YL 106R01220', 0, 30.25, 0, 1, 0.65, 'xerox-6360-sy-yl-106r01220', 'TSTFX305Y', 'http://tonersales,eu/shop/2017/xerox-6360-sy-yl-106r01220,jpg', 0, '0', '<p>Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>', '<p>5000     5%     : Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>'),
	(617, '1', ' XEROX 6360 SY MG 106R01219', 0, 30.25, 0, 1, 0.65, 'xerox-6360-sy-mg-106r01219', 'TSTFX306M', 'http://tonersales,eu/shop/2016/xerox-6360-sy-mg-106r01219,jpg', 0, '0', '<p>Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>', '<p>5000     5%     : Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>'),
	(618, '1', ' XEROX 3150 BK 109R00747', 0, 31.46, 0, 1, 0.65, 'xerox-3150-bk-109r00747', 'TSFX101B', 'http://tonersales,eu/shop/745/xerox-3150-bk-109r00747,jpg', 0, '0', '<p>Xerox Phaser 3150</p>', '<p>5000     5%     : Xerox Phaser 3150</p>'),
	(619, '1', ' XEROX 3315 106R02311', 0, 33.18, 0, 1, 0.65, '-xerox-3315-106r02311', 'TS13317808**', 'http://tonersales,eu/shop/748/-xerox-3315-106r02311,jpg', 0, '0', '<p>Xerox WorkCentre 3315 , 3325</p>', '<p>5000     5%     : Xerox WorkCentre 3315 , 3325</p>'),
	(620, '1', ' XEROX 6121 HY BK 106R01469', 53, 27.27, 0, 101, 0.65, 'xerox-6121-hy-bk-106r01469', 'TSFX6121B', 'http://tonersales,eu/shop/269/xerox-6121-hy-bk-106r01469,jpg', 0, '0', '<p>xerox Phaser 6121MFP</p>', '<p>2600     5%     : xerox Phaser 6121MFP</p>'),
	(621, '1', ' XEROX 6121 HY CY 106R01466', 53, 27.27, 0, 1, 0.65, 'xerox-6121-hy-cy-106r01466', 'TSFX6121C', 'http://tonersales,eu/shop/270/xerox-6121-hy-cy-106r01466,jpg', 0, '0', '<p>xerox Phaser 6121MFP</p>', '<p>2600     5%     : xerox Phaser 6121MFP</p>'),
	(622, '1', ' XEROX 6121 HY YL 106R01468', 53, 27.27, 0, 1, 0.65, 'xerox-6121-hy-yl-106r01468', 'TSFX6121Y', 'http://tonersales,eu/shop/272/xerox-6121-hy-yl-106r01468,jpg', 0, '0', '<p>xerox Phaser 6121MFP</p>', '<p>2600     5%     : xerox Phaser 6121MFP</p>'),
	(623, '1', ' XEROX 6121 HY MG 106R01467', 53, 27.27, 0, 103, 0.65, 'xerox-6121-hy-mg-106r01467', 'TSFX6121M', 'http://tonersales,eu/shop/273/xerox-6121-hy-mg-106r01467,jpg', 0, '0', '<p>xerox Phaser 6121MFP</p>', '<p>2600     5%     : xerox Phaser 6121MFP</p>'),
	(624, '1', ' XEROX 6360 SY BK 106R01221', 0, 34, 0, 1, 0.65, 'xerox-6360-sy-bk-106r01221', 'TSTFX303B', 'http://tonersales,eu/shop/2019/xerox-6360-sy-bk-106r01221,jpg', 0, '0', '<p>Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>', '<p>9000     5%     : Xerox Phaser 6360N , 6360DN , 6360DT , 6360DX</p>'),
	(625, '1', ' XEROX P8E BK', 0, 34.2, 0, 1, 0.65, 'xerox-p8e-bk', 'TSRX001B', 'http://tonersales,eu/shop/746/xerox-p8e-bk,jpg', 0, '0', '<p>Xerox Docuprint P8E , P8EX , WorkCentre 385</p>', '<p>4500     5%     : Xerox Docuprint P8E , P8EX , WorkCentre 385</p>'),
	(626, '1', ' XEROX 3435 BK HY 106R01415', 0, 35.19, 0, 1, 0.65, 'xerox-3435-bk-hy-106r01415', 'TSRX026B', 'http://tonersales,eu/shop/747/xerox-3435-bk-hy-106r01415,jpg', 0, '0', '<p>Xerox Phaser 3435D , 3435DN</p>', '<p>10000     5%     : Xerox Phaser 3435D , 3435DN</p>'),
	(627, '1', ' XEROX 3215 , 3260 (106R02777)', 53, 37.49, 0, 110, 0.65, 'xerox-3215-3260-106r02777', 'TS13317499**', 'http://tonersales,eu/shop/276/xerox-3215-3260-106r02777,jpg', 0, '0', '<p>XEROX Phaser 3260 XEROX WorkCentre 3215 , 3225</p>', '<p>3000     5%     : XEROX Phaser 3260 XEROX WorkCentre 3215 , 3225</p>'),
	(628, '1', ' XEROX 6350 HY BK 106R01147', 1, 35.7, 0, 1, 0.65, 'xerox-6350-hy-bk-106r01147', 'TSFX6350B', 'http://tonersales,eu/shop/749/xerox-6350-hy-bk-106r01147,jpg', 0, '0', 'xerox Phaser 6300 , 6350', '10000     5%               :  xerox Phaser 6300 , 6350'),
	(629, '1', ' XEROX 6350 HY CY 106R01144', 0, 35.7, 0, 1, 0.65, 'xerox-6350-hy-cy-106r01144', 'TSFX6350C', 'http://tonersales,eu/shop/750/xerox-6350-hy-cy-106r01144,jpg', 0, '0', '<p>xerox Phaser 6300 , 6350</p>', '<p>10000     5%     : xerox Phaser 6300 , 6350</p>'),
	(630, '1', ' XEROX 6350 HY YL 106R01146', 1, 35.7, 0, 1, 0.65, 'xerox-6350-hy-yl-106r01146', 'TSFX6350Y', 'http://tonersales,eu/shop/751/xerox-6350-hy-yl-106r01146,jpg', 0, '0', 'xerox Phaser 6300 , 6350', '10000     5%               :  xerox Phaser 6300 , 6350'),
	(631, '1', ' XEROX 6350 HY MG 106R01145', 1, 35.7, 0, 1, 0.65, 'xerox-6350-hy-mg-106r01145', 'TSFX6350M', 'http://tonersales,eu/shop/752/xerox-6350-hy-mg-106r01145,jpg', 0, '0', 'xerox Phaser 6300 , 6350', '10000     5%               :  xerox Phaser 6300 , 6350'),
	(632, '1', ' XEROX 3320 106R02307 High Volume', 53, 33.04, 0, 1, 0.65, '-xerox-3320-106r02307-high-volume', 'TS13317811**', 'http://tonersales,eu/shop/277/-xerox-3320-106r02307-high-volume,jpg', 0, '0', '<p>Xerox phaser 3320</p>', '<p>11000     5%     : Xerox phaser 3320</p>'),
	(633, '1', ' XEROX 3325 106R02313 Extra High Volume', 0, 37.04, 0, 106, 0.65, '-xerox-3325-106r02313-extra-high-volume', 'TS13317809**', 'http://tonersales,eu/shop/753/-xerox-3325-106r02313-extra-high-volume,jpg', 0, '0', '<p>Xerox WorkCentre 3325</p>', '<p>11000     5%     : Xerox WorkCentre 3325</p>'),
	(634, '1', ' XEROX 5500 (Standard Volume) 113R00668', 0, 37.27, 0, 1, 0.65, 'xerox-5500-standard-volume-113r00668', 'TS13313114**', 'http://tonersales,eu/shop/754/xerox-5500-standard-volume-113r00668,jpg', 0, '0', '<p>XEROX Phaser 5500</p>', '<p>30000     5%     : XEROX Phaser 5500</p>'),
	(635, '1', ' XEROX dc12 006R90281 Cyan', 0, 37.49, 0, 1, 0.65, '-xerox-dc12-006r90281-cyan', 'TSDC-12C', 'http://tonersales,eu/shop/755/-xerox-dc12-006r90281-cyan,jpg', 0, '0', '<p>Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>', '<p>17500     5%     : Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>'),
	(636, '1', ' XEROX dc12 006R90282 Magenta', 0, 37.49, 0, 1, 0.65, '-xerox-dc12-006r90282-magenta', 'TSDC-12M', 'http://tonersales,eu/shop/756/-xerox-dc12-006r90282-magenta,jpg', 0, '0', '<p>Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>', '<p>17500     5%     : Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>'),
	(637, '1', ' XEROX dc12 006R90283 Yellow', 0, 37.49, 0, 1, 0.65, '-xerox-dc12-006r90283-yellow', 'TSDC-12Y', 'http://tonersales,eu/shop/757/-xerox-dc12-006r90283-yellow,jpg', 0, '0', '<p>Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>', '<p>17500     5%     : Xerox Docucolor DC12 , DC30 , DC1250 , DC1255 , 1255CP , CS50 , Docuprint C1255 , C1255CP</p>'),
	(638, '1', ' XEROX 5325 ,  5330 (006R01159)', 0, 37.56, 0, 1, 0.65, 'xerox-5325-5330-006r01159', 'TS13318631**', 'http://tonersales,eu/shop/758/xerox-5325-5330-006r01159,jpg', 0, '0', '<p>XEROX WorkCentre 5325 , 5330 , 5335</p>', '<p>30000     5%     : XEROX WorkCentre 5325 , 5330 , 5335</p>'),
	(639, '1', ' XEROX 5222 ,  5230 106R01306', 0, 45.89, 0, 1, 0.65, 'xerox-5222-5230-106r01306', 'TS13317850**', 'http://tonersales,eu/shop/759/xerox-5222-5230-106r01306,jpg', 0, '0', '<p>XEROX WorkCentre 5222 , 5225 , 5230</p>', '<p>30000     5%     : XEROX WorkCentre 5222 , 5225 , 5230</p>'),
	(640, '1', ' XEROX ML-6060 BK', 0, 38.7, 0, 1, 0.65, '#NAME?', 'TSRS029B', 'http://tonersales,eu/shop/760/-xerox-ml-6060-bk,jpg', 0, '0', '<p>Samsung ML-1440 , 1450 , 1451N , 6040 , 6060 , 6060N , 6060S , IBM InfoPrint 12 , NEC SuperScript 1400 , Xerox Docuprint P1210</p>', '<p>6000     5%     : Samsung ML-1440 , 1450 , 1451N , 6040 , 6060 , 6060N , 6060S , IBM InfoPrint 12 , NEC SuperScript 1400 , Xerox Docuprint P1210</p>'),
	(641, '1', ' XEROX 3550 106R01530 High Volume', 1, 38.82, 0, 1, 0.65, 'xerox-3550-106r01530-high-volume', 'TS13313166**', 'http://tonersales,eu/shop/761/xerox-3550-106r01530-high-volume,jpg', 0, '0', 'XEROX Phaser 3550', '11000     5%               :  XEROX Phaser 3550'),
	(642, '1', ' XEROX 5550 (106R01294)', 1, 41.81, 0, 1, 0.65, 'xerox-5550-106r01294', 'TS13313142**', 'http://tonersales,eu/shop/762/xerox-5550-106r01294,jpg', 0, '0', 'XEROX Phaser 5550', '30000     5%               :  XEROX Phaser 5550'),
	(643, '1', ' XEROX M123 , M128 006R01182', 0, 44.09, 0, 1, 0.65, 'xerox-m123-m128-006r01182', 'TS13315464**', 'http://tonersales,eu/shop/763/xerox-m123-m128-006r01182,jpg', 0, '0', '<p>XEROX CopyCentre C123 , C128 XEROX WorkCentre C123 , M123 , M128 , M133 , Pro123 , Pro128 , Pro133</p>', '<p>30000     5%     : XEROX CopyCentre C123 , C128 XEROX WorkCentre C123 , M123 , M128 , M133 , Pro123 , Pro128 , Pro133</p>'),
	(644, '1', ' XEROX C20 , M20 106R01048', 1, 46.37, 0, 1, 0.65, 'xerox-c20-m20-106r01048', 'TS13317814**', 'http://tonersales,eu/shop/764/xerox-c20-m20-106r01048,jpg', 0, '0', 'XEROX C20 , M20 , M20I', '8000     5%               :  XEROX C20 , M20 , M20I'),
	(645, '1', ' XEROX M15 106R00586', 1, 46.37, 0, 1, 0.65, 'xerox-m15-106r00586', 'TS13315497**', 'http://tonersales,eu/shop/765/xerox-m15-106r00586,jpg', 0, '0', 'XEROX WorkCentre M15 XEROX WorkCentre Pro 312 , PRO 412', '6000     5%               :  XEROX WorkCentre M15 XEROX WorkCentre Pro 312 , PRO 412'),
	(646, '1', ' XEROX 3100 (High Volume) 106R01379', 1, 49.28, 0, 1, 0.65, 'xerox-3100-high-volume-106r01379', 'TS13313139**', 'http://tonersales,eu/shop/766/xerox-3100-high-volume-106r01379,jpg', 0, '0', 'XEROX Phaser 3100MFP', '4000     5%               :  XEROX Phaser 3100MFP'),
	(647, '1', ' XEROX 3655 (106R02740) (Extra HY)', 0, 49.71, 0, 1, 0.65, 'xerox-3655-106r02740-extra-hy', 'TS13318672**', 'http://tonersales,eu/shop/767/xerox-3655-106r02740-extra-hy,jpg', 0, '0', '<p>XEROX WorkCentre 3655</p>', '<p>25900     5%     : XEROX WorkCentre 3655</p>'),
	(648, '1', ' XEROX 006R01278 4118', 0, 50.12, 0, 1, 0.65, '-xerox-006r01278-4118', 'TS13313150**', 'http://tonersales,eu/shop/2020/-xerox-006r01278-4118,jpg', 0, '0', '<p>Xerox WorkCentre 4118 , 4118P , 4118X</p>', '<p>8000     5%     : Xerox WorkCentre 4118 , 4118P , 4118X</p>'),
	(649, '1', ' XEROX 6120 HY BK (113R00692)', 0, 52.04, 0, 1, 0.65, 'xerox-6120-hy-bk-113r00692', 'TSFX180B', 'http://tonersales,eu/shop/770/xerox-6120-hy-bk-113r00692,jpg', 0, '0', '<p>Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>', '<p>4500     5%     : Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>'),
	(650, '1', ' XEROX 6120 HY CY (113R00693)', 0, 52.04, 0, 101, 0.65, 'xerox-6120-hy-cy-113r00693', 'TSFX181C', 'http://tonersales,eu/shop/771/xerox-6120-hy-cy-113r00693,jpg', 0, '0', '<p>Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>', '<p>4500     5%     : Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>'),
	(651, '1', ' XEROX 6120 HY YL (113R00694)', 0, 52.04, 0, 101, 0.65, 'xerox-6120-hy-yl-113r00694', 'TSFX182Y', 'http://tonersales,eu/shop/772/xerox-6120-hy-yl-113r00694,jpg', 0, '0', '<p>Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>', '<p>4500     5%     : Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>'),
	(652, '1', ' XEROX 6120 HY MG (113R00695)', 0, 52.04, 0, 101, 0.65, 'xerox-6120-hy-mg-113r00695', 'TSFX183M', 'http://tonersales,eu/shop/773/xerox-6120-hy-mg-113r00695,jpg', 0, '0', '<p>Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>', '<p>4500     5%     : Xerox Phaser 6115MFPD , 6115MFPN , 6120 , 6120N</p>'),
	(653, '1', ' XEROX 7500 (106R01439) BK (High Volume)', 0, 53.27, 0, 1, 0.65, 'xerox-7500-106r01439-bk-high-volume', 'TS13317424**', 'http://tonersales,eu/shop/2022/xerox-7500-106r01439-bk-high-volume,jpg', 0, '0', '<p>XEROX Phaser 7500</p>', '<p>19800     5%     : XEROX Phaser 7500</p>'),
	(654, '1', ' XEROX 7500 (106R01436) CY (High Volume)', 0, 53.27, 0, 1, 0.65, 'xerox-7500-106r01436-cy-high-volume', 'TS13317425**', 'http://tonersales,eu/shop/2023/xerox-7500-106r01436-cy-high-volume,jpg', 0, '0', '<p>XEROX Phaser 7500</p>', '<p>17800     5%     : XEROX Phaser 7500</p>'),
	(655, '1', ' XEROX 7500 (106R01437) MG (High Volume)', 0, 53.27, 0, 1, 0.65, 'xerox-7500-106r01437-mg-high-volume', 'TS13317426**', 'http://tonersales,eu/shop/2021/xerox-7500-106r01437-mg-high-volume,jpg', 0, '0', '<p>XEROX Phaser 7500</p>', '<p>17800     5%     : XEROX Phaser 7500</p>'),
	(656, '1', ' XEROX 7500 (106R01438) YL (High Volume)', 0, 53.27, 0, 1, 0.65, 'xerox-7500-106r01438-yl-high-volume', 'TS13317427**', 'http://tonersales,eu/shop/2024/xerox-7500-106r01438-yl-high-volume,jpg', 0, '0', '<p>XEROX Phaser 7500</p>', '<p>17800     5%     : XEROX Phaser 7500</p>'),
	(657, '1', ' XEROX 3500 HY BK 106R01149', 0, 55.9, 0, 1, 0.65, 'xerox-3500-hy-bk-106r01149', 'TSRX028B', 'http://tonersales,eu/shop/778/xerox-3500-hy-bk-106r01149,jpg', 0, '0', '<p>Xerox 3500N</p>', '<p>12000     5%     : Xerox 3500N</p>'),
	(658, '1', ' XEROX 3610 (106R02731)  (Extra HY)', 0, 56.81, 0, 1, 0.65, 'xerox-3610-106r02731-extra-hy', 'TS13318629**', 'http://tonersales,eu/shop/779/xerox-3610-106r02731-extra-hy,jpg', 0, '0', '<p>XEROX Phaser 3610 XEROX WorkCentre 3615</p>', '<p>25300     5%     : XEROX Phaser 3610 XEROX WorkCentre 3615</p>'),
	(659, '1', ' XEROX 6100 HY BK (106R00684)', 0, 60.13, 0, 1, 0.65, 'xerox-6100-hy-bk-106r00684', 'TSFX168B', 'http://tonersales,eu/shop/782/xerox-6100-hy-bk-106r00684,jpg', 0, '0', '<p>Xerox Phaser 6100 Series</p>', '<p>7000     5%     : Xerox Phaser 6100 Series</p>'),
	(660, '1', ' XEROX 3610HY CY (106R00680)', 0, 60.13, 0, 1, 0.65, 'xerox-3610hy-cy-106r00680', 'TSFX169C', 'http://tonersales,eu/shop/781/xerox-3610hy-cy-106r00680,jpg', 0, '0', '<p>Xerox Phaser 6100 Series</p>', '<p>5000     5%     : Xerox Phaser 6100 Series</p>'),
	(661, '1', ' XEROX 6100 HY MG (106R00681)', 1, 60.13, 0, 1, 0.65, 'xerox-6100-hy-mg-106r00681', 'TSFX170M', 'http://tonersales,eu/shop/783/xerox-6100-hy-mg-106r00681,jpg', 0, '0', 'Xerox Phaser 6100 Series', '5000     5%               :  Xerox Phaser 6100 Series'),
	(662, '1', ' XEROX 6100 HY YL (106R00682)', 0, 60.13, 0, 1, 0.65, 'xerox-6100-hy-yl-106r00682', 'TSFX171Y', 'http://tonersales,eu/shop/784/xerox-6100-hy-yl-106r00682,jpg', 0, '0', '<p>Xerox Phaser 6100 Series</p>', '<p>5000     5%     : Xerox Phaser 6100 Series</p>'),
	(663, '1', ' XEROX 7750BK 106R00652', 0, 61.08, 0, 1, 0.65, '-xerox-7750bk-106r00652', 'TSDCC7750K', 'http://tonersales,eu/shop/2026/-xerox-7750bk-106r00652,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7750 , EX7750</p>', '<p>27000     5%     : Xerox Tektronix Phaser 7750 , EX7750</p>'),
	(664, '1', ' XEROX 7760BK 106R01163', 0, 61.08, 0, 1, 0.65, '-xerox-7760bk-106r01163', 'TSDCC7760K', 'http://tonersales,eu/shop/2025/-xerox-7760bk-106r01163,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>', '<p>27000     5%     : Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>'),
	(665, '1', ' XEROX C35 ,  C45 ,  M35 ,  M45 (006R01046)', 0, 62.27, 0, 13, 0.65, 'xerox-c35-c45-m35-m45-006r01046', 'TS13315448**', 'http://tonersales,eu/shop/787/xerox-c35-c45-m35-m45-006r01046,jpg', 0, '0', '<p>XEROX WorkCentre Pro245 , Pro255 , Pro45 , Pro232 , Pro238 , Pro55 , Pro35 WorkCentre M35 , 45 , M55 ,WorkCentre5645 , 5655 , 5632 , 5638 ,WorkCentre 5735 , 5740 , 5745 , 5755 , 232 , 238 , 245 , 255 CopyCentre232 , 238 , 245 , 255 ,CopyCentre C55 , 35 , 45 Digital Copier</p>', '<p>30000     5%     : XEROX WorkCentre Pro245 , Pro255 , Pro45 , Pro232 , Pro238 , Pro55 , Pro35 WorkCentre M35 , 45 , M55 ,WorkCentre5645 , 5655 , 5632 , 5638 ,WorkCentre 5735 , 5740 , 5745 , 5755 , 232 , 238 , 245 , 255 CopyCentre232 , 238 , 245 , 255 ,CopyCentre C55 , 35 , 45 Digital Copier</p>'),
	(666, '1', ' XEROX 3600 JUMBO 106R01371', 0, 63.37, 0, 1, 0.65, 'xerox-3600-jumbo-106r01371', 'TSTRX051B', 'http://tonersales,eu/shop/788/xerox-3600-jumbo-106r01371,jpg', 0, '0', '<p>Xerox Phaser 3600B , 3600N , 3600DN , 3600EDN</p>', '<p>20000     5%     : Xerox Phaser 3600B , 3600N , 3600DN , 3600EDN</p>'),
	(667, '1', ' XEROX M24 (006R01154) CY', 0, 63.37, 0, 1, 0.65, 'xerox-m24-006r01154-cy', 'TS13315483**', 'http://tonersales,eu/shop/2027/xerox-m24-006r01154-cy,jpg', 0, '0', '<p>XEROX WorkCente M24</p>', '<p>15000     5%     : XEROX WorkCente M24</p>'),
	(668, '1', ' XEROX M24 (006R01155) MG', 0, 63.37, 0, 1, 0.65, 'xerox-m24-006r01155-mg', 'TS13315484**', 'http://tonersales,eu/shop/2028/xerox-m24-006r01155-mg,jpg', 0, '0', '<p>XEROX WorkCente M24</p>', '<p>15000     5%     : XEROX WorkCente M24</p>'),
	(669, '1', ' XEROX M24 (006R01156) YL', 0, 63.37, 0, 1, 0.65, 'xerox-m24-006r01156-yl', 'TS13315485**', 'http://tonersales,eu/shop/2029/xerox-m24-006r01156-yl,jpg', 0, '0', '<p>XEROX WorkCente M24</p>', '<p>15000     5%     : XEROX WorkCente M24</p>'),
	(670, '1', ' XEROX 3535 (006R01123) CY', 0, 64.5, 0, 1, 0.65, 'xerox-3535-006r01123-cy', 'TS13315467**', 'http://tonersales,eu/shop/2031/xerox-3535-006r01123-cy,jpg', 0, '0', '<p>XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>', '<p>15000     5%     : XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>'),
	(671, '1', ' XEROX 3535 (006R01124) MG', 0, 64.5, 0, 1, 0.65, 'xerox-3535-006r01124-mg', 'TS13315468**', 'http://tonersales,eu/shop/2032/xerox-3535-006r01124-mg,jpg', 0, '0', '<p>XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>', '<p>15000     5%     : XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>'),
	(672, '1', ' XEROX 3535 (006R01125) YL', 0, 64.5, 0, 1, 0.65, 'xerox-3535-006r01125-yl', 'TS13315469**', 'http://tonersales,eu/shop/2030/xerox-3535-006r01125-yl,jpg', 0, '0', '<p>XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>', '<p>15000     5%     : XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>'),
	(673, '1', ' XEROX 4400 113R00628', 0, 68.17, 0, 1, 0.65, 'xerox-4400-113r00628', 'TSJ00158', 'http://tonersales,eu/shop/796/xerox-4400-113r00628,jpg', 0, '0', '<p>Xerox Tektronix Phaser 4400 , 4400B , 4400DT , 4400DX , 440MDX , 440N , 4400V , 4400V , MB , 4400V , MDT , 4400V , MDX , 4400V</p>', '<p>15000     5%     : Xerox Tektronix Phaser 4400 , 4400B , 4400DT , 4400DX , 440MDX , 440N , 4400V , 4400V , MB , 4400V , MDT , 4400V , MDX , 4400V</p>'),
	(674, '1', ' XEROX 7750CY 106R00653', 0, 69.59, 0, 1, 0.65, '-xerox-7750cy-106r00653', 'TSDCC7750C', 'http://tonersales,eu/shop/798/-xerox-7750cy-106r00653,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7750 , EX7750</p>', '<p>16000     5%     : Xerox Tektronix Phaser 7750 , EX7750</p>'),
	(675, '1', ' XEROX 7750MG 106R00654', 0, 69.59, 0, 1, 0.65, '-xerox-7750mg-106r00654', 'TSDCC7750M', 'http://tonersales,eu/shop/799/-xerox-7750mg-106r00654,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7750 , EX7750</p>', '<p>16000     5%     : Xerox Tektronix Phaser 7750 , EX7750</p>'),
	(676, '1', ' XEROX 7750YL 106R00655', 0, 69.59, 0, 1, 0.65, '-xerox-7750yl-106r00655', 'TSDCC7750Y', 'http://tonersales,eu/shop/800/-xerox-7750yl-106r00655,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7750 , EX7750</p>', '<p>16000     5%     : Xerox Tektronix Phaser 7750 , EX7750</p>'),
	(677, '1', ' XEROX 7760CY 106R01160', 0, 69.59, 0, 1, 0.65, '-xerox-7760cy-106r01160', 'TSDCC7760C', 'http://tonersales,eu/shop/2035/-xerox-7760cy-106r01160,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>', '<p>16000     5%     : Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>'),
	(678, '1', ' XEROX 7760MG 106R01161', 0, 69.59, 0, 1, 0.65, '-xerox-7760mg-106r01161', 'TSDCC7760M', 'http://tonersales,eu/shop/2033/-xerox-7760mg-106r01161,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>', '<p>16000     5%     : Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>'),
	(679, '1', ' XEROX 7760YL 106R01162', 0, 69.59, 0, 1, 0.65, '-xerox-7760yl-106r01162', 'TSDCC7760Y', 'http://tonersales,eu/shop/2034/-xerox-7760yl-106r01162,jpg', 0, '0', '<p>Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>', '<p>16000     5%     : Xerox Tektronix Phaser 7760 , 7760DN , 7760DX</p>'),
	(680, '1', ' XEROX M24 (006R01153) BK', 0, 73.82, 0, 1, 0.65, 'xerox-m24-006r01153-bk', 'TS13315482**', 'http://tonersales,eu/shop/2036/xerox-m24-006r01153-bk,jpg', 0, '0', '<p>XEROX WorkCente M24</p>', '<p>27000     5%     : XEROX WorkCente M24</p>'),
	(681, '1', ' XEROX 4500 (113R00657) (High Volume)', 0, 75.44, 0, 1, 0.65, 'xerox-4500-113r00657-high-volume', 'TS13315406**', 'http://tonersales,eu/shop/805/xerox-4500-113r00657-high-volume,jpg', 0, '0', '<p>XEROX Phaser 4500</p>', '<p>18000     5%     : XEROX Phaser 4500</p>'),
	(682, '1', ' XEROX 3535 (006R01122) BK', 0, 76.09, 0, 1, 0.65, 'xerox-3535-006r01122-bk', 'TS13315466**', 'http://tonersales,eu/shop/2037/xerox-3535-006r01122-bk,jpg', 0, '0', '<p>XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>', '<p>26000     5%     : XEROX worcentre Pro40 , Pro 32 XEROX DocuColor DC1632 , DC2240 , DC3535 XEROX Copycentre C40 , C32 XEROX Creo Spire CXP3535E XEROX Splash G3535 XEROX Fiery EX 3535</p>'),
	(683, '1', ' XEROX 4510 (113R00712) (High Volume)', 0, 77.5, 0, 1, 0.65, 'xerox-4510-113r00712-high-volume', 'TS13315408**', 'http://tonersales,eu/shop/806/xerox-4510-113r00712-high-volume,jpg', 0, '0', '<p>XEROX Phaser 4510</p>', '<p>19000     5%     : XEROX Phaser 4510</p>'),
	(684, '1', ' XEROX 6180 HY BK 113R00726', 0, 79.09, 0, 1, 0.65, 'xerox-6180-hy-bk-113r00726', 'TSTRX052B', 'http://tonersales,eu/shop/807/xerox-6180-hy-bk-113r00726,jpg', 0, '0', '<p>Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N</p>', '<p>8000     5%     : Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N</p>'),
	(685, '1', ' XEROX 6180 HY CY 113R00723', 0, 79.09, 0, 1, 0.65, 'xerox-6180-hy-cy-113r00723', 'TSTRX053C', 'http://tonersales,eu/shop/808/xerox-6180-hy-cy-113r00723,jpg', 0, '0', '<p>Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N</p>', '<p>6000     5%     : Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N</p>'),
	(686, '1', ' XEROX 6180 HY MG 113R00724', 1, 79.09, 0, 1, 0.65, 'xerox-6180-hy-mg-113r00724', 'TSTRX054M', 'http://tonersales,eu/shop/809/xerox-6180-hy-mg-113r00724,jpg', 0, '0', 'Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N', '6000     5%               :  Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N'),
	(687, '1', ' XEROX 6180 HY YL 113R00725', 1, 79.09, 0, 1, 0.65, 'xerox-6180-hy-yl-113r00725', 'TSTRX055Y', 'http://tonersales,eu/shop/810/xerox-6180-hy-yl-113r00725,jpg', 0, '0', 'Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N', '6000     5%               :  Xerox Phaser 6180N , 6180DN , 6180MFP-D , 6180MPF-N'),
	(688, '1', ' XEROX 6280 HY CY 106R01392', 0, 81.9, 0, 1, 0.65, 'xerox-6280-hy-cy-106r01392', 'TSTRX043C', 'http://tonersales,eu/shop/812/xerox-6280-hy-cy-106r01392,jpg', 0, '0', '<p>Xerox Phaser 6280</p>', '<p>5900     5%     : Xerox Phaser 6280</p>'),
	(689, '1', ' XEROX 6280 HY YL 106R01394', 0, 81.9, 0, 1, 0.65, 'xerox-6280-hy-yl-106r01394', 'TSTRX044Y', 'http://tonersales,eu/shop/811/xerox-6280-hy-yl-106r01394,jpg', 0, '0', '<p>Xerox Phaser 6280</p>', '<p>5900     5%     : Xerox Phaser 6280</p>'),
	(690, '1', ' XEROX 6280 HY MG 106R01393', 1, 81.9, 0, 1, 0.65, 'xerox-6280-hy-mg-106r01393', 'TSTRX045M', 'http://tonersales,eu/shop/813/xerox-6280-hy-mg-106r01393,jpg', 0, '0', 'Xerox Phaser 6280', '5900     5%               :  Xerox Phaser 6280'),
	(691, '1', ' XEROX 7120 ,  7125 BK 006R01457', 0, 82.4, 0, 1, 0.65, 'xerox-7120-7125-bk-006r01457', 'TS13315449**', 'http://tonersales,eu/shop/815/xerox-7120-7125-bk-006r01457,jpg', 0, '0', '<p>xerox WorkCentre 7120 , 7125</p>', '<p>22000     5%     : xerox WorkCentre 7120 , 7125</p>'),
	(692, '1', ' XEROX 7120 ,  7125 CY 006R01460', 0, 82.4, 0, 1, 0.65, 'xerox-7120-7125-cy-006r01460', 'TS13315451**', 'http://tonersales,eu/shop/816/xerox-7120-7125-cy-006r01460,jpg', 0, '0', '<p>xerox WorkCentre 7120 , 7125</p>', '<p>15000     5%     : xerox WorkCentre 7120 , 7125</p>'),
	(693, '1', ' XEROX 7120 ,  7125 MG 006R01459', 0, 82.4, 0, 1, 0.65, 'xerox-7120-7125-mg-006r01459', 'TS13315452**', 'http://tonersales,eu/shop/817/xerox-7120-7125-mg-006r01459,jpg', 0, '0', '<p>xerox WorkCentre 7120 , 7125</p>', '<p>15000     5%     : xerox WorkCentre 7120 , 7125</p>'),
	(694, '1', ' XEROX 7120 ,  7125 YL 006R01458', 1, 82.4, 0, 1, 0.65, 'xerox-7120-7125-yl-006r01458', 'TS13315453**', 'http://tonersales,eu/shop/818/xerox-7120-7125-yl-006r01458,jpg', 0, '0', 'xerox WorkCentre 7120 , 7125', '15000     5%               :  xerox WorkCentre 7120 , 7125'),
	(695, '1', ' XEROX 6280 HY BK 106R01395', 0, 84.15, 0, 1, 0.65, 'xerox-6280-hy-bk-106r01395', 'TSTRX042B', 'http://tonersales,eu/shop/814/xerox-6280-hy-bk-106r01395,jpg', 0, '0', '<p>Xerox Phaser 6280</p>', '<p>7000     5%     : Xerox Phaser 6280</p>'),
	(696, '1', ' XEROX 4250 ,  4260 106R01409', 0, 85.19, 0, 1, 0.65, 'xerox-4250-4260-106r01409', 'TS13315479**', 'http://tonersales,eu/shop/820/xerox-4250-4260-106r01409,jpg', 0, '0', '<p>XEROX WorkCentre 250 , 4250X , 4250S , 4250C , 4250XF XEROX WorkCentre 4260 , 4260S , 4260X , 4260XF</p>', '<p>25000     5%     : XEROX WorkCentre 250 , 4250X , 4250S , 4250C , 4250XF XEROX WorkCentre 4260 , 4260S , 4260X , 4260XF</p>'),
	(697, '1', ' XEROX 4600 (106R01535) (HY)', 0, 85.23, 0, 1, 0.65, 'xerox-4600-106r01535-hy', 'TS13317478**', 'http://tonersales,eu/shop/819/xerox-4600-106r01535-hy,jpg', 0, '0', '<p>XEROX Phaser 4600 , 4620 , 4622</p>', '<p>30000     5%     : XEROX Phaser 4600 , 4620 , 4622</p>'),
	(698, '1', ' XEROX 6700 BK 106R01510 High Volume', 1, 100.41, 0, 1, 0.65, 'xerox-6700-bk-106r01510-high-volume', 'TS13315475**', 'http://tonersales,eu/shop/821/xerox-6700-bk-106r01510-high-volume,jpg', 0, '0', 'XEROX Phaser 6700', '18000     5%               :  XEROX Phaser 6700'),
	(699, '1', ' XEROX 6700 CY 106R01507 High Volume', 0, 100.41, 0, 1, 0.65, 'xerox-6700-cy-106r01507-high-volume', 'TS13315476**', 'http://tonersales,eu/shop/822/xerox-6700-cy-106r01507-high-volume,jpg', 0, '0', '<p>XEROX Phaser 6700</p>', '<p>12000     5%     : XEROX Phaser 6700</p>'),
	(700, '1', ' XEROX 6700 MG 106R01508 High Volume', 1, 100.41, 0, 1, 0.65, 'xerox-6700-mg-106r01508-high-volume', 'TS13315477**', 'http://tonersales,eu/shop/823/xerox-6700-mg-106r01508-high-volume,jpg', 0, '0', 'XEROX Phaser 6700', '12000     5%               :  XEROX Phaser 6700'),
	(701, '1', ' XEROX 6700 YL 106R01509 High Volume', 1, 100.41, 0, 1, 0.65, 'xerox-6700-yl-106r01509-high-volume', 'TS13315478**', 'http://tonersales,eu/shop/824/xerox-6700-yl-106r01509-high-volume,jpg', 0, '0', 'XEROX Phaser 6700', '12000     5%               :  XEROX Phaser 6700'),
	(702, '1', ' LEXMARK SCX-4100 , ML-1510 , 1710', 53, 16.43, 0, 50, 0.65, '#NAME?', 'TSFS364B2', 'http://tonersales,eu/shop/171/-lexmark-scx-4100-ml-1510-1710,jpg', 0, '0', '<p>SAMSUNG ML-1500 , 1755 , 1745 SAMSUNG SCX-4100 LEXMARK X215</p>', '<p>3000     5%     : SAMSUNG ML-1500 , 1755 , 1745 SAMSUNG SCX-4100 LEXMARK X215</p>'),
	(703, '1', ' LEXMARK X203 X203A11E', 53, 19.36, 0, 112, 0.65, 'lexmark-x203-x203a11e', 'TSFL0X203B', 'http://tonersales,eu/shop/280/lexmark-x203-x203a11e,jpg', 0, '0', '<p>Lexmark LM X203T/X204T (3K)</p>', '<p>3000     5%     : Lexmark X203N , X204N</p>'),
	(704, '1', ' LEXMARK ML-1710 ,  SF-D560RA', 53, 16.43, 0, 50, 0.65, '#NAME?', 'TSFS364B', 'http://tonersales,eu/shop/172/-lexmark-ml-1710-sf-d560ra,jpg', 0, '0', '<p>Samsung ML1500 , ML1510 , ML1520 , 1520P , ML1755 , ML1710 , ML1740 , ML1745 , ML1750 Samsung SCX4016 , SCX4100 , SCX4116 , SCX4216 , 4216F Xerox Workcentre PE16 Xerox WorkCentre PE114E Xerox 3115 , 3116 , 3120 , 3121 , 3130 Samsung SF560R , 560RC , SF565RN , Lexmark X215</p>', '<p>3000     5%     : Samsung ML1500 , ML1510 , ML1520 , 1520P , ML1755 , ML1710 , ML1740 , ML1745 , ML1750 Samsung SCX4016 , SCX4100 , SCX4116 , SCX4216 , 4216F Xerox Workcentre PE16 Xerox WorkCentre PE114E Xerox 3115 , 3116 , 3120 , 3121 , 3130 Samsung SF560R , 560RC , SF565RN , Lexmark X215</p>'),
	(705, '1', ' LEXMARK E-250 (250A11E)', 53, 21.53, 0, 113, 0.65, 'lexmark-e-250-250a11e', 'TSFL022B', 'http://tonersales,eu/shop/279/lexmark-e-250-250a11e,jpg', 0, '0', '<p>Lexmark E250D , E250DN , E350D , E350DN , E352DN</p>', '<p>3500     5%     : Lexmark E250D , E250DN , E350D , E350DN , E352DN</p>'),
	(706, '1', ' LEXMARK E-120 (12016SE)', 53, 15.73, 0, 112, 0.65, 'lexmark-e-120-12016se', 'TSRL025B', 'http://tonersales,eu/shop/289/lexmark-e-120-12016se,jpg', 0, '0', '<p>Lexmark E120N , E120</p>', '<p>2000     5%     : Lexmark E120N , E120</p>'),
	(707, '1', ' LEXMARK E-350 (352H11E)', 0, 24.32, 0, 117, 0.65, 'lexmark-e-350-352h11e', 'TSFL024B', 'http://tonersales,eu/shop/93/lexmark-e-350-352h11e,jpg', 0, '0', '<p>Lexmark E350D , E350DN , 352DN</p>', '<p>9000     5%     : Lexmark E350D , E350DN , 352DN</p>'),
	(708, '1', ' LEXMARK X-340 (X340A11G)', 0, 24.55, 0, 110, 0.65, 'lexmark-x-340-x340a11g', 'TSFL021B', 'http://tonersales,eu/shop/538/lexmark-x-340-x340a11g,jpg', 0, '0', '<p>Lexmark X340 , X342 Series MFP</p>', '<p>6500     5%     : Lexmark X340 , X342 Series MFP</p>'),
	(709, '1', ' LEXMARK ML-1210D3 UNV BK (SF5100 , ML4300 , ML1210)', 53, 17.11, 0, 1, 0.65, '-lexmark-ml-1210d3-unv-bk-sf5100-ml4300-ml1210', 'TSFS203B', 'http://tonersales,eu/shop/539/-lexmark-ml-1210d3-unv-bk-sf5100-ml4300-ml1210,jpg', 0, '0', '<p>Samsung ML-1010 , 1020M , 1210 , 1220M , 1250 , 1430 ,SF-515 , 530 , 531P , 535E ,SF-5100 , 5100P ,Msys-5100p ,ML-808 Xerox Phaser 3110 , 3210 , WorkCentre Pro 580 Lexmark E210</p>', '<p>3000     5%     : Samsung ML-1010 , 1020M , 1210 , 1220M , 1250 , 1430 ,SF-515 , 530 , 531P , 535E ,SF-5100 , 5100P ,Msys-5100p ,ML-808 Xerox Phaser 3110 , 3210 , WorkCentre Pro 580 Lexmark E210</p>'),
	(710, '1', ' LEXMARK E-450 HY 450H11E', 0, 25.97, 0, 1, 0.65, 'lexmark-e-450-hy-450h11e', 'TSFL025B', 'http://tonersales,eu/shop/540/lexmark-e-450-hy-450h11e,jpg', 0, '0', '<p>Lexmark E450DN</p>', '<p>11000     5%     : Lexmark E450DN</p>'),
	(711, '1', ' LEXMARK E-230 , E-240  , E-232 34016HE', 53, 19.07, 0, 104, 0.65, 'lexmark-e-230-e-240-e-232-34016he', 'TSFD023BSY', 'http://tonersales,eu/shop/198/lexmark-e-230-e-240-e-232-34016he,jpg', 0, '0', '<p>LEXMARK E230 , E232 , E232T , E238 , E332TN , E234 , E240 , E240N , E330 , E332 , E332N , E340 , E342 , E342N , E342TN DELL 1700 , 1700n , 1710 , 1710n</p>', '<p>6000     5%     : LEXMARK E230 , E232 , E232T , E238 , E332TN , E234 , E240 , E240N , E330 , E332 , E332N , E340 , E342 , E342N , E342TN DELL 1700 , 1700n , 1710 , 1710n</p>'),
	(712, '1', ' LEXMARK LM  X364T', 53, 17.09, 0, 122, 0.65, 'lexmark-lm-x364t', 'TSFL030B', 'http://tonersales,eu/shop/92/lexmark-lm-x364t,jpg', 0, '0', '<p>LEXMARK X364T (9K)</p>', '<p>9000   <span>  5%</span>    LEXMARK X264/X363/X364</p>'),
	(713, '1', ' LEXMARK E-310 BK 13T0101', 1, 34.2, 0, 1, 0.65, 'lexmark-e-310-bk-13t0101', 'TSFL0310B', 'http://tonersales,eu/shop/541/lexmark-e-310-bk-13t0101,jpg', 0, '0', 'Lexmark Optra E310 , E312 , E312L', '5400     5%               :  Lexmark Optra E310 , E312 , E312L'),
	(714, '1', ' LEXMARK E-260 260A11E', 53, 29, 0, 103, 0.65, 'lexmark-e-260-260a11e', 'TSTFL067B', 'http://tonersales,eu/shop/91/lexmark-e-260-260a11e,jpg', 0, '0', '<p>Lexmark E260D , E260DN , E360D , E360DN , E460DN , E460DW , E462DTN</p>', '<p>3500     5%     : Lexmark E260D , E260DN , E360D , E360DN , E460DN , E460DW , E462DTN</p>'),
	(715, '1', ' LEXMARK C540H2K', 0, 44.04, 0, 102, 0.65, '-lexmark-c540h2k', 'TS13310564**', 'http://tonersales,eu/shop/542/-lexmark-c540h2k,jpg', 0, '0', '<p>Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>', '<p>2500     5%     : Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>'),
	(716, '1', ' LEXMARK C540H2C', 0, 44.04, 0, 102, 0.65, '-lexmark-c540h2c', 'TS13310565**', 'http://tonersales,eu/shop/543/-lexmark-c540h2c,jpg', 0, '0', '<p>Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>', '<p>2000     5%     : Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>'),
	(717, '1', ' LEXMARK C540H2MG', 0, 44.04, 0, 102, 0.65, '-lexmark-c540h2mg', 'TS13310566**', 'http://tonersales,eu/shop/544/-lexmark-c540h2mg,jpg', 0, '0', '<p>Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>', '<p>2000     5%     : Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>'),
	(718, '1', ' LEXMARK C540H2Y', 0, 44.04, 0, 102, 0.65, '-lexmark-c540h2y', 'TS13310567**', 'http://tonersales,eu/shop/545/-lexmark-c540h2y,jpg', 0, '0', '<p>Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>', '<p>2000     5%     : Lexmark C54X , X54X , C543DN , X543DN , C540N , C544dn , C546 , X564</p>'),
	(719, '1', ' LEXMARK W840 W84020H', 0, 44.09, 0, 1, 0.65, 'lexmark-w840-w84020h', 'TS13310568**', 'http://tonersales,eu/shop/546/lexmark-w840-w84020h,jpg', 0, '0', '<p>LEXMARK W840</p>', '<p>30000     5%     : LEXMARK W840</p>'),
	(720, '1', ' LEXMARK W850 W850H21G', 0, 44.09, 0, 1, 0.65, '#NAME?', 'TS13310523**', 'http://tonersales,eu/shop/547/-lexmark-w850-w850h21g,jpg', 0, '0', '<p>LEXMARK W850 , W850DN , W850N</p>', '<p>35000     5%     : LEXMARK W850 , W850DN , W850N</p>'),
	(721, '1', ' LEXMARK MS310 , MS510 , MS610 HY 50F2H00', 53, 41.69, 0, 103, 0.65, '-lexmark-ms310-ms510-ms610-hy-50f2h00', 'TS13310569**', 'http://tonersales,eu/shop/281/-lexmark-ms310-ms510-ms610-hy-50f2h00,jpg', 0, '0', '<p>Lexmark MS-310x , MS-410x , MS-510x , MS-610x MS310 , MS410 , MS510 , MS610 , MS312 , MS315 , MS415</p>', '<p>5000     5%     : Lexmark MS-310x , MS-410x , MS-510x , MS-610x MS310 , MS410 , MS510 , MS610 , MS312 , MS315 , MS415</p>'),
	(722, '1', ' LEXMARK E-360 360H11E', 53, 35.48, 0, 109, 0.65, 'lexmark-e-360-360h11e', 'TSTFL066B', 'http://tonersales,eu/shop/283/lexmark-e-360-360h11e,jpg', 0, '0', '<p>Lexmark E360D , E360DN , E460DN , E460DW , E462DTN</p>', '<p>9000     5%     : Lexmark E360D , E360DN , E460DN , E460DW , E462DTN</p>'),
	(723, '1', ' LEXMARK C544X1K HY', 0, 56.81, 0, 1, 0.65, '-lexmark-c544x1k-hy', 'TS13310560**', 'http://tonersales,eu/shop/548/-lexmark-c544x1k-hy,jpg', 0, '0', '<p>LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>', '<p>6000     5%     : LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>'),
	(724, '1', ' LEXMARK C544X1C HY', 0, 56.81, 0, 1, 0.65, '-lexmark-c544x1c-hy', 'TS13310561**', 'http://tonersales,eu/shop/549/-lexmark-c544x1c-hy,jpg', 0, '0', '<p>LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>', '<p>4000     5%     : LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>'),
	(725, '1', ' LEXMARK C544X1M HY', 0, 56.81, 0, 1, 0.65, '-lexmark-c544x1m-hy', 'TS13310562**', 'http://tonersales,eu/shop/550/-lexmark-c544x1m-hy,jpg', 0, '0', '<p>LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>', '<p>4000     5%     : LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>'),
	(726, '1', ' LEXMARK C544X1Y HY', 0, 56.81, 0, 1, 0.65, '-lexmark-c544x1y-hy', 'TS13310563**', 'http://tonersales,eu/shop/551/-lexmark-c544x1y-hy,jpg', 0, '0', '<p>LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>', '<p>4000     5%     : LEXMARK C544DN , C544N , C544DTN , C544DW , C546 , X544DN , X544N , X544DTN , X544DW , X546 , 548</p>'),
	(727, '1', ' LEXMARK E-321 HY BK (12A7405)', 0, 58.98, 0, 1, 0.65, 'lexmark-e-321-hy-bk-12a7405', 'TSRL015B', 'http://tonersales,eu/shop/552/lexmark-e-321-hy-bk-12a7405,jpg', 0, '0', '<p>Lexmark E321 , E323 , 323N , 323T</p>', '<p>6000     5%     : Lexmark E321 , E323 , 323N , 323T</p>'),
	(728, '1', ' LEXMARK E-322 E-320 HY BK (08A0478)', 1, 63.12, 0, 1, 0.65, 'lexmark-e-322-e-320-hy-bk-08a0478', 'TSRL030B', 'http://tonersales,eu/shop/553/lexmark-e-322-e-320-hy-bk-08a0478,jpg', 0, '0', 'Lexmark E320 , 320N , E322 , 322N', '6000     5%               :  Lexmark E320 , 320N , E322 , 322N'),
	(729, '1', ' LEXMARK T430 HY 12A8325 , 12A8425', 1, 68.17, 0, 1, 0.65, 'lexmark-t430-hy-12a8325-12a8425', 'TSRL026B', 'http://tonersales,eu/shop/554/lexmark-t430-hy-12a8325-12a8425,jpg', 0, '0', 'Lexmark T430N , T430DN', '12000     5%               :  Lexmark T430N , T430DN'),
	(730, '1', ' LEXMARK MX310 , MX510 , MX610 HY 60F2H00', 53, 79.84, 0, 1, 0.65, '-lexmark-mx310-mx510-mx610-hy-60f2h00', 'TS13310571**', 'http://tonersales,eu/shop/2290/-lexmark-mx310-mx510-mx610-hy-60f2h00,jpg', 0, '0', '<p>Lexmark MX310X , MX410X , MX510X , MX511X , MX-610 , MX611X , MX410</p>', '<p>10000     5%     : Lexmark MX-310x , MX-410x , MX-510x , MX-511x , MX-610 , MX-611x , MX410</p>'),
	(731, '1', ' LEXMARK MS410 ,  MS510 ,  MS610 (Extra High Volume) 50F2X00', 53, 53.94, 0, 101, 0.65, '-lexmark-ms410-ms510-ms610-extra-high-volume-50f2x00', 'TS13310573**', 'http://tonersales,eu/shop/282/-lexmark-ms410-ms510-ms610-extra-high-volume-50f2x00,jpg', 0, '0', '<p>LEXMARK MS-410 , MS-510 , MS-610</p>', '<p>10000     5%     : LEXMARK MS-410 , MS-510 , MS-610</p>'),
	(732, '1', ' LEXMARK E-460 460X11E', 0, 69.92, 0, 101, 0.65, '-lexmark-e-460-460x11e', 'TSTFL068B', 'http://tonersales,eu/shop/555/-lexmark-e-460-460x11e,jpg', 0, '0', '<p>Lexmark E460DN , E460DW</p>', '<p>15000     5%     : Lexmark E460DN , E460DW</p>'),
	(733, '0', ' LEXMARK MX510 , MX610 Extra HY 60F2X0E', 0, 78.12, 0, 1, 0.65, '-lexmark-mx510-mx610-extra-hy-60f2x0e', 'TS13310597**', 'http://tonersales,eu/shop/556/-lexmark-mx510-mx610-extra-hy-60f2x0e,jpg', 0, '0', '<p>LEXMARK MX510 , MX511 , MX610 , MX611</p>', '<p>20000     5%     : LEXMARK MX510 , MX511 , MX610 , MX611</p>'),
	(734, '1', ' LEXMARK MS510(Ultra HY) 50F2U00 , 50F2U0E', 0, 78.12, 0, 1, 0.65, '-lexmark-ms510ultra-hy-50f2u00-50f2u0e', 'TS13310591**', 'http://tonersales,eu/shop/557/-lexmark-ms510ultra-hy-50f2u00-50f2u0e,jpg', 0, '0', '<p>LEXMARK MS510 , MS610</p>', '<p>20000     5%     : LEXMARK MS510 , MS610</p>'),
	(735, '1', ' LEXMARK T420 12A7415', 0, 87.27, 0, 1, 0.65, '-lexmark-t420-12a7415', 'TS13310550**', 'http://tonersales,eu/shop/558/-lexmark-t420-12a7415,jpg', 0, '0', '<p>LEXMARK T420</p>', '<p>10000     5%     : LEXMARK T420</p>'),
	(736, '1', ' LEXMARK T630 12A7462', 0, 88.94, 0, 1, 0.65, 'lexmark-t630-12a7462', 'TSTFL065B', 'http://tonersales,eu/shop/559/lexmark-t630-12a7462,jpg', 0, '0', '<p>Lexmark T630 , T632 , T634</p>', '<p>32000     5%     : Lexmark T630 , T632 , T634</p>'),
	(737, '1', ' LEXMARK T640 JUMBO 64016HE', 0, 85.9, 0, 101, 0.65, 'lexmark-t640-jumbo-64016he', 'TSTFL064B', 'http://tonersales,eu/shop/560/lexmark-t640-jumbo-64016he,jpg', 0, '0', '<p>Lexmark OPTRA T640, OPTRA T640DTN, OPTRA T640DN, OPTRA T642DTN,OPTRA T642DN, OPTRA T640N, OPTRA T642, OPTRA T640TN, OPTRA T642TN, OPTRA T642N, T642TN, T640TN, T640N, T640DTN, T642DN, T642, T640DN, T642N, T642DTN, T644, T644N, T644DN, T644DTN</p>', '<p>21000     5%     : LexmarkOPTRA T640, OPTRA T640DTN, OPTRA T640DN, OPTRA T642DTN,OPTRA T642DN, OPTRA T640N, OPTRA T642, OPTRA T640TN, OPTRA T642TN, OPTRA T642N, T642TN, T640TN, T640N, T640DTN, T642DN, T642, T640DN, T642N, T642DTN, T644, T644N, T644DN, T644DTN</p>'),
	(738, '1', ' LEXMARK MX710 ,  MX810 (HY) 622H 62D2H00', 0, 91.59, 0, 1, 0.65, '-lexmark-mx710-mx810-hy-622h-62d2h00', 'TS13310584**', 'http://tonersales,eu/shop/561/-lexmark-mx710-mx810-hy-622h-62d2h00,jpg', 0, '0', '<p>LEXMARK MX-710 , MX-711 , MX-810 , MX-811 , MX-812</p>', '<p>25000     5%     : LEXMARK MX-710 , MX-711 , MX-810 , MX-811 , MX-812</p>'),
	(739, '1', ' LEXMARK MS810 52D2H00 High Yield', 0, 91.59, 0, 1, 0.65, '-lexmark-ms810-52d2h00-high-yield', 'TS13310582**', 'http://tonersales,eu/shop/562/-lexmark-ms810-52d2h00-high-yield,jpg', 0, '0', '<p>LEXMARK MS810 , MS811 , MS812</p>', '<p>25000     5%     : LEXMARK MS810 , MS811 , MS812</p>'),
	(740, '1', ' LEXMARK T620 HY 12A6865', 0, 93.38, 0, 1, 0.65, 'lexmark-t620-hy-12a6865', 'TSTFL043B', 'http://tonersales,eu/shop/563/lexmark-t620-hy-12a6865,jpg', 0, '0', '<p>Lexmark T620 , T622</p>', '<p>30000     5%     : Lexmark T620 , T622</p>'),
	(741, '1', ' LEXMARK 63H5721', 0, 99.19, 0, 1, 0.65, '-lexmark-63h5721', 'TSRH117B', 'http://tonersales,eu/shop/398/-lexmark-63h5721,jpg', 0, '0', '<p>Lexmark Optra N240 , N245</p>', '<p>25000     5%     : Lexmark Optra N240 , N245</p>'),
	(742, '1', ' LEXMARK T650 HY BK T650H11E', 0, 128.17, 0, 1, 0.65, 'lexmark-t650-hy-bk-t650h11e', 'TSTRL055B', 'http://tonersales,eu/shop/564/lexmark-t650-hy-bk-t650h11e,jpg', 0, '0', '<p>Lexmark T650n , T650dn , T650dtn , T652n , T652dn , T652dtn , T654n , T654dn , T654dtn , T656dne</p>', '<p>25000     5%     : Lexmark T650n , T650dn , T650dtn , T652n , T652dn , T652dtn , T654n , T654dn , T654dtn , T656dne</p>'),
	(743, '1', ' KYOCERA TK17', 53, 8.79, 0, 105, 0.65, '#NAME?', 'TSFK018B', 'http://tonersales,eu/shop/247/-kyocera-tk17,jpg', 0, '0', '<p>Kyocera<span>Laser Printer FS 1000,</span><span>FS 1000 PLUS,</span><span>FS 1000 PLUS N,</span><span>FS 1000 PLUS PSN,</span><span>FS 1050,</span><span>FS 1010,</span><span>FS 1010 N,</span><span>FS 1050 N,</span><span>FS 1000 N,</span><span>FS 1000 PLUS PS,</span><span>FS 1010 T,</span><span>FS 1010 TN,</span><span>FS 1050 T,</span><span>FS 1050 TN</span></p>', '<p>6000    5%     : KyoceraLaser Printer FS 1000,FS 1000 PLUS,FS 1000 PLUS N,FS 1000 PLUS PSN,FS 1050,FS 1010,FS 1010 N,FS 1050 N,FS 1000 N,FS 1000 PLUS PS,FS 1010 T,FS 1010 TN,FS 1050 T,FS 1050 TN</p>'),
	(744, '1', ' KYOCERA TK160 BK', 53, 8.79, 0, 102, 0.65, '#NAME?', 'TSFK160B', 'http://tonersales,eu/shop/252/-kyocera-tk160-bk,jpg', 0, '0', '<p>Kyocera FS1120D, FS1120DN, Ecosys P2035D</p>', '<p>2500     5%     : KyoceraS1120D, FS1120DN, Ecosys P2035D</p>'),
	(745, '1', ' KYOCERA TK110 BLACK', 53, 9.6, 0, 115, 0.65, '#NAME?', 'TSFK104B', 'http://tonersales,eu/shop/1188/-kyocera-tk110-black,jpg', 0, '0', '<p>Kyocera FS-720, FS-820, FS-820N, FS-920, FS-920N, FS-1016MFP, FS-1116MFP</p>', '<p>6000     5%     : KyoceraFS-720, FS-820, FS-820N, FS-920, FS-920N, FS-1016MFP, FS-1116MFP</p>'),
	(746, '1', ' KYOCERA TK18', 53, 8.31, 0, 105, 0.65, '#NAME?', 'TSFK020B', 'http://tonersales,eu/shop/248/-kyocera-tk18,jpg', 0, '0', '<p>Kyocera FS-1018MFP, FS-1020, FS-1020D, FS-1020DN, FS-1020DT, FS-1020DTN, FS-1118F MFP, FS-1118FDP MFP, FS-1118 MFP, DP-80F, DP-85F</p>', '<p>7200     5%     : KyoceraFS-1018MFP, FS-1020, FS-1020D, FS-1020DN, FS-1020DT, FS-1020DTN, FS-1118F MFP, FS-1118FDP MFP, FS-1118 MFP, DP-80F, DP-85F</p>'),
	(747, '1', ' KYOCERA TK120 , TK122  , 1T02G60DE0', 53, 10.08, 0, 105, 0.65, 'kyocera-tk120-tk122-1t02g60de0', 'TSFK108B', 'http://tonersales,eu/shop/249/kyocera-tk120-tk122-1t02g60de0,jpg', 0, '0', '<p>Kyocera FS-1030D, FS-1030DTN, FS-1030DN, FS-1030DT</p>', '<p>7200     5%     : KyoceraFS-1030D, FS-1030DTN, FS-1030DN, FS-1030DT</p>'),
	(748, '1', ' KYOCERA TK140 BK', 0, 14.28, 0, 102, 0.65, '#NAME?', 'TSFK124B', 'http://tonersales,eu/shop/1189/-kyocera-tk140-bk,jpg', 0, '0', '<p>Kyocera Mita FS1100 , FS-1100N</p>', '<p>4000     5%     : Kyocera Mita FS1100 , FS-1100N</p>'),
	(749, '1', ' KYOCERA TK130 , 132 , 134 (TK130)  , 1T02HS0EU0', 53, 11.05, 0, 104, 0.65, 'kyocera-tk130-132-134-tk130-1t02hs0eu0', 'TSFK122B', 'http://tonersales,eu/shop/250/kyocera-tk130-132-134-tk130-1t02hs0eu0,jpg', 0, '0', '<p>Kyocera FS-1028, FS-1128MFP, FS-1300N, FS-1350, FS-1028MFP, FS-1300, FS-1300DN, FS-1350N, FS-1128, FS-1300D, FS-1300DTN, FS-1350DN</p>', '<p>7200     5%     : KyoceraFS-1028, FS-1128MFP, FS-1300N, FS-1350, FS-1028MFP, FS-1300, FS-1300DN, FS-1350N, FS-1128, FS-1300D, FS-1300DTN, FS-1350DN</p>'),
	(750, '1', ' KYOCERA TK170 BK 1T02LZ0NL0', 53, 8.71, 0, 108, 0.65, 'kyocera-tk170-bk-1t02lz0nl0', 'TSFK170B', 'http://tonersales,eu/shop/258/kyocera-tk170-bk-1t02lz0nl0,jpg', 0, '0', '<p>Kyocera FS-1320D, FS-1370DN, FS-1320DN, P2135DN</p>', '<p>7200     5%     : KyoceraFS-1320D, FS-1370DN, FS-1320DN, P2135DN</p>'),
	(751, '1', ' KYOCERA TK340  , 1T02J00EU0 +WASTE', 0, 18.7, 0, 1, 0.65, 'kyocera-tk340-1t02j00eu0-waste', 'TSFK127B', 'http://tonersales,eu/shop/1190/kyocera-tk340-1t02j00eu0-waste,jpg', 0, '0', '<p>Kyocera Mita FS-2020DN , FS-2020D , FS2020 Olivetti PG L2035 UTAX LP3235</p>', '<p>12000     5%     : Kyocera Mita FS-2020DN , FS-2020D , FS2020 Olivetti PG L2035 UTAX LP3235</p>'),
	(752, '1', ' KYOCERA TK310 , 312  , 1T02F80EU0+WASTE', 0, 21.61, 0, 104, 0.65, 'kyocera-tk310-312-1t02f80eu0waste', 'TSFK113B', 'http://tonersales,eu/shop/1191/kyocera-tk310-312-1t02f80eu0waste,jpg', 0, '0', '<p>Kyocera Mita FS-2000D , 3900DN , 3900DTN , 4000DN , 4000DTN Olivetti Lexikon PG L 230</p>', '<p>12000     5%     : Kyocera Mita FS-2000D , 3900DN , 3900DTN , 4000DN , 4000DTN Olivetti Lexikon PG L 230</p>'),
	(753, '1', ' KYOCERA TK1130 BK (0T2MJ0NL)', 0, 21.98, 0, 120, 0.65, 'kyocera-tk1130-bk-0t2mj0nl', 'TSTFK335B', 'http://tonersales,eu/shop/1192/kyocera-tk1130-bk-0t2mj0nl,jpg', 0, '0', '<p>KYOCERA FS-1130MFP , FS1130MFP , FS1030MFP , ECOSYS M2030dn PN , , ECOSYS M2530dn Olivetti D-COPIA 3004 Utax CD5230</p>', '<p>3000     5%     : KYOCERA FS-1130MFP , FS1130MFP , FS1030MFP , ECOSYS M2030dn PN , , ECOSYS M2530dn Olivetti D-COPIA 3004 Utax CD5230</p>'),
	(754, '1', ' KYOCERA TK1140', 0, 23.31, 0, 1, 0.65, 'kyocera-tk1140', 'TS1T02ML0NL0', 'http://tonersales,eu/shop/1193/kyocera-tk1140,jpg', 0, '0', '<p>KYOCERA FS1035 , FS1035MFP , FS1135MFP M2035 Olivetti D-COPIA 3503 , 3504 Utax CD5135 , CD5235</p>', '<p>7200     5%     : KYOCERA FS1035 , FS1035MFP , FS1135MFP M2035 Olivetti D-COPIA 3503 , 3504 Utax CD5135 , CD5235</p>'),
	(755, '1', ' KYOCERA TK1115 0T2M50NL', 0, 23.56, 0, 1, 0.65, 'kyocera-tk1115-0t2m50nl', 'TSTFK412B', 'http://tonersales,eu/shop/1194/kyocera-tk1115-0t2m50nl,jpg', 0, '0', '<p>Kyocera ECOSYS FS-1041 , FS1041 , FS1220MFP , FS1320MFP</p>', '<p>1600     5%     : Kyocera ECOSYS FS-1041 , FS1041 , FS1220MFP , FS1320MFP</p>'),
	(756, '1', ' KYOCERA TK1125 0T2M70NL', 1, 23.56, 0, 1, 0.65, 'kyocera-tk1125-0t2m70nl', 'TSTFK417B', 'http://tonersales,eu/shop/1195/kyocera-tk1125-0t2m70nl,jpg', 0, '0', 'Kyocera ECOSYS FS-1061DN , FS1061 , FS1325MFP', '2100     5%               :  Kyocera ECOSYS FS-1061DN , FS1061 , FS1325MFP'),
	(757, '1', ' KYOCERA TK320 BK  , 1T02F90EU0 +waste', 0, 25.36, 0, 1, 0.65, 'kyocera-tk320-bk-1t02f90eu0-waste', 'TSFK320B', 'http://tonersales,eu/shop/1196/kyocera-tk320-bk-1t02f90eu0-waste,jpg', 0, '0', '<p>Kyocera Mita FS 3900DN , FS3900 , FS4000DN Olivetti PG L235 , L245 UTAX LP3035 , LP3240 , LP3045</p>', '<p>15000     5%     : Kyocera Mita FS 3900DN , FS3900 , FS4000DN Olivetti PG L235 , L245 UTAX LP3035 , LP3240 , LP3045</p>'),
	(758, '1', ' KYOCERA TK580 CY', 0, 25.52, 0, 101, 0.65, 'kyocera-tk580-cy', 'TSTFK326C', 'http://tonersales,eu/shop/2070/kyocera-tk580-cy,jpg', 0, '0', '<p>KYOCERA FS-C5150DN Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>2800     5%     : KYOCERA FS-C5150DN Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(759, '1', ' KYOCERA TK580 MG', 0, 25.52, 0, 101, 0.65, 'kyocera-tk580-mg', 'TSTFK327M', 'http://tonersales,eu/shop/2068/kyocera-tk580-mg,jpg', 0, '0', '<p>KYOCERA FS-C5150DN Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>2800     5%     : KYOCERA FS-C5150DN Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(760, '1', ' KYOCERA TK580 YL', 0, 25.52, 0, 101, 0.65, 'kyocera-tk580-yl', 'TSTFK328Y', 'http://tonersales,eu/shop/2066/kyocera-tk580-yl,jpg', 0, '0', '<p>KYOCERA FS-C5150DN Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>2800     5%     : KYOCERA FS-C5150DN Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(761, '1', ' KYOCERA TK350  , 1T02LX0NL0 +WASTE', 53, 16.53, 0, 107, 0.65, 'kyocera-tk350-1t02lx0nl0-waste', 'TSFK128B', 'http://tonersales,eu/shop/253/kyocera-tk350-1t02lx0nl0-waste,jpg', 0, '0', '<p>KYOCERA FS3040 MFP, FS 3290 DN, FS 3140 MFP, FS 3640</p>', '<p>15000     5%     : KYOCERAFS3040 MFP, FS 3290 DN, FS 3140 MFP, FS 3640</p>'),
	(762, '1', ' KYOCERA TK360  , 1T02J20EU0 +WASTE', 53, 26.15, 0, 1, 0.65, 'kyocera-tk360-1t02j20eu0-waste', 'TSFK129B', 'http://tonersales,eu/shop/1200/kyocera-tk360-1t02j20eu0-waste,jpg', 0, '0', '<p>Kyocera Mita FS-4020DN , FS4020 Olivetti PG L2045 UTAX LP3245</p>', '<p>20000     5%     : Kyocera Mita FS-4020DN , FS4020 Olivetti PG L2045 UTAX LP3245</p>'),
	(763, '1', ' KYOCERA TK580 BK', 0, 27.17, 0, 101, 0.65, 'kyocera-tk580-bk', 'TSTFK325B', 'http://tonersales,eu/shop/2073/kyocera-tk580-bk,jpg', 0, '0', '<p><span>KYOCERA FS-C5150DN</span></p>', '<p>3500     5%     : KYOCERA FS-C5150DN</p>'),
	(764, '1', ' KYOCERA TK475 BK  , 1T02K30NL0+2 WASTE', 0, 31.9, 0, 100, 0.65, 'kyocera-tk475-bk-1t02k30nl02-waste', 'TSTFK334B', 'http://tonersales,eu/shop/1202/kyocera-tk475-bk-1t02k30nl02-waste,jpg', 0, '0', '<p>KYOCERA MITA FS-6025MFP , FS6025 , FS6030MFP , FS6525MFP , FS6530MFP Olivetti D-COPIA253 , D-COPIA303 UTAX CD5025 , CD5030 , 256I , 306I</p>', '<p>15000     5%     : KYOCERA MITA FS-6025MFP , FS6025 , FS6030MFP , FS6525MFP , FS6530MFP Olivetti D-COPIA253 , D-COPIA303 UTAX CD5025 , CD5030 , 256I , 306I</p>'),
	(765, '1', ' KYOCERA TK540 CY', 0, 27.81, 0, 102, 0.65, '#NAME?', 'TSTFK303C', 'http://tonersales,eu/shop/2079/-kyocera-tk540-cy,jpg', 0, '0', '<p>Kyocera-Mita FS-C5100 Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>', '<p>4000     5%     : Kyocera-Mita FS-C5100 Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>'),
	(766, '1', ' KYOCERA TK540 MG', 0, 27.81, 0, 102, 0.65, '#NAME?', 'TSTFK304M', 'http://tonersales,eu/shop/2077/-kyocera-tk540-mg,jpg', 0, '0', '<p>Kyocera-Mita FS-C5100</p>', '<p>4000     5%     : Kyocera-Mita FS-C5100</p>'),
	(767, '1', ' KYOCERA TK540 YL', 0, 27.81, 0, 102, 0.65, '#NAME?', 'TSTFK305Y', 'http://tonersales,eu/shop/2075/-kyocera-tk540-yl,jpg', 0, '0', '<p>Kyocera-Mita FS-C5100</p>', '<p>4000     5%     : Kyocera-Mita FS-C5100</p>'),
	(768, '1', ' KYOCERA TK1505 BK', 0, 35, 0, 102, 0.65, '#NAME?', 'TSFK012B', 'http://tonersales,eu/shop/1206/-kyocera-tk1505-bk,jpg', 0, '0', '<p>Kyocera Mita KM1505, KM1510, KM1810 UTAX CD1115 , CD1215</p>', '<p>7000     5%     : Kyocera Mita KM1505, KM1510, KM1810 UTAX CD1115 , CD1215</p>'),
	(769, '1', ' KYOCERA TK50  +WASTE', 1, 30.58, 0, 1, 0.65, 'kyocera-tk50-waste', 'TSFK208B', 'http://tonersales,eu/shop/1207/kyocera-tk50-waste,jpg', 0, '0', 'Kyocera Mita FS1900 , FS1900N , FS1900DN , FS1900DTN', '15000     5%               :  Kyocera Mita FS1900 , FS1900N , FS1900DN , FS1900DTN'),
	(770, '1', ' KYOCERA TK55 , TK57 (TK55)  , 370QC0KX', 0, 31.2, 0, 102, 0.65, 'kyocera-tk55-tk57-tk55-370qc0kx', 'TSFK107B', 'http://tonersales,eu/shop/1208/kyocera-tk55-tk57-tk55-370qc0kx,jpg', 0, '0', '<p>Kyocera Mita FS-1920 Series</p>', '<p>15000     5%     : Kyocera Mita FS-1920 Series</p>'),
	(771, '1', ' KYOCERA TK540 BK', 0, 31.2, 0, 102, 0.65, '#NAME?', 'TSTFK302B', 'http://tonersales,eu/shop/2081/-kyocera-tk540-bk,jpg', 0, '0', '<p>Kyocera-Mita FS-C5100</p>', '<p>5000     5%     : Kyocera-Mita FS-C5100</p>'),
	(772, '1', ' KYOCERA KM1525 (TK1530) 37028000 , 10', 0, 33, 0, 1, 0.65, 'kyocera-km1525-tk1530-37028000-10', 'TSFK013B', 'http://tonersales,eu/shop/1210/kyocera-km1525-tk1530-37028000-10,jpg', 0, '0', '<p>Kyocera Mita KM1525 , KM1530 , KM2030 Olivetti D-COPIA 15 , D-COPIA 20 UTAX CD1015 , CD1020</p>', '<p>11000     5%     : Kyocera Mita KM1525 , KM1530 , KM2030 Olivetti D-COPIA 15 , D-COPIA 20 UTAX CD1015 , CD1020</p>'),
	(773, '1', ' KYOCERA TK550 CY', 0, 33.37, 0, 1, 0.65, 'kyocera-tk550-cy', 'TSTFK314C', 'http://tonersales,eu/shop/2087/kyocera-tk550-cy,jpg', 0, '0', '<p>Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>6000     5%     : Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(774, '1', ' KYOCERA TK550 MG', 0, 33.37, 0, 1, 0.65, 'kyocera-tk550-mg', 'TSTFK315M', 'http://tonersales,eu/shop/2085/kyocera-tk550-mg,jpg', 0, '0', '<p>Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>6000     5%     : Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(775, '1', ' KYOCERA TK550 YL', 0, 33.37, 0, 1, 0.65, 'kyocera-tk550-yl', 'TSTFK316Y', 'http://tonersales,eu/shop/2083/kyocera-tk550-yl,jpg', 0, '0', '<p>Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>6000     5%     : Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(776, '1', ' KYOCERA TK330 , TK332  , 1T02GA0EU0 +WASTE', 0, 34.2, 0, 1, 0.65, 'kyocera-tk330-tk332-1t02ga0eu0-waste', 'TSFK118B', 'http://tonersales,eu/shop/1214/kyocera-tk330-tk332-1t02ga0eu0-waste,jpg', 0, '0', '<p>Kyocera Mita FS-4000DN , 4000DTN Olivetti Lexikon PG L 245</p>', '<p>20000     5%     : Kyocera Mita FS-4000DN , 4000DTN Olivetti Lexikon PG L 245</p>'),
	(777, '1', ' KYOCERA TK590 CY', 0, 35.6, 0, 101, 0.65, 'kyocera-tk590-cy', 'TSTFK330C', 'http://tonersales,eu/shop/2090/kyocera-tk590-cy,jpg', 0, '0', '<p>Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>', '<p>5000     5%     : Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>'),
	(778, '1', ' KYOCERA TK590 MG', 0, 35.6, 0, 101, 0.65, 'kyocera-tk590-mg', 'TSTFK331M', 'http://tonersales,eu/shop/1896/kyocera-tk590-mg,jpg', 0, '0', '<p>Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>', '<p>5000     5%     : Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>'),
	(779, '1', ' KYOCERA TK590 YL', 0, 35.6, 0, 101, 0.65, 'kyocera-tk590-yl', 'TSTFK332Y', 'http://tonersales,eu/shop/2089/kyocera-tk590-yl,jpg', 0, '0', '<p>Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>', '<p>5000     5%     : Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>'),
	(780, '1', ' KYOCERA TK410 , TK420 , TK430 370AM010 +2 WASTE ,1 turning Knob', 53, 20.56, 0, 111, 0.65, 'kyocera-tk410-tk420-tk430-370am010-2-waste-1-turning-knob', 'TSFK102B', 'http://tonersales,eu/shop/254/kyocera-tk410-tk420-tk430-370am010-2-waste-1-turning-knob,jpg', 0, '0', '<p>Kyocera KM-1620, KM-2020, KM-1635, KM-2035, KM-1650, KM-2050</p>', '<p>15000     5%     : KyoceraKM-1620, KM-2020, KM-1635, KM-2035, KM-1650, KM-2050</p>'),
	(781, '1', ' KYOCERA TK65 , TK67 (TK65)  +WASTE', 1, 37, 0, 1, 0.65, 'kyocera-tk65-tk67-tk65-waste', 'TSFK103B', 'http://tonersales,eu/shop/1218/kyocera-tk65-tk67-tk65-waste,jpg', 0, '0', 'Kyocera Mita FS-3820 , 3830 Series Utax LP 3028', '18000     5%               :  Kyocera Mita FS-3820 , 3830 Series Utax LP 3028'),
	(782, '1', ' KYOCERA TK550 BK', 0, 37.19, 0, 1, 0.65, 'kyocera-tk550-bk', 'TSTFK313B', 'http://tonersales,eu/shop/2091/kyocera-tk550-bk,jpg', 0, '0', '<p>Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>7000     5%     : Kyocera Mita FS-C5200dn Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(783, '1', ' KYOCERA TK440  , 1T02F70EU0', 0, 35, 0, 104, 0.65, 'kyocera-tk440-1t02f70eu0', 'TS13314117', 'http://tonersales,eu/shop/1220/kyocera-tk440-1t02f70eu0,jpg', 0, '0', '<p>KYOCERA (1T02F70EU0) - FS 6950DN , 6950DTN</p>', '<p>15000     5%     : KYOCERA (1T02F70EU0) - FS 6950DN , 6950DTN</p>'),
	(784, '1', ' Kyocera TK450 1T02J50EU0', 0, 37.7, 0, 1, 0.65, 'kyocera-tk450-1t02j50eu0', 'TS12100044', 'http://tonersales,eu/shop/1221/kyocera-tk450-1t02j50eu0,jpg', 0, '0', '<p>KYOCERA FS-6970DN</p>', '<p>15000     5%     : KYOCERA FS-6970DN</p>'),
	(785, '1', ' KYOCERA TK435  , OT2KHONL +2 WASTE ,1 turning Knob', 53, 25.56, 0, 110, 0.65, 'kyocera-tk435-ot2khonl-2-waste-1-turning-knob', 'TSFK435B', 'http://tonersales,eu/shop/255/kyocera-tk435-ot2khonl-2-waste-1-turning-knob,jpg', 0, '0', '<p>Kyocera Mita TaskAlfa 180, TaskAlfa 220, TaskAlfa 181, TaskAlfa 221</p>', '<p>15000     5%     : Kyocera MitaTaskAlfa 180, TaskAlfa 220, TaskAlfa 181, TaskAlfa 221</p>'),
	(786, '1', ' KYOCERA TK3100 BK', 53, 28.63, 0, 102, 0.65, '#NAME?', 'TSTFK429B', 'http://tonersales,eu/shop/259/-kyocera-tk3100-bk,jpg', 0, '0', '<p>KYOCERA FS-2100D, Ecosys M3040, FS-2100DN, Ecosys M3540</p>', '<p>12500     5%     : KYOCERAFS-2100D, Ecosys M3040, FS-2100DN, Ecosys M3540</p>'),
	(787, '1', ' KYOCERA TK590 BK', 0, 39.18, 0, 101, 0.65, 'kyocera-tk590-bk', 'TSTFK329B', 'http://tonersales,eu/shop/2093/kyocera-tk590-bk,jpg', 0, '0', '<p>Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>', '<p>7000     5%     : Kyocera Mita FS-C5250DN , C2026MFP , C2026MFP+ , C2126MFP , C2126MFP+ , C2526MFP , C2626MFP</p>'),
	(788, '1', ' KYOCERA TK60(TK60)', 1, 39.45, 0, 1, 0.65, 'kyocera-tk60tk60', 'TSFK101B', 'http://tonersales,eu/shop/1223/kyocera-tk60tk60,jpg', 0, '0', 'Kyocera Mita FS-1800 , 3800 Series Utax LP 3018', '20000     5%               :  Kyocera Mita FS-1800 , 3800 Series Utax LP 3018'),
	(789, '1', ' KYOCERA TK895C , 1T02K0CNL0', 0, 39.47, 0, 1, 0.65, '-kyocera-tk895c-1t02k0cnl0', 'TS13318146**', 'http://tonersales,eu/shop/1224/-kyocera-tk895c-1t02k0cnl0,jpg', 0, '0', '<p>KYOCERA FS-C8020MFP , C8025MFP</p>', '<p>6000     5%     : KYOCERA FS-C8020MFP , C8025MFP</p>'),
	(790, '1', ' KYOCERA TK895M , 1T02K0BNL0', 0, 39.47, 0, 1, 0.65, '-kyocera-tk895m-1t02k0bnl0', 'TS13318147**', 'http://tonersales,eu/shop/1225/-kyocera-tk895m-1t02k0bnl0,jpg', 0, '0', '<p>KYOCERA FS-C8020MFP , C8025MFP</p>', '<p>6000     5%     : KYOCERA FS-C8020MFP , C8025MFP</p>'),
	(791, '1', ' KYOCERA TK895Y , 1T02K0ANL0', 0, 39.47, 0, 1, 0.65, '-kyocera-tk895y-1t02k0anl0', 'TS13318148**', 'http://tonersales,eu/shop/1226/-kyocera-tk895y-1t02k0anl0,jpg', 0, '0', '<p>KYOCERA FS-C8020MFP , C8025MFP</p>', '<p>6000     5%     : KYOCERA FS-C8020MFP , C8025MFP</p>'),
	(792, '1', ' KYOCERA TK510K , 1T02F30EU0', 0, 45.46, 0, 1, 0.65, '-kyocera-tk510k-1t02f30eu0', 'TS13314137**', 'http://tonersales,eu/shop/2097/-kyocera-tk510k-1t02f30eu0,jpg', 0, '0', '<p>Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>', '<p>8000     5%     : Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>'),
	(793, '1', ' KYOCERA TK510C , 1T02F3CEU0', 0, 45.46, 0, 1, 0.65, '-kyocera-tk510c-1t02f3ceu0', 'TS13314138**', 'http://tonersales,eu/shop/2096/-kyocera-tk510c-1t02f3ceu0,jpg', 0, '0', '<p>Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>', '<p>8000     5%     : Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>'),
	(794, '1', ' KYOCERA TK510M , 1T02F3BEU0', 0, 45.46, 0, 1, 0.65, '-kyocera-tk510m-1t02f3beu0', 'TS13314139**', 'http://tonersales,eu/shop/2095/-kyocera-tk510m-1t02f3beu0,jpg', 0, '0', '<p>Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>', '<p>8000     5%     : Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>'),
	(795, '1', ' KYOCERA TK510Y , 1T02F3AEU0', 0, 45.46, 0, 1, 0.65, '-kyocera-tk510y-1t02f3aeu0', 'TS13314140**', 'http://tonersales,eu/shop/2094/-kyocera-tk510y-1t02f3aeu0,jpg', 0, '0', '<p>Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>', '<p>8000     5%     : Kyocera (1T02F30EU0) - FS-C5020N , FS-5025N , FS-5030N</p>'),
	(796, '1', ' KYOCERA TK3130 , 1T02LV0NL0', 1, 46.41, 0, 1, 0.65, 'kyocera-tk3130-1t02lv0nl0', 'TS13316834**', 'http://tonersales,eu/shop/1232/kyocera-tk3130-1t02lv0nl0,jpg', 0, '0', 'KYOCERA FS-4200DN , FS-4300D', '25000     5%               :  KYOCERA FS-4200DN , FS-4300D'),
	(797, '1', ' KYOCERA TK560 MG', 0, 48.18, 0, 1, 0.65, '#NAME?', 'TS13316818**', 'http://tonersales,eu/shop/2098/-kyocera-tk560-mg,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>10000     5%     : KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(798, '1', ' KYOCERA TK560 YL', 0, 48.18, 0, 1, 0.65, '#NAME?', 'TS13316819**', 'http://tonersales,eu/shop/2102/-kyocera-tk560-yl,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>10000     5%     : KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(799, '1', ' KYOCERA TK560 CY', 0, 48.18, 0, 1, 0.65, '#NAME?', 'TS13316817**', 'http://tonersales,eu/shop/2100/-kyocera-tk560-cy,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>10000     5%     : KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(800, '1', ' KYOCERA TK570C , 1T02HGCEU0', 0, 67.85, 0, 1, 0.65, '-kyocera-tk570c-1t02hgceu0', 'TS13318112**', 'http://tonersales,eu/shop/2133/-kyocera-tk570c-1t02hgceu0,jpg', 0, '0', '<p>Kyocera FS-C5400DN</p>', '<p>12000     5%     : Kyocera FS-C5400DN</p>'),
	(801, '1', ' KYOCERA TK570M , 1T02HGBEU0', 0, 67.85, 0, 1, 0.65, '-kyocera-tk570m-1t02hgbeu0', 'TS13318113**', 'http://tonersales,eu/shop/2132/-kyocera-tk570m-1t02hgbeu0,jpg', 0, '0', '<p>Kyocera FS-C5400DN</p>', '<p>12000     5%     : Kyocera FS-C5400DN</p>'),
	(802, '1', ' KYOCERA TK570Y , 1T02HGAEU0', 0, 67.85, 0, 1, 0.65, '-kyocera-tk570y-1t02hgaeu0', 'TS13318114**', 'http://tonersales,eu/shop/2134/-kyocera-tk570y-1t02hgaeu0,jpg', 0, '0', '<p>Kyocera FS-C5400DN</p>', '<p>12000     5%     : Kyocera FS-C5400DN</p>'),
	(803, '1', ' KYOCERA TK685K', 0, 51.83, 0, 1, 0.65, '#NAME?', 'TSTK685', 'http://tonersales,eu/shop/1239/-kyocera-tk685k,jpg', 0, '0', '<p>(1T02K50NL0) Taskalfa 300i , 400i</p>', '<p>20000     5%     : (1T02K50NL0) Taskalfa 300i , 400i</p>'),
	(804, '1', ' KYOCERA TK865C , 1T02JZCEU0', 0, 52.62, 0, 1, 0.65, '-kyocera-tk865c-1t02jzceu0', 'TS13316870**', 'http://tonersales,eu/shop/2105/-kyocera-tk865c-1t02jzceu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 250ci , 300ci</p>', '<p>12000     5%     : KYOCERA TASKalfa 250ci , 300ci</p>'),
	(805, '1', ' KYOCERA TK865M , 1T02JZBEU0', 0, 52.62, 0, 1, 0.65, '-kyocera-tk865m-1t02jzbeu0', 'TS13316871**', 'http://tonersales,eu/shop/2104/-kyocera-tk865m-1t02jzbeu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 250ci , 300ci</p>', '<p>12000     5%     : KYOCERA TASKalfa 250ci , 300ci</p>'),
	(806, '1', ' KYOCERA TK865Y , 1T02JZAEU0', 0, 52.62, 0, 1, 0.65, '-kyocera-tk865y-1t02jzaeu0', 'TS13316872**', 'http://tonersales,eu/shop/2106/-kyocera-tk865y-1t02jzaeu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 250ci , 300ci</p>', '<p>12000     5%     : KYOCERA TASKalfa 250ci , 300ci</p>'),
	(807, '1', ' KYOCERA TK825 CY', 0, 53.72, 0, 1, 0.65, '#NAME?', 'TS13314146**', 'http://tonersales,eu/shop/2108/-kyocera-tk825-cy,jpg', 0, '0', '<p>Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>', '<p>7000     5%     : Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>'),
	(808, '1', ' KYOCERA TK825 MG', 0, 53.72, 0, 1, 0.65, '#NAME?', 'TS13314147**', 'http://tonersales,eu/shop/2109/-kyocera-tk825-mg,jpg', 0, '0', '<p>Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>', '<p>7000     5%     : Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>'),
	(809, '1', ' KYOCERA TK825 YL', 0, 53.72, 0, 1, 0.65, '#NAME?', 'TS13314148**', 'http://tonersales,eu/shop/2107/-kyocera-tk825-yl,jpg', 0, '0', '<p>Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>', '<p>7000     5%     : Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>'),
	(810, '1', ' KYOCERA TK895K , 1T02K00NL0', 0, 55.92, 0, 1, 0.65, '-kyocera-tk895k-1t02k00nl0', 'TS13318145**', 'http://tonersales,eu/shop/2110/-kyocera-tk895k-1t02k00nl0,jpg', 0, '0', '<p>KYOCERA FS-C8020MFP , C8025MFP</p>', '<p>12000     5%     : KYOCERA FS-C8020MFP , C8025MFP</p>'),
	(811, '1', ' KYOCERA TK560 BK', 0, 59.09, 0, 1, 0.65, '#NAME?', 'TS13316816**', 'http://tonersales,eu/shop/2111/-kyocera-tk560-bk,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>12000     5%     : KYOCERA FS-C5305DN , C5300 , FSC5350DN Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(812, '1', ' KYOCERA TK570K , 1T02HG0EU0', 0, 79.35, 0, 1, 0.65, '-kyocera-tk570k-1t02hg0eu0', 'TS13318111**', 'http://tonersales,eu/shop/2127/-kyocera-tk570k-1t02hg0eu0,jpg', 0, '0', '<p>Kyocera FS-C5400DN</p>', '<p>16000     5%     : Kyocera FS-C5400DN</p>'),
	(813, '1', ' KYOCERA TK520 BK', 0, 60.22, 0, 1, 0.65, 'kyocera-tk520-bk', 'TS13314133', 'http://tonersales,eu/shop/2117/kyocera-tk520-bk,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>6000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(814, '1', ' KYOCERA TK520 CY', 0, 60.22, 0, 1, 0.65, 'kyocera-tk520-cy', 'TS13314134', 'http://tonersales,eu/shop/2113/kyocera-tk520-cy,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>4000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(815, '1', ' KYOCERA TK520 YL', 0, 60.22, 0, 1, 0.65, 'kyocera-tk520-yl', 'TS13314135', 'http://tonersales,eu/shop/2115/kyocera-tk520-yl,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>4000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(816, '1', ' KYOCERA TK520 MG', 0, 60.22, 0, 1, 0.65, 'kyocera-tk520-mg', 'TS13314136', 'http://tonersales,eu/shop/2119/kyocera-tk520-mg,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>4000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(817, '1', ' KYOCERA TK675 , 677 , 678 , 679  , 1T02H00EU0 +2 WASTE ,1 turning Knob', 0, 64.05, 0, 1, 0.65, 'kyocera-tk675-677-678-679-1t02h00eu0-2-waste-1-turning-knob', 'TSFK139B', 'http://tonersales,eu/shop/1253/kyocera-tk675-677-678-679-1t02h00eu0-2-waste-1-turning-knob,jpg', 0, '0', '<p>Kyocera Mita KM2540 , KM2560 , KM3040 , KM3060 olivetti d-copia 2500 , D-COPIA 3000</p>', '<p>24000     5%     : Kyocera Mita KM2540 , KM2560 , KM3040 , KM3060 olivetti d-copia 2500 , D-COPIA 3000</p>'),
	(818, '1', ' KYOCERA TK70', 0, 65.18, 0, 1, 0.65, 'kyocera-tk70', 'TSFK114B', 'http://tonersales,eu/shop/1254/kyocera-tk70,jpg', 0, '0', '<p>Kyocera Mita FS-9100 , 9100DN , 9500DN Royal Copystar FS 9100 DN</p>', '<p>40000     5%     : Kyocera Mita FS-9100 , 9100DN , 9500DN Royal Copystar FS 9100 DN</p>'),
	(819, '1', ' KYOCERA TK715  , 1T02GR0EU0', 0, 65.18, 0, 1, 0.65, 'kyocera-tk715-1t02gr0eu0', 'TSFK115B', 'http://tonersales,eu/shop/1255/kyocera-tk715-1t02gr0eu0,jpg', 0, '0', '<p>Kyocera Mita KM3050 , KM4050 , KM5050 (1T02GR0EU0 Utax CD 1230 Olivetti Lexikon D-COPIA 300 MF</p>', '<p>34000     5%     : Kyocera Mita KM3050 , KM4050 , KM5050 (1T02GR0EU0 Utax CD 1230 Olivetti Lexikon D-COPIA 300 MF</p>'),
	(820, '1', ' KYOCERA KM2530 370AB000', 53, 59, 0, 1, 0.65, 'kyocera-km2530-370ab000', 'TSFK116B', 'http://tonersales,eu/shop/256/kyocera-km2530-370ab000,jpg', 0, '0', '<p>Kyocera Mita KM2530 , KM3035 , KM3530 , KM4030 , KM4035 , KM5035 OLIVETTI D-COPIA 25 , D-COPIA 35 , D-COPIA 40 , D-COPIA 300 , D-COPIA 400 , D-COPIA 500 Utax CD1025 , CD1030 Olympia OMEGA D250</p>', '<p>40000     5%     : Kyocera Mita KM2530 , KM3035 , KM3530 , KM4030 , KM4035 , KM5035 OLIVETTI D-COPIA 25 , D-COPIA 35 , D-COPIA 40 , D-COPIA 300 , D-COPIA 400 , D-COPIA 500 Utax CD1025 , CD1030 Olympia OMEGA D250</p>'),
	(821, '1', ' KYOCERA TK865K , 1T02JX0EU0', 0, 72.35, 0, 1, 0.65, '-kyocera-tk865k-1t02jx0eu0', 'TS13316869**', 'http://tonersales,eu/shop/2131/-kyocera-tk865k-1t02jx0eu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 250ci , 300ci</p>', '<p>20000     5%     : KYOCERA TASKalfa 250ci , 300ci</p>'),
	(822, '1', ' KYOCERA TK855C , 1T02H7CEU0', 0, 74.33, 0, 1, 0.65, '-kyocera-tk855c-1t02h7ceu0', 'TS13318142**', 'http://tonersales,eu/shop/2130/-kyocera-tk855c-1t02h7ceu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 400ci , 500ci , 552ci</p>', '<p>18000     5%     : KYOCERA TASKalfa 400ci , 500ci , 552ci</p>'),
	(823, '1', ' KYOCERA TK855M , 1T02H7BEU0', 0, 74.33, 0, 1, 0.65, '-kyocera-tk855m-1t02h7beu0', 'TS13318143**', 'http://tonersales,eu/shop/2128/-kyocera-tk855m-1t02h7beu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 400ci , 500ci , 552ci</p>', '<p>18000     5%     : KYOCERA TASKalfa 400ci , 500ci , 552ci</p>'),
	(824, '1', ' KYOCERA TK855Y , 1T02H7AEU0', 0, 74.33, 0, 1, 0.65, '-kyocera-tk855y-1t02h7aeu0', 'TS13318144**', 'http://tonersales,eu/shop/2129/-kyocera-tk855y-1t02h7aeu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 400ci , 500ci , 552ci</p>', '<p>18000     5%     : KYOCERA TASKalfa 400ci , 500ci , 552ci</p>'),
	(825, '1', ' KYOCERA TK825 BK', 0, 75.65, 0, 1, 0.65, '#NAME?', 'TS13314145**', 'http://tonersales,eu/shop/2121/-kyocera-tk825-bk,jpg', 0, '0', '<p>Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>', '<p>15000     5%     : Kyocera KM-C2520 , KM-C2525E , KM-C3225 , KM-C3232 , KM-C4035E</p>'),
	(826, '1', ' KYOCERA TK855K , 1T02H70EU0', 0, 91.99, 0, 1, 0.65, '-kyocera-tk855k-1t02h70eu0', 'TS13318141**', 'http://tonersales,eu/shop/2126/-kyocera-tk855k-1t02h70eu0,jpg', 0, '0', '<p>KYOCERA TASKalfa 400ci , 500ci , 552ci</p>', '<p>25000     5%     : KYOCERA TASKalfa 400ci , 500ci , 552ci</p>'),
	(827, '1', ' KYOCERA TK8305K , 1T02LK0NL0', 0, 91.99, 0, 1, 0.65, '-kyocera-tk8305k-1t02lk0nl0', 'TSTK8305K', 'http://tonersales,eu/shop/2125/-kyocera-tk8305k-1t02lk0nl0,jpg', 0, '0', '<p>KYOCERA TASKALFA 3050ci , 3550ci</p>', '<p>25000     5%     : KYOCERA TASKALFA 3050ci , 3550ci</p>'),
	(828, '1', ' KYOCERA TK8305C , 1T02LKCNL0', 0, 102.35, 0, 1, 0.65, '-kyocera-tk8305c-1t02lkcnl0', 'TSTK8305C', 'http://tonersales,eu/shop/2123/-kyocera-tk8305c-1t02lkcnl0,jpg', 0, '0', '<p>KYOCERA TASKALFA 3050ci , 3550ci</p>', '<p>15000     5%     : KYOCERA TASKALFA 3050ci , 3550ci</p>'),
	(829, '1', ' KYOCERA TK8305M , 1T02LKBNL0', 0, 102.35, 0, 1, 0.65, '-kyocera-tk8305m-1t02lkbnl0', 'TSTK8305M', 'http://tonersales,eu/shop/2122/-kyocera-tk8305m-1t02lkbnl0,jpg', 0, '0', '<p>KYOCERA TASKALFA 3050ci , 3550ci</p>', '<p>15000     5%     : KYOCERA TASKALFA 3050ci , 3550ci</p>'),
	(830, '1', ' KYOCERA TK8305Y , 1T02LKANL0', 0, 102.35, 0, 1, 0.65, '-kyocera-tk8305y-1t02lkanl0', 'TSTK8305Y', 'http://tonersales,eu/shop/2124/-kyocera-tk8305y-1t02lkanl0,jpg', 0, '0', '<p>KYOCERA TASKALFA 3050ci , 3550ci</p>', '<p>15000     5%     : KYOCERA TASKALFA 3050ci , 3550ci</p>'),
	(831, '1', ' DELL 1320 HY CY 310-9060', 0, 13.25, 0, 105, 0.65, 'dell-1320-hy-cy-310-9060', 'TSFD058C', 'http://tonersales,eu/shop/1976/dell-1320-hy-cy-310-9060,jpg', 0, '0', '<p>Dell 1320C , 2130CN , 2135CN</p>', '<p>2000     5%     : Dell 1320C , 2130CN , 2135CN</p>'),
	(832, '1', ' DELL 1320 HY BK 310-9058', 0, 13.25, 0, 105, 0.65, 'dell-1320-hy-bk-310-9058', 'TSFD057B', 'http://tonersales,eu/shop/1973/dell-1320-hy-bk-310-9058,jpg', 0, '0', '<p>Dell 1320C , 2130CN , 2135CN</p>', '<p>2000     5%     : Dell 1320C , 2130CN , 2135CN</p>'),
	(833, '1', ' DELL 1320 HY YL 310-9062', 0, 13.25, 0, 105, 0.65, 'dell-1320-hy-yl-310-9062', 'TSFD059Y', 'http://tonersales,eu/shop/1977/dell-1320-hy-yl-310-9062,jpg', 0, '0', '<p>Dell 1320C , 2130CN , 2135CN</p>', '<p>2000     5%     : Dell 1320C , 2130CN , 2135CN</p>'),
	(834, '1', ' DELL 1320 HY MG 310-9064', 0, 13.25, 0, 105, 0.65, 'dell-1320-hy-mg-310-9064', 'TSFD060M', 'http://tonersales,eu/shop/1975/dell-1320-hy-mg-310-9064,jpg', 0, '0', '<p>Dell 1320C , 2130CN , 2135CN</p>', '<p>2000     5%     : Dell 1320C , 2130CN , 2135CN</p>'),
	(835, '1', ' DELL 1250 , 1350 HY BK 593-11016 , 593-11140', 0, 16.56, 0, 1, 0.65, 'dell-1250-1350-hy-bk-593-11016-593-11140', 'TSTFD134B', 'http://tonersales,eu/shop/1983/dell-1250-1350-hy-bk-593-11016-593-11140,jpg', 0, '0', '<p>Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>', '<p>2000     5%     : Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>'),
	(836, '1', ' DELL 1250 , 1350 HY CY 593-11021 , 593-11141', 0, 16.56, 0, 1, 0.65, 'dell-1250-1350-hy-cy-593-11021-593-11141', 'TSTFD135C', 'http://tonersales,eu/shop/1982/dell-1250-1350-hy-cy-593-11021-593-11141,jpg', 0, '0', '<p>Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>', '<p>1400     5%     : Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>'),
	(837, '1', ' DELL 1250 , 1350 HY YL 593-11019 , 593-11143', 0, 16.56, 0, 1, 0.65, 'dell-1250-1350-hy-yl-593-11019-593-11143', 'TSTFD136Y', 'http://tonersales,eu/shop/1984/dell-1250-1350-hy-yl-593-11019-593-11143,jpg', 0, '0', '<p>Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>', '<p>1400     5%     : Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>'),
	(838, '1', ' DELL 1250 , 1350 HY MG 593-11018 , 593-11142', 0, 16.56, 0, 1, 0.65, 'dell-1250-1350-hy-mg-593-11018-593-11142', 'TSTFD137M', 'http://tonersales,eu/shop/1985/dell-1250-1350-hy-mg-593-11018-593-11142,jpg', 0, '0', '<p>Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>', '<p>1400     5%     : Dell 1250c , 1350cnw , 1355cn , , 1355cnw , c1760nw , c1765nfw</p>'),
	(839, '1', ' DELL 2130 , 2135 HY BK 593-10312', 0, 16.56, 0, 1, 0.65, 'dell-2130-2135-hy-bk-593-10312', 'TSFD072B', 'http://tonersales,eu/shop/1980/dell-2130-2135-hy-bk-593-10312,jpg', 0, '0', '<p>Dell 2130CN , 2135CN</p>', '<p>2500     5%     : Dell 2130CN , 2135CN</p>'),
	(840, '1', ' DELL 2130 , 2135 HY CY 593-10313', 0, 16.56, 0, 1, 0.65, 'dell-2130-2135-hy-cy-593-10313', 'TSFD073C', 'http://tonersales,eu/shop/1978/dell-2130-2135-hy-cy-593-10313,jpg', 0, '0', '<p>Dell 2130CN , 2135CN</p>', '<p>2500     5%     : Dell 2130CN , 2135CN</p>'),
	(841, '1', ' DELL 2130 , 2135 HY YL  593-10315', 0, 16.56, 0, 1, 0.65, 'dell-2130-2135-hy-yl-593-10315', 'TSFD074Y', 'http://tonersales,eu/shop/1979/dell-2130-2135-hy-yl-593-10315,jpg', 0, '0', '<p>Dell 2130CN , 2135CN</p>', '<p>2500     5%     : Dell 2130CN , 2135CN</p>'),
	(842, '1', ' DELL 2130 , 2135 HY MG 593-10314', 0, 16.56, 0, 1, 0.65, 'dell-2130-2135-hy-mg-593-10314', 'TSFD075M', 'http://tonersales,eu/shop/1981/dell-2130-2135-hy-mg-593-10314,jpg', 0, '0', '<p>Dell 2130CN , 2135CN</p>', '<p>2500     5%     : Dell 2130CN , 2135CN</p>'),
	(843, '1', ' DELL 2150 , 2155 HY BK 593-11040', 0, 16.56, 0, 1, 0.65, 'dell-2150-2155-hy-bk-593-11040', 'TSTFD122B', 'http://tonersales,eu/shop/1986/dell-2150-2155-hy-bk-593-11040,jpg', 0, '0', '<p>DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>', '<p>3000     5%     : DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>'),
	(844, '1', ' DELL 2150 , 2155 HY CY 593-11041', 0, 16.56, 0, 1, 0.65, 'dell-2150-2155-hy-cy-593-11041', 'TSTFD123C', 'http://tonersales,eu/shop/1989/dell-2150-2155-hy-cy-593-11041,jpg', 0, '0', '<p>DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>', '<p>2500     5%     : DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>'),
	(845, '1', ' DELL 2150 , 2155 HY MG 593-11033', 0, 16.56, 0, 1, 0.65, 'dell-2150-2155-hy-mg-593-11033', 'TSTFD124M', 'http://tonersales,eu/shop/1988/dell-2150-2155-hy-mg-593-11033,jpg', 0, '0', '<p>DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>', '<p>2500     5%     : DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>'),
	(846, '1', ' DELL 2150 , 2155 HY YL 593-11037', 0, 16.56, 0, 1, 0.65, 'dell-2150-2155-hy-yl-593-11037', 'TSTFD125Y', 'http://tonersales,eu/shop/1987/dell-2150-2155-hy-yl-593-11037,jpg', 0, '0', '<p>DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>', '<p>2500     5%     : DELL 2150CN , 2150CDN , 2155CN , 2155CDN</p>'),
	(847, '1', ' DELL 3000 , 3100 HY BK 310-6874', 0, 21.79, 0, 1, 0.65, 'dell-3000-3100-hy-bk-310-6874', 'TSFD019B', 'http://tonersales,eu/shop/1993/dell-3000-3100-hy-bk-310-6874,jpg', 0, '0', '<p>Dell 3000cn , 3100cn</p>', '<p>4000     5%     : Dell 3000cn , 3100cn</p>'),
	(848, '1', ' DELL 3000 , 3100 HY CY 310-5731', 0, 21.79, 0, 1, 0.65, 'dell-3000-3100-hy-cy-310-5731', 'TSFD020C', 'http://tonersales,eu/shop/1992/dell-3000-3100-hy-cy-310-5731,jpg', 0, '0', '<p>Dell 3000cn , 3100cn</p>', '<p>4000     5%     : Dell 3000cn , 3100cn</p>'),
	(849, '1', ' DELL 3000 , 3100 HY YL 310-5729', 0, 21.79, 0, 1, 0.65, 'dell-3000-3100-hy-yl-310-5729', 'TSFD021Y', 'http://tonersales,eu/shop/1991/dell-3000-3100-hy-yl-310-5729,jpg', 0, '0', '<p>Dell 3000cn , 3100cn</p>', '<p>4000     5%     : Dell 3000cn , 3100cn</p>'),
	(850, '1', ' DELL 3000 , 3100 HY MG 310-5730', 0, 21.79, 0, 1, 0.65, 'dell-3000-3100-hy-mg-310-5730', 'TSFD022M', 'http://tonersales,eu/shop/1990/dell-3000-3100-hy-mg-310-5730,jpg', 0, '0', '<p>Dell 3000cn , 3100cn</p>', '<p>4000     5%     : Dell 3000cn , 3100cn</p>'),
	(851, '1', ' DELL 3010 HY BK 341-3568', 1, 23.56, 0, 1, 0.65, 'dell-3010-hy-bk-341-3568', 'TSFD036B', 'http://tonersales,eu/shop/1286/dell-3010-hy-bk-341-3568,jpg', 0, '0', 'Dell 3010cn', '4000     5%               :  Dell 3010cn'),
	(852, '1', ' DELL 3010 HY CY 341-3571', 1, 23.56, 0, 1, 0.65, 'dell-3010-hy-cy-341-3571', 'TSFD037C', 'http://tonersales,eu/shop/1287/dell-3010-hy-cy-341-3571,jpg', 0, '0', 'Dell 3010cn', '4000     5%               :  Dell 3010cn'),
	(853, '1', ' DELL 3010 HY YL 341-3569', 0, 23.56, 0, 1, 0.65, 'dell-3010-hy-yl-341-3569', 'TSFD038Y', 'http://tonersales,eu/shop/1288/dell-3010-hy-yl-341-3569,jpg', 0, '0', '<p>Dell 3010cn</p>', '<p>4000     5%     : Dell 3010cn</p>'),
	(854, '1', ' DELL 3010 HY MG 341-3570', 1, 23.56, 0, 1, 0.65, 'dell-3010-hy-mg-341-3570', 'TSFD039M', 'http://tonersales,eu/shop/1289/dell-3010-hy-mg-341-3570,jpg', 0, '0', 'Dell 3010cn', '4000     5%               :  Dell 3010cn'),
	(855, '1', ' DELL 1720  HY (593-10239)', 0, 23.82, 0, 1, 0.65, 'dell-1720-hy-593-10239', 'TSFD065B', 'http://tonersales,eu/shop/1290/dell-1720-hy-593-10239,jpg', 0, '0', '<p>Dell 1720 , 1720N</p>', '<p>6000     5%     : Dell 1720 , 1720N</p>'),
	(856, '1', ' DELL 1130 HY (593-10961)', 0, 33, 0, 1, 0.65, 'dell-1130-hy-593-10961', 'TSTFD121B', 'http://tonersales,eu/shop/1291/dell-1130-hy-593-10961,jpg', 0, '0', '<p>Dell 1130 , 1130N , 1133 , 1135N</p>', '<p>2500     5%     : Dell 1130 , 1130N , 1133 , 1135N</p>'),
	(857, '1', ' DELL 1230 BK 593-10493', 0, 33, 0, 1, 0.65, 'dell-1230-bk-593-10493', 'TSTFD130B', 'http://tonersales,eu/shop/1294/dell-1230-bk-593-10493,jpg', 0, '0', '<p>Dell 1230C , 1235CN</p>', '<p>1500     5%     : Dell 1230C , 1235CN</p>'),
	(858, '1', ' DELL 1230 CY 593-10494', 0, 33, 0, 1, 0.65, 'dell-1230-cy-593-10494', 'TSTFD131C', 'http://tonersales,eu/shop/1293/dell-1230-cy-593-10494,jpg', 0, '0', '<p>Dell 1230C , 1235CN</p>', '<p>1000     5%     : Dell 1230C , 1235CN</p>'),
	(859, '1', ' DELL 1230 YL 593-10496', 0, 33, 0, 1, 0.65, 'dell-1230-yl-593-10496', 'TSTFD132Y', 'http://tonersales,eu/shop/1295/dell-1230-yl-593-10496,jpg', 0, '0', '<p>Dell 1230C , 1235CN</p>', '<p>1000     5%     : Dell 1230C , 1235CN</p>'),
	(860, '1', ' DELL 1230 MG 593-10495', 0, 33, 0, 1, 0.65, 'dell-1230-mg-593-10495', 'TSTFD133M', 'http://tonersales,eu/shop/1296/dell-1230-mg-593-10495,jpg', 0, '0', '<p>Dell 1230C , 1235CN</p>', '<p>1000     5%     : Dell 1230C , 1235CN</p>'),
	(861, '1', ' DELL 5100 BK 593-10054', 0, 35.7, 0, 1, 0.65, 'dell-5100-bk-593-10054', 'TSFD5100B', 'http://tonersales,eu/shop/1661/dell-5100-bk-593-10054,jpg', 0, '0', '<p>Dell 5100</p>', '<p>9000     5%     : Dell 5100</p>'),
	(862, '1', ' DELL 5100 CY 593-10051', 0, 35.7, 0, 1, 0.65, 'dell-5100-cy-593-10051', 'TSFD5100C', 'http://tonersales,eu/shop/1662/dell-5100-cy-593-10051,jpg', 0, '0', '<p>Dell 5100</p>', '<p>8000     5%     : Dell 5100</p>'),
	(863, '1', ' DELL 5100 YL 593-10053', 0, 35.7, 0, 1, 0.65, 'dell-5100-yl-593-10053', 'TSFD5100', 'http://tonersales,eu/shop/1663/dell-5100-yl-593-10053,jpg', 0, '0', '<p>Dell 5100</p>', '<p>8000     5%     : Dell 5100</p>'),
	(864, '1', ' DELL 5100 MG 593-10052', 0, 35.7, 0, 1, 0.65, 'dell-5100-mg-593-10052', 'TSFD5100M', 'http://tonersales,eu/shop/1664/dell-5100-mg-593-10052,jpg', 0, '0', '<p>Dell 5100</p>', '<p>8000     5%     : Dell 5100</p>'),
	(865, '1', ' DELL 5110 BK SY 593-10120', 0, 37.58, 0, 1, 0.65, 'dell-5110-bk-sy-593-10120', 'TSTFD053B', 'http://tonersales,eu/shop/1301/dell-5110-bk-sy-593-10120,jpg', 0, '0', '<p>Dell 5110CN</p>', '<p>10000     5%     : Dell 5110CN</p>'),
	(866, '1', ' DELL 5110 CY SY 593-10118', 0, 37.58, 0, 1, 0.65, 'dell-5110-cy-sy-593-10118', 'TSTFD054C', 'http://tonersales,eu/shop/1302/dell-5110-cy-sy-593-10118,jpg', 0, '0', '<p>Dell 5110CN</p>', '<p>8000     5%     : Dell 5110CN</p>'),
	(867, '1', ' DELL 5110 YL SY 593-10122', 0, 37.58, 0, 1, 0.65, 'dell-5110-yl-sy-593-10122', 'TSTFD055Y', 'http://tonersales,eu/shop/1303/dell-5110-yl-sy-593-10122,jpg', 0, '0', '<p>Dell 5110CN</p>', '<p>8000     5%     : Dell 5110CN</p>'),
	(868, '1', ' DELL 5110 MG SY 593-10124', 1, 37.58, 0, 1, 0.65, 'dell-5110-mg-sy-593-10124', 'TSTFD056M', 'http://tonersales,eu/shop/1304/dell-5110-mg-sy-593-10124,jpg', 0, '0', 'Dell 5110CN', '8000     5%               :  Dell 5110CN'),
	(869, '1', ' DELL 1815 HY (593-10153)', 0, 37.7, 0, 1, 0.65, 'dell-1815-hy-593-10153', 'TSRD002B', 'http://tonersales,eu/shop/1308/dell-1815-hy-593-10153,jpg', 0, '0', '<p>Dell 1815DN</p>', '<p>5000     5%     : Dell 1815DN</p>'),
	(870, '1', ' DELL 2335  HY (593-10329)', 0, 50.72, 0, 1, 0.65, 'dell-2335-hy-593-10329', 'TSTRD023B', 'http://tonersales,eu/shop/1307/dell-2335-hy-593-10329,jpg', 0, '0', '<p>Dell 2335dn</p>', '<p>6000     5%     : Dell 2335dn</p>'),
	(871, '1', ' DELL 1160  (331-7335)', 0, 52.79, 0, 1, 0.65, 'dell-1160-331-7335', 'TSTFD172B', 'http://tonersales,eu/shop/1309/dell-1160-331-7335,jpg', 0, '0', '<p>Dell B1160 , B1160w</p>', '<p>1500     5%     : Dell B1160 , B1160w</p>'),
	(872, '1', ' DELL 3110 HY BK 593-10170', 1, 78.51, 0, 1, 0.65, 'dell-3110-hy-bk-593-10170', 'TSRD004B', 'http://tonersales,eu/shop/1310/dell-3110-hy-bk-593-10170,jpg', 0, '0', 'Dell 3110CN , 3115CN', '8000     5%               :  Dell 3110CN , 3115CN'),
	(873, '1', ' DELL 3110 HY CY 593-10171', 1, 78.51, 0, 1, 0.65, 'dell-3110-hy-cy-593-10171', 'TSRD005C', 'http://tonersales,eu/shop/1311/dell-3110-hy-cy-593-10171,jpg', 0, '0', 'Dell 3110CN , 3115CN', '8000     5%               :  Dell 3110CN , 3115CN'),
	(874, '1', ' DELL 3110 HY MG 593-10172', 0, 78.51, 0, 1, 0.65, 'dell-3110-hy-mg-593-10172', 'TSRD006M', 'http://tonersales,eu/shop/1312/dell-3110-hy-mg-593-10172,jpg', 0, '0', '<p>Dell 3110CN , 3115CN</p>', '<p>8000     5%     : Dell 3110CN , 3115CN</p>'),
	(875, '1', ' DELL 3110 HY YL 593-10173', 0, 78.51, 0, 1, 0.65, 'dell-3110-hy-yl-593-10173', 'TSRD007Y', 'http://tonersales,eu/shop/1313/dell-3110-hy-yl-593-10173,jpg', 0, '0', '<p>Dell 3110CN , 3115CN</p>', '<p>8000     5%     : Dell 3110CN , 3115CN</p>'),
	(876, '1', ' DELL 3130 HY BK 593-10289', 1, 83.03, 0, 1, 0.65, 'dell-3130-hy-bk-593-10289', 'TSTRD015B', 'http://tonersales,eu/shop/1314/dell-3130-hy-bk-593-10289,jpg', 0, '0', 'Dell 3130CN', '9000     5%               :  Dell 3130CN'),
	(877, '1', ' DELL 3130 HY CY 593-10290', 1, 83.03, 0, 1, 0.65, 'dell-3130-hy-cy-593-10290', 'TSTRD016C', 'http://tonersales,eu/shop/1315/dell-3130-hy-cy-593-10290,jpg', 0, '0', 'Dell 3130CN', '9000     5%               :  Dell 3130CN'),
	(878, '1', ' DELL 3130 HY MG 593-10291', 0, 83.03, 0, 1, 0.65, 'dell-3130-hy-mg-593-10291', 'TSTRD017M', 'http://tonersales,eu/shop/1316/dell-3130-hy-mg-593-10291,jpg', 0, '0', '<p>Dell 3130CN</p>', '<p>9000     5%     : Dell 3130CN</p>'),
	(879, '1', ' DELL 3130 HY YL 593-10292', 1, 83.03, 0, 1, 0.65, 'dell-3130-hy-yl-593-10292', 'TSTRD018Y', 'http://tonersales,eu/shop/1317/dell-3130-hy-yl-593-10292,jpg', 0, '0', 'Dell 3130CN', '9000     5%               :  Dell 3130CN'),
	(880, '1', ' DELL 2230  (593-10500 , 593-10501)', 0, 85.23, 0, 1, 0.65, 'dell-2230-593-10500-593-10501', 'TSTFD152B', 'http://tonersales,eu/shop/1318/dell-2230-593-10500-593-10501,jpg', 0, '0', '<p>Dell 2230D</p>', '<p>3500     5%     : Dell 2230D</p>'),
	(881, '1', ' DELL 2330  HY (593-10334 , 593-10335)', 1, 91.85, 0, 1, 0.65, 'dell-2330-hy-593-10334-593-10335', 'TSTFD139B', 'http://tonersales,eu/shop/1319/dell-2330-hy-593-10334-593-10335,jpg', 0, '0', 'Dell 2330D , 2330DN , 2330DTN , 2350D , 2350DN', '6000     5%               :  Dell 2330D , 2330DN , 2330DTN , 2350D , 2350DN'),
	(882, '1', ' DELL 3330  HY (593-10838 , 593-10839)', 1, 143.51, 0, 1, 0.65, 'dell-3330-hy-593-10838-593-10839', 'TSTFD145B', 'http://tonersales,eu/shop/1320/dell-3330-hy-593-10838-593-10839,jpg', 0, '0', 'Dell 3330DN', '14000     5%               :  Dell 3330DN'),
	(883, '1', ' OLIVETTI TK-160 BK', 0, 12.21, 0, 1, 0.65, '#NAME?', 'TSFK160B', 'http://tonersales,eu/shop/1321/-olivetti-tk-160-bk,jpg', 0, '0', '<p>Olivetti PG L2130</p>', '<p>2500     5%     : Olivetti PG L2130</p>'),
	(884, '1', ' OLIVETTI NP6012 (NPG-11) BK', 0, 13.97, 0, 1, 0.65, '#NAME?', 'TSFC102B', 'http://tonersales,eu/shop/1322/-olivetti-np6012-npg-11-bk,jpg', 0, '0', '<p>Olivetti Lexikon COPIA 8512</p>', '<p>5000     5%     : Olivetti Lexikon COPIA 8512</p>'),
	(885, '1', ' OLIVETTI TK-110 BLACK', 53, 9.6, 0, 50, 0.65, '#NAME?', 'TSFK104B', 'http://tonersales,eu/shop/1323/-olivetti-tk-110-black,jpg', 0, '0', '<p>Olivetti d-copia163MF - d-copia164MF Utax CD1316</p>', '<p>6000     5%     : Olivetti d-copia163MF - d-copia164MF Utax CD1316</p>'),
	(886, '1', ' OLIVETTI TK-18 , TK-100 370QB0KX', 0, 13.34, 0, 50, 0.65, '-olivetti-tk-18-tk-100-370qb0kx', 'TSFK020B', 'http://tonersales,eu/shop/1324/-olivetti-tk-18-tk-100-370qb0kx,jpg', 0, '0', '<p>Olivetti D-COPIA 18 , D-COPIA 284</p>', '<p>7200     5%     : Olivetti D-COPIA 18 , D-COPIA 284</p>'),
	(887, '1', ' OLIVETTI TK-120 , TK-122  , 1T02G60DE0', 0, 13.34, 0, 50, 0.65, '-olivetti-tk-120-tk-122-1t02g60de0', 'TSFK108B', 'http://tonersales,eu/shop/1325/-olivetti-tk-120-tk-122-1t02g60de0,jpg', 0, '0', '<p>Olivetti D-COPIA 3003 LP3022 , CD5130</p>', '<p>7200     5%     : Olivetti D-COPIA 3003 LP3022 , CD5130</p>'),
	(888, '1', ' OLIVETTI NP6016 (NPG-9) BK', 0, 15.24, 0, 1, 0.65, '#NAME?', 'TSFC103B', 'http://tonersales,eu/shop/1326/-olivetti-np6016-npg-9-bk,jpg', 0, '0', '<p>Olivetti Lexikon COPIA 8021 Triumph-Adler TA3021</p>', '<p>7600     5%     : Olivetti Lexikon COPIA 8021 Triumph-Adler TA3021</p>'),
	(889, '1', ' OLIVETTI TK-140 BK', 0, 14.28, 0, 102, 0.65, '#NAME?', 'TSFK124B', 'http://tonersales,eu/shop/1327/-olivetti-tk-140-bk,jpg', 0, '0', '<p>Olivetti Lexikon PG L 2028 Utax LP 3128</p>', '<p>4000     5%     : Olivetti Lexikon PG L 2028 Utax LP 3128</p>'),
	(890, '1', ' OLIVETTI TK-130 , 132 , 134 (TK130)  , 1T02HS0EU0', 53, 11.69, 0, 50, 0.65, '-olivetti-tk-130-132-134-tk130-1t02hs0eu0', 'TSFK122B', 'http://tonersales,eu/shop/251/-olivetti-tk-130-132-134-tk130-1t02hs0eu0,jpg', 0, '0', '<p>Olivetti D-COPIA 283 Utax CD1028</p>', '<p>7200     5%     : Olivetti D-COPIA 283 Utax CD1028</p>'),
	(891, '1', ' OLIVETTI TK170 BK 1T02LZ0NL0', 0, 16.53, 0, 50, 0.65, '-olivetti-tk170-bk-1t02lz0nl0', 'TSFK170B', 'http://tonersales,eu/shop/1328/-olivetti-tk170-bk-1t02lz0nl0,jpg', 0, '0', '<p>Olivetti PG L2135 UTAX LP3135 , LP3335</p>', '<p>7200     5%     : Olivetti PG L2135 UTAX LP3135 , LP3335</p>'),
	(892, '1', ' OLIVETTI TK-340  , 1T02J00EU0', 0, 18.7, 0, 1, 0.65, '-olivetti-tk-340-1t02j00eu0', 'TSFK127B', 'http://tonersales,eu/shop/1329/-olivetti-tk-340-1t02j00eu0,jpg', 0, '0', '<p>Olivetti PG L2035 UTAX LP3235</p>', '<p>12000     5%     : Olivetti PG L2035 UTAX LP3235</p>'),
	(893, '1', ' OLIVETTI NP4050 (NPG-4) BK', 0, 18.84, 0, 1, 0.65, '#NAME?', 'TSFC004B', 'http://tonersales,eu/shop/1330/-olivetti-np4050-npg-4-bk,jpg', 0, '0', '<p>Olivetti Lexikon COPIA 8040</p>', '<p>15000     5%     : Olivetti Lexikon COPIA 8040</p>'),
	(894, '1', ' OLIVETTI TK-310 , 312  , 1T02F80EU0', 0, 21.61, 0, 50, 0.65, '-olivetti-tk-310-312-1t02f80eu0', 'TSFK113B', 'http://tonersales,eu/shop/1331/-olivetti-tk-310-312-1t02f80eu0,jpg', 0, '0', '<p>Olivetti Lexikon PG L 230</p>', '<p>12000     5%     : Olivetti Lexikon PG L 230</p>'),
	(895, '1', ' OLIVETTI TK-1130 BK (0T2MJ0NL)', 0, 21.98, 0, 1, 0.65, '-olivetti-tk-1130-bk-0t2mj0nl', 'TSTFK335B', 'http://tonersales,eu/shop/1332/-olivetti-tk-1130-bk-0t2mj0nl,jpg', 0, '0', '<p>Olivetti D-COPIA 3004 Utax CD5230</p>', '<p>3000     5%     : Olivetti D-COPIA 3004 Utax CD5230</p>'),
	(896, '1', ' OLIVETTI TK-1140', 0, 23.31, 0, 1, 0.65, '#NAME?', 'TS1T02ML0NL0', 'http://tonersales,eu/shop/1333/-olivetti-tk-1140,jpg', 0, '0', '<p>Olivetti D-COPIA 3503 , 3504 Utax CD5135 , CD5235</p>', '<p>7200     5%     : Olivetti D-COPIA 3503 , 3504 Utax CD5135 , CD5235</p>'),
	(897, '1', ' OLIVETTI TK-320 BK  , 1T02F90EU0', 0, 25.36, 0, 1, 0.65, '-olivetti-tk-320-bk-1t02f90eu0', 'TSFK320B', 'http://tonersales,eu/shop/1334/-olivetti-tk-320-bk-1t02f90eu0,jpg', 0, '0', '<p>Olivetti PG L235 , L245 UTAX LP3035 , LP3240 , LP3045</p>', '<p>15000     5%     : Olivetti PG L235 , L245 UTAX LP3035 , LP3240 , LP3045</p>'),
	(898, '1', ' OLIVETTI TK-580 CY', 0, 25.52, 0, 50, 0.65, '#NAME?', 'TSTFK326C', 'http://tonersales,eu/shop/2071/-olivetti-tk-580-cy,jpg', 0, '0', '<p>Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>2800     5%     : Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(899, '1', ' OLIVETTI TK-580 MG', 0, 25.52, 0, 50, 0.65, '#NAME?', 'TSTFK327M', 'http://tonersales,eu/shop/2069/-olivetti-tk-580-mg,jpg', 0, '0', '<p>Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>2800     5%     : Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(900, '1', ' OLIVETTI TK-580 YL', 0, 25.52, 0, 50, 0.65, '#NAME?', 'TSTFK328Y', 'http://tonersales,eu/shop/2067/-olivetti-tk-580-yl,jpg', 0, '0', '<p>Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>2800     5%     : Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(901, '1', ' OLIVETTI TK350  , 1T02LX0NL0', 0, 29.84, 0, 50, 0.65, '-olivetti-tk350-1t02lx0nl0', 'TSFK128B', 'http://tonersales,eu/shop/1338/-olivetti-tk350-1t02lx0nl0,jpg', 0, '0', '<p>Olivetti PG L2040 UTAX LP3240</p>', '<p>15000     5%     : Olivetti PG L2040 UTAX LP3240</p>'),
	(902, '1', ' OLIVETTI TK-360  , 1T02J20EU0', 0, 26.55, 0, 1, 0.65, '-olivetti-tk-360-1t02j20eu0', 'TSFK129B', 'http://tonersales,eu/shop/1339/-olivetti-tk-360-1t02j20eu0,jpg', 0, '0', '<p>Olivetti PG L2045 UTAX LP3245</p>', '<p>20000     5%     : Olivetti PG L2045 UTAX LP3245</p>'),
	(903, '1', ' OLIVETTI TK-580 BK', 0, 27.17, 0, 101, 0.65, '#NAME?', 'TSTFK325B', 'http://tonersales,eu/shop/2074/-olivetti-tk-580-bk,jpg', 0, '0', '<p>Olivetti D-COLOR P2021 UTAX CLP3721</p>', '<p>3500     5%     : Olivetti D-COLOR P2021 UTAX CLP3721</p>'),
	(904, '1', ' OLIVETTI TK-475 BK  , 1T02K30NL0', 0, 31.9, 0, 101, 0.65, '-olivetti-tk-475-bk-1t02k30nl0', 'TSTFK334B', 'http://tonersales,eu/shop/1341/-olivetti-tk-475-bk-1t02k30nl0,jpg', 0, '0', '<p>Olivetti D-COPIA253 , D-COPIA303 UTAX CD5025 , CD5030 , 256I , 306I</p>', '<p>15000     5%     : Olivetti D-COPIA253 , D-COPIA303 UTAX CD5025 , CD5030 , 256I , 306I</p>'),
	(905, '1', ' OLIVETTI TK540 CY', 0, 27.81, 0, 50, 0.65, '#NAME?', 'TSTFK303C', 'http://tonersales,eu/shop/2080/-olivetti-tk540-cy,jpg', 0, '0', '<p>Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>', '<p>4000     5%     : Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>'),
	(906, '1', ' OLIVETTI TK540 MG', 0, 27.81, 0, 102, 0.65, '#NAME?', 'TSTFK304M', 'http://tonersales,eu/shop/2078/-olivetti-tk540-mg,jpg', 0, '0', '<p>Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>', '<p>4000     5%     : Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>'),
	(907, '1', ' OLIVETTI TK540 YL', 0, 27.81, 0, 102, 0.65, '#NAME?', 'TSTFK305Y', 'http://tonersales,eu/shop/2076/-olivetti-tk540-yl,jpg', 0, '0', '<p>Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>', '<p>4000     5%     : Olivetti D-COLOR P221 UTAX CLP3521 UTAX CLP3521</p>'),
	(908, '1', ' OLIVETTI TK540 BK', 0, 31.2, 0, 102, 0.65, '#NAME?', 'TSTFK302B', 'http://tonersales,eu/shop/2082/-olivetti-tk540-bk,jpg', 0, '0', '<p>Olivetti D-COLOR P221 UTAX CLP3521</p>', '<p>5000     5%     : Olivetti D-COLOR P221 UTAX CLP3521</p>'),
	(909, '1', ' OLIVETTI KM1525 (TK-1530) 37028000 , 10', 0, 33, 0, 1, 0.65, '#NAME?', 'TSFK013B', 'http://tonersales,eu/shop/1346/-olivetti-km1525-tk-1530-37028000-10,jpg', 0, '0', '<p>Olivetti D-COPIA 15 , D-COPIA 20 UTAX CD1015 , CD1020</p>', '<p>11000     5%     : Olivetti D-COPIA 15 , D-COPIA 20 UTAX CD1015 , CD1020</p>'),
	(910, '1', ' OLIVETTI TK-550 CY', 0, 33.37, 0, 1, 0.65, '#NAME?', 'TSTFK314C', 'http://tonersales,eu/shop/2088/-olivetti-tk-550-cy,jpg', 0, '0', '<p>Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>6000     5%     : Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(911, '1', ' OLIVETTI TK-550 MG', 0, 33.37, 0, 1, 0.65, '#NAME?', 'TSTFK315M', 'http://tonersales,eu/shop/2086/-olivetti-tk-550-mg,jpg', 0, '0', '<p>Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>6000     5%     : Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(912, '1', ' OLIVETTI TK-550 YL', 0, 33.37, 0, 1, 0.65, '#NAME?', 'TSTFK316Y', 'http://tonersales,eu/shop/2084/-olivetti-tk-550-yl,jpg', 0, '0', '<p>Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>6000     5%     : Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(913, '1', ' OLIVETTI TK-330 , TK-332  , 1T02GA0EU0', 0, 34.2, 0, 1, 0.65, '-olivetti-tk-330-tk-332-1t02ga0eu0', 'TSFK118B', 'http://tonersales,eu/shop/1350/-olivetti-tk-330-tk-332-1t02ga0eu0,jpg', 0, '0', '<p>Olivetti Lexikon PG L 245</p>', '<p>20000     5%     : Olivetti Lexikon PG L 245</p>'),
	(914, '1', ' OLIVETTI TK410, TK420 , TK430 370AM010', 0, 36.23, 0, 50, 0.65, '-olivetti-tk410-tk420-tk430-370am010', 'TSFK102B', 'http://tonersales,eu/shop/1351/-olivetti-tk410-tk420-tk430-370am010,jpg', 0, '0', '<p>OLIVETTI d-Copia 16 , d-Copia 200 , d-Copia 250 , d-Copia 1600 , d-Copia 2000 Utax CD1125 , CD1016 , CD1216 , CD1116 , CD1120</p>', '<p>15000     5%     : OLIVETTI d-Copia 16 , d-Copia 200 , d-Copia 250 , d-Copia 1600 , d-Copia 2000 Utax CD1125 , CD1016 , CD1216 , CD1116 , CD1120</p>'),
	(915, '1', ' OLIVETTI TK-550 BK', 0, 37.19, 0, 1, 0.65, '#NAME?', 'TSTFK313B', 'http://tonersales,eu/shop/2092/-olivetti-tk-550-bk,jpg', 0, '0', '<p>Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>', '<p>7000     5%     : Olivetti D-COLOR P221 SPECIAL UTAX CLP3621</p>'),
	(916, '1', ' OLIVETTI TK-435', 0, 38.7, 0, 50, 0.65, '#NAME?', 'TSFK435B', 'http://tonersales,eu/shop/1353/-olivetti-tk-435,jpg', 0, '0', '<p>Olivetti D-Copia 1800MF , 1800 , 2200</p>', '<p>15000     5%     : Olivetti D-Copia 1800MF , 1800 , 2200</p>'),
	(917, '1', ' OLIVETTI TK-560 MG', 0, 48.18, 0, 1, 0.65, '#NAME?', 'TS13316818**', 'http://tonersales,eu/shop/2099/-olivetti-tk-560-mg,jpg', 0, '0', '<p>Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>10000     5%     : Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(918, '1', ' OLIVETTI TK-560 YL', 0, 48.18, 0, 1, 0.65, '#NAME?', 'TS13316819**', 'http://tonersales,eu/shop/2103/-olivetti-tk-560-yl,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>10000     5%     : KYOCERA FS-C5305DN , C5300 Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(919, '1', ' OLIVETTI TK-560 CY', 0, 48.18, 0, 1, 0.65, '#NAME?', 'TS13316817**', 'http://tonersales,eu/shop/2101/-olivetti-tk-560-cy,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>10000     5%     : KYOCERA FS-C5305DN , C5300 Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(920, '1', ' OLIVETTI GP-160 BK', 0, 56.55, 0, 1, 0.65, '#NAME?', 'TSRC136B', 'http://tonersales,eu/shop/1357/-olivetti-gp-160-bk,jpg', 0, '0', '<p>Olivetti Lexikon COPIA 9916</p>', '<p>10000     5%     : Olivetti Lexikon COPIA 9916</p>'),
	(921, '1', ' OLIVETTI TK-560 BK', 0, 59.09, 0, 1, 0.65, '#NAME?', 'TS13316816**', 'http://tonersales,eu/shop/2112/-olivetti-tk-560-bk,jpg', 0, '0', '<p>KYOCERA FS-C5305DN , C5300 Olivetti D-COLOR P226 UTAX CLP3626</p>', '<p>12000     5%     : KYOCERA FS-C5305DN , C5300 Olivetti D-COLOR P226 UTAX CLP3626</p>'),
	(922, '1', ' OLIVETTI TK-520 BK', 0, 60.22, 0, 1, 0.65, '#NAME?', 'TS13314133', 'http://tonersales,eu/shop/2118/-olivetti-tk-520-bk,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>6000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(923, '1', ' OLIVETTI TK-520 CY', 0, 60.22, 0, 1, 0.65, '#NAME?', 'TS13314134', 'http://tonersales,eu/shop/2114/-olivetti-tk-520-cy,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>4000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(924, '1', ' OLIVETTI TK-520 YL', 0, 60.22, 0, 1, 0.65, '#NAME?', 'TS13314135', 'http://tonersales,eu/shop/2116/-olivetti-tk-520-yl,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>4000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(925, '1', ' OLIVETTI TK-520 MG', 0, 60.22, 0, 1, 0.65, '#NAME?', 'TS13314136', 'http://tonersales,eu/shop/2120/-olivetti-tk-520-mg,jpg', 0, '0', '<p>Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>', '<p>4000     5%     : Kyocera Mita (1T02HJ0EU0)-FS C-5015N , C5015 Olivetti D-COLOR P216 UTAX CLP3316</p>'),
	(926, '1', ' OLIVETTI TK-675 , 677 , 678 , 679  , 1T02H00EU0', 0, 64.05, 0, 1, 0.65, '-olivetti-tk-675-677-678-679-1t02h00eu0', 'TSFK139B', 'http://tonersales,eu/shop/1363/-olivetti-tk-675-677-678-679-1t02h00eu0,jpg', 0, '0', '<p>Olivetti d-copia 2500 , D-COPIA 3000</p>', '<p>24000     5%     : Olivetti d-copia 2500 , D-COPIA 3000</p>'),
	(927, '1', ' OLIVETTI TK-715  , 1T02GR0EU0', 0, 65.18, 0, 1, 0.65, '-olivetti-tk-715-1t02gr0eu0', 'TSFK115B', 'http://tonersales,eu/shop/1364/-olivetti-tk-715-1t02gr0eu0,jpg', 0, '0', '<p>Utax CD 1230 Olivetti Lexikon D-COPIA 300 MF</p>', '<p>34000     5%     : Utax CD 1230 Olivetti Lexikon D-COPIA 300 MF</p>'),
	(928, '1', ' OLIVETTI KM-2530 370AB000', 53, 59, 0, 1, 0.65, '-olivetti-km-2530-370ab000', 'TSFK116B', 'http://tonersales,eu/shop/257/-olivetti-km-2530-370ab000,jpg', 0, '0', '<p>OLIVETTI D-COPIA 25 , D-COPIA 35 , D-COPIA 40 , D-COPIA 300 , D-COPIA 400 , D-COPIA 500 Utax CD1025 , CD1030 Olympia OMEGA D250</p>', '<p>40000     5%     : OLIVETTI D-COPIA 25 , D-COPIA 35 , D-COPIA 40 , D-COPIA 300 , D-COPIA 400 , D-COPIA 500 Utax CD1025 , CD1030 Olympia OMEGA D250</p>'),
	(929, '1', ' KONICA MINOLTA TYPE 101A', 0, 7.89, 0, 1, 0.65, '-konica-minolta-type-101a', 'TSFM103B', 'http://tonersales,eu/shop/2153/-konica-minolta-type-101a,jpg', 0, '0', '<p>Minolta EP1050 , 1070 , 1080 , 1081-CS Pro Series</p>', '<p>6000     5%     : Minolta EP1050 , 1070 , 1080 , 1081-CS Pro Series</p>'),
	(930, '1', ' KONICA MINOLTA TYPE 102B', 0, 8.78, 0, 1, 0.65, '-konica-minolta-type-102b', 'TSFM109B', 'http://tonersales,eu/shop/2154/-konica-minolta-type-102b,jpg', 0, '0', '<p>Minolta EP1052 , 1083 , 2010-CS Pro Series</p>', '<p>6000     5%     : Minolta EP1052 , 1083 , 2010-CS Pro Series</p>'),
	(931, '1', ' KONICA MINOLTA TYPE 103A BK 4PC', 0, 8.89, 0, 1, 0.65, '-konica-minolta-type-103a-bk-4pc', 'TSTFM113B**C', 'http://tonersales,eu/shop/945/-konica-minolta-type-103a-bk-4pc,jpg', 0, '0', '<p>Minolta EP1030 , 1031-CS Pro Series</p>', '<p>1500     5%     : Minolta EP1030 , 1031-CS Pro Series</p>'),
	(932, '1', ' KONICA MINOLTA TYPE 104A BK', 0, 9.59, 0, 1, 0.65, '-konica-minolta-type-104a-bk', 'TSFM107B', 'http://tonersales,eu/shop/2155/-konica-minolta-type-104a-bk,jpg', 0, '0', '<p>Minolta EP1054 , 1085-CS Pro Series</p>', '<p>7500     5%     : Minolta EP1054 , 1085-CS Pro Series</p>'),
	(933, '1', ' KONICA MINOLTA EP2120 BK 4PC', 0, 11.47, 0, 1, 0.65, '-konica-minolta-ep2120-bk-4pc', 'TSFM112B**C', 'http://tonersales,eu/shop/947/-konica-minolta-ep2120-bk-4pc,jpg', 0, '0', '<p>Minolta EP2120 , 2121 , 2130 , 2150 , 2151 , 2152 , 2153 Develop 1211 , 1212 , 1311 , 1312 ,1511 , 1512 , 1513 , 1514</p>', '<p>1500     5%     : Minolta EP2120 , 2121 , 2130 , 2150 , 2151 , 2152 , 2153 Develop 1211 , 1212 , 1311 , 1312 ,1511 , 1512 , 1513 , 1514</p>'),
	(934, '1', ' KONICA MINOLTA BIZHUB 162 , DI-152 TN114', 0, 12.21, 0, 1, 0.65, '#NAME?', 'TSFM117B', 'http://tonersales,eu/shop/2156/-konica-minolta-bizhub-162-di-152-tn114,jpg', 0, '0', '<p>TN-114 Bizhub 162 , Bizhub 163 , Bizhub 180 , Bizhub 181 , Bizhub 210 , 211 , DI-152 , 1531DI , DI-183 , 1611 , 2011 DEVELOP D1531 , D1536 , D1650 , D1831 , D2050 Ineo 161 , 163 , 210 , 213</p>', '<p>11000     5%     : TN-114 Bizhub 162 , Bizhub 163 , Bizhub 180 , Bizhub 181 , Bizhub 210 , 211 , DI-152 , 1531DI , DI-183 , 1611 , 2011 DEVELOP D1531 , D1536 , D1650 , D1831 , D2050 Ineo 161 , 163 , 210 , 213</p>'),
	(935, '1', ' KONICA MINOLTA TYPE MT-302B BK (8936-4040)', 0, 13.54, 0, 1, 0.65, '-konica-minolta-type-mt-302b-bk-8936-4040', 'TSFM116B', 'http://tonersales,eu/shop/2157/-konica-minolta-type-mt-302b-bk-8936-4040,jpg', 0, '0', '<p>Minolta Di200 , 200F , 250 , 251 , 251F , 350 , 350F , 351 , 351F , Develop D 2500 ID</p>', '<p>11000     5%     : Minolta Di200 , 200F , 250 , 251 , 251F , 350 , 350F , 351 , 351F , Develop D 2500 ID</p>'),
	(936, '1', ' KONICA MINOLTA 1015 BK', 0, 13.54, 0, 1, 0.65, '#NAME?', 'TSFK008B', 'http://tonersales,eu/shop/950/-konica-minolta-1015-bk,jpg', 0, '0', '<p>Konica 1015 , 1120 , 1212</p>', '<p>7500     5%     : Konica 1015 , 1120 , 1212</p>'),
	(937, '1', ' KONICA MINOLTA MT-205B 205A , 303A 8937755', 0, 15.59, 0, 1, 0.65, '-konica-minolta-mt-205b-205a-303a-8937755', 'TSEM25X40', 'http://tonersales,eu/shop/951/-konica-minolta-mt-205b-205a-303a-8937755,jpg', 0, '0', '<p>Minolta Di2010 , di2510 , di3010 , di3510 (205 , 303 AB) , Type MT 205B - DI2510 , DI2510F</p>', '<p>14000     5%     : Minolta Di2010 , di2510 , di3010 , di3510 (205 , 303 AB) , Type MT 205B - DI2510 , DI2510F</p>'),
	(938, '1', ' KONICA MINOLTA TN116 , TN117 A1UC050', 53, 22.94, 0, 1, 0.65, '#NAME?', 'TSTN116', 'http://tonersales,eu/shop/304/-konica-minolta-tn116-tn117-a1uc050,jpg', 0, '0', '<p>Bizhub 164 , Bizhub 165 , Bizhub 184 , Bizhub 185 , Bizhub 195 , Bizhub 7718</p>', '<p>5000     5%     : Bizhub 164 , Bizhub 165 , Bizhub 184 , Bizhub 185 , Bizhub 195 , Bizhub 7718</p>'),
	(939, '1', ' KONICA MINOLTA TN118 , A3VW050', 53, 31.08, 0, 1, 0.65, '#NAME?', 'TS13315340**', 'http://tonersales,eu/shop/303/-konica-minolta-tn118-a3vw050,jpg', 0, '0', '<p>Konica , Minolta Type TN118 BizHub 215 , 195 A3VW050</p>', '<p>11000     5%     : Konica , Minolta Type TN118 BizHub 215 , 195 A3VW050</p>'),
	(940, '1', ' KONICA MINOLTA , Develop TN211 8938415', 53, 24.11, 0, 100, 0.65, '#NAME?', 'TSFKTN211', 'http://tonersales,eu/shop/302/-konica-minolta-develop-tn211-8938415,jpg', 0, '0', '<p>TN-211 BIZHUB 222 , BIZHUB 250 , BIZHUB282 , bizhub 200</p>', '<p>17500     5%     : TN-211 BIZHUB 222 , BIZHUB 250 , BIZHUB282 , bizhub 200</p>'),
	(941, '1', ' KONICA MINOLTA TN217 (A0202051)', 0, 18.5, 0, 115, 0.65, '#NAME?', 'TSTN217', 'http://tonersales,eu/shop/954/-konica-minolta-tn217-a0202051,jpg', 0, '0', '<p>Type TN 217 BIZHUB C223, C283, C7828</p>', '<p>17500     5%     : KONICA MINOLTA BIZHUB C223, C283, C7828</p>'),
	(942, '1', ' KONICA MINOLTA 350 TN311 8938404', 0, 17.66, 0, 1, 0.65, '#NAME?', 'TSTN311', 'http://tonersales,eu/shop/955/-konica-minolta-350-tn311-8938404,jpg', 0, '0', '<p>Bizhub350 , Bizhub362 , Bizhub300</p>', '<p>11500     5%     : Bizhub350 , Bizhub362 , Bizhub300</p>'),
	(943, '1', ' KONICA MINOLTA KM1350 , 1390 BK HY (1710567-002)', 1, 25.86, 0, 1, 0.65, 'konica-minolta-km1350-1390-bk-hy-1710567-002', 'TSFK204B', 'http://tonersales,eu/shop/956/konica-minolta-km1350-1390-bk-hy-1710567-002,jpg', 0, '0', 'Konica Minolta PagePro 1300W , 1350W , 1350WN , 1380 MF , 1390 MF', '6000     5%               :  Konica Minolta PagePro 1300W , 1350W , 1350WN , 1380 MF , 1390 MF'),
	(944, '1', ' KONICA MINOLTA TN301', 0, 25.93, 0, 1, 0.65, '#NAME?', 'TSTN301', 'http://tonersales,eu/shop/2158/-konica-minolta-tn301,jpg', 0, '0', '<p>KONICA 7022 , 7130</p>', '<p>26000     5%     : KONICA 7022 , 7130</p>'),
	(945, '1', ' KONICA MINOLTA , Develop TN511', 0, 28, 0, 1, 0.65, '#NAME?', 'TS13100063', 'http://tonersales,eu/shop/958/-konica-minolta-develop-tn511,jpg', 0, '0', '<p>TN-511 Minolta bizhub 360 , 361 , 420 , 421 , 500 , 501</p>', '<p>32000     5%     : TN-511 Minolta bizhub 360 , 361 , 420 , 421 , 500 , 501</p>'),
	(946, '1', ' KONICA MINOLTA 1200W', 0, 28.41, 0, 1, 0.65, '-konica-minolta-1200w', 'TSRM001B', 'http://tonersales,eu/shop/959/-konica-minolta-1200w,jpg', 0, '0', '<p>Minolta PagePro 8 , 8L , 1100 , 1100L , 1200W , 1250E ,Minolta Fax 1600 , 1600E , 2600 , 2600E , 3600 , 3600E</p>', '<p>6000     5%     : Minolta PagePro 8 , 8L , 1100 , 1100L , 1200W , 1250E ,Minolta Fax 1600 , 1600E , 2600 , 2600E , 3600 , 3600E</p>'),
	(947, '1', ' KONICA MINOLTA TNP22 , C35 BK A0X5152', 0, 28.41, 0, 1, 0.65, '#NAME?', 'TS13313201**', 'http://tonersales,eu/shop/2159/-konica-minolta-tnp22-c35-bk-a0x5152,jpg', 0, '0', '<p>KONICA Minolta bizhub C35 , 35P</p>', '<p>5200     5%     : KONICA Minolta bizhub C35 , 35P</p>'),
	(948, '1', ' KONICA MINOLTA TNP22 , C35 CY A0X5452', 0, 28.41, 0, 1, 0.65, '#NAME?', 'TS13312102**', 'http://tonersales,eu/shop/2160/-konica-minolta-tnp22-c35-cy-a0x5452,jpg', 0, '0', '<p>KONICA Minolta bizhub C35 , 35P</p>', '<p>4600     5%     : KONICA Minolta bizhub C35 , 35P</p>'),
	(949, '1', ' KONICA MINOLTA TNP22 , C35 MG A0X5352', 0, 28.41, 0, 1, 0.65, '#NAME?', 'TS13311003**', 'http://tonersales,eu/shop/2161/-konica-minolta-tnp22-c35-mg-a0x5352,jpg', 0, '0', '<p>KONICA Minolta bizhub C35 , 35P</p>', '<p>4600     5%     : KONICA Minolta bizhub C35 , 35P</p>'),
	(950, '1', ' KONICA MINOLTA TNP22 , C35 YL A0X5252', 0, 28.41, 0, 1, 0.65, '#NAME?', 'TS13309904**', 'http://tonersales,eu/shop/2162/-konica-minolta-tnp22-c35-yl-a0x5252,jpg', 0, '0', '<p>KONICA Minolta bizhub C35 , 35P</p>', '<p>4600     5%     : KONICA Minolta bizhub C35 , 35P</p>'),
	(951, '1', ' KONICA MINOLTA C350 TN310K 4053403', 0, 30.06, 0, 1, 0.65, '#NAME?', 'TSTN310K', 'http://tonersales,eu/shop/2163/-konica-minolta-c350-tn310k-4053403,jpg', 0, '0', '<p>BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>', '<p>11000     5%     : BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>'),
	(952, '1', ' KONICA MINOLTA C350 TN310C 4053701', 0, 32.13, 0, 1, 0.65, '#NAME?', 'TSTN310C', 'http://tonersales,eu/shop/2166/-konica-minolta-c350-tn310c-4053701,jpg', 0, '0', '<p>BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>', '<p>11000     5%     : BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>'),
	(953, '1', ' KONICA MINOLTA C350 TN310M 4053601', 0, 32.13, 0, 1, 0.65, '#NAME?', 'TSTN310M', 'http://tonersales,eu/shop/2165/-konica-minolta-c350-tn310m-4053601,jpg', 0, '0', '<p>BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>', '<p>11000     5%     : BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>'),
	(954, '1', ' KONICA MINOLTA C350 TN310Y 4053501', 0, 32.13, 0, 1, 0.65, '#NAME?', 'TSTN310Y', 'http://tonersales,eu/shop/2164/-konica-minolta-c350-tn310y-4053501,jpg', 0, '0', '<p>BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>', '<p>11000     5%     : BIZHUB C350 , BIZHUB C351 , BIZHUB C450</p>'),
	(955, '1', ' KONICA MINOLTA TYPE 201A BK 2PC', 0, 32.5, 0, 1, 0.65, '-konica-minolta-type-201a-bk-2pc', 'TSFM110B**A', 'http://tonersales,eu/shop/968/-konica-minolta-type-201a-bk-2pc,jpg', 0, '0', '<p>Minolta EP2050-CS Pro Series</p>', '<p>12500     5%     : Minolta EP2050-CS Pro Series</p>'),
	(956, '1', ' KONICA MINOLTA KM1600 HY BK A0V301H', 53, 24.37, 0, 1, 0.65, 'konica-minolta-km1600-hy-bk-a0v301h', 'TSFK1600B', 'http://tonersales,eu/shop/298/konica-minolta-km1600-hy-bk-a0v301h,jpg', 0, '0', '<p>Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>', '<p>2500     5%     : Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>'),
	(957, '1', ' KONICA MINOLTA KM1600 HY CY A0V30HH', 53, 24.37, 0, 1, 0.65, 'konica-minolta-km1600-hy-cy-a0v30hh', 'TSFK1600C', 'http://tonersales,eu/shop/299/konica-minolta-km1600-hy-cy-a0v30hh,jpg', 0, '0', '<p>Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>', '<p>2500     5%     : Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>'),
	(958, '1', ' KONICA MINOLTA KM1600 HY YL A0V306H', 53, 24.37, 0, 1, 0.65, 'konica-minolta-km1600-hy-yl-a0v306h', 'TSFK1600Y', 'http://tonersales,eu/shop/300/konica-minolta-km1600-hy-yl-a0v306h,jpg', 0, '0', '<p>Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>', '<p>2500     5%     : Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>'),
	(959, '1', ' KONICA MINOLTA KM1600 HY MG A0V30CH', 53, 24.37, 0, 1, 0.65, 'konica-minolta-km1600-hy-mg-a0v30ch', 'TSFK1600MG', 'http://tonersales,eu/shop/301/konica-minolta-km1600-hy-mg-a0v30ch,jpg', 0, '0', '<p>Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>', '<p>2500     5%     : Konica Minolta 1600W , 1650MF , 1680MF , 1690MF</p>'),
	(960, '1', ' KONICA MINOLTA QMS TNP27K (A0X5153)', 0, 34.09, 0, 1, 0.65, '#NAME?', 'TSTNP27K', 'http://tonersales,eu/shop/2169/-konica-minolta-qms-tnp27k-a0x5153,jpg', 0, '0', '<p>KONICA Minolta Bizhub C25</p>', '<p>6000     5%     : KONICA Minolta Bizhub C25</p>'),
	(961, '1', ' KONICA MINOLTA QMS TNP27C (A0X5453)', 0, 34.09, 0, 1, 0.65, '#NAME?', 'TSTNP27C', 'http://tonersales,eu/shop/2170/-konica-minolta-qms-tnp27c-a0x5453,jpg', 0, '0', '<p>KONICA Minolta Bizhub C25</p>', '<p>3000     5%     : KONICA Minolta Bizhub C25</p>'),
	(962, '1', ' KONICA MINOLTA QMS TNP27M (A0X5353)', 0, 34.09, 0, 1, 0.65, '#NAME?', 'TSTNP27M', 'http://tonersales,eu/shop/2168/-konica-minolta-qms-tnp27m-a0x5353,jpg', 0, '0', '<p>KONICA Minolta Bizhub C25</p>', '<p>3000     5%     : KONICA Minolta Bizhub C25</p>'),
	(963, '1', ' KONICA MINOLTA QMS TNP27Y (A0X5253)', 0, 34.09, 0, 1, 0.65, '#NAME?', 'TSTNP27Y', 'http://tonersales,eu/shop/2167/-konica-minolta-qms-tnp27y-a0x5253,jpg', 0, '0', '<p>KONICA Minolta Bizhub C25</p>', '<p>3000     5%     : KONICA Minolta Bizhub C25</p>'),
	(964, '1', ' KONICA MINOLTA MT-502B 8936904', 0, 34.2, 0, 1, 0.65, 'konica-minolta-mt-502b-8936904', 'TS13100058', 'http://tonersales,eu/shop/973/konica-minolta-mt-502b-8936904,jpg', 0, '0', '<p>MINOLTA Di450 , DI470 , DI550</p>', '<p>33000     5%     : MINOLTA Di450 , DI470 , DI550</p>'),
	(965, '1', ' KONICA MINOLTA C900 , MIN 2350 (QMS2300) BK (1710517-005)', 0, 34.75, 0, 1, 0.65, '#NAME?', 'TSRE005B', 'http://tonersales,eu/shop/2174/-konica-minolta-c900-min-2350-qms2300-bk-1710517-005,jpg', 0, '0', '<p>Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>', '<p>4500     5%     : Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>'),
	(966, '1', ' KONICA MINOLTA C900 , MIN 2350 (QMS2300) YL (1710517-004)', 0, 34.75, 0, 1, 0.65, '#NAME?', 'TSRE006Y', 'http://tonersales,eu/shop/2173/-konica-minolta-c900-min-2350-qms2300-yl-1710517-004,jpg', 0, '0', '<p>Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>', '<p>4500     5%     : Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>'),
	(967, '1', ' KONICA MINOLTA C900 , MIN 2350 (QMS2300) MG (1710517-003)', 0, 34.75, 0, 1, 0.65, '#NAME?', 'TSRE007M', 'http://tonersales,eu/shop/2172/-konica-minolta-c900-min-2350-qms2300-mg-1710517-003,jpg', 0, '0', '<p>Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>', '<p>4500     5%     : Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>'),
	(968, '1', ' KONICA MINOLTA C900 , MIN 2350 (QMS2300) CY (1710517-004)', 0, 34.75, 0, 1, 0.65, '#NAME?', 'TSRE008C', 'http://tonersales,eu/shop/2171/-konica-minolta-c900-min-2350-qms2300-cy-1710517-004,jpg', 0, '0', '<p>Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>', '<p>4500     5%     : Epson AcuLaser C900 , C1900 Series Minolta Magicolor 2300 , 2350 Series</p>'),
	(969, '1', ' KONICA MINOLTA BIZHUB 20 STD A32W011', 0, 35.23, 0, 1, 0.65, '#NAME?', 'TSA32W011', 'http://tonersales,eu/shop/978/-konica-minolta-bizhub-20-std-a32w011,jpg', 0, '0', '<p>Konica Minolta Bizhub 20 , Bizhub 20P</p>', '<p>8000     5%     : Konica Minolta Bizhub 20 , Bizhub 20P</p>'),
	(970, '1', ' KONICA MINOLTA QMS TN213K', 0, 38.32, 0, 1, 0.65, '#NAME?', 'TS13315310**', 'http://tonersales,eu/shop/979/-konica-minolta-qms-tn213k,jpg', 0, '0', '<p>KONICA Minolta BIZHUBC203 , BIZHUBC253</p>', '<p>24000     5%     : KONICA Minolta BIZHUBC203 , BIZHUBC253</p>'),
	(971, '1', ' KONICA MINOLTA TN214K , TN314K A0D7154', 0, 38.32, 0, 1, 0.65, '#NAME?', 'TSTN214K', 'http://tonersales,eu/shop/980/-konica-minolta-tn214k-tn314k-a0d7154,jpg', 0, '0', '<p>Bizhub C200 , Bizhub C353</p>', '<p>24000     5%     : Bizhub C200 , Bizhub C353</p>'),
	(973, '1', ' KONICA MINOLTA KM1400 BK', 1, 38.7, 0, 1, 0.65, 'konica-minolta-km1400-bk', 'TSFK202B', 'http://tonersales,eu/shop/982/konica-minolta-km1400-bk,jpg', 0, '0', 'Konica Minolta PagePro 1400W', '2000     5%               :  Konica Minolta PagePro 1400W'),
	(974, '1', ' KONICA MINOLTA QMS TN216K A11G151', 0, 41.84, 0, 1, 0.65, '#NAME?', 'TSTN216K', 'http://tonersales,eu/shop/2175/-konica-minolta-qms-tn216k-a11g151,jpg', 0, '0', '<p>KONICA Minolta bizhub C220 , C280 , C360</p>', '<p>29000     5%     : KONICA Minolta bizhub C220 , C280 , C360</p>'),
	(975, '1', ' KONICA MINOLTA MT-603B 8935904', 0, 42.26, 0, 1, 0.65, 'konica-minolta-mt-603b-8935904', 'TS13100017', 'http://tonersales,eu/shop/2176/konica-minolta-mt-603b-8935904,jpg', 0, '0', '<p>MINOLTA Di520 , DI620 8935904</p>', '<p>40000     5%     : MINOLTA Di520 , DI620 8935904</p>'),
	(976, '1', ' KONICA MINOLTA MT-604B 8937802', 0, 42.26, 0, 1, 0.65, 'konica-minolta-mt-604b-8937802', 'TS13100042', 'http://tonersales,eu/shop/985/konica-minolta-mt-604b-8937802,jpg', 0, '0', '<p>Minolta DI551 , DI650 , DI5510 , DI7210 Konica 7155 , 7165 , 7255 , 7272 , DP65 Develop D5510ID , D5550ID , D6500ID</p>', '<p>47500     5%     : Minolta DI551 , DI650 , DI5510 , DI7210 Konica 7155 , 7165 , 7255 , 7272 , DP65 Develop D5510ID , D5550ID , D6500ID</p>'),
	(977, '1', ' KONICA MINOLTA TN210K 8938509', 0, 42.46, 0, 1, 0.65, '#NAME?', 'TSTN210K', 'http://tonersales,eu/shop/2177/-konica-minolta-tn210k-8938509,jpg', 0, '0', '<p>BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>', '<p>20000     5%     : BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>'),
	(978, '1', ' KONICA MINOLTA TN321 BK A33K150', 0, 42.61, 0, 1, 0.65, '#NAME?', 'TS13315371**', 'http://tonersales,eu/shop/2178/-konica-minolta-tn321-bk-a33k150,jpg', 0, '0', '<p>KONICA Minolta bizhub C224 , C284 , C364</p>', '<p>27000     5%     : KONICA Minolta bizhub C224 , C284 , C364</p>'),
	(982, '1', ' KONICA MINOLTA TN710', 0, 46.59, 0, 1, 0.65, '#NAME?', 'TS13100064', 'http://tonersales,eu/shop/991/-konica-minolta-tn710,jpg', 0, '0', '<p>TN-710 bizhub 600 , 601 , 750 , 751</p>', '<p>55000     5%     : TN-710 bizhub 600 , 601 , 750 , 751</p>'),
	(983, '1', ' KONICA MINOLTA TN210C 8938512', 0, 48.66, 0, 1, 0.65, '#NAME?', 'TSTN210C', 'http://tonersales,eu/shop/2181/-konica-minolta-tn210c-8938512,jpg', 0, '0', '<p>BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>', '<p>12000     5%     : BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>'),
	(984, '1', ' KONICA MINOLTA TN210M 8938511', 0, 48.66, 0, 1, 0.65, '#NAME?', 'TSTN210M', 'http://tonersales,eu/shop/2179/-konica-minolta-tn210m-8938511,jpg', 0, '0', '<p>BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>', '<p>12000     5%     : BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>'),
	(985, '1', ' KONICA MINOLTA TN210Y 8938510', 0, 48.66, 0, 1, 0.65, '#NAME?', 'TSTN210Y', 'http://tonersales,eu/shop/2180/-konica-minolta-tn210y-8938510,jpg', 0, '0', '<p>BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>', '<p>12000     5%     : BIZHUB C250 , BIZHUBC250P , BIZHUB C252 , BIZHUB C252P</p>'),
	(986, '1', ' KONICA MINOLTA QMS TN611K , A070150', 0, 49.72, 0, 1, 0.65, '#NAME?', 'TSTN611K', 'http://tonersales,eu/shop/2182/-konica-minolta-qms-tn611k-a070150,jpg', 0, '0', '<p>Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>', '<p>45000     5%     : Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>'),
	(987, '1', ' KONICA MINOLTA TN512 BK A33K152', 0, 50.14, 0, 1, 0.65, '#NAME?', 'TS13315395**', 'http://tonersales,eu/shop/2183/-konica-minolta-tn512-bk-a33k152,jpg', 0, '0', '<p>KONICA Minolta bizhub C454 , C554</p>', '<p>27500     5%     : KONICA Minolta bizhub C454 , C554</p>'),
	(988, '1', ' KONICA MINOLTA KM2400 BK(1710589004)', 0, 50.91, 0, 1, 0.65, 'konica-minolta-km2400-bk1710589004', 'TSFK215B', 'http://tonersales,eu/shop/2186/konica-minolta-km2400-bk1710589004,jpg', 0, '0', '<p>Konica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>', '<p>4500     5%     : Konica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>'),
	(989, '1', ' KONICA MINOLTA KM2400 CY (1710589007)', 0, 50.91, 0, 1, 0.65, 'konica-minolta-km2400-cy-1710589007', 'TSFK216C', 'http://tonersales,eu/shop/2187/konica-minolta-km2400-cy-1710589007,jpg', 0, '0', '<p>Konica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>', '<p>4500     5%     : Konica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>'),
	(990, '1', ' KONICA MINOLTA KM2400 YL (1710589005)', 0, 50.91, 0, 1, 0.65, 'konica-minolta-km2400-yl-1710589005', 'TSFK217Y', 'http://tonersales,eu/shop/2185/konica-minolta-km2400-yl-1710589005,jpg', 0, '0', '<p>Konica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>', '<p>4500     5%     : Konica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>'),
	(991, '1', ' KONICA MINOLTA KM2400 MG (1710589006)', 0, 50.91, 0, 1, 0.65, 'konica-minolta-km2400-mg-1710589006', 'TSFK218M', 'http://tonersales,eu/shop/2184/konica-minolta-km2400-mg-1710589006,jpg', 0, '0', '<p>Konoica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>', '<p>4500     5%     : Konoica Minolta Magicolor 2450 , 2400W , 2430DL , 2500W , 2530DL , 2550 , 2480MF , 2490MF , 2590MF</p>'),
	(992, '1', ' KONICA MINOLTA TC-16 BLACK 996700046', 0, 51.13, 0, 1, 0.65, 'konica-minolta-tc-16-black-996700046', 'TS1331530940', 'http://tonersales,eu/shop/1001/konica-minolta-tc-16-black-996700046,jpg', 0, '0', '<p>KONICA MINOLTA BIZHUB 1600F</p>', '<p>3000     5%     : KONICA MINOLTA BIZHUB 1600F</p>'),
	(993, '1', ' KONICA MINOLTA Page Pro 1480', 0, 52.27, 0, 1, 0.65, '#NAME?', 'TS13315308', 'http://tonersales,eu/shop/1002/-konica-minolta-page-pro-1480,jpg', 0, '0', '<p>Konica Minolta Page Pro 1480MF , 1490MF</p>', '<p>5500     5%     : Konica Minolta Page Pro 1480MF , 1490MF</p>'),
	(994, '1', ' KONICA MINOLTA TN512 CY A33K452', 0, 52.55, 0, 1, 0.65, '#NAME?', 'TS13315396**', 'http://tonersales,eu/shop/2190/-konica-minolta-tn512-cy-a33k452,jpg', 0, '0', '<p>KONICA Minolta bizhub C454 , C554</p>', '<p>26000     5%     : KONICA Minolta bizhub C454 , C554</p>'),
	(995, '1', ' KONICA MINOLTA TN512 MG A33K352', 0, 52.55, 0, 1, 0.65, '#NAME?', 'TS13315397**', 'http://tonersales,eu/shop/2189/-konica-minolta-tn512-mg-a33k352,jpg', 0, '0', '<p>KONICA Minolta bizhub C454 , C554</p>', '<p>26000     5%     : KONICA Minolta bizhub C454 , C554</p>'),
	(996, '1', ' KONICA MINOLTA TN512 YL A33K252', 0, 52.55, 0, 1, 0.65, '#NAME?', 'TS13315398**', 'http://tonersales,eu/shop/2188/-konica-minolta-tn512-yl-a33k252,jpg', 0, '0', '<p>KONICA Minolta bizhub C454 , C554</p>', '<p>26000     5%     : KONICA Minolta bizhub C454 , C554</p>'),
	(997, '1', ' KONICA MINOLTA QMS TN213C', 0, 54.86, 0, 1, 0.65, '#NAME?', 'TS13315311**', 'http://tonersales,eu/shop/2194/-konica-minolta-qms-tn213c,jpg', 0, '0', '<p>KONICA Minolta BIZHUBC203 , BIZHUBC253</p>', '<p>18000     5%     : KONICA Minolta BIZHUBC203 , BIZHUBC253</p>'),
	(998, '1', ' KONICA MINOLTA QMS TN213M', 0, 54.86, 0, 1, 0.65, '#NAME?', 'TS13315312**', 'http://tonersales,eu/shop/2197/-konica-minolta-qms-tn213m,jpg', 0, '0', '<p>KONICA Minolta BIZHUBC203 , BIZHUBC253</p>', '<p>18000     5%     : KONICA Minolta BIZHUBC203 , BIZHUBC253</p>'),
	(999, '1', ' KONICA MINOLTA QMS TN213Y', 0, 54.86, 0, 1, 0.65, '#NAME?', 'TS13315313**', 'http://tonersales,eu/shop/2195/-konica-minolta-qms-tn213y,jpg', 0, '0', '<p>KONICA Minolta BIZHUBC203 , BIZHUBC253</p>', '<p>18000     5%     : KONICA Minolta BIZHUBC203 , BIZHUBC253</p>'),
	(1000, '1', ' KONICA MINOLTA TN214C , TN314C A0D7454', 0, 54.86, 0, 1, 0.65, '#NAME?', 'TSTN214C', 'http://tonersales,eu/shop/2193/-konica-minolta-tn214c-tn314c-a0d7454,jpg', 0, '0', '<p>Bizhub C200 , Bizhub C353</p>', '<p>18000     5%     : Bizhub C200 , Bizhub C353</p>'),
	(1001, '1', ' KONICA MINOLTA TN214M , TN314M A0D7354', 0, 54.86, 0, 1, 0.65, '#NAME?', 'TSTN214M', 'http://tonersales,eu/shop/2191/-konica-minolta-tn214m-tn314m-a0d7354,jpg', 0, '0', '<p>Bizhub C200 , Bizhub C353</p>', '<p>18000     5%     : Bizhub C200 , Bizhub C353</p>'),
	(1002, '1', ' KONICA MINOLTA TN214Y , TN314Y A0D7254', 0, 54.86, 0, 1, 0.65, '#NAME?', 'TSTN214Y', 'http://tonersales,eu/shop/2192/-konica-minolta-tn214y-tn314y-a0d7254,jpg', 0, '0', '<p>Bizhub C200 , Bizhub C353</p>', '<p>18000     5%     : Bizhub C200 , Bizhub C353</p>'),
	(1003, '1', ' KONICA MINOLTA QMS TN216C A11G451', 0, 58.98, 0, 1, 0.65, '#NAME?', 'TSTN216C', 'http://tonersales,eu/shop/2198/-konica-minolta-qms-tn216c-a11g451,jpg', 0, '0', '<p>KONICA Minolta bizhub C220 , C280 , C360</p>', '<p>26000     5%     : KONICA Minolta bizhub C220 , C280 , C360</p>'),
	(1004, '1', ' KONICA MINOLTA QMS TN216M A11G351', 0, 58.98, 0, 1, 0.65, '#NAME?', 'TSTN216M', 'http://tonersales,eu/shop/2199/-konica-minolta-qms-tn216m-a11g351,jpg', 0, '0', '<p>KONICA Minolta bizhub C220 , C280 , C360</p>', '<p>26000     5%     : KONICA Minolta bizhub C220 , C280 , C360</p>'),
	(1005, '1', ' KONICA MINOLTA QMS TN216Y A11G251', 0, 58.98, 0, 1, 0.65, '#NAME?', 'TSTN216Y', 'http://tonersales,eu/shop/2200/-konica-minolta-qms-tn216y-a11g251,jpg', 0, '0', '<p>KONICA Minolta bizhub C220 , C280 , C360</p>', '<p>26000     5%     : KONICA Minolta bizhub C220 , C280 , C360</p>'),
	(1006, '1', ' KONICA MINOLTA TN321 CY A33K450', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13315372**', 'http://tonersales,eu/shop/2202/-konica-minolta-tn321-cy-a33k450,jpg', 0, '0', '<p>KONICA Minolta bizhub C224 , C284 , C364</p>', '<p>25000     5%     : KONICA Minolta bizhub C224 , C284 , C364</p>'),
	(1007, '1', ' KONICA MINOLTA TN321 MG A33K350', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13315373**', 'http://tonersales,eu/shop/2203/-konica-minolta-tn321-mg-a33k350,jpg', 0, '0', '<p>KONICA Minolta bizhub C224 , C284 , C364</p>', '<p>25000     5%     : KONICA Minolta bizhub C224 , C284 , C364</p>'),
	(1008, '1', ' KONICA MINOLTA TN321 YL A33K250', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13315374**', 'http://tonersales,eu/shop/2201/-konica-minolta-tn321-yl-a33k250,jpg', 0, '0', '<p>KONICA Minolta bizhub C224 , C284 , C364</p>', '<p>25000     5%     : KONICA Minolta bizhub C224 , C284 , C364</p>'),
	(1009, '1', ' KONICA MINOLTA MT-602B (8935602)', 0, 61.26, 0, 1, 0.65, '-konica-minolta-mt-602b-8935602', 'TS13100018', 'http://tonersales,eu/shop/1019/-konica-minolta-mt-602b-8935602,jpg', 0, '0', '<p>EP 5050 , 6000 , 6001 , 8015 (601 , 602 A , B) , Develop 6050 , 6051 , 8151</p>', '<p>43000     5%     : EP 5050 , 6000 , 6001 , 8015 (601 , 602 A , B) , Develop 6050 , 6051 , 8151</p>'),
	(1010, '1', ' KONICA MINOLTA TNP37 ,  4700', 0, 63.92, 0, 1, 0.65, '#NAME?', 'TS13315390**', 'http://tonersales,eu/shop/1020/-konica-minolta-tnp37-4700,jpg', 0, '0', '<p>KONICA Minolta bizhub 4700P</p>', '<p>20000     5%     : KONICA Minolta bizhub 4700P</p>'),
	(1011, '1', ' KONICA MINOLTA TNP39 ,  3300', 0, 63.92, 0, 1, 0.65, '#NAME?', 'TS13315392**', 'http://tonersales,eu/shop/1021/-konica-minolta-tnp39-3300,jpg', 0, '0', '<p>KONICA Minolta bizhub 3300P</p>', '<p>10000     5%     : KONICA Minolta bizhub 3300P</p>'),
	(1012, '1', ' KONICA MINOLTA TNP43 ,  3320', 0, 63.92, 0, 1, 0.65, '#NAME?', 'TS13315393**', 'http://tonersales,eu/shop/1022/-konica-minolta-tnp43-3320,jpg', 0, '0', '<p>KONICA Minolta bizhub 3320</p>', '<p>10000     5%     : KONICA Minolta bizhub 3320</p>'),
	(1013, '1', ' KONICA MINOLTA TN613K , A0TM150 (TN413K)', 0, 63.92, 0, 1, 0.65, '#NAME?', 'TSTN413K', 'http://tonersales,eu/shop/2204/-konica-minolta-tn613k-a0tm150-tn413k,jpg', 0, '0', '<p>KONICA Minolta Bizhub C452 , C552 , C652</p>', '<p>40000     5%     : KONICA Minolta Bizhub C452 , C552 , C652</p>'),
	(1014, '1', ' KONICA MINOLTA QMS TN611C , A070450', 0, 68.17, 0, 1, 0.65, '#NAME?', 'TSTN611C', 'http://tonersales,eu/shop/2207/-konica-minolta-qms-tn611c-a070450,jpg', 0, '0', '<p>Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>', '<p>27000     5%     : Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>'),
	(1015, '1', ' KONICA MINOLTA QMS TN611M , A070350', 0, 68.17, 0, 1, 0.65, '#NAME?', 'TSTN611M', 'http://tonersales,eu/shop/2205/-konica-minolta-qms-tn611m-a070350,jpg', 0, '0', '<p>Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>', '<p>27000     5%     : Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>'),
	(1016, '1', ' KONICA MINOLTA QMS TN611Y , A070250', 0, 68.17, 0, 1, 0.65, '#NAME?', 'TSTN611Y', 'http://tonersales,eu/shop/2208/-konica-minolta-qms-tn611y-a070250,jpg', 0, '0', '<p>Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>', '<p>27000     5%     : Konica , Minolta , QMS Type TN 611K (A070150) BIZHUB C550 , BIZHUB C650 , BIZHUB C451</p>'),
	(1017, '1', ' KONICA MINOLTA TN613C , A0TM450', 0, 76.7, 0, 1, 0.65, '#NAME?', 'TSTN613C', 'http://tonersales,eu/shop/2211/-konica-minolta-tn613c-a0tm450,jpg', 0, '0', '<p>KONICA Minolta Bizhub C452 , C552 , C652</p>', '<p>25000     5%     : KONICA Minolta Bizhub C452 , C552 , C652</p>'),
	(1018, '1', ' KONICA MINOLTA TN613M , A0TM350', 0, 76.7, 0, 1, 0.65, '#NAME?', 'TSTN613M', 'http://tonersales,eu/shop/2210/-konica-minolta-tn613m-a0tm350,jpg', 0, '0', '<p>KONICA Minolta Bizhub C452 , C552 , C652</p>', '<p>25000     5%     : KONICA Minolta Bizhub C452 , C552 , C652</p>'),
	(1019, '1', ' KONICA MINOLTA TN613Y , A0TM250', 0, 76.7, 0, 1, 0.65, '#NAME?', 'TSTN613Y', 'http://tonersales,eu/shop/2209/-konica-minolta-tn613y-a0tm250,jpg', 0, '0', '<p>KONICA Minolta Bizhub C452 , C552 , C652</p>', '<p>25000     5%     : KONICA Minolta Bizhub C452 , C552 , C652</p>'),
	(1020, '1', ' KONICA MINOLTA TNP38 , 4000', 0, 78.12, 0, 1, 0.65, '#NAME?', 'TS13315391**', 'http://tonersales,eu/shop/1031/-konica-minolta-tnp38-4000,jpg', 0, '0', '<p>KONICA Minolta bizhub 4000P</p>', '<p>20000     5%     : KONICA Minolta bizhub 4000P</p>'),
	(1021, '1', ' KONICA MINOLTA TNP46 , 4050', 0, 78.12, 0, 1, 0.65, '#NAME?', 'TS13315394**', 'http://tonersales,eu/shop/953/-konica-minolta-tnp46-4050,jpg', 0, '0', '<p>KONICA Minolta bizhub 4050 , 4750</p>', '<p>20000     5%     : KONICA Minolta bizhub 4050 , 4750</p>'),
	(1022, '1', ' KONICA MINOLTA TN414 A202050', 0, 29.9, 0, 1, 0.65, '#NAME?', 'TS13315377**', 'http://tonersales,eu/shop/952/-konica-minolta-tn414-a202050,jpg', 0, '0', '<p>KONICA Minolta bizhub 423 , bizhub 363</p>', '<p>25000     5%     : KONICA Minolta bizhub 423 , bizhub 363</p>'),
	(1023, '1', ' PANASONIC KX-FA76 BK (KX-FA76A)', 0, 7.4, 0, 115, 0.65, '#NAME?', 'TSFP006B', 'http://tonersales,eu/shop/1667/-panasonic-kx-fa76-bk-kx-fa76a,jpg', 0, '0', '<p>Panasonic KX-FL501, 502, 503, 523, FLM551, 552, 553, FLB751, 752, 753, 755, 756, 758</p>', '<p>2000     5%     :Panasonic KX-FL501, 502, 503, 523, FLM551, 552, 553, FLB751, 752, 753, 755, 756, 758</p>'),
	(1024, '1', ' PANASONIC KX-FAT83 BK (KX-FA83X)', 53, 5.77, 0, 105, 0.65, 'panasonic-kx-fa83-bk-kx-fa83x', 'TSFP007B', 'http://tonersales,eu/shop/226/panasonic-kx-fa83-bk-kx-fa83x,jpg', 0, '0', '<p>Panasonic KX-FL511, KX-FL513, KX-FL541, KX-FL611G, KX-FLM650, KX-FL511G, KX-FL540, KX-FL543, KX-FL612, KX-FLM651, KX-FL512, KX-FL540G, KX-FL611, KX-FL613, KX-FLM653CN</p>', '<p>2500     5%     : PanasonicKX-FL511, KX-FL513, KX-FL541, KX-FL611G, KX-FLM650, KX-FL511G, KX-FL540, KX-FL543, KX-FL612, KX-FLM651, KX-FL512, KX-FL540G, KX-FL611, KX-FL613, KX-FLM653CN</p>'),
	(1025, '1', ' PANASONIC KX-FAT90E BK', 0, 7.33, 0, 1, 0.65, 'panasonic-kx-fat90e-bk', 'TSFP012B', 'http://tonersales,eu/shop/2063/panasonic-kx-fat90e-bk,jpg', 0, '0', '<p>Panasonic KX-FL313HK</p>', '<p>2000     5%     : Panasonic KX-FL313HK</p>'),
	(1026, '1', ' PANASONIC KX-FAT88', 53, 6.37, 0, 105, 0.65, '#NAME?', 'TSTFP014B', 'http://tonersales,eu/shop/227/-panasonic-kx-fat88,jpg', 0, '0', '<p>PanasonicKX-FL401, 402, 403, 411, 412, 413</p>', '<p>2000     5%     :PanasonicKX-FL401, 402, 403, 411, 412, 413</p>'),
	(1027, '1', ' PANASONIC KX-FAT411X', 53, 5.97, 0, 102, 0.65, 'panasonic-kx-fat411x', 'TSKX-FA411A', 'http://tonersales,eu/shop/1367/panasonic-kx-fat411x,jpg', 0, '0', '<p>Panasonic KX-MB2000, KX-MB2020, KX-MB2033, KX-MB2008, KX-MB2025, KX-MB2035, KX-MB2010, KX-MB2030, KX-MB2038, KX-MB2061</p>', '<p>2000     5%     : PanasonicKX-MB2000, KX-MB2020, KX-MB2033, KX-MB2008, KX-MB2025, KX-MB2035, KX-MB2010, KX-MB2030, KX-MB2038, KX-MB2061</p>'),
	(1028, '1', ' PANASONIC KX-FA87 BK (KX-FA87X)', 1, 9.96, 0, 1, 0.65, 'panasonic-kx-fa87-bk-kx-fa87x', 'TSFP009B', 'http://tonersales,eu/shop/1368/panasonic-kx-fa87-bk-kx-fa87x,jpg', 0, '0', 'Panasonic KX-FLB801 ,  KX-FL802 ,  KX-FL803 ,  KX-FL811 ,  KX-FL812 ,  KX-FL813 ,  KX-FL833 ,  KX-FL851 ,  KX-FL852 ,  KX-FL853 ,  KX-FL888', '3500     5%               :  Panasonic KX-FLB801 ,  KX-FL802 ,  KX-FL803 ,  KX-FL811 ,  KX-FL812 ,  KX-FL813 ,  KX-FL833 ,  KX-FL851 ,  KX-FL852 ,  KX-FL853 ,  KX-FL888'),
	(1029, '1', ' PANASONIC KX-FA85 BK (KX-FA85X)', 0, 11.67, 0, 1, 0.65, 'panasonic-kx-fa85-bk-kx-fa85x', 'TSFP008B', 'http://tonersales,eu/shop/2065/panasonic-kx-fa85-bk-kx-fa85x,jpg', 0, '0', '<p>Panasonic KX-FLB801 , KX-FL802 KX-FL , 803 , KX-FL811 , KX-FL812 , KX-FL813 , KX-FL833 , KX-FL851 , KX-FL852 , KX-FL853 , KX-FL888</p>', '<p>8000     5%     : Panasonic KX-FLB801 , KX-FL802 KX-FL , 803 , KX-FL811 , KX-FL812 , KX-FL813 , KX-FL833 , KX-FL851 , KX-FL852 , KX-FL853 , KX-FL888</p>'),
	(1030, '1', ' PANASONIC DQ-TU10J DP1520 and WASTE TONER', 0, 18.7, 0, 1, 0.65, '#NAME?', 'TS13800006', 'http://tonersales,eu/shop/1370/-panasonic-dq-tu10j-dp1520-and-waste-toner,jpg', 0, '0', '<p>Panasonic Workio DP1520 , 1520P , DP1820P , DP1820 , 1820E , DP8020 , 8020E , DP8016</p>', '<p>10000     5%     : Panasonic Workio DP1520 , 1520P , DP1820P , DP1820 , 1820E , DP8020 , 8020E , DP8016</p>'),
	(1031, '1', ' PANASONIC DQ-TU10C-PU DP1810', 0, 20.56, 0, 1, 0.65, '#NAME?', 'TSDP1810', 'http://tonersales,eu/shop/1371/-panasonic-dq-tu10c-pu-dp1810,jpg', 0, '0', '<p>Panasonic Workio DP1810F , 1810P , DP1810 , DP1510 , 1510P , DP2010E , 1810PM</p>', '<p>10000     5%     : Panasonic Workio DP1810F , 1810P , DP1810 , DP1510 , 1510P , DP2010E , 1810PM</p>'),
	(1032, '1', ' PANASONIC DQ-TU15E DP2310 and WASTE TONER', 0, 39, 0, 102, 0.65, '#NAME?', 'TS13800001', 'http://tonersales,eu/shop/1372/-panasonic-dq-tu15e-dp2310-and-waste-toner,jpg', 0, '0', '<p>Panasonic Workio DP2310 , DP3010 , DP3030 , DP2330 , DP8032 , DP8025</p>', '<p>15000     5%     : Panasonic Workio DP2310 , DP3010 , DP3030 , DP2330 , DP8032 , DP8025</p>'),
	(1033, '1', ' PANASONIC UG-3350 BK', 0, 63.14, 0, 1, 0.65, 'panasonic-ug-3350-bk', 'TSRP133B', 'http://tonersales,eu/shop/2064/panasonic-ug-3350-bk,jpg', 0, '0', '<p>Panasonic PanaFax UF580 , UF585 , UF590 , UF595</p>', '<p>7500     5%     : Panasonic PanaFax UF580 , UF585 , UF590 , UF595</p>'),
	(1034, '1', ' PANASONIC UG-3380 BK', 1, 45.26, 0, 1, 0.65, 'panasonic-ug-3380-bk', 'TSFP3380B', 'http://tonersales,eu/shop/1375/panasonic-ug-3380-bk,jpg', 0, '0', 'Panasonic UF585 , UF6300 , UF6000 , UF5100 , UF6100 , UF580 , UF790 , UF590 , UF595 , UF5300 , UF780 , DX600 , DX800 , Kyocera-Mita KM-F650', '8000     5%               :  Panasonic UF585 , UF6300 , UF6000 , UF5100 , UF6100 , UF580 , UF790 , UF590 , UF595 , UF5300 , UF780 , DX600 , DX800 , Kyocera-Mita KM-F650'),
	(1035, '1', ' PHILIPS PFA822 253109266, PFA821', 0, 58.35, 0, 1, 0.65, '#NAME?', 'TS13317600**', 'http://tonersales,eu/shop/1376/-philips-pfa822-253109266-pfa821,jpg', 0, '0', '<p>PHILIPS MFD6020, mdf6050, mdf6080</p>', '<p>5500     5%     : PHILIPSMFD6020, mdf6050, mdf6080</p>'),
	(1036, '1', ' RICOH TYPE 1220D (888087)', 0, 11.04, 0, 102, 0.65, 'ricoh-type-1220d-888087', 'TSFR207B', 'http://tonersales,eu/shop/1377/ricoh-type-1220d-888087,jpg', 0, '0', '<p>Ricoh 1018, 1113, Rex Rotary 1318, Rex Rotary 1508, Rex Rotary 1808, Gestetner 1312, Gestetner 1502, Gestetner 1802, Gestetner 1802D, Lanier 5515, Lanier 5518, Lanier 5518D, Lanier LD013, Nashuatec 1315, Nashuatec 1505, Nashuatec 1805, Nashuatec F230 Ricoh 1015</p>', '<p>10000     5%     :Ricoh 1018, 1113, Rex Rotary 1318, Rex Rotary 1508, Rex Rotary 1808, Gestetner 1312, Gestetner 1502, Gestetner 1802, Gestetner 1802D, Lanier 5515, Lanier 5518, Lanier 5518D, Lanier LD013, Nashuatec 1315, Nashuatec 1505, Nashuatec 1805, Nashuatec F230 Ricoh 1015</p>'),
	(1037, '1', ' RICOH TYPE 1250D (885258)', 1, 11.04, 0, 1, 0.65, 'ricoh-type-1250d-885258', 'TSFR210B', 'http://tonersales,eu/shop/1378/ricoh-type-1250d-885258,jpg', 0, '0', 'Ricoh Aficio 1013 , 1013F , 1250D , 1150D Lanier 5612 , 5613 Gestetner 1302 , 1302F Infotec 2013  ,  2013F Lanier 5613  ,  5613f', '7000     5%               :  Ricoh Aficio 1013 , 1013F , 1250D , 1150D Lanier 5612 , 5613 Gestetner 1302 , 1302F Infotec 2013  ,  2013F Lanier 5613  ,  5613f'),
	(1038, '1', ' RICOH AFICIO 200 , 250 (TYPE 20D) BK', 0, 13.25, 0, 1, 0.65, 'ricoh-aficio-200-250-type-20d-bk', 'TSFR202B', 'http://tonersales,eu/shop/1994/ricoh-aficio-200-250-type-20d-bk,jpg', 0, '0', '<p>Ricoh Aficio 200 , 250 Series , 2205D 2105D Infotec 5201MF , 4251MF Gestetner 3220 , 3225 Lanier 5020mfd , 5025MFD Nashuatec d420 , D425 Okidata 2097MF Rex Rotary 2820 , 2825</p>', '<p>8000     5%     : Ricoh Aficio 200 , 250 Series , 2205D 2105D Infotec 5201MF , 4251MF Gestetner 3220 , 3225 Lanier 5020mfd , 5025MFD Nashuatec d420 , D425 Okidata 2097MF Rex Rotary 2820 , 2825</p>'),
	(1039, '1', ' RICOH TYPE 1230D  , 1130', 53, 11.46, 0, 1, 0.65, 'ricoh-type-1230d-1130', 'TSFR1230B', 'http://tonersales,eu/shop/235/ricoh-type-1230d-1130,jpg', 0, '0', '<p>Aficio 2015 , 2016 , 2018 , 2020 , 2020D , Aficio MP1500 , MP1600 , 1600L , 1600SP , MP2000 , 2000LN , 2000SP Infotec IS2015 , IS2018 , IS2320 Gestetner DSM615 , DSM616 , DSM618 , DSM620 , DSM715 , DSM716 , DSM721 , MP1600 Lanier LD115 , LD118 , 118D , LD116 , LD120 , ld316 , LD320 , MP1600 Nashuatec-NRG DT-42 , DSM615 , DSM618 , MP1600 Docustation DSM615 , DSM618 , 618D , DSM616 , DSM620 , 620D , DSM715 Rex Rotary DSM615 , DSM618 , MP1600</p>', '<p>9000     5%     : Aficio 2015 , 2016 , 2018 , 2020 , 2020D , Aficio MP1500 , MP1600 , 1600L , 1600SP , MP2000 , 2000LN , 2000SP Infotec IS2015 , IS2018 , IS2320 Gestetner DSM615 , DSM616 , DSM618 , DSM620 , DSM715 , DSM716 , DSM721 , MP1600 Lanier LD115 , LD118 , 118D , LD116 , LD120 , ld316 , LD320 , MP1600 Nashuatec-NRG DT-42 , DSM615 , DSM618 , MP1600 Docustation DSM615 , DSM618 , 618D , DSM616 , DSM620 , 620D , DSM715 Rex Rotary DSM615 , DSM618 , MP1600</p>'),
	(1040, '1', ' RICOH MP2500 841040 , 841001 , 885017', 0, 13.25, 0, 1, 0.65, '#NAME?', 'TSER17X31', 'http://tonersales,eu/shop/1380/-ricoh-mp2500-841040-841001-885017,jpg', 0, '0', '<p>Ricoh Type 2500 - Aficio MP2500 , 2500LN , 2500SP Gestetner MP 2500 Lanier LD125 Nashuatec DT-40 , MP-2500 Rex Rotary MP2500</p>', '<p>10500     5%     : Ricoh Type 2500 - Aficio MP2500 , 2500LN , 2500SP Gestetner MP 2500 Lanier LD125 Nashuatec DT-40 , MP-2500 Rex Rotary MP2500</p>'),
	(1041, '1', ' RICOH TYPE 1270D 888261 , 885476 , 888262 , 842024', 53, 12.02, 0, 1, 0.65, '-ricoh-type-1270d-888261-885476-888262-842024', 'TSER15X23', 'http://tonersales,eu/shop/1995/-ricoh-type-1270d-888261-885476-888262-842024,jpg', 0, '0', '<p>Ricoh Aficio1515 , 1515F , 1515MF , 1515PS , Aficio MP161 , 161L , 161LN , 171 , 171SPF Infotec IS2213 , IS2215 , 2215F , 22515FPS , 2215PS , IS2416 Nashuatec Docustation DSM415 , 415 , P , 415PF , 415F , DSM MP 161 Lanier LD117F , LD015 , LD016 , NRG DT-415 Rex Rotary DSM415 Gestetner DSM 415</p>', '<p>7000     5%     : Ricoh Aficio1515 , 1515F , 1515MF , 1515PS , Aficio MP161 , 161L , 161LN , 171 , 171SPF Infotec IS2213 , IS2215 , 2215F , 22515FPS , 2215PS , IS2416 Nashuatec Docustation DSM415 , 415 , P , 415PF , 415F , DSM MP 161 Lanier LD117F , LD015 , LD016 , NRG DT-415 Rex Rotary DSM415 Gestetner DSM 415</p>'),
	(1042, '1', ' RICOH TYPE 2220D', 53, 11.21, 0, 110, 0.65, '-ricoh-type-2220d', 'TSFR206B', 'http://tonersales,eu/shop/238/-ricoh-type-2220d,jpg', 0, '0', '<p>Ricoh Aficio 1022, 2022, 2032, 3025 P, 3030, 3030 PS, MP 2550 B, MP 2851, MP 3010, MP 3350 SPF, MP 3550, 1027, 2022 SP, 3025, 3025 PS, 3030 AD, MP 2510, MP 2550 SP, MP 2851 B, MP 3350, MP 3351 B, MP 3550 B, 1032, 2027, 3025 AD, 3025 SP, 3030 P, MP 2550, MP 2550 SPF, MP 2851 SP, MP 3350 B, MP 3351 SP</p>', '<p>12000     5%     : Ricoh Aficio1022, 2022, 2032, 3025 P, 3030, 3030 PS, MP 2550 B, MP 2851, MP 3010, MP 3350 SPF, MP 3550, 1027, 2022 SP, 3025, 3025 PS, 3030 AD, MP 2510, MP 2550 SP, MP 2851 B, MP 3350, MP 3351 B, MP 3550 B, 1032, 2027, 3025 AD, 3025 SP, 3030 P, MP 2550, MP 2550 SPF, MP 2851 SP, MP 3350 B, MP 3351 SP</p>'),
	(1043, '1', ' RICOH FT4418 , 4415 , 4421 (TYPE410)', 1, 15.59, 0, 1, 0.65, 'ricoh-ft4418-4415-4421-type410', 'TSFR024B', 'http://tonersales,eu/shop/1381/ricoh-ft4418-4415-4421-type410,jpg', 0, '0', 'Ricoh FT4215 , 4220 , 4222 , 4415 , 4418 , 4421', '8500     5%               :  Ricoh FT4215 , 4220 , 4222 , 4415 , 4418 , 4421'),
	(1044, '1', ' RICOH TN2120', 0, 16.84, 0, 112, 0.65, '#NAME?', 'TSFB216B', 'http://tonersales,eu/shop/1382/-ricoh-tn2120,jpg', 0, '0', '<p>Ricoh SP1200 , SP1200S</p>', '<p>2600     5%     : Ricoh SP1200 , SP1200S</p>'),
	(1045, '1', ' RICOH TYPE 3205D (885251)', 0, 16.92, 0, 1, 0.65, 'ricoh-type-3205d-885251', 'TSFR201B', 'http://tonersales,eu/shop/1383/ricoh-type-3205d-885251,jpg', 0, '0', '<p>Ricoh Aficio 1035 , 1045 , 1035P , 1045P , SP8100DN , 8100N Nashuatec D3525 , 4525 , DSM735E , 745E Gestetner 3502 , 4502 Infotec 4353MF , 4452MF , P320 , 350 , IS2435 , 2445 Rex Rotay 3508 , 4508 , NRG 3502 , 4502 , 3525 , 4525 , 3508 , 4508 lanier 5635 , 5645</p>', '<p>23000     5%     : Ricoh Aficio 1035 , 1045 , 1035P , 1045P , SP8100DN , 8100N Nashuatec D3525 , 4525 , DSM735E , 745E Gestetner 3502 , 4502 Infotec 4353MF , 4452MF , P320 , 350 , IS2435 , 2445 Rex Rotay 3508 , 4508 , NRG 3502 , 4502 , 3525 , 4525 , 3508 , 4508 lanier 5635 , 5645</p>'),
	(1046, '1', ' RICOH TYPE 3210D 1036856 , 888182 , 888513', 0, 17.66, 0, 1, 0.65, '-ricoh-type-3210d-1036856-888182-888513', 'TSER30X55', 'http://tonersales,eu/shop/1384/-ricoh-type-3210d-1036856-888182-888513,jpg', 0, '0', '<p>Type 3210D - Aficio 2035 , 2045 , 2045E , 2035E , 3035 , 3045 , 3045AD , 3045P , 3045PS , 3035AD , 3035F , 2045F , 2035G , 2035PS , 2035F , 3035P , 3035PS Lanier LD135 , LD145 , LD235 , LD035 , LD045 , LD245 Nashuatec Docustation 3545 , 4545 Rex Rotary DSM635 , DSM645 , DSM735 , DSM745 , 3518 , 3545 , 4518 , 4545 Gestetner 3532 , 4235G , 4532 , 4245G , DSM735 , DSM745 , DSM755 Infotec IS2035 , IS2045 , IS2135 , IS2145 , NRG DT-39 D3545 , 4532 , 4545</p>', '<p>30000     5%     : Type 3210D - Aficio 2035 , 2045 , 2045E , 2035E , 3035 , 3045 , 3045AD , 3045P , 3045PS , 3035AD , 3035F , 2045F , 2035G , 2035PS , 2035F , 3035P , 3035PS Lanier LD135 , LD145 , LD235 , LD035 , LD045 , LD245 Nashuatec Docustation 3545 , 4545 Rex Rotary DSM635 , DSM645 , DSM735 , DSM745 , 3518 , 3545 , 4518 , 4545 Gestetner 3532 , 4235G , 4532 , 4245G , DSM735 , DSM745 , DSM755 Infotec IS2035 , IS2045 , IS2135 , IS2145 , NRG DT-39 D3545 , 4532 , 4545</p>'),
	(1047, '1', ' RICOH MP3500 TYPE 4500 840041 , 841347', 0, 18.7, 0, 1, 0.65, '#NAME?', 'TS14400047', 'http://tonersales,eu/shop/1482/-ricoh-mp3500-type-4500-840041-841347,jpg', 0, '0', '<p>RICOH Type 4500E - Aficio MP4000 , 4000B , MP4500 , 4500B , MP5000 , 5000B , MP3500 , 3500AD , 3500P , 3500SP , 4500AD , 4500P , 4500SP , MP2550SP , MP3550B , 3550Badr , MP3350CSP , NRG DT-4500 Infotec IS2435 , IS2445 Gestetner DSM735 , MP3500 , DSM745 Lanier LD335 , LD040 , LD345 , LD050 Nashuatec MP-3500</p>', '<p>23000     5%     : RICOH Type 4500E - Aficio MP4000 , 4000B , MP4500 , 4500B , MP5000 , 5000B , MP3500 , 3500AD , 3500P , 3500SP , 4500AD , 4500P , 4500SP , MP2550SP , MP3550B , 3550Badr , MP3350CSP , NRG DT-4500 Infotec IS2435 , IS2445 Gestetner DSM735 , MP3500 , DSM745 Lanier LD335 , LD040 , LD345 , LD050 Nashuatec MP-3500</p>'),
	(1048, '1', ' RICOH AFICIO 220 , 270 (TYPE 2210D) (885229 , 885053)', 53, 16.58, 0, 1, 0.65, 'ricoh-aficio-220-270-type-2210d-885229-885053', 'TSFR211B', 'http://tonersales,eu/shop/237/ricoh-aficio-220-270-type-2210d-885229-885053,jpg', 0, '0', '<p>Ricoh Aficio 220 , 270 , AP2700 , AP3200 Gestetner Docustation 3222 , 3227 , P7022 , 7027 , 7032 Rex Rotary Docustation 2822 , 2827 , D422 , D427 , P7032 , 7027 Infotec 4220MF , 2827 , 4270MF Lanier 5222MFD , 5227MFD , D422 Nashuatec D427 Danka 4220MF , 2827 , 4270MF , NRG DT-20 , 2110D</p>', '<p>11000     5%     : Ricoh Aficio 220 , 270 , AP2700 , AP3200 Gestetner Docustation 3222 , 3227 , P7022 , 7027 , 7032 Rex Rotary Docustation 2822 , 2827 , D422 , D427 , P7032 , 7027 Infotec 4220MF , 2827 , 4270MF Lanier 5222MFD , 5227MFD , D422 Nashuatec D427 Danka 4220MF , 2827 , 4270MF , NRG DT-20 , 2110D</p>'),
	(1049, '1', ' RICOH TYPE 450E 2PC (889490 , 885084)', 0, 20.48, 0, 1, 0.65, 'ricoh-type-450e-2pc-889490-885084', 'TSFR003B**A', 'http://tonersales,eu/shop/1385/ricoh-type-450e-2pc-889490-885084,jpg', 0, '0', '<p>Ricoh FT4022 , 4027 , 4127 , 4522 , 4527 , 4622 , 4822 , 5035 , 5135 , 5535 , 5627 , 5632 , 5640 , 5740 , 5827 , 5832 , 5840 Infotec 5221z , 5271Z , 5271z Gestetner 2822 , 2627 Nashuatec 3522 , 3527 , Okidata 2797z Rex Rotary 8622z , 8627Z</p>', '<p>17000     5%     : Ricoh FT4022 , 4027 , 4127 , 4522 , 4527 , 4622 , 4822 , 5035 , 5135 , 5535 , 5627 , 5632 , 5640 , 5740 , 5827 , 5832 , 5840 Infotec 5221z , 5271Z , 5271z Gestetner 2822 , 2627 Nashuatec 3522 , 3527 , Okidata 2797z Rex Rotary 8622z , 8627Z</p>'),
	(1050, '1', ' RICOH AFICIO 350 , 450 (TYPE 3200D  ,  3100D)', 0, 21.24, 0, 1, 0.65, 'ricoh-aficio-350-450-type-3200d-3100d', 'TSFR203B', 'http://tonersales,eu/shop/1386/ricoh-aficio-350-450-type-3200d-3100d,jpg', 0, '0', '<p>Type 3200D - Ricoh Aficio 450 , 350 , 340 , 355 , 380 , 455 , 350E , 450E , 3245 , Aficio AP4500 , 4510 , 45 Imagio MF3550 , 4550 Nashuatec Docustation D435 , D445 , D435S , P7145 , 7045 , D435 , 435S , D445 Gestetner Docustation 3235 , 3245 , 3245E , P7045 , 7145 Rex Rotary Docustation 2835 , P7045 , 7145 , 2855S , 2845 Infotec 3545 , 4352MF , 4351MF , 4451MF , P450 Lanier 5235 , 2145 , 5635 , 5645 , 5135 , 5245 , 5235MFD , 5245MFD Danka 4352MF , 4351MFMF , P450</p>', '<p>27000     5%     : Type 3200D - Ricoh Aficio 450 , 350 , 340 , 355 , 380 , 455 , 350E , 450E , 3245 , Aficio AP4500 , 4510 , 45 Imagio MF3550 , 4550 Nashuatec Docustation D435 , D445 , D435S , P7145 , 7045 , D435 , 435S , D445 Gestetner Docustation 3235 , 3245 , 3245E , P7045 , 7145 Rex Rotary Docustation 2835 , P7045 , 7145 , 2855S , 2845 Infotec 3545 , 4352MF , 4351MF , 4451MF , P450 Lanier 5235 , 2145 , 5635 , 5645 , 5135 , 5245 , 5235MFD , 5245MFD Danka 4352MF , 4351MFMF , P450</p>'),
	(1052, '1', ' RICOH TYPE 6210D 885394 , 885098 , 885274 , 841992', 0, 25.93, 0, 1, 0.65, '-ricoh-type-6210d-885394-885098-885274-841992', 'TSER75X12', 'http://tonersales,eu/shop/1388/-ricoh-type-6210d-885394-885098-885274-841992,jpg', 0, '0', '<p>Type 6210D - Aficio1060 , 1075 , 2051 , 2060 , 2075 , Aficio AP 900 , 900N , Aficio MP5500 , MP6000 , MP6500 , MP7000 , MP7500 , MP8000 , MP6001 , MP7001 , MP8001 , MP9001 , Aficio SP9100DN Lanier LD160 , ld170 , ld055 , ld060 , ld151 , ld175 , ld075 , LD255 , LD260 , LD265 , LD360 , LD270 , LD275 , LD370 , LD280 , LD380 , LD390 Nashuatec DSM651 , 660 , 675 , 775 P7575 , Docustation D6005 , D7505 Infotec IS2060 , IS2075 , IS2151 , IS2160 , IS2175 , IS2255 , IS2265 , IS2275 GESTETNER AFICIO MP6002 , MP7502 , NRG DT-50 , DSM651 , DSM660 , DSM675 , DSM765 , DSM775 Rex Rotary 6008 , 7508</p>', '<p>43000     5%     : Type 6210D - Aficio1060 , 1075 , 2051 , 2060 , 2075 , Aficio AP 900 , 900N , Aficio MP5500 , MP6000 , MP6500 , MP7000 , MP7500 , MP8000 , MP6001 , MP7001 , MP8001 , MP9001 , Aficio SP9100DN Lanier LD160 , ld170 , ld055 , ld060 , ld151 , ld175 , ld075 , LD255 , LD260 , LD265 , LD360 , LD270 , LD275 , LD370 , LD280 , LD380 , LD390 Nashuatec DSM651 , 660 , 675 , 775 P7575 , Docustation D6005 , D7505 Infotec IS2060 , IS2075 , IS2151 , IS2160 , IS2175 , IS2255 , IS2265 , IS2275 GESTETNER AFICIO MP6002 , MP7502 , NRG DT-50 , DSM651 , DSM660 , DSM675 , DSM765 , DSM775 Rex Rotary 6008 , 7508</p>'),
	(1053, '1', ' RICOH TYPE 5205D 885241 , 887995 , 885048 , 885243', 0, 29.64, 0, 1, 0.65, '-ricoh-type-5205d-885241-887995-885048-885243', 'TS14400031', 'http://tonersales,eu/shop/1389/-ricoh-type-5205d-885241-887995-885048-885243,jpg', 0, '0', '<p>Ricoh Aficio 551 , 700 , 800 , 1055 Lanier 5470 , 5455 , 5470MF , 5455MF Nashuatec Docustatin D555 , D570 , d5505 Infotec IS 2055 Gestetner 5502 Rex Rotary 5508</p>', '<p>43000     5%     : Ricoh Aficio 551 , 700 , 800 , 1055 Lanier 5470 , 5455 , 5470MF , 5455MF Nashuatec Docustatin D555 , D570 , d5505 Infotec IS 2055 Gestetner 5502 Rex Rotary 5508</p>'),
	(1054, '1', ' RICOH SP100 407166 , 407165', 0, 36.72, 0, 1, 0.65, '#NAME?', 'TSTFR240B', 'http://tonersales,eu/shop/1390/-ricoh-sp100-407166-407165,jpg', 0, '0', '<p>Ricoh Aficio sp100 , sp100su , sp100sf , Ricoh sp112 , sp112su , sp112sf</p>', '<p>1200     5%     : Ricoh Aficio sp100 , sp100su , sp100sf , Ricoh sp112 , sp112su , sp112sf</p>'),
	(1055, '1', ' RICOH AFICIO 550 , 650 (TYPE 5100D  , 5200D) (885190 , 885459 , 885063)', 0, 30.8, 0, 1, 0.65, 'ricoh-aficio-550-650-type-5100d-5200d-885190-885459-885063', 'TSFR204B', 'http://tonersales,eu/shop/1391/ricoh-aficio-550-650-type-5100d-5200d-885190-885459-885063,jpg', 0, '0', '<p>Ricoh Aficio 550 , 600 , 650 Series Infotec 4550MF , 4651MF Gestetner 3255 , 3265 Lanier 5255 , 5265 Nashuatec D455 , D465 Rex Rotary 2855 , 8255E , 2865</p>', '<p>43000     5%     : Ricoh Aficio 550 , 600 , 650 Series Infotec 4550MF , 4651MF Gestetner 3255 , 3265 Lanier 5255 , 5265 Nashuatec D455 , D465 Rex Rotary 2855 , 8255E , 2865</p>'),
	(1056, '1', ' RICOH MPC2031 Black 841587', 0, 34.09, 0, 1, 0.65, '#NAME?', 'TS13316947**', 'http://tonersales,eu/shop/1392/-ricoh-mpc2031-black-841587,jpg', 0, '0', '<p>RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>', '<p>10000     5%     : RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>'),
	(1057, '1', ' RICOH MPC2030 Black 841196 , 841208', 0, 35.51, 0, 1, 0.65, '#NAME?', 'TS13316951**', 'http://tonersales,eu/shop/1393/-ricoh-mpc2030-black-841196-841208,jpg', 0, '0', '<p>Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>', '<p>10000     5%     : Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>'),
	(1058, '1', ' RICOH MPC2030 cyan 841197 , 841209', 0, 35.51, 0, 1, 0.65, '#NAME?', 'TS13316952**', 'http://tonersales,eu/shop/1394/-ricoh-mpc2030-cyan-841197-841209,jpg', 0, '0', '<p>Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>', '<p>5500     5%     : Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>'),
	(1059, '1', ' RICOH MPC2030 magenta 841198 , 841210', 0, 35.51, 0, 1, 0.65, '#NAME?', 'TS13316954**', 'http://tonersales,eu/shop/1395/-ricoh-mpc2030-magenta-841198-841210,jpg', 0, '0', '<p>Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>', '<p>5500     5%     : Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>'),
	(1060, '1', ' RICOH MPC2030 yellow 841199 , 841215', 0, 35.51, 0, 1, 0.65, '#NAME?', 'TS13316953**', 'http://tonersales,eu/shop/1396/-ricoh-mpc2030-yellow-841199-841215,jpg', 0, '0', '<p>Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>', '<p>5500     5%     : Ricoh Aficio MPC2030 , MPC2050 , MPC2530 , MPC2550 , Gestetner MP-C2030 , 2050 , 2530 , 2550 , Lanier LD520C , LD525C , NRG MP C2550 , 2030</p>'),
	(1061, '1', ' RICOH BP20 BK', 0, 39.83, 0, 1, 0.65, 'ricoh-bp20-bk', 'TSFR212B', 'http://tonersales,eu/shop/1397/ricoh-bp20-bk,jpg', 0, '0', '<p>Ricoh BP20 , BP20N</p>', '<p>6000     5%     : Ricoh BP20 , BP20N</p>'),
	(1062, '1', ' RICOH MPC2031 cyan 841505', 0, 40.49, 0, 1, 0.65, '#NAME?', 'TS13316948**', 'http://tonersales,eu/shop/1996/-ricoh-mpc2031-cyan-841505,jpg', 0, '0', '<p>RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>', '<p>9500     5%     : RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>'),
	(1063, '1', ' RICOH MPC2031 magenta 841506', 0, 40.49, 0, 1, 0.65, '#NAME?', 'TS13316950**', 'http://tonersales,eu/shop/1399/-ricoh-mpc2031-magenta-841506,jpg', 0, '0', '<p>RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>', '<p>9500     5%     : RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>'),
	(1064, '1', ' RICOH MPC2031 yellow 841507', 0, 40.49, 0, 1, 0.65, '#NAME?', 'TS13316949**', 'http://tonersales,eu/shop/1400/-ricoh-mpc2031-yellow-841507,jpg', 0, '0', '<p>RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>', '<p>9500     5%     : RICOH Aficio MPC2031 , MPC2051 , MPC2531 , MPC2551</p>'),
	(1065, '1', ' RICOH TYPE 8205D , 8200D 885344 , 885644 , 888157 , 888009', 0, 42.46, 0, 1, 0.65, '-ricoh-type-8205d-8200d-885344-885644-888157-888009', 'TS14400042', 'http://tonersales,eu/shop/1401/-ricoh-type-8205d-8200d-885344-885644-888157-888009,jpg', 0, '0', '<p>Ricoh Type 8205D - Aficio 850 , 1050 , 1085 , 1105 , 2090 , 2105 Lanier 5505 , 5485 , 5685 , 5705 , LD0105 , LD090 , LD075 Nashuatec D4105 , 5505 , 8505 , D485 , 10505 , 10515 , DSC428 , 435 , 445 , 435S Infotec IS2085 , 2105 , 2090 , 4105MF , 4850MF , 4850E , 4105EMF , 485MF , 485SMF Gestetner Docustation 32105 , 3285 , 8502 , 5505 , 10502 , 9002 , 10512 IBM Infoprint 2085 , 2090ES , 2090 , 2105 Rex Rotary 8508 , 10508 , 2885 Toshiba E-STUDIO 900 , E-STUDIO 1050</p>', '<p>55000     5%     : Ricoh Type 8205D - Aficio 850 , 1050 , 1085 , 1105 , 2090 , 2105 Lanier 5505 , 5485 , 5685 , 5705 , LD0105 , LD090 , LD075 Nashuatec D4105 , 5505 , 8505 , D485 , 10505 , 10515 , DSC428 , 435 , 445 , 435S Infotec IS2085 , 2105 , 2090 , 4105MF , 4850MF , 4850E , 4105EMF , 485MF , 485SMF Gestetner Docustation 32105 , 3285 , 8502 , 5505 , 10502 , 9002 , 10512 IBM Infoprint 2085 , 2090ES , 2090 , 2105 Rex Rotary 8508 , 10508 , 2885 Toshiba E-STUDIO 900 , E-STUDIO 1050</p>'),
	(1066, '1', ' RICOH TYPE MP1350E type 1350 , 840005 , 884916', 0, 42.46, 0, 1, 0.65, '#NAME?', 'TS14400091', 'http://tonersales,eu/shop/1408/-ricoh-type-mp1350e-type-1350-840005-884916,jpg', 0, '0', '<p>Ricoh Type 1350E , Ricoh Aficio MP9000 , MP1100 , MP1350 Gestetner DSM790 INFOPRINT 2090ES , 2190 Lanier LD190 Toshiba E-STUDIO 1101 , E-STUDIO 901</p>', '<p>60000     5%     : Ricoh Type 1350E , Ricoh Aficio MP9000 , MP1100 , MP1350 Gestetner DSM790 INFOPRINT 2090ES , 2190 Lanier LD190 Toshiba E-STUDIO 1101 , E-STUDIO 901</p>'),
	(1067, '1', ' RICOH SP3400E 406522', 0, 42.93, 0, 1, 0.65, '#NAME?', 'TS13316905**', 'http://tonersales,eu/shop/1409/-ricoh-sp3400e-406522,jpg', 0, '0', '<p>Ricoh Aficio SP3400 , SP3410</p>', '<p>5000     5%     : Ricoh Aficio SP3400 , SP3410</p>'),
	(1068, '1', ' RICOH SP3500', 0, 42.93, 0, 1, 0.65, '#NAME?', 'TS13316905**', 'http://tonersales,eu/shop/1410/-ricoh-sp3500,jpg', 0, '0', '<p>RICOH Aficio SP3500 , SP3510</p>', '<p>6400     5%     : RICOH Aficio SP3500 , SP3510</p>'),
	(1069, '1', ' RICOH SP3200 BK', 0, 43.11, 0, 1, 0.65, 'ricoh-sp3200-bk', 'TSTFR232B', 'http://tonersales,eu/shop/1411/ricoh-sp3200-bk,jpg', 0, '0', '<p>Ricoh Aficio SP3200 , 3200SF , NRG SP3200E (402887 , 402888 , 407162)</p>', '<p>8000     5%     : Ricoh Aficio SP3200 , 3200SF , NRG SP3200E (402887 , 402888 , 407162)</p>'),
	(1070, '1', ' RICOH MPC4501 BLACK', 0, 44.04, 0, 1, 0.65, '#NAME?', 'TSMPC4501K', 'http://tonersales,eu/shop/1412/-ricoh-mpc4501-black,jpg', 0, '0', '<p>Ricoh Aficio MPC5501 , MPC4501</p>', '<p>23000     5%     : Ricoh Aficio MPC5501 , MPC4501</p>'),
	(1071, '1', ' RICOH MPC4000 black (888608)', 0, 44.04, 0, 1, 0.65, '#NAME?', 'TSMPC4000K', 'http://tonersales,eu/shop/1997/-ricoh-mpc4000-black-888608,jpg', 0, '0', '<p>Ricoh Aficio MPC4000 , MPC5000</p>', '<p>23000     5%     : Ricoh Aficio MPC4000 , MPC5000</p>'),
	(1072, '1', ' RICOH CL4000 BK 888280', 53, 68.14, 0, 1, 0.65, '#NAME?', 'TSCL4000K', 'http://tonersales,eu/shop/230/-ricoh-cl4000-bk-888280,jpg', 0, '0', '<p>Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>', '<p>5000     5%     : Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>'),
	(1073, '1', ' RICOH MPC2800 BLACK TYPE 3300841124 , 841140 , 842043', 0, 45.46, 0, 1, 0.65, '#NAME?', 'TSMPC2800K', 'http://tonersales,eu/shop/1998/-ricoh-mpc2800-black-type-3300841124-841140-842043,jpg', 0, '0', '<p>Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>', '<p>20000     5%     : Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>'),
	(1074, '1', ' RICOH BLACK 888640 MP2000', 0, 46.59, 0, 1, 0.65, 'ricoh-black-888640-mp2000', 'TS14400060', 'http://tonersales,eu/shop/1999/ricoh-black-888640-mp2000,jpg', 0, '0', '<p>Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 , ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500</p>', '<p>20000     5%     : Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 , ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500</p>'),
	(1075, '1', ' RICOH 888608 BLACK MP3500', 0, 48.66, 0, 1, 0.65, '#NAME?', 'TS14400064', 'http://tonersales,eu/shop/1481/-ricoh-888608-black-mp3500,jpg', 0, '0', '<p>Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>', '<p>23000     5%     : Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>'),
	(1076, '1', ' TONER RICOH 413196 , 413197 , SP1000', 1, 51.13, 0, 1, 0.65, 'toner-ricoh-413196-413197-sp1000', 'TS13316902', 'http://tonersales,eu/shop/1416/toner-ricoh-413196-413197-sp1000,jpg', 0, '0', 'RICOH Aficio SP1000 , 1000S , 1000SF Fax 1140L , 1180L Infotec IF4030 , 4040 Nashuatec Faxstation F110 , NRG SP1000E Gestetner F111 lanier LF225M', '4000     5%               :  RICOH Aficio SP1000 , 1000S , 1000SF Fax 1140L , 1180L Infotec IF4030 , 4040 Nashuatec Faxstation F110 , NRG SP1000E Gestetner F111 lanier LF225M'),
	(1077, '1', ' RICOH SP1100 (406572)', 1, 51.13, 0, 1, 0.65, 'ricoh-sp1100-406572', 'TS13316935**', 'http://tonersales,eu/shop/1417/ricoh-sp1100-406572,jpg', 0, '0', 'Ricoh Aficio SP1100 , 1100S , 1100SF , NRG SP1100', '4000     5%               :  Ricoh Aficio SP1100 , 1100S , 1100SF , NRG SP1100'),
	(1078, '1', ' RICOH CYAN 888643 MP2000', 1, 58.98, 0, 1, 0.65, 'ricoh-cyan-888643-mp2000', 'TS4400063', 'http://tonersales,eu/shop/1418/ricoh-cyan-888643-mp2000,jpg', 0, '0', 'Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 ,  ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500', '15000     5%               :  Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 ,  ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500'),
	(1079, '1', ' RICOH MAGENTA 888642 MP2000', 0, 58.98, 0, 1, 0.65, 'ricoh-magenta-888642-mp2000', 'TS14400062', 'http://tonersales,eu/shop/1419/ricoh-magenta-888642-mp2000,jpg', 0, '0', '<p>Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 , ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500</p>', '<p>15000     5%     : Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 , ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500</p>'),
	(1080, '1', ' RICOH YELLOW 888641 MP2000', 1, 58.98, 0, 1, 0.65, 'ricoh-yellow-888641-mp2000', 'TS14400061', 'http://tonersales,eu/shop/1421/ricoh-yellow-888641-mp2000,jpg', 0, '0', 'Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 ,  ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500', '15000     5%               :  Ricoh MP C-2000 , c-2500 , c-3000 Infotec ISC 2525 ,  ISC 3030 Gestetner dsc525 , 530 MP C2500 Lanier LD425C , LD430 Nashuatec MP-C2500 Rex Rotary MP C2500'),
	(1081, '1', ' RICOH SP C430 BK 821074 , 821094', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13316983**', 'http://tonersales,eu/shop/1422/-ricoh-sp-c430-bk-821074-821094,jpg', 0, '0', '<p>RICOH SP C430 , C431</p>', '<p>24000     5%     : RICOH SP C430 , C431</p>'),
	(1082, '1', ' RICOH SP C430 CY 821077 , 821097', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13316984**', 'http://tonersales,eu/shop/1423/-ricoh-sp-c430-cy-821077-821097,jpg', 0, '0', '<p>RICOH SP C430 , C431</p>', '<p>21000     5%     : RICOH SP C430 , C431</p>'),
	(1083, '1', ' RICOH SP C430 MG 821076 , 821096', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13316985**', 'http://tonersales,eu/shop/1424/-ricoh-sp-c430-mg-821076-821096,jpg', 0, '0', '<p>RICOH SP C430 , C431</p>', '<p>21000     5%     : RICOH SP C430 , C431</p>'),
	(1084, '1', ' RICOH SP C430 YL 821075 , 821095', 0, 59.66, 0, 1, 0.65, '#NAME?', 'TS13316986**', 'http://tonersales,eu/shop/1425/-ricoh-sp-c430-yl-821075-821095,jpg', 0, '0', '<p>RICOH SP C430 , C431</p>', '<p>21000     5%     : RICOH SP C430 , C431</p>'),
	(1085, '1', ' RICOH CL4000 CY 888283', 53, 68.14, 0, 1, 0.65, '#NAME?', 'TSCL4000C', 'http://tonersales,eu/shop/232/-ricoh-cl4000-cy-888283,jpg', 0, '0', '<p>Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>', '<p>5000     5%     : Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>'),
	(1086, '1', ' Ricoh CL4000 MG 888282', 53, 54.96, 0, 1, 0.65, 'ricoh-cl4000-mg-888282', 'TSCL4000M', 'http://tonersales,eu/shop/231/ricoh-cl4000-mg-888282,jpg', 0, '0', '<p>Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>', '<p>5000     5%     : Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>'),
	(1087, '1', ' RICOH CL4000 YL 888281', 53, 54.95, 0, 1, 0.65, '#NAME?', 'TSCL4000Y', 'http://tonersales,eu/shop/233/-ricoh-cl4000-yl-888281,jpg', 0, '0', '<p>Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>', '<p>5000     5%     : Type 245 - Aficio Color CL4000 , Aficio SPC410 , 411 , 420 , Lanier LP125CX , 126C , 125C , 126CXN Nashuatec Gestetner Rex Rotary NRG C7425</p>'),
	(1088, '1', ' RICOH 888611 CYAN MP3500', 0, 62.09, 0, 1, 0.65, '#NAME?', 'TS14400067', 'http://tonersales,eu/shop/1426/-ricoh-888611-cyan-mp3500,jpg', 0, '0', '<p>Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>', '<p>17000     5%     : Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>'),
	(1089, '1', ' RICOH 888610 MAGENTA MP3500', 0, 62.09, 0, 1, 0.65, '#NAME?', 'TS14400066', 'http://tonersales,eu/shop/1427/-ricoh-888610-magenta-mp3500,jpg', 0, '0', '<p>Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>', '<p>17000     5%     : Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>'),
	(1090, '1', ' RICOH 888609 YELLOW MP3500', 0, 62.09, 0, 1, 0.65, '#NAME?', 'TS14400065', 'http://tonersales,eu/shop/1428/-ricoh-888609-yellow-mp3500,jpg', 0, '0', '<p>Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>', '<p>17000     5%     : Ricoh MP C-3500 , c-4500 Infotec ISC 3535 E1 , ISC 4045 Gestetner DSC535 , 545 , MP C 3500 E1 , MP C 4500 Lanier LD435C , LD445C Nashuatec MP-C3500 , MP-C4500 Rex Rotary MP C3500 , MP C4500</p>'),
	(1091, '1', ' RICOH SPC811 TYPE 811k BLACK P , N: 820001 , 884201', 0, 63.33, 0, 1, 0.65, '-ricoh-spc811-type-811k-black-p-n-820001-884201', 'TS14400071', 'http://tonersales,eu/shop/2000/-ricoh-spc811-type-811k-black-p-n-820001-884201,jpg', 0, '0', '<p>Ricoh Aficio SPC811DN , C810</p>', '<p>20000     5%     : Ricoh Aficio SPC811DN , C810</p>'),
	(1092, '1', ' RICOH MPC2800 CYAN TYPE 3300 (841127 , 841427 , 841431 , 842046)', 0, 65.34, 0, 1, 0.65, '#NAME?', 'TSMPC2800C', 'http://tonersales,eu/shop/2006/-ricoh-mpc2800-cyan-type-3300-841127-841427-841431-842046,jpg', 0, '0', '<p>Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>', '<p>15000     5%     : Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>'),
	(1093, '1', ' RICOH MPC2800 MAGENTA TYPE 3300 (841126 , 841426 , 841430 , 842045)', 0, 65.34, 0, 1, 0.65, '#NAME?', 'TSMPC2800M', 'http://tonersales,eu/shop/2005/-ricoh-mpc2800-magenta-type-3300-841126-841426-841430-842045,jpg', 0, '0', '<p>Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>', '<p>15000     5%     : Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>'),
	(1094, '1', ' RICOH MPC2800 YELLOW TYPE 3300 (841125 , 841425 , 841429 , 842044)', 0, 65.34, 0, 1, 0.65, '#NAME?', 'TSMPC2800Y', 'http://tonersales,eu/shop/2004/-ricoh-mpc2800-yellow-type-3300-841125-841425-841429-842044,jpg', 0, '0', '<p>Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>', '<p>15000     5%     : Ricoh Aficio MPC2800 , MPC3300 , MPC3501 NRG MP C3501 (MPC-3300)</p>'),
	(1095, '1', ' RICOH MPC4000 CYAN (841459 , 841163 , 842051)', 0, 65.34, 0, 1, 0.65, '#NAME?', 'TSMPC4000C', 'http://tonersales,eu/shop/2003/-ricoh-mpc4000-cyan-841459-841163-842051,jpg', 0, '0', '<p>Ricoh Aficio MPC4000 , MPC5000 , MPC5501 , MPC4501</p>', '<p>18000     5%     : Ricoh Aficio MPC4000 , MPC5000 , MPC5501 , MPC4501</p>'),
	(1096, '1', ' RICOH MPC4000 MAGENTA (841458 , 841162 , 842050)', 0, 65.34, 0, 1, 0.65, '#NAME?', 'TSMPC4000M', 'http://tonersales,eu/shop/2001/-ricoh-mpc4000-magenta-841458-841162-842050,jpg', 0, '0', '<p>Ricoh Aficio MPC4000 , MPC5000 , MPC5501 , MPC4501</p>', '<p>18000     5%     : Ricoh Aficio MPC4000 , MPC5000 , MPC5501 , MPC4501</p>'),
	(1097, '1', ' RICOH MPC4000 YELLOW (841457 , 841161 , 842049)', 0, 65.34, 0, 1, 0.65, '#NAME?', 'TSMPC4000Y', 'http://tonersales,eu/shop/2002/-ricoh-mpc4000-yellow-841457-841161-842049,jpg', 0, '0', '<p>Ricoh Aficio MPC4000 , MPC5000 , MPC5501 , MPC4501</p>', '<p>18000     5%     : Ricoh Aficio MPC4000 , MPC5000 , MPC5501 , MPC4501</p>'),
	(1098, '1', ' RICOH SPC811 TYPE 811c CYAN P , N: 820054 , 820053', 0, 71.59, 0, 1, 0.65, '-ricoh-spc811-type-811c-cyan-p-n-820054-820053', 'TS14400070', 'http://tonersales,eu/shop/2009/-ricoh-spc811-type-811c-cyan-p-n-820054-820053,jpg', 0, '0', '<p>Ricoh Aficio SPC811DN , C810</p>', '<p>8000     5%     : Ricoh Aficio SPC811DN , C810</p>'),
	(1099, '1', ' RICOH SPC811 TYPE 811m MAGENTA P , N: 820047 , 820046 , 820017', 0, 71.59, 0, 1, 0.65, '-ricoh-spc811-type-811m-magenta-p-n-820047-820046-820017', 'TS14400069', 'http://tonersales,eu/shop/2007/-ricoh-spc811-type-811m-magenta-p-n-820047-820046-820017,jpg', 0, '0', '<p>Ricoh Aficio SPC811DN , C810</p>', '<p>8000     5%     : Ricoh Aficio SPC811DN , C810</p>'),
	(1100, '1', ' RICOH SPC811 TYPE 811y YELLOW P , N: 820040 , 820039', 0, 71.59, 0, 1, 0.65, '-ricoh-spc811-type-811y-yellow-p-n-820040-820039', 'TS14400068', 'http://tonersales,eu/shop/2010/-ricoh-spc811-type-811y-yellow-p-n-820040-820039,jpg', 0, '0', '<p>Ricoh Aficio SPC811DN , C810</p>', '<p>8000     5%     : Ricoh Aficio SPC811DN , C810</p>'),
	(1101, '1', ' RICOH MP C4503 , C5503 CY 841856', 0, 85.23, 0, 1, 0.65, '#NAME?', 'TS13316980**', 'http://tonersales,eu/shop/2012/-ricoh-mp-c4503-c5503-cy-841856,jpg', 0, '0', '<p>RICOH Aficio MP C4503 , C5503 , C6003</p>', '<p>22500     5%     : RICOH Aficio MP C4503 , C5503 , C6003</p>'),
	(1102, '1', ' RICOH MP C4503 , C5503 YL 841854', 0, 85.23, 0, 1, 0.65, '#NAME?', 'TS13316981**', 'http://tonersales,eu/shop/2013/-ricoh-mp-c4503-c5503-yl-841854,jpg', 0, '0', '<p>RICOH Aficio MP C4503 , C5503 , C6003</p>', '<p>22500     5%     : RICOH Aficio MP C4503 , C5503 , C6003</p>'),
	(1103, '1', ' RICOH MP C4503 , C5503 MG 841855', 0, 85.23, 0, 1, 0.65, '#NAME?', 'TS13316982**', 'http://tonersales,eu/shop/2011/-ricoh-mp-c4503-c5503-mg-841855,jpg', 0, '0', '<p>RICOH Aficio MP C4503 , C5503 , C6003</p>', '<p>22500     5%     : RICOH Aficio MP C4503 , C5503 , C6003</p>'),
	(1104, '1', ' RICOH MP C4503 , C5503 BK 841853', 0, 92.32, 0, 1, 0.65, '#NAME?', 'TS13316979**', 'http://tonersales,eu/shop/2014/-ricoh-mp-c4503-c5503-bk-841853,jpg', 0, '0', '<p>RICOH Aficio MP C4503 , C5503 , C6003</p>', '<p>33000     5%     : RICOH Aficio MP C4503 , C5503 , C6003</p>'),
	(1105, '1', ' TOSHIBA T1600E e-Studio 16  66061614 , 60066062051', 0, 17.04, 0, 1, 0.65, '#NAME?', 'TSET25X50', 'http://tonersales,eu/shop/1443/-toshiba-t1600e-e-studio-16-66061614-60066062051,jpg', 0, '0', '<p>Toshiba e-Studio 16 , 16P , 16S , 160 , 168 , 168S , 169 , DP1600 , BD1600</p>', '<p>5000     5%     : Toshiba e-Studio 16 , 16P , 16S , 160 , 168 , 168S , 169 , DP1600 , BD1600</p>'),
	(1106, '1', ' TOSHIBA T2450E', 0, 20.56, 0, 1, 0.65, '#NAME?', 'TS15100027', 'http://tonersales,eu/shop/1444/-toshiba-t2450e,jpg', 0, '0', '<p>TOSHIBA e-Studio 195 , 223 , 225 , 243 , 245</p>', '<p>10000     5%     : TOSHIBA e-Studio 195 , 223 , 225 , 243 , 245</p>'),
	(1107, '1', ' TOSHIBA T1640  , 6AJ00000024', 0, 22.2, 0, 1, 0.65, '-toshiba-t1640-6aj00000024', 'TS13317100', 'http://tonersales,eu/shop/1445/-toshiba-t1640-6aj00000024,jpg', 0, '0', '<p>Toshiba e-Studio 163 , 165 , 166 , 167 , 203 , 205 , 206 , 207 , 237</p>', '<p>24000     5%     : Toshiba e-Studio 163 , 165 , 166 , 167 , 203 , 205 , 206 , 207 , 237</p>'),
	(1108, '1', ' TOSHIBA T1810E 6AJ00000058', 0, 22.2, 0, 1, 0.65, '-toshiba-t1810e-6aj00000058', 'TS15100026', 'http://tonersales,eu/shop/1446/-toshiba-t1810e-6aj00000058,jpg', 0, '0', '<p>Toshiba e-Studio 181 , 182 , 211 , 212 , 242</p>', '<p>24500     5%     : Toshiba e-Studio 181 , 182 , 211 , 212 , 242</p>'),
	(1109, '1', ' TOSHIBA T2340 , T2320 6AJ00000025 , 6AK00000009 , 6AJ00000006', 0, 22.2, 0, 1, 0.65, '-toshiba-t2340-t2320-6aj00000025-6ak00000009-6aj00000006', 'TSET18X67', 'http://tonersales,eu/shop/1447/-toshiba-t2340-t2320-6aj00000025-6ak00000009-6aj00000006,jpg', 0, '0', '<p>E-Studio 230 , E-Studio 232 , E-Studio 280 , E-Studio 282</p>', '<p>23000     5%     : E-Studio 230 , E-Studio 232 , E-Studio 280 , E-Studio 282</p>'),
	(1110, '1', ' TOSHIBA T1800', 0, 23.03, 0, 1, 0.65, 'toshiba-t1800', 'TST-1800', 'http://tonersales,eu/shop/1448/toshiba-t1800,jpg', 0, '0', '<p>Toshiba e-Studio 18 digital MFPs</p>', '<p>10000     5%     : Toshiba e-Studio 18 digital MFPs</p>'),
	(1111, '1', ' TOSHIBA T4530E 6AK000000134 , 6AJ00000055', 0, 23.03, 0, 1, 0.65, 'toshiba-t4530e-6ak000000134-6aj00000055', 'TS15100025', 'http://tonersales,eu/shop/2212/toshiba-t4530e-6ak000000134-6aj00000055,jpg', 0, '0', '<p>TOSHIBA e-Studio 255 , 305 , 355 , 455</p>', '<p>24000     5%     : TOSHIBA e-Studio 255 , 305 , 355 , 455</p>'),
	(1112, '1', ' TOSHIBA T1820E , 6A000000931', 0, 24.01, 0, 1, 0.65, '-toshiba-t1820e-6a000000931', 'TS13317104**', 'http://tonersales,eu/shop/1450/-toshiba-t1820e-6a000000931,jpg', 0, '0', '<p>Toshiba E-Studio 180 , E-Studio 180S</p>', '<p>3000     5%     : Toshiba E-Studio 180 , E-Studio 180S</p>'),
	(1113, '1', ' TOSHIBA E-Studio 2007 T2507', 0, 24.14, 0, 1, 0.65, '#NAME?', 'TST2507', 'http://tonersales,eu/shop/1451/-toshiba-e-studio-2007-t2507,jpg', 0, '0', '<p>Toshiba e-Studio 2007 , 2507 , 2006 , 2506 (6AG00005086)</p>', '<p>10000     5%     : Toshiba e-Studio 2007 , 2507 , 2006 , 2506 (6AG00005086)</p>'),
	(1114, '1', ' TOSHIBA T2840  , 6AJ00000035', 0, 24.14, 0, 1, 0.65, '-toshiba-t2840-6aj00000035', 'TST2840', 'http://tonersales,eu/shop/1452/-toshiba-t2840-6aj00000035,jpg', 0, '0', '<p>Toshiba E-Studio 203L , 233 , 233P , 283 , 283P</p>', '<p>23000     5%     : Toshiba E-Studio 203L , 233 , 233P , 283 , 283P</p>'),
	(1115, '1', ' TOSHIBA T2025  , 6A000000932', 0, 24.26, 0, 1, 0.65, '-toshiba-t2025-6a000000932', 'TS13317105**', 'http://tonersales,eu/shop/1453/-toshiba-t2025-6a000000932,jpg', 0, '0', '<p>Toshiba e-Studio 200S</p>', '<p>16000     5%     : Toshiba e-Studio 200S</p>'),
	(1116, '1', ' TOSHIBA T3520E 6AK00000007 , 6AJ00000037', 0, 25.72, 0, 1, 0.65, 'toshiba-t3520e-6ak00000007-6aj00000037', 'TS15100021', 'http://tonersales,eu/shop/1454/toshiba-t3520e-6ak00000007-6aj00000037,jpg', 0, '0', '<p>TOSHIBA e-Studio 350 , 352 , 353 , 450 , 452 , 453</p>', '<p>21000     5%     : TOSHIBA e-Studio 350 , 352 , 353 , 450 , 452 , 453</p>'),
	(1117, '1', ' TOSHIBA T3500E 66089631', 1, 26.14, 0, 1, 0.65, 'toshiba-t3500e-66089631', 'TS15100016', 'http://tonersales,eu/shop/1455/toshiba-t3500e-66089631,jpg', 0, '0', 'TOSHIBA e-Studio 28 , e-Studio 35 , e-Studio 45', '13500     5%               :  TOSHIBA e-Studio 28 , e-Studio 35 , e-Studio 45'),
	(1118, '1', ' TOSHIBA T1350E (66084567) 4 PC', 1, 32.13, 0, 1, 0.65, 'toshiba-t1350e-66084567-4-pc', 'TSF111B**C', 'http://tonersales,eu/shop/1456/toshiba-t1350e-66084567-4-pc,jpg', 0, '0', 'Toshiba BD1340 , 1350 , 1360 , 1370 Lanier 6613 , 6713 , 7213 , 7313', '4300     5%               :  Toshiba BD1340 , 1350 , 1360 , 1370 Lanier 6613 , 6713 , 7213 , 7313'),
	(1119, '1', ' TOSHIBA T1710E (66062020) 4 PC', 0, 49.58, 0, 1, 0.65, 'toshiba-t1710e-66062020-4-pc', 'TSF116B**C', 'http://tonersales,eu/shop/1457/toshiba-t1710e-66062020-4-pc,jpg', 0, '0', '<p>Toshiba BD1650 , 1710 , 2050 , 2310 , 2500 , 2540 Lanier 6425 , 6523 , 6625</p>', '<p>10000     5%     : Toshiba BD1650 , 1710 , 2050 , 2310 , 2500 , 2540 Lanier 6425 , 6523 , 6625</p>'),
	(1120, '1', ' TOSHIBA 2060 2 PRG BK 4PC', 0, 49.58, 0, 1, 0.65, 'toshiba-2060-2-prg-bk-4pc', 'TSF120B**C', 'http://tonersales,eu/shop/1458/toshiba-2060-2-prg-bk-4pc,jpg', 0, '0', '<p>Toshiba BD2060 , 2860 , 2870 Lanier 7228 , 7320 , 7328</p>', '<p>8000     5%     : Toshiba BD2060 , 2860 , 2870 Lanier 7228 , 7320 , 7328</p>'),
	(1121, '1', ' SHARP AR-020T , AR-021', 0, 26.76, 0, 1, 0.65, '-sharp-ar-020t-ar-021', 'TS14900032A', 'http://tonersales,eu/shop/1459/-sharp-ar-020t-ar-021,jpg', 0, '0', '<p>Sharp AR3818 , AR3820 , AR3821 , AR3020 , AR5516 , AR5020 , AR5520</p>', '<p>15000     5%     : Sharp AR3818 , AR3820 , AR3821 , AR3020 , AR5516 , AR5020 , AR5520</p>'),
	(1122, '1', ' SHARP MX-27GTBA Black', 0, 44.52, 0, 1, 0.65, '-sharp-mx-27gtba-black', 'TSMX-27CT K', 'http://tonersales,eu/shop/1460/-sharp-mx-27gtba-black,jpg', 0, '0', '<p>Sharp MX2300 , MX2700</p>', '<p>18000     5%     : Sharp MX2300 , MX2700</p>'),
	(1123, '1', ' SHARP MX-31GTBA', 0, 44.52, 0, 1, 0.65, '-sharp-mx-31gtba', 'TSMX31GT-BK', 'http://tonersales,eu/shop/1461/-sharp-mx-31gtba,jpg', 0, '0', '<p>SHARP MX2301 , MX2600 , MX3100</p>', '<p>18000     5%     : SHARP MX2301 , MX2600 , MX3100</p>'),
	(1124, '1', ' SHARP AL100', 0, 45.46, 0, 1, 0.65, '#NAME?', 'TSFX100B', 'http://tonersales,eu/shop/1462/-sharp-al100,jpg', 0, '0', '<p>Sharp AL1000 , 1010 , 1020 , 1041 , 1200 , 1220 , 1250 , 1551CS , 1631 , 1641CS , 1661CS , 2030</p>', '<p>6000     5%     : Sharp AL1000 , 1010 , 1020 , 1041 , 1200 , 1220 , 1250 , 1551CS , 1631 , 1641CS , 1661CS , 2030</p>'),
	(1125, '1', ' SHARP AR-450T', 0, 45.55, 0, 13, 0.65, '-sharp-ar-450t', 'TSAR-450T', 'http://tonersales,eu/shop/1463/-sharp-ar-450t,jpg', 0, '0', '<p>Sharp ARM280 , ARM350 , ARM450 , ARP350 , ARP450</p>', '<p>24000     5%     : Sharp ARM280 , ARM350 , ARM450 , ARP350 , ARP450</p>'),
	(1126, '1', ' SHARP AR-455LT', 0, 45.55, 0, 1, 0.65, '-sharp-ar-455lt', 'TSAR455T', 'http://tonersales,eu/shop/1464/-sharp-ar-455lt,jpg', 0, '0', '<p>Sharp ARM351 , ARM451 , ARM355 , ARM455 , MX-M350 , 350N , 350U , MX-M 450 , 450N , 450U , MX-M451U , MX-M455U</p>', '<p>35000     5%     : Sharp ARM351 , ARM451 , ARM355 , ARM455 , MX-M350 , 350N , 350U , MX-M 450 , 450N , 450U , MX-M451U , MX-M455U</p>'),
	(1127, '1', ' SHARP MX-235GT', 0, 46.38, 0, 1, 0.65, '-sharp-mx-235gt', 'TSMX235GT', 'http://tonersales,eu/shop/1465/-sharp-mx-235gt,jpg', 0, '0', '<p>Sharp AR5618 , AR5620 , AR5623 , MX-M182 , MX-M202 , MX-M 232</p>', '<p>16000     5%     : Sharp AR5618 , AR5620 , AR5623 , MX-M182 , MX-M202 , MX-M 232</p>'),
	(1128, '1', ' SHARP MX-312GT', 0, 46.86, 0, 1, 0.65, '-sharp-mx-312gt', 'TSMX312GT', 'http://tonersales,eu/shop/1466/-sharp-mx-312gt,jpg', 0, '0', '<p>Sharp MX-M310 , MX-M260 , MX-M314 , MX-M354 , AR5726 , AR5731G</p>', '<p>25000     5%     : Sharp MX-M310 , MX-M260 , MX-M314 , MX-M354 , AR5726 , AR5731G</p>'),
	(1129, '1', ' SHARP MX-27GTCA Cyan', 0, 65.18, 0, 1, 0.65, '-sharp-mx-27gtca-cyan', 'TSMX-27CT C', 'http://tonersales,eu/shop/1467/-sharp-mx-27gtca-cyan,jpg', 0, '0', '<p>Sharp MX2300 , MX2700</p>', '<p>15000     5%     : Sharp MX2300 , MX2700</p>'),
	(1130, '1', ' SHARP MX-27GTMA Magenta', 0, 65.18, 0, 1, 0.65, '-sharp-mx-27gtma-magenta', 'TSMX-27CT M', 'http://tonersales,eu/shop/1468/-sharp-mx-27gtma-magenta,jpg', 0, '0', '<p>Sharp MX2300 , MX2700</p>', '<p>15000     5%     : Sharp MX2300 , MX2700</p>'),
	(1131, '1', ' SHARP MX-27GTYA Yellow', 0, 65.18, 0, 1, 0.65, '-sharp-mx-27gtya-yellow', 'TSMX-27CT Y', 'http://tonersales,eu/shop/1469/-sharp-mx-27gtya-yellow,jpg', 0, '0', '<p>Sharp MX2300 , MX2700</p>', '<p>15000     5%     : Sharp MX2300 , MX2700</p>'),
	(1132, '1', ' SHARP MX-31GTCA', 0, 65.18, 0, 1, 0.65, '-sharp-mx-31gtca', 'TSMX31GT-C', 'http://tonersales,eu/shop/2149/-sharp-mx-31gtca,jpg', 0, '0', '<p>SHARP MX2301 , MX2600 , MX3100</p>', '<p>15000     5%     : SHARP MX2301 , MX2600 , MX3100</p>'),
	(1133, '1', ' SHARP MX-31GTMA', 0, 65.18, 0, 1, 0.65, '-sharp-mx-31gtma', 'TSMX31GT-M', 'http://tonersales,eu/shop/2152/-sharp-mx-31gtma,jpg', 0, '0', '<p>SHARP MX2301 , MX2600 , MX3100</p>', '<p>15000     5%     : SHARP MX2301 , MX2600 , MX3100</p>'),
	(1134, '1', ' SHARP MX-31GTYA', 0, 65.18, 0, 1, 0.65, '-sharp-mx-31gtya', 'TSMX31GT-Y', 'http://tonersales,eu/shop/2151/-sharp-mx-31gtya,jpg', 0, '0', '<p>SHARP MX2301 , MX2600 , MX3100</p>', '<p>15000     5%     : SHARP MX2301 , MX2600 , MX3100</p>'),
	(1135, '1', ' HP 363 BK C8719EE', 0, 2.17, 0, 102, 0.2, '-hp-363-bk-c8719ee', 'TS1HP 363BK', 'http://tonersales,eu/shop/1682/-hp-363-bk-c8719ee,jpg', 0, '0', '<p>Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>', '<p>30 ml     : Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>'),
	(1136, '1', ' HP 363 C C8771EE', 0, 2.17, 0, 102, 0.2, '-hp-363-c-c8771ee', 'TS1HP 363C', 'http://tonersales,eu/shop/1686/-hp-363-c-c8771ee,jpg', 0, '0', '<p>Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>', '<p>10 ml     : Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>'),
	(1137, '1', ' HP 363 M C8772EE', 0, 2.17, 0, 103, 0.2, '-hp-363-m-c8772ee', 'TS1HP 363M', 'http://tonersales,eu/shop/1685/-hp-363-m-c8772ee,jpg', 0, '0', '<p>Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>', '<p>10 ml     : Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>'),
	(1138, '1', ' HP 363 Y C8773EE', 0, 2.17, 0, 102, 0.2, '-hp-363-y-c8773ee', 'TS1HP 363Y', 'http://tonersales,eu/shop/1683/-hp-363-y-c8773ee,jpg', 0, '0', '<p>Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>', '<p>10 ml     : Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>'),
	(1139, '1', ' HP 363 LC C8774EE', 0, 2.17, 0, 102, 0.2, '-hp-363-lc-c8774ee', 'TS1HP 363LC', 'http://tonersales,eu/shop/1681/-hp-363-lc-c8774ee,jpg', 0, '0', '<p>Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>', '<p>10 ml     : Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>'),
	(1140, '1', ' HP 363 LM C8775EE', 0, 2.17, 0, 102, 0.2, '-hp-363-lm-c8775ee', 'TS1HP 363LM', 'http://tonersales,eu/shop/1684/-hp-363-lm-c8775ee,jpg', 0, '0', '<p>Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>', '<p>10 ml     : Photosmart 3110 , 3210 , 3310 , D6160 , D7160 , D7260 , D7360 , D7460 , C5180 , C6180 , C6270 , C6285 , C7180 , C6280 , C7280 , C8180 , 8250</p>'),
	(1141, '1', ' HP 88 BK C9396AE', 0, 2.73, 0, 104, 0.2, '-hp-88-bk-c9396ae', 'TS1HP 88BK', 'http://tonersales,eu/shop/1690/-hp-88-bk-c9396ae,jpg', 0, '0', '<p>HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>', '<p>60 ml     : HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>'),
	(1142, '1', ' HP 88 C C9391AE', 0, 2.73, 0, 106, 0.2, '-hp-88-c-c9391ae', 'TS1HP 88C', 'http://tonersales,eu/shop/1689/-hp-88-c-c9391ae,jpg', 0, '0', '<p>HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>', '<p>18 ml     : HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>'),
	(1143, '1', ' HP 88 M C9392AE', 0, 2.73, 0, 101, 0.2, '-hp-88-m-c9392ae', 'TS1HP 88M', 'http://tonersales,eu/shop/1687/-hp-88-m-c9392ae,jpg', 0, '0', '<p>HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>', '<p>18 ml     : HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>'),
	(1144, '1', ' HP 88 Y C9393AE', 0, 2.73, 0, 101, 0.2, '-hp-88-y-c9393ae', 'TS1HP 88Y', 'http://tonersales,eu/shop/1688/-hp-88-y-c9393ae,jpg', 0, '0', '<p>HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>', '<p>18 ml     : HP Officejet Pro K550 , K5400 , K8600 , L7480 , L7580 , L7590 , L7680 , L7780</p>'),
	(1145, '1', ' HP 82 BK CH565A', 0, 8.11, 0, 99, 0.2, '#NAME?', 'TSB40194', 'http://tonersales,eu/shop/409/-hp-82-bk-ch565a,jpg', 0, '0', '<p>Hp Designjet 510 Printer series</p>', '<p>69 ml     : Hp Designjet 510 Printer series</p>'),
	(1146, '1', ' HP 11 C C4836AE', 0, 5.98, 0, 101, 0.2, '-hp-11-c-c4836ae', 'TS1HP 11C', 'http://tonersales,eu/shop/410/-hp-11-c-c4836ae,jpg', 0, '0', '<p>Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series Officejet Pro K850series Designjet 10ps , 20ps , 50ps , DesignJet 111 , 110nr</p>', '<p>28 ml     : Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series Officejet Pro K850series Designjet 10ps , 20ps , 50ps , DesignJet 111 , 110nr</p>'),
	(1147, '1', ' HP 11 M C4837AE', 0, 5.98, 0, 101, 0.2, '-hp-11-m-c4837ae', 'TS1HP 11M', 'http://tonersales,eu/shop/411/-hp-11-m-c4837ae,jpg', 0, '0', '<p>Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series Officejet Pro K850series Designjet 10ps , 20ps , 50ps , DesignJet 111 , 110nr</p>', '<p>28 ml     : Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series Officejet Pro K850series Designjet 10ps , 20ps , 50ps , DesignJet 111 , 110nr</p>'),
	(1148, '1', ' HP 11 Y C4838AE', 0, 5.98, 0, 102, 0.2, '-hp-11-y-c4838ae', 'TS1HP 11Y', 'http://tonersales,eu/shop/412/-hp-11-y-c4838ae,jpg', 0, '0', '<p>Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series Officejet Pro K850series Designjet 10ps , 20ps , 50ps , DesignJet 111 , 110nr</p>', '<p>28 ml     : Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series Officejet Pro K850series Designjet 10ps , 20ps , 50ps , DesignJet 111 , 110nr</p>'),
	(1149, '1', ' HP NO 364XL CY CB323E', 0, 3.37, 0, 110, 0.2, 'hp-no-364xl-cy-cb323e', 'TSHP NO 364XLCY', 'http://tonersales,eu/shop/1692/hp-no-364xl-cy-cb323e,jpg', 0, '0', '<p>HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>', '<p>12 ml     : HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>'),
	(1150, '1', ' HP NO 364XL MG CB324E', 0, 3.37, 0, 110, 0.2, 'hp-no-364xl-mg-cb324e', 'TSHP NO 364XLMG', 'http://tonersales,eu/shop/1693/hp-no-364xl-mg-cb324e,jpg', 0, '0', '<p>HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>', '<p>12 ml     : HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>'),
	(1151, '1', ' HP NO 364XL YL CB325E', 0, 3.37, 0, 111, 0.2, 'hp-no-364xl-yl-cb325e', 'TSHP NO 364XLYL', 'http://tonersales,eu/shop/1691/hp-no-364xl-yl-cb325e,jpg', 0, '0', '<p>HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>', '<p>12 ml     : HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>'),
	(1153, '1', ' HP 10 BK C4844AE', 0, 12.85, 0, 1, 0.2, '-hp-10-bk-c4844ae', 'TS1HP 10BK', 'http://tonersales,eu/shop/418/-hp-10-bk-c4844ae,jpg', 0, '0', '<p>2000c , cn Color Printer series , 2500c , cm printer series Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series , 3000series Officejet Pro K850series 2250tn , 2600 , 2600dn , 3000 , 3000dtn , 3000n , 1100 , 1100d , 1200 , 1200d Designjet colorpro cad , ga , 500 , 500PS , 800 , 800ps Designjet copier cc800ps Business inkjet 2800 Designjet 70 , 815MFP , 110nr Officejet 9100 , 9110 , 9120 , 9130</p>', '<p>69 ml     : 2000c , cn Color Printer series , 2500c , cm printer series Color Inkjet CP1700series Officejet 9110 , 9120 , 9130 Business Inkjet 2600series , 1000series , 1100series , 1200series , 2200se ries , 2300series , 2800series , 3000series Officejet Pro K850series 2250tn , 2600 , 2600dn , 3000 , 3000dtn , 3000n , 1100 , 1100d , 1200 , 1200d Designjet colorpro cad , ga , 500 , 500PS , 800 , 800ps Designjet copier cc800ps Business inkjet 2800 Designjet 70 , 815MFP , 110nr Officejet 9100 , 9110 , 9120 , 9130</p>'),
	(1154, '1', ' HP NO 920XL CYAN', 0, 3.71, 0, 108, 0.2, '-hp-no-920xl-cyan', 'TS1HP NO 920XL cy', 'http://tonersales,eu/shop/1695/-hp-no-920xl-cyan,jpg', 0, '0', '<p>Officejet 6000 , 6500 , 7000 , 7500A</p>', '<p>12 ml     : Officejet 6000 , 6500 , 7000 , 7500A</p>'),
	(1155, '1', ' HP NO 920XL YELLOW', 0, 3.71, 0, 114, 0.2, '-hp-no-920xl-yellow', 'TS1HP NO 920XL yl', 'http://tonersales,eu/shop/1701/-hp-no-920xl-yellow,jpg', 0, '0', '<p>Officejet 6000 , 6500 , 7000 , 7500A</p>', '<p>12 ml     : Officejet 6000 , 6500 , 7000 , 7500A</p>'),
	(1156, '1', ' HP NO 920XL MAGENTA', 0, 3.71, 0, 108, 0.2, '-hp-no-920xl-magenta', 'TS1HP NO 920XL mg', 'http://tonersales,eu/shop/1699/-hp-no-920xl-magenta,jpg', 0, '0', '<p>Officejet 6000 , 6500 , 7000 , 7500A</p>', '<p>12 ml     : Officejet 6000 , 6500 , 7000 , 7500A</p>'),
	(1157, '1', ' HP NO 920XL BLACK', 0, 4.54, 0, 116, 0.2, '-hp-no-920xl-black', 'TS1HP NO 920XL', 'http://tonersales,eu/shop/1698/-hp-no-920xl-black,jpg', 0, '0', '<p>Officejet 6000 , 6500 , 7000 , 7500A</p>', '<p>49 ml     : Officejet 6000 , 6500 , 7000 , 7500A</p>'),
	(1158, '1', ' HP NO 940XL CYAN C4907A', 0, 4.58, 0, 101, 0.2, '-hp-no-940xl-cyan-c4907a', 'TS940XLCY', 'http://tonersales,eu/shop/1702/-hp-no-940xl-cyan-c4907a,jpg', 0, '0', '<p>Officejet Pro8000 , Pro8500series</p>', '<p>16 ml     : Officejet Pro8000 , Pro8500series</p>'),
	(1159, '1', ' HP NO 940XL MAGENTA C4908A', 0, 4.58, 0, 102, 0.2, '-hp-no-940xl-magenta-c4908a', 'TS940XLMG', 'http://tonersales,eu/shop/419/-hp-no-940xl-magenta-c4908a,jpg', 0, '0', '<p>Officejet Pro8000 , Pro8500series</p>', '<p>16 ml     : Officejet Pro8000 , Pro8500series</p>'),
	(1160, '1', ' HP NO 940XL YELLOW C4909A', 0, 4.58, 0, 102, 0.2, '-hp-no-940xl-yellow-c4909a', 'TS940XLYL', 'http://tonersales,eu/shop/1703/-hp-no-940xl-yellow-c4909a,jpg', 0, '0', '<p>Officejet Pro8000 , Pro8500series</p>', '<p>16 ml     : Officejet Pro8000 , Pro8500series</p>'),
	(1161, '1', ' HP NO 940XL BLACK C4906A', 0, 4.75, 0, 101, 0.2, '-hp-no-940xl-black-c4906a', 'TS940XLBK', 'http://tonersales,eu/shop/1704/-hp-no-940xl-black-c4906a,jpg', 0, '0', '<p>Officejet Pro8000 , Pro8500series</p>', '<p>43 ml     : Officejet Pro8000 , Pro8500series</p>'),
	(1162, '1', ' HP 82 CY C4911A', 0, 8.11, 0, 99, 0.2, 'hp-82-cy-c4911a', 'TSIFH039C**J', 'http://tonersales,eu/shop/422/hp-82-cy-c4911a,jpg', 0, '0', '<p>HP DesignJet 500 , 500ps , 815mfp , 820mfp Printer series , 510 DesignJet copier cc800 , 800ps</p>', '<p>69 ml     : HP DesignJet 500 , 500ps , 815mfp , 820mfp Printer series , 510 DesignJet copier cc800 , 800ps</p>'),
	(1163, '1', ' HP 82 MG C4912A', 0, 8.11, 0, 100, 0.2, 'hp-82-mg-c4912a', 'TSIFH040M**J', 'http://tonersales,eu/shop/423/hp-82-mg-c4912a,jpg', 0, '0', '<p>HP DesignJet 500 , 500ps , 815mfp , 820mfp Printer series , 510 DesignJet copier cc800 , 800ps</p>', '<p>69 ml     : HP DesignJet 500 , 500ps , 815mfp , 820mfp Printer series , 510 DesignJet copier cc800 , 800ps</p>'),
	(1164, '1', ' HP 82 YL C4913A', 0, 8.11, 0, 100, 0.2, 'hp-82-yl-c4913a', 'TSIFH041Y**J', 'http://tonersales,eu/shop/424/hp-82-yl-c4913a,jpg', 0, '0', '<p>HP DesignJet 500 , 500ps , 815mfp , 820mfp Printer series , 510 DesignJet copier cc800 , 800ps</p>', '<p>69 ml     : HP DesignJet 500 , 500ps , 815mfp , 820mfp Printer series , 510 DesignJet copier cc800 , 800ps</p>'),
	(1165, '1', ' HP 655XL CYAN', 0, 5.27, 0, 121, 0.2, '-hp-655xl-cyan', 'TSIFH587C**J', 'http://tonersales,eu/shop/1707/-hp-655xl-cyan,jpg', 0, '0', '<p><span>HP Deskjet 3525 , 4615 , 4625 , 5525 , 6525</span></p>', '<p>18ml     :<span>HP Deskjet 3525 , 4615 , 4625 , 5525 , 6525</span></p>'),
	(1166, '1', ' HP 655XL MAGENTA', 0, 5.27, 0, 120, 0.2, '-hp-655xl-magenta', 'TSIFH588M**J', 'http://tonersales,eu/shop/1705/-hp-655xl-magenta,jpg', 0, '0', '<p><span>HP Deskjet 3525 , 4615 , 4625 , 5525 , 6525</span></p>', '<p>18ml     :<span>HP Deskjet 3525 , 4615 , 4625 , 5525 , 6525</span></p>'),
	(1167, '1', ' HP 655XL YELLOW', 0, 5.27, 0, 120, 0.2, '0', 'TSIFH589Y**J', '0', 0, '0', '<div id="short_description_block">', '0'),
	(1168, '1', ' HP 655XL BLACK', 0, 5.44, 0, 120, 0.2, '-hp-655xl-black', 'TSIFH586B**J', 'http://tonersales,eu/shop/1710/-hp-655xl-black,jpg', 0, '0', '<p>HP Deskjet 3525 , 4615 , 4625 , 5525 , 6525</p>', '<p>30ml     :HP Deskjet 3525 , 4615 , 4625 , 5525 , 6525</p>'),
	(1169, '1', ' HP NO 933XL CYAN CN054AE', 0, 5.3, 0, 105, 0.2, '-hp-no-933xl-cyan-cn054ae', 'TS109331', 'http://tonersales,eu/shop/1711/-hp-no-933xl-cyan-cn054ae,jpg', 0, '0', '<p>HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>', '<p>16 ml     : HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>'),
	(1170, '1', ' HP NO 933XL MAGENTA CN055A', 0, 5.3, 0, 105, 0.2, '-hp-no-933xl-magenta-cn055a', 'TS109332', 'http://tonersales,eu/shop/1709/-hp-no-933xl-magenta-cn055a,jpg', 0, '0', '<p>HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>', '<p>16ml     : HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>'),
	(1171, '1', ' HP NO 933XL YELLOW CN056A', 0, 5.3, 0, 105, 0.2, '-hp-no-933xl-yellow-cn056a', 'TS109333', 'http://tonersales,eu/shop/1708/-hp-no-933xl-yellow-cn056a,jpg', 0, '0', '<p>HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>', '<p>16 ml     : HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>'),
	(1172, '1', ' HP NO 364XL BK CN684E', 0, 5.58, 0, 110, 0.2, 'hp-no-364xl-bk-cn684e', 'TSHP NO 364XLBK', 'http://tonersales,eu/shop/1694/hp-no-364xl-bk-cn684e,jpg', 0, '0', '<p>HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>', '<p>18 ml     : HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</p>'),
	(1173, '1', ' HP NO 932XL BK CN053A', 0, 5.5, 0, 115, 0.2, '-hp-no-932xl-bk-cn053a', 'TS109320', 'http://tonersales,eu/shop/1715/-hp-no-932xl-bk-cn053a,jpg', 0, '0', '<p>HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>', '<p>32ml     : HP Officejet 6100 , 6600 , 6700 , 7110 , 7612</p>'),
	(1174, '1', ' HP NO 951XL CYAN CN046A', 0, 7.5, 0, 112, 0.2, '-hp-no-951xl-cyan-cn046a', 'TS109511', 'http://tonersales,eu/shop/1714/-hp-no-951xl-cyan-cn046a,jpg', 0, '0', '<p>HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>', '<p>28 ml     : HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>'),
	(1175, '1', ' HP NO 951XL MAGENTA CN047A', 0, 7.5, 0, 114, 0.2, '-hp-no-951xl-magenta-cn047a', 'TS109512', 'http://tonersales,eu/shop/1713/-hp-no-951xl-magenta-cn047a,jpg', 0, '0', '<p>HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>', '<p>28 ml     : HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>'),
	(1176, '1', ' HP NO 951XL YELLOW CN048A', 0, 7.5, 0, 113, 0.2, '-hp-no-951xl-yellow-cn048a', 'TS109513', 'http://tonersales,eu/shop/1712/-hp-no-951xl-yellow-cn048a,jpg', 0, '0', '<p>HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>', '<p>28 ml     : HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>'),
	(1177, '1', ' HP NO 950XL BK CN045A', 0, 7.9, 0, 108, 0.2, '-hp-no-950xl-bk-cn045a', 'TS109500', 'http://tonersales,eu/shop/1542/-hp-no-950xl-bk-cn045a,jpg', 0, '0', '<p>HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>', '<p>75ml     : HP Officejet Pro 251dw , Pro 276DW , Pro 8100 , PRO 8600 , Pro 8620 , Pro 8610</p>'),
	(1178, '1', ' HP NO 935XL CYAN C2P24AE', 0, 8.9, 0, 105, 0.2, '-hp-no-935xl-cyan-c2p24ae', 'TSB45169', 'http://tonersales,eu/shop/1716/-hp-no-935xl-cyan-c2p24ae,jpg', 0, '0', '<p>OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>', '<p>18 ml     : OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>'),
	(1179, '1', ' HP NO 935XL MAGENTA C2P25AE', 0, 8.9, 0, 105, 0.2, '-hp-no-935xl-magenta-c2p25ae', 'TSB45170', 'http://tonersales,eu/shop/1718/-hp-no-935xl-magenta-c2p25ae,jpg', 0, '0', '<p>OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>', '<p>18 ml     : OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>'),
	(1180, '1', ' HP NO 935XL YELLOW C2P26AE', 0, 8.9, 0, 105, 0.2, '-hp-no-935xl-yellow-c2p26ae', 'TSB45171', 'http://tonersales,eu/shop/1717/-hp-no-935xl-yellow-c2p26ae,jpg', 0, '0', '<p>OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>', '<p>18 ml     : OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>'),
	(1181, '1', ' HP 21XL BLACK', 0, 8.63, 0, 106, 0.2, '0', 'TS1HP NO 21', '0', 0, '0', '<p><span>Deskjet D 1311, D 1320, D 1330, D 1338, D 1341, D 1360, D 1368, D 2320, D 2330, D 2430, D 2445, D 2450, D 2460, D 2468, F 2100 Series, F 2110, F 310, F 325, F 335, F 340, F 350, F 370, F 375, F 378, F 380, F 385, F 388, F 390, F 394, F 4100 Series, F4135, F 4140, F 4150, F 4172, F 4175, F 4180, F 4185, F 4188, F 4190, F 4194, 3910, 3920, 3930, 3940, 3950, D 1300 Series, D 2338, D 2345, D 2360, F 2120, F2128, F 2140, F 2180, F 2185, F 2187, F 2188, F300, 3920 V, D 2300, F 2235, D 1568, 3938, D1500 Series, D2340, 3930 V, PSC 1401, 1402, 1403, 1406, 1408, 1410, 1410 V, 1410 XI, 1415, 1417, 1400 Series, Fax 1250, 1250 XI, 3180, OFFICEJET 4311, 4312, 4314, 4315, 4315 V, 4315 XI, 4317, 4319, 4352, 4353, 4355, 4357, 4359, 1410, 1410 XI, 4300 Series, 1400 Series, 4700 Series</span></p>', '0'),
	(1182, '1', ' HP NO 27 C8727', 0, 8.63, 0, 101, 0.2, '#NAME?', 'TS1HP NO 27', 'http://tonersales,eu/shop/1550/-hp-no-27-c8727,jpg', 0, '0', '<p>Deskjet 3320 , 3325 , 3420 , 3425series , 3520 , 3535 , 3550 , 3745 , 3645 , 3647 , 3650 , 3845 , 5650 , 5652 , 5655 , 5850 Officejet 4212 , 4215 , 4219 , 4252 , 4255 , 4315 , 4355 , 5600 , 5605 , 5607 , 5610 , 5615 , 6110 PSC 1210 , 1213 , 1215 , 1217 , 1219 , 1311 , 1312 , 1315 , 1315s , 1317</p>', '<p>220,14 ml     : Deskjet 3320 , 3325 , 3420 , 3425series , 3520 , 3535 , 3550 , 3745 , 3645 , 3647 , 3650 , 3845 , 5650 , 5652 , 5655 , 5850 Officejet 4212 , 4215 , 4219 , 4252 , 4255 , 4315 , 4355 , 5600 , 5605 , 5607 , 5610 , 5615 , 6110 PSC 1210 , 1213 , 1215 , 1217 , 1219 , 1311 , 1312 , 1315 , 1315s , 1317</p>'),
	(1183, '1', ' HP NO 56 C6656A', 0, 8.63, 0, 103, 0.2, '-hp-no-56-c6656a', 'TS1HP NO 56', 'http://tonersales,eu/shop/1720/-hp-no-56-c6656a,jpg', 0, '0', '<p>Deskjet 450ci , 450cbi , 450wbt , 5145 , 5150 , 5151 , 5550 , 5552 , 5650 , 5652 , 5655 , 5850 , 9650 , 9670 , 9680 , 9680gp Digital Copier 410 Officejet 4105 , 4110 , 4212 , 4215 , 4219 , 4252 , 4255 , 5505 , 5510 , 5515 , 5600 , 5605 , 5607 , 5610 , 5615 , 6110 PSC 1110 , 1200 , 1205 , 1210 , 1213 , 1215 , 1217 , 1219 , 1310 , 1311 , 1312 , 1315 , 1315s , 1317 , 1340 , 1350 , 1355 , 2105 , 2108 , 2110 , 2115 , 2171 , 2175 , 2179 , 2210 , 2410 , 2510 Photosmart 7150 , 7260 , 7345 , 7350 , 7450 , 7459 , 7550 , 7655 , 7660 , 7755 , 7760 , 7762 , 7960 , 7960gp</p>', '<p>416,19,2 ml     : Deskjet 450ci , 450cbi , 450wbt , 5145 , 5150 , 5151 , 5550 , 5552 , 5650 , 5652 , 5655 , 5850 , 9650 , 9670 , 9680 , 9680gp Digital Copier 410 Officejet 4105 , 4110 , 4212 , 4215 , 4219 , 4252 , 4255 , 5505 , 5510 , 5515 , 5600 , 5605 , 5607 , 5610 , 5615 , 6110 PSC 1110 , 1200 , 1205 , 1210 , 1213 , 1215 , 1217 , 1219 , 1310 , 1311 , 1312 , 1315 , 1315s , 1317 , 1340 , 1350 , 1355 , 2105 , 2108 , 2110 , 2115 , 2171 , 2175 , 2179 , 2210 , 2410 , 2510 Photosmart 7150 , 7260 , 7345 , 7350 , 7450 , 7459 , 7550 , 7655 , 7660 , 7755 , 7760 , 7762 , 7960 , 7960gp</p>'),
	(1185, '1', ' HP NO 45 51645', 0, 23.3, 0, 104, 0.2, '#NAME?', 'TS1HP NO 45', 'http://tonersales,eu/shop/445/-hp-no-45-51645,jpg', 0, '0', '<p>Deskjet 710c , 712c , 720c , 722c , 815c , 820c , 820cXi , 850c , 870cXi , 880c , 890c , 895cXi , 930c , cm , 950c , 959c , 960c , 970cXi , 980cXi , 990cXi , 995c , 1100c , 1120c , 1125c , 1180c , 1220c , 1220c , ps , 1280 , 1600c , cm , 6122 , 6127 , 9300 Color Copier 290 Officejet t45 , t65 , r45 , r65 , g55 , g85 , g95 , k60 , k80 Fax 1220 Officejet Pro 1150c , 1170c , 1175c Photosmart 1000 , 1100 , 1115 , 1215 , 1218 , 1315 Designjet 700 Printer series , 750c , plus , 755cm Printer series</p>', '<p>50ml     : HPDeskjet 710c , 712c , 720c , 722c , 815c , 820c , 820cXi , 850c , 870cXi , 880c , 890c , 895cXi , 930c , cm , 950c , 959c , 960c , 970cXi , 980cXi , 990cXi , 995c , 1100c , 1120c , 1125c , 1180c , 1220c , 1220c , ps , 1280 , 1600c , cm , 6122 , 6127 , 9300 Color Copier 290 Officejet t45 , t65 , r45 , r65 , g55 , g85 , g95 , k60 , k80 Fax 1220 Officejet Pro 1150c , 1170c , 1175c Photosmart 1000 , 1100 , 1115 , 1215 , 1218 , 1315 Designjet 700 Printer series , 750c , plus , 755cm Printer series</p>'),
	(1186, '1', ' HP NO 934XL BLACK C2P23AE', 0, 11.5, 0, 105, 0.2, '-hp-no-934xl-black-c2p23ae', 'TSB45168', 'http://tonersales,eu/shop/109/-hp-no-934xl-black-c2p23ae,jpg', 0, '0', '<p>OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>', '<p>55 ml     : OfficeJet Pro 6230 , 6830 e-ALL-in-One , 6815 e-AiO Printer , 6812 e-AiO Printer , 6835 e-AiO Printer</p>'),
	(1187, '1', ' HP NO 901XL BLACK CC654AE', 0, 12.59, 0, 115, 0.2, '-hp-no-901xl-black-cc654ae', 'TS1HP NO 901xlBLACK', 'http://tonersales,eu/shop/446/-hp-no-901xl-black-cc654ae,jpg', 0, '0', '<p>Officejet 4500 , G510 , a , g , n , J4524 , J4535 , J4580 , J4624 , J4660 , J4680</p>', '<p>18 ml     : Officejet 4500 , G510 , a , g , n , J4524 , J4535 , J4580 , J4624 , J4660 , J4680</p>'),
	(1188, '1', ' HP NO 300XL BLACK (CC641EE)', 0, 11.5, 0, 112, 0.2, '-hp-no-300xl-black-cc641ee', 'TS1HP NO 300xl black', 'http://tonersales,eu/shop/1721/-hp-no-300xl-black-cc641ee,jpg', 0, '0', '<p>Deskjet D1660 , D2560 , D2660 , D5560 , F4224 , F2420 , F2480 , F2492 , F4200 , F4210 , F4272 , F4280 , f4283 , F4580 Photosmart C4670 , C4680 , C4685 , C4780 ENVY 114 e-All-in-One Printer , 110 e-All-in-One</p>', '<p>18 ml     : Deskjet D1660 , D2560 , D2660 , D5560 , F4224 , F2420 , F2480 , F2492 , F4200 , F4210 , F4272 , F4280 , f4283 , F4580 Photosmart C4670 , C4680 , C4685 , C4780 ENVY 114 e-All-in-One Printer , 110 e-All-in-One</p>'),
	(1189, '1', ' HP 336XL BLACK', 0, 11.91, 0, 105, 0.2, '0', 'TS1HP NO 336', '0', 0, '0', '<p><span>Officejet 6307, 6308, 6310, 6315, 6318, 6301, 6304, 6305, Deskjet 5440, 5440XI, 5442, 5443, D4145, 5420, 5420V, D4155, D4160, D4163, D4168, D4180, Photosmart C3173, C3175, C3180, C3183, C3188, C3190, C3193, 7838, 7850, 7853, C3100, C3110, C3125, C3135, C3140, C3150, C3170, C3194, 2575, 2710, 7800, 7830, 7850 v, 7850 xi,</span>PSC 1500, 1503, 1504, 1513s, 1514, 1507, 1508, 1510, 1510s, 1510xi</p>', '0'),
	(1190, '1', ' HP NO 338 C8765EE', 0, 12.38, 0, 1, 0.2, '-hp-no-338-c8765ee', 'TS1HP NO 338', 'http://tonersales,eu/shop/449/-hp-no-338-c8765ee,jpg', 0, '0', '<p>Deskjet 460c , 5740 , 5745 , 6520 , 6540 , 6540d , 6620 , 6840 , 9800 , 9800d Officejet H470 , 6205 , 6210 , 6215 , K7100 , 7210 , 7310 , 7410 , Officejet 100 Mobile , Officejet 150 Mobile , PSC 1507 , 1510 , 1510s , 1600 , 1610 , 1613 , 2350 , 2355 , 2355p Photosmart 2570 , 2575 , 2610 , 2710 , C3170 , C3180 , C3175 , C3190 , 7850 , 8150 , 8450 , 8450gp , 8750 , 8750gp Photosmart Pro B8350</p>', '<p>290,13 ml     : Deskjet 460c , 5740 , 5745 , 6520 , 6540 , 6540d , 6620 , 6840 , 9800 , 9800d Officejet H470 , 6205 , 6210 , 6215 , K7100 , 7210 , 7310 , 7410 , Officejet 100 Mobile , Officejet 150 Mobile , PSC 1507 , 1510 , 1510s , 1600 , 1610 , 1613 , 2350 , 2355 , 2355p Photosmart 2570 , 2575 , 2610 , 2710 , C3170 , C3180 , C3175 , C3190 , 7850 , 8150 , 8450 , 8450gp , 8750 , 8750gp Photosmart Pro B8350</p>'),
	(1191, '1', ' HP NO 650 BLACK CZ101AE JUMBO', 0, 12.78, 0, 101, 0.2, '#NAME?', 'TSHC-J650B', 'http://tonersales,eu/shop/1722/-hp-no-650-black-cz101ae-jumbo,jpg', 0, '0', '<p>Deskjet Ink Advantage 2515, 3515</p>', '<p>360 ,     :Deskjet Ink Advantage 2515, 3515</p>'),
	(1192, '1', ' HP NO 901XL COLOUR CC656AE', 0, 13.74, 0, 113, 0.2, '-hp-no-901xl-colour-cc656ae', 'TS1HP NO 901xlCOLOUR', 'http://tonersales,eu/shop/451/-hp-no-901xl-colour-cc656ae,jpg', 0, '0', '<p>Officejet 4500 , G510 , a , g , n , J4524 , J4535 , J4580 , J4624 , J4660 , J4680</p>', '<p>21 ml     : Officejet 4500 , G510 , a , g , n , J4524 , J4535 , J4580 , J4624 , J4660 , J4680</p>'),
	(1193, '1', ' HP NO 300XL COLOUR (CC644EE)', 0, 13.9, 0, 112, 0.2, '-hp-no-300xl-colour-cc644ee', 'TS1HP NO 300xl colour', 'http://tonersales,eu/shop/452/-hp-no-300xl-colour-cc644ee,jpg', 0, '0', '<p>Deskjet D1660 , D2560 , D2660 , D5560 , F4224 , F2420 , F2480 , F2492 , F4200 , F4210 , F4272 , F4280 , f4283 , F4580 Photosmart C4670 , C4680 , C4685 , C4780 ENVY 114 e-All-in-One Printer , 110 e-All-in-One</p>', '<p>21 ml     : Deskjet D1660 , D2560 , D2660 , D5560 , F4224 , F2420 , F2480 , F2492 , F4200 , F4210 , F4272 , F4280 , f4283 , F4580 Photosmart C4670 , C4680 , C4685 , C4780 ENVY 114 e-All-in-One Printer , 110 e-All-in-One</p>'),
	(1194, '1', ' HP NO 711XL BLACK (CZ133A)', 0, 13.21, 0, 105, 0.2, '-hp-no-711xl-black-cz133a', 'TSIFH639B**J', 'http://tonersales,eu/shop/1725/-hp-no-711xl-black-cz133a,jpg', 0, '0', '<p>HPDesignjetT120 , T520</p>', '<p>75 ml     : HPDesignjetT120 , T520</p>'),
	(1195, '1', ' HP NO 711XL CYAN (CZ130A)', 0, 13.21, 0, 105, 0.2, '-hp-no-711xl-cyan-cz130a', 'TSIFH640C**J', 'http://tonersales,eu/shop/1727/-hp-no-711xl-cyan-cz130a,jpg', 0, '0', '<p>HPDesignjetT120 , T520</p>', '<p>28ml     : HPDesignjetT120 , T520</p>'),
	(1196, '1', ' HP NO 711XL MAGENTA (CZ131A)', 0, 13.21, 0, 105, 0.2, '-hp-no-711xl-magenta-cz131a', 'TSIFH641M**J', 'http://tonersales,eu/shop/1723/-hp-no-711xl-magenta-cz131a,jpg', 0, '0', '<p>HPDesignjetT120 , T520</p>', '<p>28ml     : HPDesignjetT120 , T520</p>'),
	(1197, '1', ' HP NO 711XL YELLOW (CZ132A)', 0, 13.21, 0, 105, 0.2, '-hp-no-711xl-yellow-cz132a', 'TSIFH642Y**J', 'http://tonersales,eu/shop/1726/-hp-no-711xl-yellow-cz132a,jpg', 0, '0', '<p>HPDesignjetT120 , T520</p>', '<p>28ml     : HPDesignjetT120 , T520</p>'),
	(1198, '1', ' HP 22XL COLOUR', 0, 15.43, 0, 107, 0.2, '-hp-22xl-colour', 'TS1HP NO 22', 'http://tonersales,eu/shop/1728/-hp-22xl-colour,jpg', 0, '0', '<p><span>Deskjet D 1311, D 1320, D 1330, D 1338, D 1341, D 1360, D 1368, D 2320, D 2330, D 2430, D 2445, D 2450, D 2460, D 2468, F 2100 Series, F 2110, F 310, F 325, F 335, F 340, F 350, F 370, F 375, F 378, F 380, F 385, F 388, F 390, F 394, F 4100 Series, F4135, F 4140, F 4150, F 4172, F 4175, F 4180, F 4185, F 4188, F 4190, F 4194, 3910, 3920, 3930, 3940, 3950, D 1300 Series, D 2338, D 2345, D 2360, F 2120, F2128, F 2140, F 2180, F 2185, F 2187, F 2188, F300, 3920 V, D 2300, F 2235, D 1568, 3938, D1500 Series, D2340, 3930 V, PSC 1401, 1402, 1403, 1406, 1408, 1410, 1410 V, 1410 XI, 1415, 1417, 1400 Series, Fax 1250, 1250 XI, 3180, OFFICEJET 4311, 4312, 4314, 4315, 4315 V, 4315 XI, 4317, 4319, 4352, 4353, 4355, 4357, 4359, 1410, 1410 XI, 4300 Series, 1400 Series, 4700 Series</span></p>', '<p>20ml     :<span>HP Deskjet D 1311, D 1320, D 1330, D 1338, D 1341, D 1360, D 1368, D 2320, D 2330, D 2430, D 2445, D 2450, D 2460, D 2468, F 2100 Series, F 2110, F 310, F 325, F 335, F 340, F 350, F 370, F 375, F 378, F 380, F 385, F 388, F 390, F 394, F 4100 Series, F4135, F 4140, F 4150, F 4172, F 4175, F 4180, F 4185, F 4188, F 4190, F 4194, 3910, 3920, 3930, 3940, 3950, D 1300 Series, D 2338, D 2345, D 2360, F 2120, F2128, F 2140, F 2180, F 2185, F 2187, F 2188, F300, 3920 V, D 2300, F 2235, D 1568, 3938, D1500 Series, D2340, 3930 V,PSC 1401, 1402, 1403, 1406, 1408, 1410, 1410 V, 1410 XI, 1415, 1417, 1400 Series,Fax 1250, 1250 XI, 3180,OFFICEJET 4311, 4312, 4314, 4315, 4315 V, 4315 XI, 4317, 4319, 4352, 4353, 4355, 4357, 4359, 1410, 1410 XI, 4300 Series, 1400 Series, 4700 Series</span></p>'),
	(1199, '1', ' HP NO 28 C8728A', 0, 14.5, 0, 112, 0.2, '-hp-no-28-c8728a', 'TS1HP NO 28', 'http://tonersales,eu/shop/458/-hp-no-28-c8728a,jpg', 0, '0', '<p>Deskjet 3320 , 3325 , 3420 , 3425 series , 3520 , 3535 , 3550 , 3745 , 3645 , 3647 , 3650 , 3845 , 5650 , 5652 , 5655 , 5850 Officejet 4105 , 4110 , 4212 , 4215 , 4219 , 4252 , 4255 , 6110 PSC 1110 , 1200 , 1205 , 1210 , 1213 , 1215 , 1217 , 1219 , 1310 , 1311 , 1312 , 1315 , 1315s , 1317</p>', '<p>17 ml     : Deskjet 3320 , 3325 , 3420 , 3425 series , 3520 , 3535 , 3550 , 3745 , 3645 , 3647 , 3650 , 3845 , 5650 , 5652 , 5655 , 5850 Officejet 4105 , 4110 , 4212 , 4215 , 4219 , 4252 , 4255 , 6110 PSC 1110 , 1200 , 1205 , 1210 , 1213 , 1215 , 1217 , 1219 , 1310 , 1311 , 1312 , 1315 , 1315s , 1317</p>'),
	(1200, '1', ' HP NO 57 C6657A', 0, 13.32, 0, 111, 0.2, '-hp-no-57-c6657a', 'TS1HPNO 57', 'http://tonersales,eu/shop/459/-hp-no-57-c6657a,jpg', 0, '0', '<p>Deskjet 450ci , 450cbi , 450wbt , 5145 , 5150 , 5151 , 5550 , 5552 , 5650 , 5652 , 5655 , 5850 , 9650 , 9670 , 9680 , 9680gp , F4100 , F4140 , F4172 , F4180 , F4190 Digital Copier 410 Officejet 4105 , 4110 , 4212 , 4215 , 4219 , 4252 , 4255 , 5505 , 5510 , 5515 , 6110 PSC 1110 , 1200 , 1205 , 1210 , 1213 , 1215 , 1217 , 1219 , 1310 , 1311 , 1312 , 1315 , 1315s , 1317 , 1340 , 1350 , 1355 , 2105 , 2108 , 2110 , 2115 , 2171 , 2175 , 2179 , 2210 , 2410 , 2510 Photosmart 100 , 130 , 230 , 145 , 245 , 7150 , 7260 , 7345 , 7350 , 7450 , 7459 , 7550 , 7655 , 7660 , 7755 , 7760 , 7762 , 7960 , 7960gp</p>', '<p>260,15 ml     : Deskjet 450ci , 450cbi , 450wbt , 5145 , 5150 , 5151 , 5550 , 5552 , 5650 , 5652 , 5655 , 5850 , 9650 , 9670 , 9680 , 9680gp , F4100 , F4140 , F4172 , F4180 , F4190 Digital Copier 410 Officejet 4105 , 4110 , 4212 , 4215 , 4219 , 4252 , 4255 , 5505 , 5510 , 5515 , 6110 PSC 1110 , 1200 , 1205 , 1210 , 1213 , 1215 , 1217 , 1219 , 1310 , 1311 , 1312 , 1315 , 1315s , 1317 , 1340 , 1350 , 1355 , 2105 , 2108 , 2110 , 2115 , 2171 , 2175 , 2179 , 2210 , 2410 , 2510 Photosmart 100 , 130 , 230 , 145 , 245 , 7150 , 7260 , 7345 , 7350 , 7450 , 7459 , 7550 , 7655 , 7660 , 7755 , 7760 , 7762 , 7960 , 7960gp</p>'),
	(1201, '1', ' HP NO 650 Tri-Color CZ102AE JUMBO', 0, 13.5, 0, 101, 0.2, '#NAME?', 'TSHC-J650C', 'http://tonersales,eu/shop/1729/-hp-no-650-tri-color-cz102ae-jumbo,jpg', 0, '0', '<p><span>Deskjet Ink Advantage 2515, 3515</span></p>', '<p>200 ,     :<span>Deskjet Ink Advantage 2515, 3515</span></p>'),
	(1202, '1', ' HP 337XL BLACK', 0, 14.24, 0, 106, 0.2, '-hp-337xl-black', 'TS1HP NO 337', 'http://tonersales,eu/shop/1730/-hp-337xl-black,jpg', 0, '0', '<p>DESKJET D4160, 5940, 5943, 5950, 6940, 6940DT, 6980, 6980DT, OFFICEJET 6300 Series, 6304, 6305, 6307, 6310, 6310XI, 6313, 6315, PHOTOSMART 2500 Series, 2570, 2575, 2575XI, 2578, C4100, C4110, C4140, C4150, C4170, C4175, C4180, C4183, C4188, C4190, C4193, C4194, D5060, D5065, D5100 Series, D5145, D5155, D5156, D5160</p>', '<p>20ml     : HP DESKJET D4160, 5940, 5943, 5950, 6940, 6940DT, 6980, 6980DT, OFFICEJET 6300 Series, 6304, 6305, 6307, 6310, 6310XI, 6313, 6315, PHOTOSMART 2500 Series, 2570, 2575, 2575XI, 2578, C4100, C4110, C4140, C4150, C4170, C4175, C4180, C4183, C4188, C4190, C4193, C4194, D5060, D5065, D5100 Series, D5145, D5155, D5156, D5160</p>'),
	(1203, '1', ' HP 342XL COLOUR', 0, 14.24, 0, 106, 0.2, '-hp-342xl-colour', 'TS1HP NO 342', 'http://tonersales,eu/shop/1731/-hp-342xl-colour,jpg', 0, '0', '<p><span>Officejet 6307, 6308, 6310, 6315, 6318, 6301, 6304, 6305, Deskjet 5440, 5440XI, 5442, 5443, D4145, 5420, 5420V, D4155, D4160, D4163, D4168, D4180, Photosmart C3173, C3175, C3180, C3183, C3188, C3190, C3193, 7838, 7850, 7853, C3100, C3110, C3125, C3135, C3140, C3150, C3170, C3194, 2575, 2710, 7800, 7830, 7850 v, 7850 xi,</span><span>PSC 1500, 1503, 1504, 1513s, 1514, 1507, 1508, 1510, 1510s, 1510xi</span></p>', '<p>21ml     : HP<span>Officejet 6307, 6308, 6310, 6315, 6318, 6301, 6304, 6305, Deskjet 5440, 5440XI, 5442, 5443, D4145, 5420, 5420V, D4155, D4160, D4163, D4168, D4180, Photosmart C3173, C3175, C3180, C3183, C3188, C3190, C3193, 7838, 7850, 7853, C3100, C3110, C3125, C3135, C3140, C3150, C3170, C3194, 2575, 2710, 7800, 7830, 7850 v, 7850 xi,</span><span>PSC 1500, 1503, 1504, 1513s, 1514, 1507, 1508, 1510, 1510s, 1510xi</span></p>'),
	(1204, '1', ' HP 339XL BLACK', 0, 15.18, 0, 157, 0.2, '-hp-339xl-black', 'TS1HP NO 339', 'http://tonersales,eu/shop/1732/-hp-339xl-black,jpg', 0, '0', '<p>Deskjet 5740 , 5745 , 5940 , 6450 , 6520 , 6540 , 6540d , 6620 , 6840 , 9800 , 9800d , 6940 , 6980 Officejet 6310 , 6315 , K7100 , 7210 , 7310 , 7410 Photosmart 2575 , 2610 , 2710 , D5160 , 8050 , 8150 , 8450 , 8450gp , 8750 , 8750gp Photosmart Pro B8350</p>', '<p>370,23ml     :Deskjet 5740 , 5745 , 5940 , 6450 , 6520 , 6540 , 6540d , 6620 , 6840 , 9800 , 9800d , 6940 , 6980 Officejet 6310 , 6315 , K7100 , 7210 , 7310 , 7410 Photosmart 2575 , 2610 , 2710 , D5160 , 8050 , 8150 , 8450 , 8450gp , 8750 , 8750gp Photosmart Pro B8350</p>'),
	(1205, '1', ' HP 343XL COLOUR', 0, 15.18, 0, 106, 0.2, '-hp-343xl-colour', 'TS1HP NO 343', 'http://tonersales,eu/shop/1733/-hp-343xl-colour,jpg', 0, '0', '<p><span>DESKJET D4160, 5940, 5943, 5950, 6940, 6940DT, 6980, 6980DT, OFFICEJET 6300 Series, 6304, 6305, 6307, 6310, 6310XI, 6313, 6315, PHOTOSMART 2500 Series, 2570, 2575, 2575XI, 2578, C4100, C4110, C4140, C4150, C4170, C4175, C4180, C4183, C4188, C4190, C4193, C4194, D5060, D5065, D5100 Series, D5145, D5155, D5156, D5160</span></p>', '<p>21ml     : HP<span>DESKJET D4160, 5940, 5943, 5950, 6940, 6940DT, 6980, 6980DT, OFFICEJET 6300 Series, 6304, 6305, 6307, 6310, 6310XI, 6313, 6315, PHOTOSMART 2500 Series, 2570, 2575, 2575XI, 2578, C4100, C4110, C4140, C4150, C4170, C4175, C4180, C4183, C4188, C4190, C4193, C4194, D5060, D5065, D5100 Series, D5145, D5155, D5156, D5160</span></p>'),
	(1206, '1', ' HP NO 344XL COLOUR', 0, 15.18, 0, 106, 0.2, '-hp-no-344xl-colour', 'TS1HP NO 344', 'http://tonersales,eu/shop/465/-hp-no-344xl-colour,jpg', 0, '0', '<p>Deskjet 460c , 5740 , 5745 , 5940 , 6520 , 6540 , 6540d , 6620 , 6840 , 9800 , 9800d , 6940 , 6980 , D4160 Officejet 6205 , 6210 , 6215 , K7100 , 7210 , 7310 , 7410 , Officejet 100 Mobile , Officejet 150 Mobile , PSC 1600 , 1610 , 1613 , 2350 , 2355 , 2355p Photosmart 325 , 335 , 375 , 385 , 422 , 428 , 475 , 2570 , 2575 , 2610 , 2710 , D5160 , 8050 , 8150 , 8450 , 8450gp , 8750 , 8750gp Photosmart Pro B8350</p>', '<p>185,14ml     : HP Deskjet 460c , 5740 , 5745 , 5940 , 6520 , 6540 , 6540d , 6620 , 6840 , 9800 , 9800d , 6940 , 6980 , D4160 Officejet 6205 , 6210 , 6215 , K7100 , 7210 , 7310 , 7410 , Officejet 100 Mobile , Officejet 150 Mobile , PSC 1600 , 1610 , 1613 , 2350 , 2355 , 2355p Photosmart 325 , 335 , 375 , 385 , 422 , 428 , 475 , 2570 , 2575 , 2610 , 2710 , D5160 , 8050 , 8150 , 8450 , 8450gp , 8750 , 8750gp Photosmart Pro B8350</p>'),
	(1207, '1', ' HP NO 301XL BLACK CH563EE', 0, 15.5, 0, 107, 0.2, '-hp-no-301xl-black-ch563ee', 'TS1HP NO 301XL bk', 'http://tonersales,eu/shop/1666/-hp-no-301xl-black-ch563ee,jpg', 0, '0', '<p>Deskjet 1000 J110 a , c , d , e , 1010 , 1012 , 1014 , 1050-J110d , 1050 J410a , b , c , e , 1050A J410a , g , h , f , 1051 , 1051A J410f , 1055 J410e , 1056 J410a , 1510 , 1512 , 1514 , 2000 J210b , c , 2050 J510a , b , c , d , e ,2050s , 2050A J510a , c , g , h , 2054A J510j , k , 2510 , 2512 , 2514 , 2540 , 2543 , 2544 , 2547 , 2548 , 2549 , 3000-J310a , 3050-J610a , b , c , d , e , f , 3050A J611a , b , c , e , f , g , 3052A J611e , g , 3054 J610a , 3054A J611c , d , 3055A J611n , 3057A J611n , 3059A J611n , 3510 Envy 4500 , 4502 , 4503 , 4504 , 4505 , 4507 , 4508 , 4520 , 5530 , 5534 , 5539 Officejet 2620 , 2622 , 2624 , 4630 , 4632 , 4635 , 4636 , 4639</p>', '<p>21 ml     : HP Deskjet 1000 J110 a , c , d , e , 1010 , 1012 , 1014 , 1050-J110d , 1050 J410a , b , c , e , 1050A J410a , g , h , f , 1051 , 1051A J410f , 1055 J410e , 1056 J410a , 1510 , 1512 , 1514 , 2000 J210b , c , 2050 J510a , b , c , d , e ,2050s , 2050A J510a , c , g , h , 2054A J510j , k , 2510 , 2512 , 2514 , 2540 , 2543 , 2544 , 2547 , 2548 , 2549 , 3000-J310a , 3050-J610a , b , c , d , e , f , 3050A J611a , b , c , e , f , g , 3052A J611e , g , 3054 J610a , 3054A J611c , d , 3055A J611n , 3057A J611n , 3059A J611n , 3510 Envy 4500 , 4502 , 4503 , 4504 , 4505 , 4507 , 4508 , 4520 , 5530 , 5534 , 5539 Officejet 2620 , 2622 , 2624 , 4630 , 4632 , 4635 , 4636 , 4639</p>'),
	(1208, '1', ' HP NO 350XL (CB336EE)', 0, 12.5, 0, 105, 0.2, '-hp-no-350xl-cb336ee', 'TS1HP NO 350xl', 'http://tonersales,eu/shop/1734/-hp-no-350xl-cb336ee,jpg', 0, '0', '<p>Deskjet D4260 , D4360 J5730 , J5780 , J5785 , J6410 , J6415 , J6424 Photosmart C4205 , C4270 , C4272 , C4280 , C4340 , C4380 , C4390C , 4472 , C4480 , C4485 , C4580 , C4585 , C4599 , C4424 , C4524 , C5280 , C5288 , D5360</p>', '<p>28ml     : Deskjet D4260 , D4360 J5730 , J5780 , J5785 , J6410 , J6415 , J6424 Photosmart C4205 , C4270 , C4272 , C4280 , C4340 , C4380 , C4390C , 4472 , C4480 , C4485 , C4580 , C4585 , C4599 , C4424 , C4524 , C5280 , C5288 , D5360</p>'),
	(1209, '1', ' HP NO 351XL (cb338EE)', 0, 15.5, 0, 107, 0.2, '-hp-no-351xl-cb338ee', 'TS1HP NO 351xl', 'http://tonersales,eu/shop/1735/-hp-no-351xl-cb338ee,jpg', 0, '0', '<p>Deskjet D4260 , D4360 J5730 , J5780 , J5785 , J6410 , J6415 , J6424 Photosmart C4205 , C4270 , C4272 , C4280 , C4340 , C4380 , C4390C , 4472 , C4480 , C4485 , C4580 , C4585 , C4599 , C4424 , C4524 , C5280 , C5288 , D5360</p>', '<p>18ml     : Deskjet D4260 , D4360 J5730 , J5780 , J5785 , J6410 , J6415 , J6424 Photosmart C4205 , C4270 , C4272 , C4280 , C4340 , C4380 , C4390C , 4472 , C4480 , C4485 , C4580 , C4585 , C4599 , C4424 , C4524 , C5280 , C5288 , D5360</p>'),
	(1210, '1', ' HP NO 110 Tri-Color CB304AE', 0, 15.18, 0, 1, 0.2, '#NAME?', 'TSHC-F04L', 'http://tonersales,eu/shop/469/-hp-no-110-tri-color-cb304ae,jpg', 0, '0', '<p>HP Photosmart A432 , A433 , A440 , A441 , A444 , A516 , A526 , A532 , A612 , A646 , A310 , A314 , A320 , A436 , A618 , A626 , A636 , A717 , A826</p>', '<p>60 photos,14 ml     : HP Photosmart A432 , A433 , A440 , A441 , A444 , A516 , A526 , A532 , A612 , A646 , A310 , A314 , A320 , A436 , A618 , A626 , A636 , A717 , A826</p>'),
	(1211, '1', ' HP NO 17 C6625A', 0, 15.65, 0, 1, 0.2, '-hp-no-17-c6625a', 'TS1HP NO 17', 'http://tonersales,eu/shop/470/-hp-no-17-c6625a,jpg', 0, '0', '<p>Deskjet 810c , 816C , 825c , 840c , 843c , 845c</p>', '<p>360,15 ml     : Deskjet 810c , 816C , 825c , 840c , 843c , 845c</p>'),
	(1212, '1', ' HP NO 23 C1823D', 0, 15.65, 0, 1, 0.2, '-hp-no-23-c1823d', 'TSHP NO 23', 'http://tonersales,eu/shop/471/-hp-no-23-c1823d,jpg', 0, '0', '<p>Deskjet 710c , 720c , 722c , 815c , 810c , 812c , 880c , 890c , 895cXi , 1120c , 1125c Officejet t45 , t65 , r45 , r65 PSC 500 Officejet Pro 1170c , 1175c</p>', '<p>600,30 ml     : Deskjet 710c , 720c , 722c , 815c , 810c , 812c , 880c , 890c , 895cXi , 1120c , 1125c Officejet t45 , t65 , r45 , r65 PSC 500 Officejet Pro 1170c , 1175c</p>'),
	(1213, '1', ' HP NO 78 C6578', 0, 19.3, 0, 111, 0.2, '0', 'TS1HP NO 78', '0', 0, '0', '<p>HP Deskjet 920 series , 930 series , 930Photo , 932 , 932C , 935 , 935C , 940 series , 948 , 948C , 950 , 950C , 952 , 952C , 955 , 955C , 959 , 960 series , 970 series , 980 , 980Cxi , 990 series , 995 , 995C , 1180 , 1180C , 1220 series , 1280 , 3810 , 3816 , 3820 , 3822 , 6122 , 6127 , 9300 ,Photosmart P1000 , P1000xi , P1100 , P1100xi , 1115 , 1215 , 1215VM , 1218 , 1818xi , 1315 ,OfficeJet G55 , G55xi , G85 , G85xi , G95 , K60 , K60xi , K80 , K80xi , V30 , V40 , V40xi , V45 , 5110 series , Color Copier 180 , 190 , 280 , 290 , Digital Copier 310 , PSC 720 , 750 , 750xi , 760 , 900 , 920 , 940 , 950 series , 2120 , FAX 1220 , 1220xi , 1230 , 1230xi</p>', '0'),
	(1214, '1', ' HP NO 301XL COLOUR (CH564EE)', 0, 16.5, 0, 107, 0.2, '-hp-no-301xl-colour-ch564ee', 'TS1HP NO 301col', 'http://tonersales,eu/shop/473/-hp-no-301xl-colour-ch564ee,jpg', 0, '0', '<p>Deskjet 1000 J110 a , c , d , e , 1010 , 1012 , 1014 , 1050 J110d , 1050 J410a , b , c , e , 1050A J410a , g , h , f , 1051 , 1051A J410f , 1055 J410e , 1056 J410a , 1510 , 1512 , 1514 , 2000 J210b , c , 2050 J510a , b , c , d , e ,2050s , 2050A J510a , c , g , h , 2054A J510j , k , 2510 , 2512 , 2514 , 2540 , 2543 , 2544 , 2547 , 2548 , 2549 , 3000 J310a , 3050 J610a , b , c , d , e , f , 3050A J611a , b , c , e , f , g , 3052A J611e , g , 3054 J610a , 3054A J611c , d , 3055A J611n , 3057A J611n , 3059A J611n , 3510 Envy 4500 , 4502 , 4503 , 4504 , 4505 , 4507 , 4508 , 4520 , 5530 , 5534 , 5539 Officejet 2620 , 2622 , 2624 , 4630 , 4632 , 4635 , 4636 , 4639</p>', '<p>18ml     : HP Deskjet 1000 J110 a , c , d , e , 1010 , 1012 , 1014 , 1050 J110d , 1050 J410a , b , c , e , 1050A J410a , g , h , f , 1051 , 1051A J410f , 1055 J410e , 1056 J410a , 1510 , 1512 , 1514 , 2000 J210b , c , 2050 J510a , b , c , d , e ,2050s , 2050A J510a , c , g , h , 2054A J510j , k , 2510 , 2512 , 2514 , 2540 , 2543 , 2544 , 2547 , 2548 , 2549 , 3000 J310a , 3050 J610a , b , c , d , e , f , 3050A J611a , b , c , e , f , g , 3052A J611e , g , 3054 J610a , 3054A J611c , d , 3055A J611n , 3057A J611n , 3059A J611n , 3510 Envy 4500 , 4502 , 4503 , 4504 , 4505 , 4507 , 4508 , 4520 , 5530 , 5534 , 5539 Officejet 2620 , 2622 , 2624 , 4630 , 4632 , 4635 , 4636 , 4639</p>'),
	(1215, '1', ' HP 971XL C CN626A', 0, 33.84, 0, 1, 0.2, 'hp-971xl-c-cn626a', 'TSB45059', 'http://tonersales,eu/shop/1739/hp-971xl-c-cn626a,jpg', 0, '0', '<p>HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>', '<p>120 ml     : HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>'),
	(1216, '1', ' HP 971XL M CN627A', 0, 33.84, 0, 1, 0.2, 'hp-971xl-m-cn627a', 'TSB45060', 'http://tonersales,eu/shop/1738/hp-971xl-m-cn627a,jpg', 0, '0', '<p>HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>', '<p>120 ml     : HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>'),
	(1217, '1', ' HP 971XL Y CN628A', 0, 33.84, 0, 1, 0.2, 'hp-971xl-y-cn628a', 'TSB45061', 'http://tonersales,eu/shop/1737/hp-971xl-y-cn628a,jpg', 0, '0', '<p>HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>', '<p>120 ml     : HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>'),
	(1218, '1', ' HP 970XL BK CN625AE', 0, 35.58, 0, 1, 0.2, 'hp-970xl-bk-cn625ae', 'TSB45058', 'http://tonersales,eu/shop/1740/hp-970xl-bk-cn625ae,jpg', 0, '0', '<p>HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>', '<p>240 ml     : HP Officejet Pro X551dw , X451dw , X476dw , X576dw , X451dn , X476dn , X757</p>'),
	(1219, '1', ' HP NO 980 (D8J10A) black', 0, 45.46, 0, 1, 0.2, '#NAME?', 'TSIFH629B**J', 'http://tonersales,eu/shop/1741/-hp-no-980-d8j10a-black,jpg', 0, '0', '<p>HP Officejet Enterprise Color MFP X585 , SFP X555</p>', '<p>260 ml     : HP Officejet Enterprise Color MFP X585 , SFP X555</p>'),
	(1220, '1', ' HP NO 980 (D8J07A) cyan', 0, 45.46, 0, 1, 0.2, '#NAME?', 'TSIFH630C**J', 'http://tonersales,eu/shop/1744/-hp-no-980-d8j07a-cyan,jpg', 0, '0', '<p>HP Officejet Enterprise Color MFP X585 , SFP X555</p>', '<p>120 ml     : HP Officejet Enterprise Color MFP X585 , SFP X555</p>'),
	(1221, '1', ' HP NO 980 (D8J08A) magenta', 0, 45.46, 0, 1, 0.2, '#NAME?', 'TSIFH631M**J', 'http://tonersales,eu/shop/1743/-hp-no-980-d8j08a-magenta,jpg', 0, '0', '<p>HP Officejet Enterprise Color MFP X585 , SFP X555</p>', '<p>120 ml     : HP Officejet Enterprise Color MFP X585 , SFP X555</p>'),
	(1222, '1', ' HP NO 980 (D8J09A) yellow', 0, 45.46, 0, 1, 0.2, '#NAME?', 'TSIFH632Y**J', 'http://tonersales,eu/shop/1742/-hp-no-980-d8j09a-yellow,jpg', 0, '0', '<p>HP Officejet Enterprise Color MFP X585 , SFP X555</p>', '<p>120 ml     : HP Officejet Enterprise Color MFP X585 , SFP X555</p>'),
	(1223, '1', ' BROTHER LC800 , LC31 BK', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-800B', 'http://tonersales,eu/shop/1765/-brother-lc800-lc31-bk,jpg', 0, '0', '<p>MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>', '<p>22 ml     : MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>'),
	(1224, '1', ' BROTHER LC800 , LC31 CYAN', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-800C', 'http://tonersales,eu/shop/1762/-brother-lc800-lc31-cyan,jpg', 0, '0', '<p>MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>', '<p>12 ml     : MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>'),
	(1225, '1', ' BROTHER LC800 , LC31 MAGENTA', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-800M', 'http://tonersales,eu/shop/1763/-brother-lc800-lc31-magenta,jpg', 0, '0', '<p>MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>', '<p>12 ml     : MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>'),
	(1226, '1', ' BROTHER LC800 , LC31 YELLOW', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-800Y', 'http://tonersales,eu/shop/1764/-brother-lc800-lc31-yellow,jpg', 0, '0', '<p>MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>', '<p>12 ml     : MFC 3220C , 3220CN , 3320C , 3320CN , 3420C , 3820C , 3820CN , PPF1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN , Fax1810 , 1810C , 1815 , 1815C , 1820 , 1820C , 1920 , 1920C , 1920CN</p>'),
	(1227, '1', ' BROTHER LC900 , LC41 , LC47 , LC950 BK', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-900B', 'http://tonersales,eu/shop/1474/-brother-lc900-lc41-lc47-lc950-bk,jpg', 0, '0', '<p>MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>', '<p>19 ml     : MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>'),
	(1228, '1', ' BROTHER LC900 , LC41 , LC47 , LC950 CYAN', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-900C', 'http://tonersales,eu/shop/1475/-brother-lc900-lc41-lc47-lc950-cyan,jpg', 0, '0', '<p>MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>', '<p>12,5 ml     : MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>'),
	(1229, '1', ' BROTHER LC900 , LC41 , LC47 , LC950 MAGENTA', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-900M', 'http://tonersales,eu/shop/1746/-brother-lc900-lc41-lc47-lc950-magenta,jpg', 0, '0', '<p>MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>', '<p>12,5 ml     : MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>'),
	(1230, '1', ' BROTHER LC900 , LC41 , LC47 , LC950 YELLOW', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TS1LC-900Y', 'http://tonersales,eu/shop/1477/-brother-lc900-lc41-lc47-lc950-yellow,jpg', 0, '0', '<p>MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>', '<p>12,5 ml     : MFC 210C , 215C , 410CN , 420CN , 425CN , 610 , 610CLN , 615 , 615CL , 620 , 620CN , 620CLN , 640 , 820 , 3240 , 3240C , 3340CN , 5440CN , 5840CN , DCP110C , 115C , 116C , 117C , 120C , 310CN , 315CN , 340CW , Fax1835C , 1840C , 1940CN , 2440C</p>'),
	(1235, '1', ' BROTHER LC10/37/51/57/960/970/1000 BK', 0, 2.76, 0, 104, 0.2, '#ERROR!', 'TSLC37/51/57b', 'http://tonersales,eu/shop/1760/-brother-lc103751579609701000-bk,jpg', 0, '0', '<p>MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>', '<p>30 ml     : MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>'),
	(1236, '1', ' BROTHER LC10/37/51/57/960/970/1000 CYAN', 0, 2.76, 0, 105, 0.2, '#ERROR!', 'TSLC37/51/57c', 'http://tonersales,eu/shop/1756/-brother-lc103751579609701000-cyan,jpg', 0, '0', '<p>MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>', '<p>20 ml     : MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>'),
	(1237, '1', ' BROTHER LC10/37/51/57/960/970/1000 MAGENTA', 0, 2.76, 0, 105, 0.2, '#ERROR!', 'TSLC37/51/57m', 'http://tonersales,eu/shop/1757/-brother-lc103751579609701000-magenta,jpg', 0, '0', '<p>MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>', '<p>20 ml     : MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>'),
	(1238, '1', ' BROTHER LC10/37/51/57/960/970/1000 YELLOW', 0, 2.76, 0, 105, 0.2, '#ERROR!', 'TSLC37/51/57y', 'http://tonersales,eu/shop/1761/-brother-lc103751579609701000-yellow,jpg', 0, '0', '<p>MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>', '<p>20 ml     : MFC 240 , 440 , 465 , 660 , 680 , 845 , 885 , 3360 , 5460 , 5490 , 5860 , DCP130 , 135C , 150C , 153C , 155C , 157C , 330C , 350C , 353C , 357C , 385 , 540 , 560 , 750 , 770 ,FAX-1560 , 1460 , 1360</p>'),
	(1239, '1', ' BROTHER LC11/16/38/39/67/60/61/65/ 975/990/980/985/1100 BK', 0, 2.76, 0, 114, 0.2, '#ERROR!', 'TSIFB374B**J', 'http://tonersales,eu/shop/1759/-brother-lc1116383967606165-9759909809851100-bk,jpg', 0, '0', '<p>BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>', '<p>23,5 ml     : BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>'),
	(1240, '1', ' BROTHER LC11/16/38/39/67/60/61/65 /975/990/980/985/1100 CY', 0, 2.76, 0, 114, 0.2, '#ERROR!', 'TSIFB376C**J', 'http://tonersales,eu/shop/1755/-brother-lc1116383967606165-9759909809851100-cy,jpg', 0, '0', '<p>BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>', '<p>11 ml     : BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>'),
	(1241, '1', ' BROTHER LC11/16/38/39/67/60/61/65 /975/990/980/985/1100 MG', 0, 2.76, 0, 119, 0.2, '#ERROR!', 'TSIFB377M**J', 'http://tonersales,eu/shop/1754/-brother-lc1116383967606165-9759909809851100-mg,jpg', 0, '0', '<p>BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>', '<p>11 ml     : BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>'),
	(1242, '1', ' BROTHER LC11/16/38/39/67/60/61/65 /975/990/980/985/1100 YL', 0, 2.76, 0, 109, 0.2, '#ERROR!', 'TSIFB378Y**J', 'http://tonersales,eu/shop/1753/-brother-lc1116383967606165-9759909809851100-yl,jpg', 0, '0', '<p>BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>', '<p>11 ml     : BROTHER DCP-145C , 163C , 165C , 167C , 185C , 195C , 365CN , 375CW , 383C , 385C , 387C , 395CN , 535CN , 585CW , 6690CW , J715W MFC-250C , 255CW , 257CW , J270W , 290C , 295CN , 297C , 490CN , 490CW , 495CW , J615W , J630W , 650CD , 650CDW , 670CD , 670CDW , 790CW , 795CW , 930CDN , 930CDWN , 990CW , 5490CN , 5890CN , 6490CW , 6890CDW</p>'),
	(1243, '1', ' BROTHER LC12/40/71/73/75XL/400 /1220/1240 BK', 0, 2.76, 0, 101, 0.2, '#NAME?', 'TSIFB564B', 'http://tonersales,eu/shop/1747/-brother-lc1240717375xl400-12201240-bk,jpg', 0, '0', '<p>BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>', '<p>26 ml     : BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>'),
	(1244, '1', ' BROTHER LC12/40/71/73/75XL/400/1220/1240 CY', 0, 2.76, 0, 109, 0.2, '#NAME?', 'TSIFB566C', 'http://tonersales,eu/shop/1750/-brother-lc1240717375xl40012201240-cy,jpg', 0, '0', '<p>BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>', '<p>12 ml     : BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>'),
	(1245, '1', ' BROTHER LC12/40/71/73/75XL/400/1220/1240 MG', 0, 2.76, 0, 112, 0.2, '#NAME?', 'TSIFB567M', 'http://tonersales,eu/shop/1751/-brother-lc1240717375xl40012201240-mg,jpg', 0, '0', '<p>BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>', '<p>12 ml     : BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>'),
	(1246, '1', ' BROTHER LC12/40/71/73/75XL/400/1220/1240 YL', 0, 2.76, 0, 112, 0.2, '#NAME?', 'TSIFB568Y', 'http://tonersales,eu/shop/1752/-brother-lc1240717375xl40012201240-yl,jpg', 0, '0', '<p>BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>', '<p>12 ml     : BROTHER DCP-J525W , J725DW , J925DW MFC-J280W , J425W , J430W , J432W , J435W , J625DW , J825DW , J835DW , J5910DW , J6510DW , J6710DW , J6910DW</p>'),
	(1247, '1', ' BROTHER LC123 BK', 0, 3.2, 0, 101, 0.2, 'brother-lc123-bk', 'TSIFB647B**J', 'http://tonersales,eu/shop/1768/brother-lc123-bk,jpg', 0, '0', '<p>BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>', '<p>17 ml     : BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>'),
	(1248, '1', ' BROTHER LC123 CY', 0, 3.2, 0, 101, 0.2, 'brother-lc123-cy', 'TSIFB610C**J', 'http://tonersales,eu/shop/1769/brother-lc123-cy,jpg', 0, '0', '<p>BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>', '<p>10 ml     : BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>'),
	(1249, '1', ' BROTHER LC123 MG', 0, 3.2, 0, 101, 0.2, 'brother-lc123-mg', 'TSIFB611M**J', 'http://tonersales,eu/shop/1767/brother-lc123-mg,jpg', 0, '0', '<p>BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>', '<p>10 ml     : BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>'),
	(1250, '1', ' BROTHER LC123 YL', 0, 3.2, 0, 101, 0.2, 'brother-lc123-yl', 'TSIFB612Y**J', 'http://tonersales,eu/shop/1766/brother-lc123-yl,jpg', 0, '0', '<p>BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>', '<p>10 ml     : BROTHER DCP-J132W , J152W , J172W , J552DW , J752DW , J4110DW BROTHER MFC-J470DW , J650DW , J870DW , J4410DW , J4510DW , J4610DW , J4710DW , J6520DW , J6720DW , J6920DW</p>'),
	(1251, '1', ' BROTHER LC123BK(cleaning Cartridge)', 0, 4.31, 0, 1, 0.2, '#NAME?', 'TSB35177', 'http://tonersales,eu/shop/1506/-brother-lc123bkcleaning-cartridge,jpg', 0, '0', '<p>Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>', '<p>20ml     : Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>'),
	(1252, '1', ' BROTHER LC123C(cleaning Cartridge)', 0, 4.31, 0, 1, 0.2, '#NAME?', 'TSB35178', 'http://tonersales,eu/shop/1507/-brother-lc123ccleaning-cartridge,jpg', 0, '0', '<p>Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>', '<p>14ml     : Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>'),
	(1253, '1', ' BROTHER LC123M(cleaning Cartridge)', 0, 4.31, 0, 1, 0.2, '#NAME?', 'TSB35179', 'http://tonersales,eu/shop/1508/-brother-lc123mcleaning-cartridge,jpg', 0, '0', '<p>Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>', '<p>14ml     : Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>'),
	(1254, '1', ' BROTHER LC123Y(cleaning Cartridge)', 0, 4.31, 0, 1, 0.2, '#NAME?', 'TSB35180', 'http://tonersales,eu/shop/1509/-brother-lc123ycleaning-cartridge,jpg', 0, '0', '<p>Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>', '<p>14ml     : Brother MFC-J4510DW , J4410DW , J4610 , J4710DW , J4110DW , DCP-J132W , J152W , J552DW , J752DW , MFC-J470DW , J650DW , J870DW , MFC-J6920DW , J6520DW , J6720DW</p>'),
	(1255, '1', ' BROTHER LC129XL BK', 0, 6.51, 0, 1, 0.2, 'brother-lc129xl-bk', 'TSIFB677B**J', 'http://tonersales,eu/shop/1770/brother-lc129xl-bk,jpg', 0, '0', '<p>BROTHER MFC-J6520DW , J6720DW , J6920DW</p>', '<p>1800 ml     : BROTHER MFC-J6520DW , J6720DW , J6920DW</p>'),
	(1256, '1', ' BROTHER LC225XL CYAN', 0, 7.09, 0, 1, 0.2, '#NAME?', 'TSLC225XLC', 'http://tonersales,eu/shop/1773/-brother-lc225xl-cyan,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>1200 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1257, '1', ' BROTHER LC225XL AGENTA', 0, 7.09, 0, 1, 0.2, '#NAME?', 'TSLC225XLM', 'http://tonersales,eu/shop/1774/-brother-lc225xl-agenta,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>1200 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1258, '1', ' BROTHER LC225XL ELLOW', 0, 7.09, 0, 1, 0.2, '#NAME?', 'TSLC225XLY', 'http://tonersales,eu/shop/1772/-brother-lc225xl-ellow,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>1200 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1259, '1', ' BROTHER LC227XL BK', 0, 7.09, 0, 1, 0.2, '#NAME?', 'TSLC227XLBK', 'http://tonersales,eu/shop/1771/-brother-lc227xl-bk,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , J4625DW</p>', '<p>2400 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , J4625DW</p>'),
	(1260, '1', ' BROTHER LC125XL CYAN', 0, 7.18, 0, 102, 0.2, '#NAME?', 'TSIFB614C**J', 'http://tonersales,eu/shop/1776/-brother-lc125xl-cyan,jpg', 0, '0', '<p>BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>', '<p>15 ml     : BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>'),
	(1261, '1', ' BROTHER LC125XL MAGENTA', 0, 7.18, 0, 102, 0.2, '#NAME?', 'TSIFB615M**J', 'http://tonersales,eu/shop/1777/-brother-lc125xl-magenta,jpg', 0, '0', '<p>BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>', '<p>15 ml     : BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>'),
	(1262, '1', ' BROTHER LC125XL YELLOW', 0, 7.18, 0, 102, 0.2, '#NAME?', 'TSIFB616Y**J', 'http://tonersales,eu/shop/1775/-brother-lc125xl-yellow,jpg', 0, '0', '<p>BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>', '<p>15 ml     : BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>'),
	(1263, '1', ' BROTHER LC127XL BK', 0, 7.18, 0, 102, 0.2, 'brother-lc127xl-bk', 'TSIFB648B**J', 'http://tonersales,eu/shop/1781/brother-lc127xl-bk,jpg', 0, '0', '<p>BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>', '<p>30 ml     : BROTHER DCP-J4110DW , MFC-J4410DW , MFC-J4510DW , J4610DW , J4710DW LC-127</p>'),
	(1264, '1', ' BROTHER LC223 BK', 0, 7.18, 0, 110, 0.2, '#NAME?', 'TSLC223BK', 'http://tonersales,eu/shop/1782/-brother-lc223-bk,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>550 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1265, '1', ' BROTHER LC223 CYAN', 0, 7.18, 0, 110, 0.2, '#NAME?', 'TSLC223C', 'http://tonersales,eu/shop/1780/-brother-lc223-cyan,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>550 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1266, '1', ' BROTHER LC223 AGENTA', 0, 7.18, 0, 110, 0.2, '#NAME?', 'TSLC223', 'http://tonersales,eu/shop/1779/-brother-lc223-agenta,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>550 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1267, '1', ' BROTHER LC223 ELLOW', 0, 7.18, 0, 110, 0.2, '#NAME?', 'TSLC223', 'http://tonersales,eu/shop/1778/-brother-lc223-ellow,jpg', 0, '0', '<p>Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>', '<p>550 ml     : Brother DCP-J4120DW Brother MFC-J4420DW , J4620DW , 4625DW , J5320DW , J5620DW , J5625DW , J5720DW</p>'),
	(1268, '1', ' BROTHER LC229XL BK', 0, 10.36, 0, 1, 0.2, 'brother-lc229xl-bk', 'TSIFB677B**J', 'http://tonersales,eu/shop/1783/brother-lc229xl-bk,jpg', 0, '0', '<p>MFC-J5320DW , MFC-J5620DW , MFC-J5720DW , MFC-J5625DW</p>', '<p>2400pgs,50ml     : MFC-J5320DW , MFC-J5620DW , MFC-J5720DW , MFC-J5625DW</p>'),
	(1269, '1', ' SAMSUNG INK M40', 0, 13.1, 0, 1, 0.2, '#NAME?', 'TSSAM40', 'http://tonersales,eu/shop/535/-samsung-ink-m40,jpg', 0, '0', '<p>SAMSUNG<span>SF330, SF331P, SF335T, SF340, SF341P, SF345TP, SF360, SF361P, SF365TP</span></p>', '<p>17ml     : SAMSUNGSF330, SF331P, SF335T, SF340, SF341P, SF345TP, SF360, SF361P, SF365TP</p>'),
	(1270, '1', ' SAMSUNG INK M41', 0, 16.95, 0, 105, 0.2, '#NAME?', 'TSSAM41', 'http://tonersales,eu/shop/1784/-samsung-ink-m41,jpg', 0, '0', '<p>Samsung SF370 , SF371 , sf375 , sf375TP</p>', '<p>17ml     : Samsung SF370 , SF371 , sf375 , sf375TP</p>'),
	(1271, '1', ' SAMSUNG M10', 0, 12.5, 0, 1, 0.2, '#NAME?', 'TSM10', 'http://tonersales,eu/shop/537/-samsung-m10,jpg', 0, '0', '<p>SAMSUNG SF3100 , sf3100T , 3100P , SF3200 , SF3200T , 3200P , 4000 , 4200 , MJ63H , 630G , 630G, 630GC , 630V , 635B , 635C , 637V , 640G , 640H , 640HCMJC 500SF , 510SF , 605G , 605GC , 640V , 640VC , 650G , 650GC , 650P , 655V , 655VC , 657V , 660G , 760i , 765C , SIJ630 , 630V</p>', '<p>23,4 ml     : SAMSUNG SF3100 , SF3100T , 3100P , SF3200 , SF3200T , 3200P , 4000 , 4200 , MJ63H , 630G , 630G , 630GC , 630V , 635B , 635C , 637V , 640G , 640H , 640HCMJC 500SF , 510SF , 605G , 605GC , 640V , 640VC , 650G , 650GC , 650P , 655V , 655VC , 657V , 660G , 760i , 765C , SIJ630 , 630V</p>'),
	(1272, '1', ' CANON BCI 21B', 0, 2.76, 0, 50, 0.2, '-canon-bci-21b', 'TS1BCI-21B / BCI-24B', 'http://tonersales,eu/shop/651/-canon-bci-21b,jpg', 0, '0', '<p>CANON BJC-400J , 410J , 455J , 2000 , 2000SP , 2115 , 4000 , 4100 , 4200 , 4300 , 4310SP , 4304 Photo , 4400 , 4550 , 4650 , 5000 , 5100 , 5500 S100SP , S200 , S300 , S330 , i250 , i320 , i350 , i450 , i455 , i470D , i475D CFX-B380IF MultiPASS C20 , C30 , C50 , C70 , C75 , C80 , C530 , C545 , C555 , C560 , C635 , C2500 , C3000</p>', '<p>9 ml     : CANON BJC-400J , 410J , 455J , 2000 , 2000SP , 2115 , 4000 , 4100 , 4200 , 4300 , 4310SP , 4304 Photo , 4400 , 4550 , 4650 , 5000 , 5100 , 5500 S100SP , S200 , S300 , S330 , i250 , i320 , i350 , i450 , i455 , i470D , i475D CFX-B380IF MultiPASS C20 , C30 , C50 , C70 , C75 , C80 , C530 , C545 , C555 , C560 , C635 , C2500 , C3000</p>'),
	(1273, '1', ' CANON BCI 24C', 0, 2.76, 0, 102, 0.2, '-canon-bci-24c', ' BCI-24C', 'http://tonersales,eu/shop/652/-canon-bci-24c,jpg', 0, '0', '<p>CANON BJC-400J , 410J , 455J , 2000 , 2000SP , 2115 , 4000 , 4100 , 4200 , 4300 , 4310SP , 4304 Photo , 4400 , 4550 , 4650 , 5000 , 5100 , 5500 S100SP , S200 , S300 , S330 , i250 , i320 , i350 , i450 , i455 , i470D , i475D CFX-B380IF MultiPASS C20 , C30 , C50 , C70 , C75 , C80 , C530 , C545 , C555 , C560 , C635 , C2500</p>', '<p>5 ,5 ml     : CANON BJC-400J , 410J , 455J , 2000 , 2000SP , 2115 , 4000 , 4100 , 4200 , 4300 , 4310SP , 4304 Photo , 4400 , 4550 , 4650 , 5000 , 5100 , 5500 S100SP , S200 , S300 , S330 , i250 , i320 , i350 , i450 , i455 , i470D , i475D CFX-B380IF MultiPASS C20 , C30 , C50 , C70 , C75 , C80 , C530 , C545 , C555 , C560 , C635 , C2500</p>'),
	(1274, '1', ' CANON BCI 3eBK 4479A002AB', 0, 2.76, 0, 50, 0.2, '-canon-bci-3ebk-4479a002ab', 'TS1BCI-3eBK', 'http://tonersales,eu/shop/653/-canon-bci-3ebk-4479a002ab,jpg', 0, '0', '<p>CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i6500 , i560 , i865 MP750 , 760 , 780 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000</p>', '<p>26 ml     : CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i6500 , i560 , i865 MP750 , 760 , 780 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000</p>'),
	(1275, '1', ' CANON BCI 3e, 5, 6PC', 0, 2.76, 0, 50, 0.2, '-canon-bci-3e-5-6pc', 'TS1BCI-3ePC', 'http://tonersales,eu/shop/1813/-canon-bci-3e-5-6pc,jpg', 0, '0', '<p>CANON S800 , S820D , S900 , S9000 , S830D i950 , i9100 , I905D , i965 , i9100 , i990 , i9950 Ip6000D , 8500</p>', '<p>14,5 ml     : CANON S800 , S820D , S900 , S9000 , S830D i950 , i9100 , I905D , i965 , i9100 , i990 , i9950 Ip6000D , 8500</p>'),
	(1276, '1', ' CANON BCI 3e, 5, 6PM', 0, 2.76, 0, 50, 0.2, '-canon-bci-3e-5-6pm', 'TS1BCI-3ePM', 'http://tonersales,eu/shop/1798/-canon-bci-3e-5-6pm,jpg', 0, '0', '<p>CANON S800 , S820D , S900 , S9000 , S830D i950 , i9100 , I905D , i965 , i9100 , i990 , i9950 Ip6000D , 8500</p>', '<p>14,5 ml     : CANON S800 , S820D , S900 , S9000 , S830D i950 , i9100 , I905D , i965 , i9100 , i990 , i9950 Ip6000D , 8500</p>'),
	(1277, '1', ' CANON BCI 3e, 5, 6C', 0, 2.76, 0, 50, 0.2, '-canon-bci-3e-5-6c', 'TS1BCI-3e/5/6C', 'http://tonersales,eu/shop/1812/-canon-bci-3e-5-6c,jpg', 0, '0', '<p>CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S800 , S820D , S900 , S9000 , S830D , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i950 , i9100 , I905D , i965 , i9100 , i560 , i865 , i990 , i9950 , i6500 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>', '<p>14,5 ml     : CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S800 , S820D , S900 , S9000 , S830D , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i950 , i9100 , I905D , i965 , i9100 , i560 , i865 , i990 , i9950 , i6500 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>'),
	(1278, '1', ' CANON BCI 3e, 5, 6M', 0, 2.76, 0, 50, 0.2, '-canon-bci-3e-5-6m', 'TS1BCI-3e/5/6M', 'http://tonersales,eu/shop/1794/-canon-bci-3e-5-6m,jpg', 0, '0', '<p>CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S800 , S820D , S900 , S9000 , S830D , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i950 , i9100 , I905D , i965 , i9100 , i560 , i865 , i990 , i9950 , i6500 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>', '<p>14,5 ml     : CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S800 , S820D , S900 , S9000 , S830D , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i950 , i9100 , I905D , i965 , i9100 , i560 , i865 , i990 , i9950 , i6500 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>'),
	(1279, '1', ' CANON BCI 3e, 5, 6Y', 0, 2.76, 0, 50, 0.2, '-canon-bci-3e-5-6y', 'TS1BCI-3e/5/6Y', 'http://tonersales,eu/shop/1795/-canon-bci-3e-5-6y,jpg', 0, '0', '<p>CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S800 , S820D , S900 , S9000 , S830D , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i950 , i9100 , I905D , i965 , i9100 , i560 , i865 , i990 , i9950 , i6500 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>', '<p>14,5 ml     : CANON BJC3000 , 6000Series S400 , S4500 , S450 , S600 , S630 , S800 , S820D , S900 , S9000 , S830D , S6300 , S500 , S750 , S520 , S530D i550 , i850 , i950 , i9100 , I905D , i965 , i9100 , i560 , i865 , i990 , i9950 , i6500 MPC400 , 600F , 700 , 730 Ip3000 , 4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>'),
	(1280, '1', ' CANON BCI 3ePB, 5, 6BL', 0, 2.76, 0, 50, 0.2, '-canon-bci-3epb-5-6bl', 'TS1BCI-6BL', 'http://tonersales,eu/shop/1792/-canon-bci-3epb-5-6bl,jpg', 0, '0', '<p>CANON S800 , S820D , S900 , S9000 , S830D i950 , i9100 , I905D , i965 , i9100 , i865 , i990 , i9950 Ip4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>', '<p>14,5 ml     : CANON S800 , S820D , S900 , S9000 , S830D i950 , i9100 , I905D , i965 , i9100 , i865 , i990 , i9950 Ip4000 , 4000R , 5000 , 6000D , 8500 MP750 , 760 , 780</p>'),
	(1281, '1', ' CANON PGI 5BK', 0, 2.76, 0, 101, 0.2, '-canon-pgi-5bk', 'TS1PGI-5BK', 'http://tonersales,eu/shop/1676/-canon-pgi-5bk,jpg', 0, '0', '<p>CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , iP5300 , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850</p>', '<p>24 ml     : CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , iP5300 , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850</p>'),
	(1283, '1', ' CANON CLI 8C', 0, 2.76, 0, 110, 0.2, '-canon-cli-8c', 'TS1CLI-8C', 'http://tonersales,eu/shop/1677/-canon-cli-8c,jpg', 0, '0', '<p>CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</p>', '<p>14 ml     : CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</p>'),
	(1284, '1', ' CANON CLI 8M', 0, 2.76, 0, 110, 0.2, '-canon-cli-8m', 'TS1CLI-8M', 'http://tonersales,eu/shop/1678/-canon-cli-8m,jpg', 0, '0', '<p>CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</p>', '<p>14 ml     : CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</p>'),
	(1285, '1', ' CANON CLI 8Y', 0, 2.76, 0, 110, 0.2, '-canon-cli-8y', 'TS1CLI-8Y', 'http://tonersales,eu/shop/1816/-canon-cli-8y,jpg', 0, '0', '<p>CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</p>', '<p>14 ml     : CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</p>'),
	(1286, '1', ' CANON CLI 8PC', 0, 2.76, 0, 115, 0.2, '-canon-cli-8pc', 'TS1CLI-8PC', 'http://tonersales,eu/shop/1809/-canon-cli-8pc,jpg', 0, '0', '<p>CANON PIXMA iP6600D , iP6700D , MP950 , MP960 , MP970 CANON PIXMA Pro9000</p>', '<p>14 ml     : CANON PIXMA iP6600D , iP6700D , MP950 , MP960 , MP970 CANON PIXMA Pro9000</p>'),
	(1287, '1', ' CANON CLI 8PM', 0, 2.76, 0, 115, 0.2, '-canon-cli-8pm', 'TS1CLI-8PM', 'http://tonersales,eu/shop/1814/-canon-cli-8pm,jpg', 0, '0', '<p>CANON PIXMA iP6600D , iP6700D , MP950 , MP960 , MP970 CANON PIXMA Pro9000</p>', '<p>14 ml     : CANON PIXMA iP6600D , iP6700D , MP950 , MP960 , MP970 CANON PIXMA Pro9000</p>'),
	(1288, '1', ' CANON CLI 8 GREEN', 0, 2.76, 0, 1, 0.2, '#NAME?', 'TSIFC832G**J', 'http://tonersales,eu/shop/669/-canon-cli-8-green,jpg', 0, '0', '<p>CANON PIXMA Pro9000</p>', '<p>14 ml     : CANON PIXMA Pro9000</p>'),
	(1289, '1', ' CANON PGI 520 2932B001', 0, 2.76, 0, 105, 0.2, '-canon-pgi-520-2932b001', 'TSPGI-520', 'http://tonersales,eu/shop/1815/-canon-pgi-520-2932b001,jpg', 0, '0', '<p>CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>', '<p>20 ml     : CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>'),
	(1290, '1', ' CANON CLI 521C', 0, 2.76, 0, 99, 0.2, '-canon-cli-521c', 'TSCLI-521C', 'http://tonersales,eu/shop/1805/-canon-cli-521c,jpg', 0, '0', '<p>CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>', '<p>10 ml     : CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>'),
	(1291, '1', ' CANON CLI 521M', 0, 2.76, 0, 99, 0.2, '-canon-cli-521m', 'TSCLI-521M', 'http://tonersales,eu/shop/1802/-canon-cli-521m,jpg', 0, '0', '<p>CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>', '<p>10 ml     : CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>'),
	(1292, '1', ' CANON CLI 521Y', 0, 2.76, 0, 103, 0.2, '-canon-cli-521y', 'TSCLI-521Y', 'http://tonersales,eu/shop/1803/-canon-cli-521y,jpg', 0, '0', '<p>CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>', '<p>10 ml     : CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP990 , MX860 , MX870</p>'),
	(1293, '1', ' CANON CLI 521BK', 0, 2.76, 0, 102, 0.2, '-canon-cli-521bk', 'TSCLI-521B', 'http://tonersales,eu/shop/1799/-canon-cli-521bk,jpg', 0, '0', '<p>CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP99 , MX870</p>', '<p>10 ml     : CANON PIXMA IP3600 , IP4600 , IP4700 , MP540 , MP550 , MP560 , MP620 , MP630 , MP640 , MP650 , MP980 , MP99 , MX870</p>'),
	(1294, '1', ' CANON CLI 521 GY', 0, 2.76, 0, 102, 0.2, '#NAME?', 'TSIFC784E**J', 'http://tonersales,eu/shop/1804/-canon-cli-521-gy,jpg', 0, '0', '<p>CANON PIXMA MP980 , MP990</p>', '<p>10 ml     : CANON PIXMA MP980 , MP990</p>'),
	(1295, '1', ' CANON PGI 525 BK', 0, 2.76, 0, 114, 0.2, '#NAME?', 'TSPGI-525', 'http://tonersales,eu/shop/1806/-canon-pgi-525-bk,jpg', 0, '0', '<p>CANON PIXMA iP4840 , IP4850 , 4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>', '<p>20 ml     : CANON PIXMA iP4840 , IP4850 , 4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>'),
	(1296, '1', ' CANON CLI 526BK', 0, 2.76, 0, 111, 0.2, '-canon-cli-526bk', 'TSCLI-526', 'http://tonersales,eu/shop/1807/-canon-cli-526bk,jpg', 0, '0', '<p>CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>', '<p>11 ml     : CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>'),
	(1297, '1', ' CANON CLI 526C', 0, 2.76, 0, 114, 0.2, '-canon-cli-526c', 'TSCLI-526C', 'http://tonersales,eu/shop/1817/-canon-cli-526c,jpg', 0, '0', '<p>CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>', '<p>11 ml     : CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>'),
	(1298, '1', ' CANON CLI 526M', 0, 2.76, 0, 114, 0.2, '-canon-cli-526m', 'TSCLI-526M', 'http://tonersales,eu/shop/1820/-canon-cli-526m,jpg', 0, '0', '<p>CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>', '<p>11 ml     : CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>'),
	(1299, '1', ' CANON CLI 526Y', 0, 2.76, 0, 116, 0.2, '-canon-cli-526y', 'TSCLI-526Y', 'http://tonersales,eu/shop/1818/-canon-cli-526y,jpg', 0, '0', '<p>CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>', '<p>11 ml     : CANON PIXMA iP4840 , IP4850 , IP4900 , IP4950 , IP4840 , IX6550 , MG5150 , MG5250 , 5350 , MG6150 , 6250 , MG8150 , 8250 , MFP MX715 , 885 , 895</p>'),
	(1300, '1', ' CANON CLI 526grey', 0, 2.76, 0, 110, 0.2, '-canon-cli-526grey', 'TSCLI-526 GREY', 'http://tonersales,eu/shop/1819/-canon-cli-526grey,jpg', 0, '0', '<p>CANON PIXMA MG6150 , MG6250 , MG8150 , MG8250</p>', '<p>11 ml     : CANON PIXMA MG6150 , MG6250 , MG8150 , MG8250</p>'),
	(1301, '1', ' CANON PG 550XL BLACK', 0, 4.42, 0, 152, 0.2, '-canon-pg-550xl-black', 'TSIFCD13BPRJ', 'http://tonersales,eu/shop/1825/-canon-pg-550xl-black,jpg', 0, '0', '<p>Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>', '<p>25 ml     : Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>'),
	(1302, '1', ' CANON CL 551XL CYAN', 0, 4.42, 0, 145, 0.2, '-canon-cl-551xl-cyan', 'TSIFCC87CPRJ', 'http://tonersales,eu/shop/79/-canon-cl-551xl-cyan,jpg', 0, '0', '<p>Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>', '<p>13 ml     : Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>'),
	(1303, '1', ' CANON CL 551XL MAGENTA', 0, 4.42, 0, 147, 0.2, '-canon-cl-551xl-magenta', 'TSIFCC88MPRJ', 'http://tonersales,eu/shop/1824/-canon-cl-551xl-magenta,jpg', 0, '0', '<p>Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>', '<p>13 ml     : Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>'),
	(1304, '1', ' CANON CL 551XL YL', 0, 4.42, 0, 146, 0.2, '-canon-cl-551xl-yl', 'TSIFCC89YPRJ', 'http://tonersales,eu/shop/1823/-canon-cl-551xl-yl,jpg', 0, '0', '<p>Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>', '<p>13 ml     : Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>'),
	(1305, '1', ' CANON CL 551XL BLACK', 0, 4.42, 0, 155, 0.2, '-canon-cl-551xl-black', 'TSIFCC86BPRJ', 'http://tonersales,eu/shop/1821/-canon-cl-551xl-black,jpg', 0, '0', '<p>Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>', '<p>13 ml     : Canon IP7250 Pixma MG5450 , MG5450S , MG6350 , MG6450 , MG5550 , MG5650 , MX925</p>'),
	(1306, '1', ' CANON CLI 551XL GRAY', 0, 4.42, 0, 112, 0.2, '-canon-cli-551xl-gray', 'TSIFCC90E**J', 'http://tonersales,eu/shop/1822/-canon-cli-551xl-gray,jpg', 0, '0', '<p>CANON PIXMA MG6350 , MG7150</p>', '<p>15 ml     : CANON PIXMA MG6350 , MG7150</p>'),
	(1307, '1', ' CANON PGI-1500XL lack HY (9182B001)', 0, 9.23, 0, 1, 0.2, '-canon-pgi-1500xl-lack-hy-9182b001', 'TSIFCF09B**J', 'http://tonersales,eu/shop/1826/-canon-pgi-1500xl-lack-hy-9182b001,jpg', 0, '0', '<p>CANON MAXIFY MB2050 , MB2350</p>', '<p>36 ml     : CANON MAXIFY MB2050 , MB2350</p>'),
	(1308, '1', ' CANON PGI-1500XL Cyan HY (9193B001)', 0, 9.23, 0, 1, 0.2, '-canon-pgi-1500xl-cyan-hy-9193b001', 'TSIFCF10C**J', 'http://tonersales,eu/shop/1829/-canon-pgi-1500xl-cyan-hy-9193b001,jpg', 0, '0', '<p>CANON MAXIFY MB2050 , MB2350</p>', '<p>14 ml     : CANON MAXIFY MB2050 , MB2350</p>'),
	(1309, '1', ' CANON PGI-1500XL Magenta HY (9194B001)', 0, 9.23, 0, 1, 0.2, '-canon-pgi-1500xl-magenta-hy-9194b001', 'TSIFCF11M**J', 'http://tonersales,eu/shop/1827/-canon-pgi-1500xl-magenta-hy-9194b001,jpg', 0, '0', '<p>CANON MAXIFY MB2050 , MB2350</p>', '<p>14 ml     : CANON MAXIFY MB2050 , MB2350</p>'),
	(1310, '1', ' CANON PGI-1500XL Yellow HY (9195B001)', 0, 9.23, 0, 1, 0.2, '-canon-pgi-1500xl-yellow-hy-9195b001', 'TSIFCF17Y**J', 'http://tonersales,eu/shop/1828/-canon-pgi-1500xl-yellow-hy-9195b001,jpg', 0, '0', '<p>CANON MAXIFY MB2050 , MB2350</p>', '<p>14 ml     : CANON MAXIFY MB2050 , MB2350</p>'),
	(1311, '1', ' CANON PG-40 BLACK', 0, 12.55, 0, 105, 0.2, '#NAME?', 'TSPG-40 Black', 'http://tonersales,eu/shop/1830/-canon-pg-40-black,jpg', 0, '0', '<p>Canon Ip1800 , 2500 , 2600 , 2200 , 1200 , 1300 , 1600 , 1700 MP140 , 190 , 210 , 220 , 470 , 150 , 160 , 170 , 180 , 450 , 460 MX300 , 310</p>', '<p>228 ,13,5 ml     : Canon Ip1800 , 2500 , 2600 , 2200 , 1200 , 1300 , 1600 , 1700 MP140 , 190 , 210 , 220 , 470 , 150 , 160 , 170 , 180 , 450 , 460 MX300 , 310</p>'),
	(1312, '1', ' CANON PGI-2500XL Black HY (9254B001)', 0, 10.64, 0, 110, 0.2, '-canon-pgi-2500xl-black-hy-9254b001', 'TSIFCF14B**J', 'http://tonersales,eu/shop/1833/-canon-pgi-2500xl-black-hy-9254b001,jpg', 0, '0', '<p>CANON MAXIFY iB4050 , MB5050 , MB5350</p>', '<p>75 ml     : CANON MAXIFY iB4050 , MB5050 , MB5350</p>'),
	(1313, '1', ' CANON PGI-2500XL Cyan HY (9265B001)', 0, 10.64, 0, 110, 0.2, '-canon-pgi-2500xl-cyan-hy-9265b001', 'TSIFCF15C**J', 'http://tonersales,eu/shop/1834/-canon-pgi-2500xl-cyan-hy-9265b001,jpg', 0, '0', '<p>CANON MAXIFY iB4050 , MB5050 , MB5350</p>', '<p>21 ml     : CANON MAXIFY iB4050 , MB5050 , MB5350</p>'),
	(1314, '1', ' CANON PGI-2500XL Magenta HY (9266B001)', 0, 10.64, 0, 110, 0.2, '-canon-pgi-2500xl-magenta-hy-9266b001', 'TSIFCF16M**J', 'http://tonersales,eu/shop/1832/-canon-pgi-2500xl-magenta-hy-9266b001,jpg', 0, '0', '<p>CANON MAXIFY iB4050 , MB5050 , MB5350</p>', '<p>21 ml     : CANON MAXIFY iB4050 , MB5050 , MB5350</p>'),
	(1315, '1', ' CANON PGI-2500XL Yellow HY (9195B001)', 0, 10.64, 0, 110, 0.2, '-canon-pgi-2500xl-yellow-hy-9195b001', 'TSIFCF17Y**J', 'http://tonersales,eu/shop/1831/-canon-pgi-2500xl-yellow-hy-9195b001,jpg', 0, '0', '<p>CANON MAXIFY iB4050 , MB5050 , MB5350</p>', '<p>21 ml     : CANON MAXIFY iB4050 , MB5050 , MB5350</p>'),
	(1316, '1', ' CANON BX-20 0896A002', 0, 13.98, 0, 1, 0.2, 'canon-bx-20-0896a002', 'TSCAN BX-20', 'http://tonersales,eu/shop/1835/canon-bx-20-0896a002,jpg', 0, '0', '<p>Canon FAX EB10 , 15 B160 , 210C , 215C , 230C , 180C MPC20 , C30 , C50 , C70 , C75 , C80</p>', '<p>    : Canon FAX EB10 , 15 B160 , 210C , 215C , 230C , 180C MPC20 , C30 , C50 , C70 , C75 , C80</p>'),
	(1317, '1', ' CANON PG-50 Black', 0, 15.06, 0, 1, 0.2, '#NAME?', 'TSJX200', 'http://tonersales,eu/shop/693/-canon-pg-50-black,jpg', 0, '0', '<p>Canon Ip2200 MP150 , mp160 , mp170 , mp180 , mp450 , mp460 MX300 , mx310 FAX JX-200 , jx-210 , jx-500</p>', '<p>320,19 ml     : Canon Ip2200 MP150 , mp160 , mp170 , mp180 , mp450 , mp460 MX300 , mx310 FAX JX-200 , jx-210 , jx-500</p>'),
	(1318, '1', ' CANON CL-41 COLOUR', 0, 15.62, 0, 103, 0.2, '#NAME?', 'TSCL-41 Color', 'http://tonersales,eu/shop/1836/-canon-cl-41-colour,jpg', 0, '0', '<p>Canon Ip1800 , 2500 , 2600 , 200 , 6210D , 6220D , 1200 , 1300 , 1600 , 1700, MP140 , 190 , 210 , 220 , 470 , 150 , 160 , 170 , 180 , 450 , 460 MX300 , 310</p>', '<p>228,12,5 ml     : Canon Ip1800 , 2500 , 2600 , 200 , 6210D , 6220D , 1200 , 1300 , 1600 , 1700, MP140 , 190 , 210 , 220 , 470 , 150 , 160 , 170 , 180 , 450 , 460 MX300 , 310</p>'),
	(1319, '1', ' PG-510  ,  PG-512', 0, 15.64, 0, 1, 0.2, '#NAME?', 'TSPGI-510', 'http://tonersales,eu/shop/694/-pg-510-pg-512,jpg', 0, '0', '<p>MP230 , MP240 , MP250 , MP260 , MP270 , MP280 , MP480 , MP490 , MP495 MX320 , MX330 , MX350 , MX360 , MX410 , MX420 , IP2700</p>', '<p>16 ml     : MP230 , MP240 , MP250 , MP260 , MP270 , MP280 , MP480 , MP490 , MP495 MX320 , MX330 , MX350 , MX360 , MX410 , MX420 , IP2700</p>'),
	(1320, '1', ' CANON CL-51 Colour', 0, 15.91, 0, 104, 0.2, '#NAME?', 'TSCl41', 'http://tonersales,eu/shop/696/-canon-cl-51-colour,jpg', 0, '0', '<p>Canon Ip2200 MP150 , mp160 , mp170 , mp180 , mp450 , mp460 MX300 , mx310 FAX JX-200 , jx-210 , jx-500</p>', '<p>330,17,5 ml     : Canon Ip2200 MP150 , mp160 , mp170 , mp180 , mp450 , mp460 MX300 , mx310 FAX JX-200 , jx-210 , jx-500</p>'),
	(1321, '1', ' CL-511  , CL-513', 0, 22.5, 0, 1, 0.2, '#NAME?', 'TSCLI-511', 'http://tonersales,eu/shop/697/-cl-511-cl-513,jpg', 0, '0', '<p>MP230 , MP240 , MP250 , MP260 , MP270 , MP280 , MP480 , MP490 , MP495 MX320 , MX330 , MX350 , MX360 , MX410 , MX420 , IP2700</p>', '<p>15 ml     : MP230 , MP240 , MP250 , MP260 , MP270 , MP280 , MP480 , MP490 , MP495 MX320 , MX330 , MX350 , MX360 , MX410 , MX420 , IP2700</p>'),
	(1322, '1', ' CANON BX-3 0884A002', 1, 19.22, 0, 1, 0.2, 'canon-bx-3-0884a002', 'TSCAN BX-3', 'http://tonersales,eu/shop/698/canon-bx-3-0884a002,jpg', 0, '0', 'Canon FAX-B100 , B110 , B115 , B120 , B140 , B150 , B155 , B820 , B822 , B840 , MultiPass 10', '     :  Canon FAX-B100 , B110 , B115 , B120 , B140 , B150 , B155 , B820 , B822 , B840 , MultiPass 10'),
	(1323, '1', ' EPSON 1T017(C13T01740120)', 0, 2.76, 0, 1, 0.2, '-epson-1t017c13t01740120', 'TS1T017C13T01740120', 'http://tonersales,eu/shop/862/-epson-1t017c13t01740120,jpg', 0, '0', '<p>EPSON Stylus Color 777 , 777i , 680 , 680T , 685</p>', '<p>18 ml     : EPSON Stylus Color 777 , 777i , 680 , 680T , 685</p>'),
	(1324, '1', ' EPSON 1T018(C13T01840120)', 0, 2.76, 0, 1, 0.2, '-epson-1t018c13t01840120', 'TS1T018C13T01840120', 'http://tonersales,eu/shop/1845/-epson-1t018c13t01840120,jpg', 0, '0', '<p>EPSON Stylus Color 777 , 777i , 680 , 680T , 685</p>', '<p>12 ml     : EPSON Stylus Color 777 , 777i , 680 , 680T , 685</p>'),
	(1325, '1', ' EPSON 1T036 (C13T03614020)', 0, 2.76, 0, 1, 0.2, '-epson-1t036-c13t03614020', 'TS1T036 C13T03614020', 'http://tonersales,eu/shop/1846/-epson-1t036-c13t03614020,jpg', 0, '0', '<p>EPSON Stylus C42 Plus , C42S , C42SX , C42UX , C46 , C44 Plus , C44S , C44SX , C44UX</p>', '<p>10 ml     : EPSON Stylus C42 Plus , C42S , C42SX , C42UX , C46 , C44 Plus , C44S , C44SX , C44UX</p>'),
	(1326, '1', ' EPSON 1T037 (C13T03704020)', 0, 2.76, 0, 1, 0.2, '-epson-1t037-c13t03704020', 'TS1T037 C13T03704020', 'http://tonersales,eu/shop/1847/-epson-1t037-c13t03704020,jpg', 0, '0', '<p>EPSON Stylus C42 Plus , C42S , C42SX , C42UX , C46 , C44 Plus , C44S , C44SX , C44UX</p>', '<p>8,5 ml     : EPSON Stylus C42 Plus , C42S , C42SX , C42UX , C46 , C44 Plus , C44S , C44SX , C44UX</p>'),
	(1327, '1', ' EPSON 1T0481 C13T04814020 Black', 0, 2.76, 0, 120, 0.2, '-epson-1t0481-c13t04814020-black', 'TS1T0481', 'http://tonersales,eu/shop/866/-epson-1t0481-c13t04814020-black,jpg', 0, '0', '<p>EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>', '<p>17 ml     : EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>'),
	(1328, '1', ' EPSON 1T0482 C13T04824020 Cyan', 0, 2.76, 0, 108, 0.2, '-epson-1t0482-c13t04824020-cyan', 'TS1T0482', 'http://tonersales,eu/shop/1844/-epson-1t0482-c13t04824020-cyan,jpg', 0, '0', '<p>EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>', '<p>17 ml     : EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>'),
	(1329, '1', ' EPSON 1T0483 C13T04834020 Magenta', 0, 2.76, 0, 110, 0.2, '-epson-1t0483-c13t04834020-magenta', 'TS1T0483', 'http://tonersales,eu/shop/870/-epson-1t0483-c13t04834020-magenta,jpg', 0, '0', '<p>EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>', '<p>17 ml     : EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>'),
	(1330, '1', ' EPSON 1T0484 C13T04844020 Yellow', 0, 2.76, 0, 108, 0.2, '-epson-1t0484-c13t04844020-yellow', 'TS1T0484', 'http://tonersales,eu/shop/869/-epson-1t0484-c13t04844020-yellow,jpg', 0, '0', '<p>EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>', '<p>17 ml     : EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>'),
	(1331, '1', ' EPSON 1T0485 C13T04854020 Light Cyan', 0, 2.76, 0, 108, 0.2, '-epson-1t0485-c13t04854020-light-cyan', 'TS1T0485', 'http://tonersales,eu/shop/1842/-epson-1t0485-c13t04854020-light-cyan,jpg', 0, '0', '<p>EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>', '<p>17 ml     : EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>'),
	(1332, '1', ' EPSON 1T0486 C13T04864020 Light Magenta', 0, 2.76, 0, 108, 0.2, '-epson-1t0486-c13t04864020-light-magenta', 'TS1T0486', 'http://tonersales,eu/shop/1843/-epson-1t0486-c13t04864020-light-magenta,jpg', 0, '0', '<p>EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>', '<p>17 ml     : EPSON Stylus Photo R200 , R220 , R300 , R300M , R320 , R340 , RX500 , RX600 , RX620 , RX640</p>'),
	(1333, '1', ' EPSON 1T0611 C13T06114020 Black', 0, 2.76, 0, 115, 0.2, '-epson-1t0611-c13t06114020-black', 'TS1T0611', 'http://tonersales,eu/shop/873/-epson-1t0611-c13t06114020-black,jpg', 0, '0', '<p>EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>', '<p>12 ml     : EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>'),
	(1334, '1', ' EPSON 1T0612 C13T06124020 Cyan', 0, 2.76, 0, 116, 0.2, '-epson-1t0612-c13t06124020-cyan', 'TS1T0612', 'http://tonersales,eu/shop/874/-epson-1t0612-c13t06124020-cyan,jpg', 0, '0', '<p>EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>', '<p>12 ml     : EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>'),
	(1335, '1', ' EPSON 1T0613 C13T06134020 Magenta', 0, 2.76, 0, 106, 0.2, '-epson-1t0613-c13t06134020-magenta', 'TS1T0613', 'http://tonersales,eu/shop/875/-epson-1t0613-c13t06134020-magenta,jpg', 0, '0', '<p>EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>', '<p>12 ml     : EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>'),
	(1336, '1', ' EPSON 1T0614 C13T06144020 Yellow', 0, 2.76, 0, 106, 0.2, '-epson-1t0614-c13t06144020-yellow', 'TS1T0614', 'http://tonersales,eu/shop/876/-epson-1t0614-c13t06144020-yellow,jpg', 0, '0', '<p>EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>', '<p>12 ml     : EPSON Stylus D68 , D68PE , D88 , D88PE , DX3800 , DX3850 , DX4200 , DX4250 , DX4800 , DX4850</p>'),
	(1337, '1', ' EPSON T0711/T0891 BK', 0, 2.76, 0, 107, 0.2, '#NAME?', 'TST0711H', 'http://tonersales,eu/shop/1850/-epson-t0711t0891-bk,jpg', 0, '0', '<p>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</p>', '<p>14 ml     : EPSON StylusD78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</p>'),
	(1339, '1', ' EPSON T0712/T0892 C', 0, 2.76, 0, 108, 0.2, '-epson-t0712t0892-c', 'TS1T0712', 'http://tonersales,eu/shop/1852/-epson-t0712t0892-c,jpg', 0, '0', '<p><span>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</span></p>', '<p>14 ml     :<span>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</span></p>'),
	(1340, '1', ' EPSON T0713/T0893 MG', 0, 2.76, 0, 109, 0.2, '#NAME?', 'TS1T0713', 'http://tonersales,eu/shop/1849/-epson-t0713t0893-mg,jpg', 0, '0', '<p><span>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</span></p>', '<p>14 ml     :<span>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</span></p>'),
	(1341, '1', ' EPSON T0714/T0894 Y', 0, 2.76, 0, 109, 0.2, '#NAME?', 'TS1T0714', 'http://tonersales,eu/shop/1848/-epson-t0714t0894-y,jpg', 0, '0', '<p><span>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</span></p>', '<p>14 ml     :<span>EPSON Stylus D78, D92, D92, D120, DX4000, DX4050, DX4400, DX4450, DX5000, DX5050, DX6000, DX6050, DX7000F, DX7400, DX7450, DX8400, DX8450, S20, S21, SX100, SX105, SX110, SX115, SX200, SX205, SX210, SX215, SX218, SX400, SX405, SX410, SX415, SX510W, SX515W, SX610FW/SX218 EPSON Stylus Office B40W, BX300F, BX310FN, BX600FW, BX610FW</span></p>'),
	(1342, '1', ' EPSON T0801 BK', 0, 2.76, 0, 128, 0.2, '#NAME?', 'TS1T0801', 'http://tonersales,eu/shop/1838/-epson-t0801-bk,jpg', 0, '0', '<p>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</p>', '<p>15 ml     :EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</p>'),
	(1343, '1', ' EPSON T0802 C', 0, 2.76, 0, 115, 0.2, '-epson-t0802-c', 'TS1T0802', 'http://tonersales,eu/shop/1837/-epson-t0802-c,jpg', 0, '0', '<p><span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>', '<p>15 ml     :<span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>'),
	(1344, '1', ' EPSON T0803 MG', 0, 2.76, 0, 115, 0.2, '#NAME?', 'TS1T0803', 'http://tonersales,eu/shop/1839/-epson-t0803-mg,jpg', 0, '0', '<p><span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>', '<p>15 ml     :<span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>'),
	(1345, '1', ' EPSON T0804 Y', 0, 2.76, 0, 114, 0.2, '#NAME?', 'TS1T0804', 'http://tonersales,eu/shop/1840/-epson-t0804-y,jpg', 0, '0', '<p><span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>', '<p>15 ml     :<span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>'),
	(1346, '1', ' EPSON T0805 LC', 0, 2.76, 0, 114, 0.2, '#NAME?', 'TS1T0805', 'http://tonersales,eu/shop/1841/-epson-t0805-lc,jpg', 0, '0', '<p><span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>', '<p>15 ml     :<span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>'),
	(1347, '1', ' EPSON T0806 LM', 0, 2.76, 0, 114, 0.2, '#NAME?', 'TS1T0806', 'http://tonersales,eu/shop/1864/-epson-t0806-lm,jpg', 0, '0', '<p><span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>', '<p>15 ml     :<span>EPSON Stylus R265, R285, R360, RX560, RX585, RX685, P50, PX650W, PX700W, PX710W, PX800FW, PX810W, PHOTO PX660/PHOTO PX720WD</span></p>'),
	(1348, '1', ' EPSON T1281 BK', 0, 2.76, 0, 107, 0.2, '#NAME?', 'TST1281', 'http://tonersales,eu/shop/1860/-epson-t1281-bk,jpg', 0, '0', '<p>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</p>', '<p>10 ml     :EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</p>'),
	(1349, '1', ' EPSON T1282 C', 0, 2.76, 0, 109, 0.2, '-epson-t1282-c', 'TST1282', 'http://tonersales,eu/shop/1861/-epson-t1282-c,jpg', 0, '0', '<p><span>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</span></p>', '<p>8ml     :<span>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</span></p>'),
	(1350, '1', ' EPSON T1283 MG', 0, 2.76, 0, 110, 0.2, '#NAME?', 'TST1283', 'http://tonersales,eu/shop/1862/-epson-t1283-mg,jpg', 0, '0', '<p><span>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</span></p>', '<p>8 ml     :<span>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</span></p>'),
	(1351, '1', ' EPSON T1284 Y', 0, 2.76, 0, 108, 0.2, '#NAME?', 'TST1284', 'http://tonersales,eu/shop/1863/-epson-t1284-y,jpg', 0, '0', '<p><span>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</span></p>', '<p>8ml     :<span>EPSON Stylus S22, SX125, SX130, SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W EPSON Stylus Office BX305F, BX305FW</span></p>'),
	(1352, '1', ' EPSON T1291 BK', 0, 2.76, 0, 111, 0.2, '#NAME?', 'TST1291', 'http://tonersales,eu/shop/1859/-epson-t1291-bk,jpg', 0, '0', '<p>EPSON Stylus SX230, SX235W, SX420W, SX425W, SX435W, SX440W, SX445, SX525WD, SX535WD, SX620FW, OFFICE B42WD, BX305F, BX305FW, BX525WD, BX535WD, BX625FWD, BX635FWD, BX925FWD, BX925FW, BX935FWD Workforce WF3540DTWF</p>', '<p>15 ml     :EPSON Stylus SX230, SX235W, SX420W, SX425W, SX435W, SX440W, SX445, SX525WD, SX535WD, SX620FW, OFFICE B42WD, BX305F, BX305FW, BX525WD, BX535WD, BX625FWD, BX635FWD, BX925FWD, BX925FW, BX935FWD Workforce WF3540DTWF</p>'),
	(1353, '1', ' EPSON T1292 C', 0, 2.76, 0, 113, 0.2, '-epson-t1292-c', 'TST1292', 'http://tonersales,eu/shop/1858/-epson-t1292-c,jpg', 0, '0', '<p>EPSON Stylus SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W, SX525WD, SX535WD, SX620FW, Stylus Office BX305F, BX305FW, BX320FW, BX525WD, BX625FWD, BX635FWD, BX925FWD, BX935FWD, B42WD, WorkForce WF-7015/7515/7525</p>', '<p>12 ml     :EPSON Stylus SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W, SX525WD, SX535WD, SX620FW, Stylus Office BX305F, BX305FW, BX320FW, BX525WD, BX625FWD, BX635FWD, BX925FWD, BX935FWD, B42WD, WorkForce WF-7015/7515/7525</p>'),
	(1354, '1', ' EPSON T1293 MG', 0, 2.76, 0, 111, 0.2, '#NAME?', 'TST1293', 'http://tonersales,eu/shop/1854/-epson-t1293-mg,jpg', 0, '0', '<p><span>EPSON Stylus SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W, SX525WD, SX535WD, SX620FW, Stylus Office BX305F, BX305FW, BX320FW, BX525WD, BX625FWD, BX635FWD, BX925FWD, BX935FWD, B42WD, WorkForce WF-7015/7515/7525</span></p>', '<p>12 ml     :<span>EPSON Stylus SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W, SX525WD, SX535WD, SX620FW, Stylus Office BX305F, BX305FW, BX320FW, BX525WD, BX625FWD, BX635FWD, BX925FWD, BX935FWD, B42WD, WorkForce WF-7015/7515/7525</span></p>'),
	(1355, '1', ' EPSON T1294 Y', 0, 2.76, 0, 112, 0.2, '#NAME?', 'TST1294', 'http://tonersales,eu/shop/1853/-epson-t1294-y,jpg', 0, '0', '<p><span>EPSON Stylus SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W, SX525WD, SX535WD, SX620FW, Stylus Office BX305F, BX305FW, BX320FW, BX525WD, BX625FWD, BX635FWD, BX925FWD, BX935FWD, B42WD, WorkForce WF-7015/7515/7525</span></p>', '<p>12 ml     :<span>EPSON Stylus SX230, SX235W, SX420W, SX425W, SX430W, SX435W, SX440W, SX445W, SX525WD, SX535WD, SX620FW, Stylus Office BX305F, BX305FW, BX320FW, BX525WD, BX625FWD, BX635FWD, BX925FWD, BX935FWD, B42WD, WorkForce WF-7015/7515/7525</span></p>'),
	(1356, '1', ' EPSON T1001 C13T10014020 Black', 0, 2.76, 0, 1, 0.2, '-epson-t1001-c13t10014020-black', 'TSIFEF27B**J', 'http://tonersales,eu/shop/1855/-epson-t1001-c13t10014020-black,jpg', 0, '0', '<p>Rinnoceros- EPSON Stylus Office B40W , BX600FW , BX610FW , Stylus SX510Wseries , SX600FW , SX610FW</p>', '<p>26 ml     : Rinnoceros- EPSON Stylus Office B40W , BX600FW , BX610FW , Stylus SX510Wseries , SX600FW , SX610FW</p>'),
	(1357, '1', ' EPSON T1002 C13T10024020 Cyan', 0, 2.76, 0, 1, 0.2, '-epson-t1002-c13t10024020-cyan', 'TSIFEF95C**J', 'http://tonersales,eu/shop/1856/-epson-t1002-c13t10024020-cyan,jpg', 0, '0', '<p>Rinnoceros-EPSON Stylus SX510W , SX600FW , SX610FW EPSON Stylus Office B30 , B40W , BX310FN , BX600FW , BX610FW , B1100</p>', '<p>14 ml     : Rinnoceros-EPSON Stylus SX510W , SX600FW , SX610FW EPSON Stylus Office B30 , B40W , BX310FN , BX600FW , BX610FW , B1100</p>'),
	(1358, '1', ' EPSON T1003 C13T10034020 Magenta', 0, 2.76, 0, 1, 0.2, '-epson-t1003-c13t10034020-magenta', 'TSIFEF96M**J', 'http://tonersales,eu/shop/1857/-epson-t1003-c13t10034020-magenta,jpg', 0, '0', '<p>Rinnoceros-EPSON Stylus SX510W , SX600FW , SX610FW EPSON Stylus Office B30 , B40W , BX310FN , BX600FW , BX610FW , B1100</p>', '<p>14 ml     : Rinnoceros-EPSON Stylus SX510W , SX600FW , SX610FW EPSON Stylus Office B30 , B40W , BX310FN , BX600FW , BX610FW , B1100</p>'),
	(1359, '1', ' EPSON T1004 C13T10044020 Yellow', 0, 2.76, 0, 1, 0.2, '-epson-t1004-c13t10044020-yellow', 'TSIFEF97Y**J', 'http://tonersales,eu/shop/1877/-epson-t1004-c13t10044020-yellow,jpg', 0, '0', '<p>Rinnoceros-EPSON Stylus SX510W , SX600FW , SX610FW EPSON Stylus Office B30 , B40W , BX310FN , BX600FW , BX610FW , B1100</p>', '<p>14 ml     : Rinnoceros-EPSON Stylus SX510W , SX600FW , SX610FW EPSON Stylus Office B30 , B40W , BX310FN , BX600FW , BX610FW , B1100</p>'),
	(1360, '1', ' EPSON T1301 BK', 0, 3.2, 0, 101, 0.2, '#NAME?', 'TSB20020', 'http://tonersales,eu/shop/1878/-epson-t1301-bk,jpg', 0, '0', '<p>Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>', '<p>35,5 ml     : Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>'),
	(1361, '1', ' EPSON T1302 C', 0, 2.76, 0, 105, 0.2, '-epson-t1302-c', 'TSB20021', 'http://tonersales,eu/shop/1873/-epson-t1302-c,jpg', 0, '0', '<p>Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>', '<p>15,8 ml     : Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>'),
	(1362, '1', ' EPSON T1303 MG', 0, 2.76, 0, 105, 0.2, '#NAME?', 'TSB20022', 'http://tonersales,eu/shop/1874/-epson-t1303-mg,jpg', 0, '0', '<p>Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>', '<p>15,8 ml     : Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>'),
	(1363, '1', ' EPSON T1304 Y', 0, 2.76, 0, 105, 0.2, '#NAME?', 'TSB20023', 'http://tonersales,eu/shop/1875/-epson-t1304-y,jpg', 0, '0', '<p>Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>', '<p>15,8 ml     : Epson XL Stag-WorkForce WF3010DW , WF3520DWF , WF3530DTWF , WF3540DTWF , WF7015 , WF7515 , WF7525 , Stylus Office B42WD , BX320FW , BX525WD , BX535WD , BX625FWD , BX630FW , BX635FWD , BX925FWD , BX935FWD , Stylus SX445 , SX525WD , SX535WD , SX620FW</p>'),
	(1364, '1', ' EPSON T163140 XL  ,  16XL C13T16314010 black', 0, 2.76, 0, 113, 0.2, 'epson-t163140-xl-16xl-c13t16314010-black', 'TSIFEL90B', 'http://tonersales,eu/shop/1876/epson-t163140-xl-16xl-c13t16314010-black,jpg', 0, '0', '<p>(16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>', '<p>14 ml     : (16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>'),
	(1365, '1', ' EPSON T163240 XL  ,  16XL C13T16324010 cyan', 0, 2.76, 0, 112, 0.2, 'epson-t163240-xl-16xl-c13t16324010-cyan', 'TSIFEL91C', 'http://tonersales,eu/shop/1872/epson-t163240-xl-16xl-c13t16324010-cyan,jpg', 0, '0', '<p>(16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>', '<p>10ml     : (16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>'),
	(1366, '1', ' EPSON T163340 XL  ,  16XL C13T16334010 magenta', 0, 2.76, 0, 113, 0.2, 'epson-t163340-xl-16xl-c13t16334010-magenta', 'TSIFEL92M', 'http://tonersales,eu/shop/1871/epson-t163340-xl-16xl-c13t16334010-magenta,jpg', 0, '0', '<p>(16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>', '<p>10ml     : (16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>'),
	(1367, '1', ' EPSON T163440 XL  ,  16XL C13T16344010 yellow', 0, 2.76, 0, 113, 0.2, 'epson-t163440-xl-16xl-c13t16344010-yellow', 'TSIFEL93Y', 'http://tonersales,eu/shop/1867/epson-t163440-xl-16xl-c13t16344010-yellow,jpg', 0, '0', '<p>(16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>', '<p>10ml     : (16XL) Pen and Crossword-EPSON WorkForce WF2010W , WF2510WF , WF2520NF , WF2530WF , WF2540WF</p>'),
	(1368, '1', ' EPSON T181140 XL  ,  T1811  ,  18XL', 0, 2.76, 0, 117, 0.2, 'epson-t181140-xl-t1811-18xl', 'TSIFEL82B', 'http://tonersales,eu/shop/1865/epson-t181140-xl-t1811-18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>14 ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1369, '1', ' EPSON T181240 XL  ,  T1812  ,  18XL', 0, 2.76, 0, 119, 0.2, 'epson-t181240-xl-t1812-18xl', 'TSIFEL83C', 'http://tonersales,eu/shop/1868/epson-t181240-xl-t1812-18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>10ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1370, '1', ' EPSON T181340 XL  ,  T1813 ,  18XL', 0, 2.76, 0, 116, 0.2, 'epson-t181340-xl-t1813-18xl', 'TSIFEL84M', 'http://tonersales,eu/shop/1869/epson-t181340-xl-t1813-18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>10ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1371, '1', ' EPSON T181440 XL  ,  T1814 ,  18XL', 0, 2.76, 0, 119, 0.2, 'epson-t181440-xl-t1814-18xl', 'TSIFEL85Y', 'http://tonersales,eu/shop/1870/epson-t181440-xl-t1814-18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>10ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1372, '1', ' EPSON T2621 XL Black', 0, 4.99, 0, 111, 0.2, '#NAME?', 'TSB20926', 'http://tonersales,eu/shop/1887/-epson-t2621-xl-black,jpg', 0, '0', '<p>Epson Expression Premium XP600, XP605, XP610, XP615, XP700, XP710, XP800, XP810</p>', '<p>21ml     :Epson Expression Premium XP600, XP605, XP610, XP615, XP700, XP710, XP800, XP810</p>'),
	(1373, '1', ' EPSON T2631 XL Photo Black', 0, 3.57, 0, 100, 0.2, '#NAME?', 'TSB20927', 'http://tonersales,eu/shop/1881/-epson-t2631-xl-photo-black,jpg', 0, '0', '<p>Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>', '<p>15,5 ml     : Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>'),
	(1374, '1', ' EPSON T2632 XL Cyan', 0, 3.57, 0, 111, 0.2, '#NAME?', 'TSB20928', 'http://tonersales,eu/shop/1882/-epson-t2632-xl-cyan,jpg', 0, '0', '<p>Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>', '<p>10 ml     : Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>'),
	(1375, '1', ' EPSON T2633 XL Magenta', 0, 3.57, 0, 111, 0.2, '#NAME?', 'TSB20929', 'http://tonersales,eu/shop/1880/-epson-t2633-xl-magenta,jpg', 0, '0', '<p>Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>', '<p>10 ml     : Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>'),
	(1376, '1', ' EPSON T2634 XL Yellow', 0, 3.57, 0, 111, 0.2, '#NAME?', 'TSB20930', 'http://tonersales,eu/shop/1879/-epson-t2634-xl-yellow,jpg', 0, '0', '<p>Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>', '<p>10 ml     : Epson 26XL Polar Bear-Expression Premium XP600 , XP605 , XP700 , XP800</p>'),
	(1377, '1', ' EPSON 27XL T2711XL BK', 0, 3.86, 0, 107, 0.2, '-epson-27xl-t2711xl-bk', 'TSIQE580B**J', 'http://tonersales,eu/shop/1885/-epson-27xl-t2711xl-bk,jpg', 0, '0', '<p>EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>', '<p>35 ml     : EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>'),
	(1378, '1', ' EPSON 27XL T2712 Cyan', 0, 3.86, 0, 107, 0.2, '-epson-27xl-t2712-cyan', 'TSIQE581C**J', 'http://tonersales,eu/shop/1886/-epson-27xl-t2712-cyan,jpg', 0, '0', '<p>EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>', '<p>15ml     : EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>'),
	(1379, '1', ' EPSON 27XL T2713 Magenta', 0, 3.86, 0, 107, 0.2, '-epson-27xl-t2713-magenta', 'TSIQE582M**J', 'http://tonersales,eu/shop/1884/-epson-27xl-t2713-magenta,jpg', 0, '0', '<p>EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>', '<p>15 ml     : EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>'),
	(1380, '1', ' EPSON 27XL T2714 Yellow', 0, 3.86, 0, 107, 0.2, '-epson-27xl-t2714-yellow', 'TSIQE583Y**J', 'http://tonersales,eu/shop/1883/-epson-27xl-t2714-yellow,jpg', 0, '0', '<p>EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>', '<p>15ml     : EPSON WorkForce WF-3620DWF , 3640DTWF , 7110DTW , 7610DWF , 7620DTWF</p>'),
	(1381, '1', ' EPSON T0591', 0, 4.42, 0, 1, 0.2, 'epson-t0591', 'TSIFE372D', 'http://tonersales,eu/shop/922/epson-t0591,jpg', 0, '0', '<p>EPSON Stylus Photo R2400</p>', '<p>17 ml     : EPSON Stylus Photo R2400</p>'),
	(1382, '1', ' EPSON T0592', 0, 4.42, 0, 1, 0.2, 'epson-t0592', 'TSIFE373C', 'http://tonersales,eu/shop/923/epson-t0592,jpg', 0, '0', '<p>EPSON Stylus Photo R2400</p>', '<p>17 ml     : EPSON Stylus Photo R2400</p>'),
	(1383, '1', ' EPSON T0593', 1, 4.42, 0, 1, 0.2, 'epson-t0593', 'TSIFE374M', 'http://tonersales,eu/shop/924/epson-t0593,jpg', 0, '0', 'EPSON Stylus Photo R2400', '17 ml               :  EPSON Stylus Photo R2400'),
	(1384, '1', ' EPSON T0594', 0, 4.42, 0, 1, 0.2, 'epson-t0594', 'TSIFE375Y', 'http://tonersales,eu/shop/925/epson-t0594,jpg', 0, '0', '<p>EPSON Stylus Photo R2400</p>', '<p>17 ml     : EPSON Stylus Photo R2400</p>'),
	(1385, '1', ' EPSON T0595', 0, 4.42, 0, 1, 0.2, 'epson-t0595', 'TSIFE376Z', 'http://tonersales,eu/shop/926/epson-t0595,jpg', 0, '0', '<p>EPSON Stylus Photo R2400</p>', '<p>17 ml     : EPSON Stylus Photo R2400</p>'),
	(1386, '1', ' EPSON T0596', 1, 4.42, 0, 1, 0.2, 'epson-t0596', 'TSIFE377J', 'http://tonersales,eu/shop/927/epson-t0596,jpg', 0, '0', 'EPSON Stylus Photo R2400', '17 ml               :  EPSON Stylus Photo R2400'),
	(1387, '1', ' EPSON T0597', 1, 4.42, 0, 1, 0.2, 'epson-t0597', 'TSIFE378F', 'http://tonersales,eu/shop/928/epson-t0597,jpg', 0, '0', 'EPSON Stylus Photo R2400', '17 ml               :  EPSON Stylus Photo R2400'),
	(1388, '1', ' EPSON T0598', 1, 4.42, 0, 1, 0.2, 'epson-t0598', 'TSIFE379H', 'http://tonersales,eu/shop/929/epson-t0598,jpg', 0, '0', 'EPSON Stylus Photo R2400', '17 ml               :  EPSON Stylus Photo R2400'),
	(1389, '1', ' EPSON T0599', 0, 4.42, 0, 1, 0.2, 'epson-t0599', 'TSIFE380F', 'http://tonersales,eu/shop/930/epson-t0599,jpg', 0, '0', '<p>EPSON Stylus Photo R2400</p>', '<p>17 ml     : EPSON Stylus Photo R2400</p>'),
	(1390, '1', ' EPSON E1811(cleaning Cartridge)18xl', 0, 4.42, 0, 1, 0.2, '#NAME?', 'TSB28338', 'http://tonersales,eu/shop/931/-epson-e1811cleaning-cartridge18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>17ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1391, '1', ' EPSON E1812(cleaning Cartridge)18xl', 0, 4.42, 0, 1, 0.2, '#NAME?', 'TSB28339', 'http://tonersales,eu/shop/932/-epson-e1812cleaning-cartridge18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>13 ,5ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1392, '1', ' EPSON E1813(cleaning Cartridge)18xl', 0, 4.42, 0, 1, 0.2, '#NAME?', 'TSB28340', 'http://tonersales,eu/shop/933/-epson-e1813cleaning-cartridge18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>13 ,5ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1393, '1', ' EPSON E1814 cleaning Cartridge 18xl', 0, 4.42, 0, 1, 0.2, '-epson-e1814-cleaning-cartridge-18xl', 'TSB28341', 'http://tonersales,eu/shop/934/-epson-e1814-cleaning-cartridge-18xl,jpg', 0, '0', '<p>EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>', '<p>13 ,5 ml     : EPSON Expression Home XP102 , XP202 , XP205 , XP30 , XP302 , XP305 , XP402 , XP405 , XP212 , XP215 , XP225 , XP312 , XP315 , XP322 , XP325 , XP412 , XP415 , XP422 , XP425</p>'),
	(1394, '1', ' EPSON T702140  , T7011  ,  T703140', 0, 6.62, 0, 1, 0.2, 'epson-t702140-t7011-t703140', 'TSIFEK58B', 'http://tonersales,eu/shop/1888/epson-t702140-t7011-t703140,jpg', 0, '0', '<p>EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>', '<p>70 ml     : EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>'),
	(1395, '1', ' EPSON T702240  ,  T7012 ,  T703240', 0, 6.62, 0, 1, 0.2, 'epson-t702240-t7012-t703240', 'TSIFEK59C', 'http://tonersales,eu/shop/1889/epson-t702240-t7012-t703240,jpg', 0, '0', '<p>EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>', '<p>36 ml     : EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>'),
	(1396, '1', ' EPSON T702340  ,  T7013 , T703340', 0, 6.62, 0, 1, 0.2, 'epson-t702340-t7013-t703340', 'TSIFEK60M', 'http://tonersales,eu/shop/1891/epson-t702340-t7013-t703340,jpg', 0, '0', '<p>EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>', '<p>36 ml     : EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>'),
	(1397, '1', ' EPSON T702440  , T7014 , T703440', 0, 6.62, 0, 1, 0.2, 'epson-t702440-t7014-t703440', 'TSIFEK61Y', 'http://tonersales,eu/shop/1890/epson-t702440-t7014-t703440,jpg', 0, '0', '<p>EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>', '<p>36 ml     : EPSON Workforce Pro WP4000Series , WP4015DN , WP4025DN , WP4095DN , WP4515DN , WP4525DNF , WP4500Series , WP4535DWF , WP4545DTWF , WP4595DNF</p>'),
	(1398, '1', ' EPSON 79XL C13T79014010 E7891XXL Black', 0, 9.94, 0, 1, 0.2, '-epson-79xl-c13t79014010-e7891xxl-black', 'TSIFES66B**J', 'http://tonersales,eu/shop/1892/-epson-79xl-c13t79014010-e7891xxl-black,jpg', 0, '0', '<p>EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>', '<p>70 ml     : EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>'),
	(1399, '1', ' EPSON 79XL C13T79024010 E7892XXL Cyan', 0, 9.94, 0, 102, 0.2, '-epson-79xl-c13t79024010-e7892xxl-cyan', 'TSIFES67C**J', 'http://tonersales,eu/shop/1893/-epson-79xl-c13t79024010-e7892xxl-cyan,jpg', 0, '0', '<p>EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>', '<p>36 ml     : EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>'),
	(1400, '1', ' EPSON 79XL C13T79034010 E7893XXL Magenta', 0, 9.94, 0, 102, 0.2, '-epson-79xl-c13t79034010-e7893xxl-magenta', 'TSIFES68M**J', 'http://tonersales,eu/shop/1894/-epson-79xl-c13t79034010-e7893xxl-magenta,jpg', 0, '0', '<p>EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>', '<p>36 ml     : EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>'),
	(1401, '1', ' EPSON 79XL C13T79044010 E7894 XXL Yellow', 0, 9.94, 0, 102, 0.2, '-epson-79xl-c13t79044010-e7894-xxl-yellow', 'TSIFES69Y**J', 'http://tonersales,eu/shop/1895/-epson-79xl-c13t79044010-e7894-xxl-yellow,jpg', 0, '0', '<p>EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>', '<p>36 ml     : EPSON WorkForce Pro WF5110 , WF5190 , WF5690 , WF5620</p>'),
	(1402, '1', ' LEXMARK NO 100XL, 108XL CY (14N1069E)', 0, 4.31, 0, 1, 0.2, '-lexmark-no-100xl-108xl-cy-14n1069e', 'TS100/108XL CY 14N1069E', 'http://tonersales,eu/shop/1785/-lexmark-no-100xl-108xl-cy-14n1069e,jpg', 0, '0', '<p>LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>', '<p>13 ml     : LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>'),
	(1403, '1', ' LEXMARK NO 100XL, 108XL MG (14N1070E)', 0, 4.31, 0, 1, 0.2, '-lexmark-no-100xl-108xl-mg-14n1070e', 'TS100/108XL MG 14N1070E', 'http://tonersales,eu/shop/1787/-lexmark-no-100xl-108xl-mg-14n1070e,jpg', 0, '0', '<p>LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>', '<p>13 ml     : LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>'),
	(1404, '1', ' LEXMARK NO 100XL, 108XL YL (14N1071E)', 0, 4.31, 0, 1, 0.2, '-lexmark-no-100xl-108xl-yl-14n1071e', 'TS100/108XL YL 14N1071E', 'http://tonersales,eu/shop/1786/-lexmark-no-100xl-108xl-yl-14n1071e,jpg', 0, '0', '<p>LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>', '<p>13 ml     : LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>'),
	(1405, '1', ' LEXMARK NO 100XL, 105, 108XL BK 14N1068E', 0, 4.42, 0, 13, 0.2, '-lexmark-no-100xl-105-108xl-bk-14n1068e', 'TS100/105/108XL BK 14N1068E', 'http://tonersales,eu/shop/1788/-lexmark-no-100xl-105-108xl-bk-14n1068e,jpg', 0, '0', '<p>LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>', '<p>25 ml     : LEXMARK S300 , S305 , S308 , S405 , S409 , S505 , S508 , S605 , Pro205 , Pro200 , Pro209 , Pro704 , Pro705 , Pro709 , Pro714 , Pro805 , Pro905 , Pro901 , Pro905</p>'),
	(1406, '1', ' LEXMARK 210XL CYAN 14L0175E', 0, 8.72, 0, 13, 0.2, 'lexmark-210xl-cyan-14l0175e', 'TSIFL045C**J', 'http://tonersales,eu/shop/571/lexmark-210xl-cyan-14l0175e,jpg', 0, '0', '<p>Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>', '<p>1600 ml     : Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>'),
	(1407, '1', ' LEXMARK 210XL MAGENTA 14L0176E', 0, 8.72, 0, 13, 0.2, 'lexmark-210xl-magenta-14l0176e', 'TSIFL046M**J', 'http://tonersales,eu/shop/572/lexmark-210xl-magenta-14l0176e,jpg', 0, '0', '<p>Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>', '<p>1600 ml     : Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>'),
	(1408, '1', ' LEXMARK 210XL YELLOW 14L0177E', 0, 8.72, 0, 13, 0.2, 'lexmark-210xl-yellow-14l0177e', 'TSIFL047Y**J', 'http://tonersales,eu/shop/573/lexmark-210xl-yellow-14l0177e,jpg', 0, '0', '<p>Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>', '<p>1600 ml     : Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>'),
	(1409, '1', ' LEXMARK 210XL BLACK 14L0174E', 0, 9.05, 0, 1, 0.2, 'lexmark-210xl-black-14l0174e', 'TSIFL044B**J', 'http://tonersales,eu/shop/1547/lexmark-210xl-black-14l0174e,jpg', 0, '0', '<p>Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>', '<p>2500 ml     : Lexmark OfficeEdge Pro4000 Series Lexmark OfficeEdge Pro5500 Pro5500t</p>'),
	(1411, '1', ' LEXMARK NO 16 (10N0016) BK', 0, 14.95, 0, 1, 0.2, '-lexmark-no-16-10n0016-bk', 'TSLEX NO 16 10N0016', 'http://tonersales,eu/shop/1620/-lexmark-no-16-10n0016-bk,jpg', 0, '0', '<p>LEXMARK I3 , Z13 , Z23 , Z24 , Z25 , Z33 , Z34 , Z35 , Z500 , Z511 , Z513 , Z515 , Z517 , Z600 , Z601 , Z602 , Z603 , Z605 , Z611 , , Z612 , Z613 , Z614 , Z615 , Z600 , Z617 , Z640 , Z645 , Z647 , X74 , X75 , X1110 , X1130 , X1140 , X1150 , X1155 , X1160 , X1170 , X1180 , X1185 , X1190 , X1195 , X1250 , X1200 , X1270 , X1290 , X2230 , X2240 , X2250</p>', '<p>200,12,8 ml     : LEXMARK I3 , Z13 , Z23 , Z24 , Z25 , Z33 , Z34 , Z35 , Z500 , Z511 , Z513 , Z515 , Z517 , Z600 , Z601 , Z602 , Z603 , Z605 , Z611 , , Z612 , Z613 , Z614 , Z615 , Z600 , Z617 , Z640 , Z645 , Z647 , X74 , X75 , X1110 , X1130 , X1140 , X1150 , X1155 , X1160 , X1170 , X1180 , X1185 , X1190 , X1195 , X1250 , X1200 , X1270 , X1290 , X2230 , X2240 , X2250</p>'),
	(1412, '1', ' LEXMARK NO 26 (10N0026) 3C', 0, 16.85, 0, 1, 0.2, '-lexmark-no-26-10n0026-3c', 'TSLEX NO 26 10N0026', 'http://tonersales,eu/shop/1548/-lexmark-no-26-10n0026-3c,jpg', 0, '0', '<p>LEXMARK I3 , Z13 , Z23 , Z24 , Z25 , Z33 , Z34 , Z35 , Z500 , Z511 , Z513 , Z515 , Z517 , Z600 , Z601 , Z602 , Z603 , Z605 , Z611 , , Z612 , Z613 , Z614 , Z615 , Z600 , Z617 , Z640 , Z645 , Z647 , X74 , X75 , X1110 , X1130 , X1140 , X1150 , X1155 , X1160 , X1170 , X1180 , X1185 , X1190 , X1195 , X1250 , X1200 , X1270 , X1290 , X2230 , X2240 , X2250</p>', '<p>240,11,3 ml     : LEXMARK I3 , Z13 , Z23 , Z24 , Z25 , Z33 , Z34 , Z35 , Z500 , Z511 , Z513 , Z515 , Z517 , Z600 , Z601 , Z602 , Z603 , Z605 , Z611 , , Z612 , Z613 , Z614 , Z615 , Z600 , Z617 , Z640 , Z645 , Z647 , X74 , X75 , X1110 , X1130 , X1140 , X1150 , X1155 , X1160 , X1170 , X1180 , X1185 , X1190 , X1195 , X1250 , X1200 , X1270 , X1290 , X2230 , X2240 , X2250</p>'),
	(1413, '1', ' LEXMARK 12A1975 NO 75 , 12A1970E NO 70 XL', 0, 13.79, 0, 50, 0.2, '-lexmark-12a1975-no-75-12a1970e-no-70-xl', 'TS13210805', 'http://tonersales,eu/shop/578/-lexmark-12a1975-no-75-12a1970e-no-70-xl,jpg', 0, '0', '<p>Color Jetprinter 3200 , 5000 , 5700 , 5770 , 7000 , 7200 , 7200V Color Jetprinter Z11 , Z31 , Z42 , Z43 , Z44 , Z45 , Z51 , Z52 , Z53 , Z54 , Z54SE , Z82 Color Jetprinter X63 , X70 , x72 , X73 , X80 , X83 , X84 , X85 , X85PRO , X125 , X125PRO , X4250 , x4270 Color Jetprinter F4250 , F4270 , F4260 , F4290 Optra Color 40 , 45 , 40N , 45N , 12AX970E , 12A1970E</p>', '<p>436,26 ml     : Color Jetprinter 3200 , 5000 , 5700 , 5770 , 7000 , 7200 , 7200V Color Jetprinter Z11 , Z31 , Z42 , Z43 , Z44 , Z45 , Z51 , Z52 , Z53 , Z54 , Z54SE , Z82 Color Jetprinter X63 , X70 , x72 , X73 , X80 , X83 , X84 , X85 , X85PRO , X125 , X125PRO , X4250 , x4270 Color Jetprinter F4250 , F4270 , F4260 , F4290 Optra Color 40 , 45 , 40N , 45N , 12AX970E , 12A1970E</p>'),
	(1414, '1', ' LEXMARK 15M0120 No 20  , 15MX120E', 0, 15.65, 0, 1, 0.2, 'lexmark-15m0120-no-20-15mx120e', 'TS13210808', 'http://tonersales,eu/shop/579/lexmark-15m0120-no-20-15mx120e,jpg', 0, '0', '<p>Z42 , Z43 , Z45 , Z45se , Z51 , Z52 , Z53 , Z54 , Z54se , Z82 , Z700 , Z703 , Z705 , Z715 P122 , P700 , P705 , P706 , P707 , P3100 , P3120 , P3150 X63 , X70 , X73 , X76 , X80 , X83 , X84 , X85 , X125 , X4250 , X4270 , F4270</p>', '<p>440,32 ml     : Z42 , Z43 , Z45 , Z45se , Z51 , Z52 , Z53 , Z54 , Z54se , Z82 , Z700 , Z703 , Z705 , Z715 P122 , P700 , P705 , P706 , P707 , P3100 , P3120 , P3150 X63 , X70 , X73 , X76 , X80 , X83 , X84 , X85 , X125 , X4250 , X4270 , F4270</p>'),
	(1415, '1', ' LEXMARK 12A1980 (NO 80)', 1, 15.65, 0, 1, 0.2, 'lexmark-12a1980-no-80', 'TSLEX12A1980', 'http://tonersales,eu/shop/580/lexmark-12a1980-no-80,jpg', 0, '0', 'LEXMARK Z11 , Z31 , 3200 , 5000 , 5700 , 5770 , 7000 , 7000v , 7200 , 7200v Optra Color 40 , 40N , 4', '131,18 ml               :  LEXMARK Z11 , Z31 , 3200 , 5000 , 5700 , 5770 , 7000 , 7000v , 7200 , 7200v Optra Color 40 , 40N , 4'),
	(1416, '1', ' LEXMARK NO 3 18C1530E', 0, 19.87, 0, 50, 0.2, '-lexmark-no-3-18c1530e', 'TSHL-G3B', 'http://tonersales,eu/shop/1791/-lexmark-no-3-18c1530e,jpg', 0, '0', '<p>Lexmark Z1380 , Z1480 , X2480 , X3480 , X2580 ,X3580 , X4580</p>', '<p>175 ml     : Lexmark Z1380 , Z1480 , X2480 , X3480 , X2580 ,X3580 , X4580</p>'),
	(1417, '1', ' LEXMARK NO 4, 4A 18C1974', 0, 19.87, 0, 50, 0.2, '-lexmark-no-4-4a-18c1974', 'TSHL-G4B', 'http://tonersales,eu/shop/582/-lexmark-no-4-4a-18c1974,jpg', 0, '0', '<p>Lexmark Z2390 , Z2490 , X2690 , X3690 , X4690</p>', '<p>175 ml     : Lexmark Z2390 , Z2490 , X2690 , X3690 , X4690</p>'),
	(1418, '1', ' LEXMARK NO 14, 14A 18C2090', 0, 19.87, 0, 1, 0.2, '-lexmark-no-14-14a-18c2090', 'TSHL-G14B', 'http://tonersales,eu/shop/583/-lexmark-no-14-14a-18c2090,jpg', 0, '0', '<p>Lexmark X2650 , Z2320 ,X2670 , X2620</p>', '<p>175 ml     : Lexmark X2650 , Z2320 ,X2670 , X2620</p>'),
	(1419, '1', ' LEXMARK NO 23, 23A 18C1523', 0, 19.87, 0, 50, 0.2, '-lexmark-no-23-23a-18c1523', 'TSHL-G23B', 'http://tonersales,eu/shop/1545/-lexmark-no-23-23a-18c1523,jpg', 0, '0', '<p>Lexmark Z1400 , Z1410 , Z1420 , X3530 , X3550 , X4530 , X4550</p>', '<p>215 ml     : Lexmark Z1400 , Z1410 , Z1420 , X3530 , X3550 , X4530 , X4550</p>'),
	(1420, '1', ' LEXMARK NO 28, 28A 18C1428', 0, 19.87, 0, 50, 0.2, '-lexmark-no-28-28a-18c1428', 'TSHL-G28B', 'http://tonersales,eu/shop/1789/-lexmark-no-28-28a-18c1428,jpg', 0, '0', '<p>Lexmark Z845 , Z1300 , Z1310 , Z1320 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X5495 , X5075</p>', '<p>175 ml     : Lexmark Z845 , Z1300 , Z1310 , Z1320 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X5495 , X5075</p>'),
	(1421, '1', ' LEXMARK NO 32 18CX032E', 0, 19.87, 0, 1, 0.2, '-lexmark-no-32-18cx032e', 'TSHL-G32B', 'http://tonersales,eu/shop/586/-lexmark-no-32-18cx032e,jpg', 0, '0', '<p>Lexmark Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350</p>', '<p>350 ml     : Lexmark Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350</p>'),
	(1422, '1', ' LEXMARK NO 34 18C0034E', 0, 19.87, 0, 50, 0.2, '-lexmark-no-34-18c0034e', 'TSHL-G34B', 'http://tonersales,eu/shop/1544/-lexmark-no-34-18c0034e,jpg', 0, '0', '<p>Lexmark Z845 , Z1300 , Z1310 , Z1320 , Z1400 , Z1410 , Z1420 , Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X3530 , X3550 , X4530 , X4550 , X3310 , X3330 , X3350 , X5210 , X5250 , X52X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350 , X5495 , X5075</p>', '<p>580 ml     : Lexmark Z845 , Z1300 , Z1310 , Z1320 , Z1400 , Z1410 , Z1420 , Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X3530 , X3550 , X4530 , X4550 , X3310 , X3330 , X3350 , X5210 , X5250 , X52X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350 , X5495 , X5075</p>'),
	(1423, '1', ' LEXMARK NO 36XL, 36XLA 18C2170E', 0, 19.87, 0, 50, 0.2, '-lexmark-no-36xl-36xla-18c2170e', 'TSHL-G36B', 'http://tonersales,eu/shop/588/-lexmark-no-36xl-36xla-18c2170e,jpg', 0, '0', '<p>Lexmark Z2420 , X3650 , X4650 , X5650 , X6650 , X6675</p>', '<p>500 ml     : Lexmark Z2420 , X3650 , X4650 , X5650 , X6650 , X6675</p>'),
	(1424, '1', ' LEXMARK NO 82 18L0032E', 0, 19.87, 0, 50, 0.2, '-lexmark-no-82-18l0032e', 'TSHL-G82B', 'http://tonersales,eu/shop/589/-lexmark-no-82-18l0032e,jpg', 0, '0', '<p>Lexmark Z55 , Z65 , X5130 , X5150 , X5190 , X6150 , X6170 , X6190</p>', '<p>600 ml     : Lexmark Z55 , Z65 , X5130 , X5150 , X5190 , X6150 , X6170 , X6190</p>'),
	(1425, '1', ' LEXMARK NO 1 18CX781E', 0, 20.8, 0, 101, 0.2, '-lexmark-no-1-18cx781e', 'TSHL-G1C', 'http://tonersales,eu/shop/590/-lexmark-no-1-18cx781e,jpg', 0, '0', '<p>Lexmark Z730 , Z735 , X2310 , X2330 , X2350 , X2450 , X2470 , X3450 , X3470</p>', '<p>120 ml     : Lexmark Z730 , Z735 , X2310 , X2330 , X2350 , X2450 , X2470 , X3450 , X3470</p>'),
	(1426, '1', ' LEXMARK NO 2 18CX190E', 0, 20.8, 0, 50, 0.2, '-lexmark-no-2-18cx190e', 'TSHL-G2C', 'http://tonersales,eu/shop/591/-lexmark-no-2-18cx190e,jpg', 0, '0', '<p>Lexmark Z1380 , Z1480 , X2480 , X3480 , X2580 ,X3580 , X4580</p>', '<p>300 ml     : Lexmark Z1380 , Z1480 , X2480 , X3480 , X2580 ,X3580 , X4580</p>'),
	(1427, '1', ' LEXMARK NO 5, 5A 18C1960', 0, 20.8, 0, 50, 0.2, '-lexmark-no-5-5a-18c1960', 'TSHL-G5C', 'http://tonersales,eu/shop/592/-lexmark-no-5-5a-18c1960,jpg', 0, '0', '<p>Lexmark Z2390 , Z2490 , X2690 , X3690 , X4690</p>', '<p>150 ml     : Lexmark Z2390 , Z2490 , X2690 , X3690 , X4690</p>'),
	(1428, '1', ' LEXMARK NO 15, 15A 18C2110', 0, 20.8, 0, 50, 0.2, '-lexmark-no-15-15a-18c2110', 'TSHL-G15C', 'http://tonersales,eu/shop/1546/-lexmark-no-15-15a-18c2110,jpg', 0, '0', '<p>Lexmark X2650 , Z2320 ,X2670 , X2620</p>', '<p>150 ml     : Lexmark X2650 , Z2320 ,X2670 , X2620</p>'),
	(1429, '1', ' LEXMARK NO 24, 24A 18C1524', 0, 20.8, 0, 50, 0.2, '-lexmark-no-24-24a-18c1524', 'TSHL-G24C', 'http://tonersales,eu/shop/594/-lexmark-no-24-24a-18c1524,jpg', 0, '0', '<p>Lexmark Z1400 , Z1410 , Z1420 , X3530 , X3550 , X4530 , X4550</p>', '<p>185 ml     : Lexmark Z1400 , Z1410 , Z1420 , X3530 , X3550 , X4530 , X4550</p>'),
	(1430, '1', ' LEXMARK NO 29, 29A 18C1429', 0, 20.8, 0, 50, 0.2, '-lexmark-no-29-29a-18c1429', 'TSHL-G29C', 'http://tonersales,eu/shop/1790/-lexmark-no-29-29a-18c1429,jpg', 0, '0', '<p>Lexmark Z845 , Z1300 , Z1310 , Z1320 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X5495 , X5075</p>', '<p>150 ml     : Lexmark Z845 , Z1300 , Z1310 , Z1320 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X5495 , X5075</p>'),
	(1431, '1', ' LEXMARK NO 31 18C0031', 0, 20.8, 0, 50, 0.2, '-lexmark-no-31-18c0031', 'TSHL-G31P', 'http://tonersales,eu/shop/1543/-lexmark-no-31-18c0031,jpg', 0, '0', '<p>Lexmark Z845 , Z1300 , Z1310 , Z1320 , Z1400 , Z1410 , Z1420 , Z2320 , Z2420 , Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X2650 , X3530 , X3550 , X4530 , X4550 , X3650 , X4650 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350 , X5495 , X5650 , X6650 , X6675 , X5075</p>', '<p>125 Photos 10x15 ml     : Lexmark Z845 , Z1300 , Z1310 , Z1320 , Z1400 , Z1410 , Z1420 , Z2320 , Z2420 , Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X2650 , X3530 , X3550 , X4530 , X4550 , X3650 , X4650 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350 , X5495 , X5650 , X6650 , X6675 , X5075</p>'),
	(1432, '1', ' LEXMARK NO 33 18CX033E', 0, 20.8, 0, 50, 0.2, '-lexmark-no-33-18cx033e', 'TSHL-G33C', 'http://tonersales,eu/shop/597/-lexmark-no-33-18cx033e,jpg', 0, '0', '<p>Lexmark Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350</p>', '<p>280 ml     : Lexmark Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350</p>'),
	(1433, '1', ' LEXMARK NO 35 18C0035E', 0, 20.8, 0, 50, 0.2, '-lexmark-no-35-18c0035e', 'TSHL-G35C', 'http://tonersales,eu/shop/598/-lexmark-no-35-18c0035e,jpg', 0, '0', '<p>Lexmark Z845 , Z1300 , Z1310 , Z1320 , Z1400 , Z1410 , Z1420 , Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X3530 , X3550 , X4530 , X4550 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350 , X5495 , X5075</p>', '<p>595 ml     : Lexmark Z845 , Z1300 , Z1310 , Z1320 , Z1400 , Z1410 , Z1420 , Z810 , Z812 , Z815 , Z816 , Z818 , P910 , P915 , P4310 , P4330 , P4350 , P6210 , P6250 , P6350 , X2500 , X2510 , X2530 , X2550 , X5070 , X5320 , X5370 , X5490 , X3530 , X3550 , X4530 , X4550 , X3310 , X3330 , X3350 , X5210 , X5250 , X5260 , X5270 , X5410 , X5450 , X5470 , X7170 , X7310 , X7350 , X8310 , X8350 , X5495 , X5075</p>'),
	(1434, '1', ' LEXMARK NO 37XL, 37XLA 18C2180E', 0, 20.8, 0, 50, 0.2, '-lexmark-no-37xl-37xla-18c2180e', 'TSHL-G37C', 'http://tonersales,eu/shop/599/-lexmark-no-37xl-37xla-18c2180e,jpg', 0, '0', '<p>Lexmark Z2420 , X3650 , X4650 , X5650 , X6650 , X6675</p>', '<p>500 ml     : Lexmark Z2420 , X3650 , X4650 , X5650 , X6650 , X6675</p>'),
	(1435, '1', ' LEXMARK NO 83 18LX042E', 0, 20.8, 0, 50, 0.2, '-lexmark-no-83-18lx042e', 'TSHL-G83C', 'http://tonersales,eu/shop/601/-lexmark-no-83-18lx042e,jpg', 0, '0', '<p>Lexmark Z55 , Z65 , X5130 , X5150 , X5190 , X6150 , X6170 , X6190</p>', '<p>285 ml     : Lexmark Z55 , Z65 , X5130 , X5150 , X5190 , X6150 , X6170 , X6190</p>'),
	(1436, '1', ' OLIVETTI FJ20 84431  ,  B0384 FPJ20', 0, 12.5, 0, 1, 0.2, '#NAME?', 'TSOLI FJ20', 'http://tonersales,eu/shop/1524/-olivetti-fj20-84431-b0384-fpj20,jpg', 0, '0', '<p>Olivetti JP 150 ,150WS ,170 ,170C ,170S ,190 ,192 ,192SC ,250 ,270 ,350 ,350S , WS ,360 ,370 ,450 ,470 ,OFX 140 ,150 ,180 ,500 ,520 , P ,525 ,540 ,550 ,560 ,570 ,580 ,1000 ,1100 ,1200 ,1900 ,2100 ,2200 ,3100 ,3200 ,LinkFax 500 ,1000 ,1100 ,1200 ,1900 ,2100 ,2200 ,3100 ,3200 ,Fax-Lab 200p ,210 ,250 , p ,260 ,"FPJ-20</p>', '<p>286, 20 ml     : Olivetti JP 150 ,150WS ,170 ,170C ,170S ,190 ,192 ,192SC ,250 ,270 ,350 ,350S , WS ,360 ,370 ,450 ,470 ,OFX 140 ,150 ,180 ,500 ,520 , P ,525 ,540 ,550 ,560 ,570 ,580 ,1000 ,1100 ,1200 ,1900 ,2100 ,2200 ,3100 ,3200 ,LinkFax 500 ,1000 ,1100 ,1200 ,1900 ,2100 ,2200 ,3100 ,3200 ,Fax-Lab 200p ,210 ,250 , p ,260 ,"FPJ-20"</p>'),
	(1437, '1', ' OLIVETTI B0336 FaxLab 300 FJ31', 0, 12.5, 0, 1, 0.2, '#NAME?', 'TSOLIFJ31', 'http://tonersales,eu/shop/1525/-olivetti-b0336-faxlab-300-fj31,jpg', 0, '0', '<p>OLIVETTI Fax Lab 95 , M100 , S100 , 100 , 105 , 105F , M100 , S100 , 115 , 120 , 125 , 145D , 220 , 270 , 275 , 300 , 300SMS , 310 , 350 , 360 , 450 , 460 , 480 , 3160 Jet-Lab 400 , 490 , OFX300 , 350 "FJ-31</p>', '<p>283,13 ml     : OLIVETTI Fax Lab 95 , M100 , S100 , 100 , 105 , 105F , M100 , S100 , 115 , 120 , 125 , 145D , 220 , 270 , 275 , 300 , 300SMS , 310 , 350 , 360 , 450 , 460 , 480 , 3160 Jet-Lab 400 , 490 , OFX300 , 350 "FJ-31"</p>'),
	(1438, '1', ' OLIVETTI B0494 FJ51', 0, 12.5, 0, 1, 0.2, '#NAME?', 'TSHF-51', 'http://tonersales,eu/shop/1526/-olivetti-b0494-fj51,jpg', 0, '0', '<p>Olivetti FAX LAB101 , 101F , S101 , 106 , 116 , 121 , 126 , 128 , 146D ,FJ-51</p>', '<p>319,18 ml     : Olivetti FAX LAB101 , 101F , S101 , 106 , 116 , 121 , 126 , 128 , 146D ,FJ-51</p>'),
	(1439, '1', ' OLIVETTI B0702 FJ63', 0, 12.5, 0, 1, 0.2, '#NAME?', 'TSOLIFJ63', 'http://tonersales,eu/shop/1527/-olivetti-b0702-fj63,jpg', 0, '0', '<p>OLIVETTI FaxLab 610 , 630 , 710 , 730"FJ-63"</p>', '<p>283,13 ml     : OLIVETTI FaxLab 610 , 630 , 710 , 730 "FJ-63"</p>'),
	(1440, '1', ' OLIVETTI B0797 FJ83', 0, 17.66, 0, 1, 0.2, '#NAME?', 'TSHF-83', 'http://tonersales,eu/shop/1528/-olivetti-b0797-fj83,jpg', 0, '0', '<p>Olivetti FaxLab 650 , 680 FJ-83</p>', '<p>205,8 ml     : Olivetti FaxLab 650 , 680 FJ-83</p>'),
	(1441, '1', ' PHILIPS PFA-421', 0, 16.56, 0, 1, 0.2, '#NAME?', 'TSHH-421', 'http://tonersales,eu/shop/1529/-philips-pfa-421,jpg', 0, '0', '<p>Philips IPF 146 , 131 , 141 , 174 , 176 , 188 , Monoblock ,PFA421</p>', '<p>500 ml     : Philips IPF 146 , 131 , 141 , 174 , 176 , 188 , Monoblock ,PFA421</p>'),
	(1442, '1', ' PHILIPS PFA-431', 0, 16.56, 0, 1, 0.2, '#NAME?', 'TSHH-431', 'http://tonersales,eu/shop/1530/-philips-pfa-431,jpg', 0, '0', '<p>Philips IPF 320 , 325 , 330 , 335 , 365 , 355 , 375 , MF-Jet460MMS , 495 Black Monoblock ,PFA431 , 00</p>', '<p>500 ml     : Philips IPF 320 , 325 , 330 , 335 , 365 , 355 , 375 , MF-Jet460MMS , 495 Black Monoblock ,PFA431 , 00</p>'),
	(1443, '1', ' PHILIPS PFA-441', 0, 16.56, 0, 1, 0.2, '#NAME?', 'TSHH-441', 'http://tonersales,eu/shop/1531/-philips-pfa-441,jpg', 0, '0', '<p>Philips FaxJet 500 , 520 , 525 , 535 , 550 , 555 , PFA441</p>', '<p>500 ml     : Philips FaxJet 500 , 520 , 525 , 535 , 550 , 555 , PFA441</p>'),
	(1444, '1', '  SHARP FO-3CR , UX-3CR 2PC', 0, 8.83, 0, 1, 0.2, '-sharp-fo-3cr-ux-3cr-2pc', 'TSRFS416BGUA', 'http://tonersales,eu/shop/1532/-sharp-fo-3cr-ux-3cr-2pc,jpg', 0, '0', '<p>SHARP FO-720 , 730 , 760 , 775L , 780 , 781 , 880 , 785 , 885 , 9000Colorfax SHARP NX-100 , 530 , 670 , NX-670 , UNX100 SHARP UX-300 , 305 , 310 , 345L , 355 , 370 , 460 , 470 , 385 , 485</p>', '<p>30 ml     : SHARP FO-720 , 730 , 760 , 775L , 780 , 781 , 880 , 785 , 885 , 9000Colorfax SHARP NX-100 , 530 , 670 , NX-670 , UNX100 SHARP UX-300 , 305 , 310 , 345L , 355 , 370 , 460 , 470 , 385 , 485</p>'),
	(1445, '1', '  SHARP FO-9CR , UX-91CR 60M', 0, 8.83, 0, 1, 0.65, '-sharp-fo-9cr-ux-91cr-60m', 'TSRFS421BGUJ', 'http://tonersales,eu/shop/1533/-sharp-fo-9cr-ux-91cr-60m,jpg', 0, '0', '<p>SHARP UX-310 , P110 , P400 , P410 , P430 , P760 , P500 , P510 , P110 , A450 , A460 , D50 , S10 , 160 SHARP FO-D60 , P600 , P610 , P510 , P630 , A650 , A660 , A560 , CC500 , D60 , 6550 SHARP UX-S10 , UX-D50 , NX-D60 SHARP NX-P150 , P160 , P510 , P500 , A550 , A560 , D60</p>', '<p>60 ml     : SHARP UX-310 , P110 , P400 , P410 , P430 , P760 , P500 , P510 , P110 , A450 , A460 , D50 , S10 , 160 SHARP FO-D60 , P600 , P610 , P510 , P630 , A650 , A660 , A560 , CC500 , D60 , 6550 SHARP UX-S10 , UX-D50 , NX-D60 SHARP NX-P150 , P160 , P510 , P500 , A550 , A560 , D60</p>'),
	(1446, '1', '  SHARP FO-15CR , UX-15CR 135M', 0, 9.94, 0, 1, 0.2, '-sharp-fo-15cr-ux-15cr-135m', 'TSRFS415BGUJ', 'http://tonersales,eu/shop/1534/-sharp-fo-15cr-ux-15cr-135m,jpg', 0, '0', '<p>SHARP FO-1450 , 1460 , 1466 , 1500 , 1530 , 1550 , 1650 , 1850 , 1500M , 1660M , F1500M SHARP UX-500 , 510 , 600 , 1000 , 1100 , 1150M , 1300 , 1400 , 1400L</p>', '<p>135 ml     : SHARP FO-1450 , 1460 , 1466 , 1500 , 1530 , 1550 , 1650 , 1850 , 1500M , 1660M , F1500M SHARP UX-500 , 510 , 600 , 1000 , 1100 , 1150M , 1300 , 1400 , 1400L</p>'),
	(1447, '1', ' HP CP1025 DRUM UNIT CE314A', 53, 21.59, 0, 1, 0.65, '#NAME?', 'TSCE314A', 'http://tonersales,eu/shop/160/-hp-cp1025-drum-unit-ce314a,jpg', 0, '0', '<p>HP Color LaserJet CP1025 , CP1025NW , CF346A HP LaserJet Pro 100 color MFP M175a , M275a CANON LBP 7010C , 7018C</p>', '<p>14000     5%     : HP Color LaserJet CP1025 , CP1025NW , CF346A HP LaserJet Pro 100 color MFP M175a , M275a CANON LBP 7010C , 7018C</p>'),
	(1448, '1', ' HP Q3964A DRUM UNIT', 0, 62.04, 0, 1, 0.65, '#NAME?', 'TS13315108**', 'http://tonersales,eu/shop/1187/-hp-q3964a-drum-unit,jpg', 0, '0', '<p>HP Color Laserjet 1500 , 1500I , 2500 , 2500l , 2500n , 2500tn , 2550 , 2550l , 2550ln , 2550n , 2800 , 2820 , 2840 CANON LBP2400 , LBP2410 , LBP5200</p>', '<p>20000     5%     : HP Color Laserjet 1500 , 1500I , 2500 , 2500l , 2500n , 2500tn , 2550 , 2550l , 2550ln , 2550n , 2800 , 2820 , 2840 CANON LBP2400 , LBP2410 , LBP5200</p>'),
	(1454, '1', ' HP CF287A', 53, 53.15, 0, 102, 0.65, 'hp-cf287a', '0', 'http://tonersales,eu/shop/1402/hp-cf287a,jpg', 0, '0', '<p>HP M506 , MFP M527</p>', '<p>9000     5%     :HP M506 , MFP M527</p>'),
	(1455, '1', ' HP CF226A (HP 26A BLACK)', 53, 43.47, 0, 102, 0.65, '0', '0', '0', 0, '0', '<p>HP LaserJet Pro M402n, M402d, M402dn, MFP M426dw, MFP M426fdn, MFP M426fdw</p>', '0'),
	(1456, '1', ' HP CF226X (HP 26X BLACK)', 53, 46.08, 0, 110, 0.65, '-hp-cf226x-hp-26x-black', '0', 'http://tonersales,eu/shop/1404/-hp-cf226x-hp-26x-black,jpg', 0, '0', '<p>HP LaserJet Pro M402n, M402d, M402dn, MFP M426dw, MFP M426fdn, MFP M426fdw</p>', '<p>9000     5%     :HP LaserJet ProM402n, M402d, M402dn, MFP M426dw, MFP M426fdn, MFP M426fdw</p>'),
	(1458, '1', '  SAMSUNG CLT-K406S+CLT-Y406S+CLT-C406S+CLT-M406S', 53, 72.5, 0, 5, 0.65, '-samsung-clt-k406sclt-y406sclt-c406sclt-m406s', 'TS13315231**', 'http://tonersales,eu/shop/1505/-samsung-clt-k406sclt-y406sclt-c406sclt-m406s,jpg', 0, '0', '<p>SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W, XPRESS 460FW</p>', '<p>1500     5%     : SAMSUNG CLP-360 , CLP-365 , 365W , 366 , 368SAMSUNG CLX-3300 , CLX-3305 , 3305W , 3305FW , 3305FN , C410W,XPRESS 460FW</p>'),
	(1459, '1', '  HP CF210X+CF211A+CF212A+CF213A', 53, 56.37, 0, 106, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1535/-hp-cf210xcf211acf212acf213a,jpg', 0, '0', '<p>HP LaserJet Pro Color M251n M251nw MFP M276n M276nw PRO200</p>', '<p>1,400     5%     :HP LaserJet Pro Color M251n M251nw MFP M276n M276nw PRO200</p>'),
	(1460, '1', '  HP CB540A+CB541A+CB542A+CB543A', 53, 56.37, 0, 8, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1536/-hp-cb540acb541acb542acb543a,jpg', 0, '0', '<p> 4   HP Color LaserJet CM1312 CM1312nfi CP1210 Cp1215 CP1217 CP1510 CP1515n CP1518ni CAN LBP5050 805</p>', '<p>2400  ( ) &amp; 1400  ( )    5%     :HP Color LaserJet CM1312 CM1312nfi CP1210/Cp1215 CP1217 CP1510 CP1515n CP1518ni CAN LBP5050 8050</p>'),
	(1462, '1', ' HP CF279A (HP 79A BLACK)', 53, 10.44, 0, 117, 0.65, '-hp-cf279a-hp-79a-black', '0', 'http://tonersales,eu/shop/1540/-hp-cf279a-hp-79a-black,jpg', 0, '0', '<p>HPLaserJet Pro M12a, M12w, MFP M26a/MFP M26nw</p>', '<p>1000<span>    5%     :HPLaserJet Pro M12a, M12w, MFP M26a/MFP M26nw</span></p>'),
	(1467, '1', ' LEXMARK C5240KH BLACK', 53, 39.1, 0, 1, 0.65, 'lexmark-c5240kh-black', '0', 'http://tonersales,eu/shop/1549/lexmark-c5240kh-black,jpg', 0, '0', '<p>LEXMARK C534n,Lexmark C524dtn</p>', '<p>8000     5%     : Lexmark Optra C734 DN , Lexmark Optra C734 DTN , Lexmark Optra C734 DW , Lexmark Optra C734 N , Lexmark Optra C736 DN , Lexmark Optra C736 N , Lexmark Optra C736 DTN , Lexmark C522n , Lexmark C524dn , Lexmark C524n , Lexmark C524dtn , Lexmark C530dn , Lexmark C532dn , Lexmark C532n , Lexmark C534dn , Lexmark C534n , Lexmark C534dtn</p>'),
	(1469, '1', ' SAMSUNG MLT-D108S/ML 1640', 53, 12.02, 0, 119, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1552/-samsung-mlt-d108sml-1640,jpg', 0, '0', '<p>Samsung ML 1640/1641/2240/2241</p>', '<p>1500     5%     : Samsung ML 1640/1641/2240/2241</p>'),
	(1470, '1', ' LEXMARK LM X264T', 53, 14.52, 0, 112, 0.65, 'lexmark-lm-x264t', 'LM X264T', 'http://tonersales,eu/shop/1553/lexmark-lm-x264t,jpg', 0, '0', '<p>Lexmark X264T (3,5K)</p>', '<p>Lexmark X264T, 3500  ,     X264/X363/X364</p>'),
	(1471, '1', ' EPSON E-551 BK (T0551)', 53, 0.81, 0, 115, 0.65, 'epson-e-551-bk-t0551', '0', 'http://tonersales,eu/shop/1554/epson-e-551-bk-t0551,jpg', 0, '0', '<p>18 ml</p>', '<p>18 ml,     Epson Stylus Photo R240/R245, RX420/RX425/RX520</p>'),
	(1472, '1', ' EPSON E-552 C (T0552)', 53, 0.81, 0, 109, 0.65, 'epson-e-552-c-t0552', '0', 'http://tonersales,eu/shop/1555/epson-e-552-c-t0552,jpg', 0, '0', '<p>18ml</p>', '<p>18ml,     Epson Stylus Photo R240/R245, RX420/RX425/RX520</p>'),
	(1473, '1', ' EPSON E-553 M (T0553)', 53, 0.81, 0, 109, 0.65, 'epson-e-553-m-t0553', '0', 'http://tonersales,eu/shop/1556/epson-e-553-m-t0553,jpg', 0, '0', '<p>18ml</p>', '<p>18 ml,     Epson Stylus Photo R240/R245, RX420/RX425/RX520</p>'),
	(1474, '1', ' EPSON E-554 Y (T0554)', 53, 0.81, 0, 109, 0.65, 'epson-e-554-y-t0554', '0', 'http://tonersales,eu/shop/1557/epson-e-554-y-t0554,jpg', 0, '0', '<p>18ml</p>', '<p>18 ml,     Epson Stylus Photo R240//R245, RX420/RX425/RX520</p>'),
	(1475, '1', ' EPSON E-441 BK (T0441)', 53, 0.81, 0, 118, 0.65, 'epson-e-441-bk-t0441', '0', 'http://tonersales,eu/shop/1558/epson-e-441-bk-t0441,jpg', 0, '0', '<p>18 ml</p>', '<p>18 ml,     Epson Stylus C64/C66/C84/C84N/C84WN/C86/CX4600/CX6400/CX6600</p>'),
	(1476, '1', ' EPSON E-442 C (T0442)', 53, 0.81, 0, 108, 0.65, 'epson-e-442-c-t0442', '0', 'http://tonersales,eu/shop/1559/epson-e-442-c-t0442,jpg', 0, '0', '<p>18 ml</p>', '<p>18 ml,     Epson Stylus C64/C66/C84/C84N/C84WN/C86/CX4600/CX6400/CX6600</p>'),
	(1477, '1', ' EPSON E-443 M (T0443)', 53, 0.81, 0, 108, 0.65, 'epson-e-443-m-t0443', '0', 'http://tonersales,eu/shop/1560/epson-e-443-m-t0443,jpg', 0, '0', '<p>18 ml</p>', '<p>18 ml,     Epson Stylus C64/C66/C84/C84N/C84WN/C86/CX4600/CX6400/CX6600</p>'),
	(1478, '1', ' EPSON E-444 Y (T0444)', 53, 0.81, 0, 106, 0.65, 'epson-e-444-y-t0444', '0', 'http://tonersales,eu/shop/1561/epson-e-444-y-t0444,jpg', 0, '0', '<p>18 ml</p>', '<p>18ml,     Epson Stylus C64/C66/C84/C84N/C84WN/C86/CX4600/CX6400/CX6600</p>'),
	(1479, '1', ' EPSON E-791 BK', 53, 2.34, 0, 105, 0.65, 'epson-e-791-bk', '0', 'http://tonersales,eu/shop/1566/epson-e-791-bk,jpg', 0, '0', '<p>17 ml</p>', '<p>17 ml,     Epson Stylus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1480, '1', ' EPSON E-792 C', 53, 2.34, 0, 105, 0.65, 'epson-e-792-c', '0', 'http://tonersales,eu/shop/1567/epson-e-792-c,jpg', 0, '0', '<p>17ml</p>', '<p>17 ml,     Epson Stylus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1481, '1', ' EPSON E-793 M', 53, 2.34, 0, 105, 0.65, 'epson-e-793-m', '0', 'http://tonersales,eu/shop/1568/epson-e-793-m,jpg', 0, '0', '<p>17 ml</p>', '<p>17 ml,     Epson Styus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1482, '1', ' EPSON E-794 Y', 53, 2.34, 0, 104, 0.65, 'epson-e-794-y', '0', 'http://tonersales,eu/shop/1569/epson-e-794-y,jpg', 0, '0', '<p>17 ml</p>', '<p>17 ml,     Epson Stylus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1483, '1', ' EPSON E-795 LC', 53, 2.34, 0, 105, 0.65, 'epson-e-795-lc', '0', 'http://tonersales,eu/shop/1570/epson-e-795-lc,jpg', 0, '0', '<p>17 ml</p>', '<p>17 ml,     Epson Stylus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1484, '1', ' EPSON E-796 LM', 53, 2.34, 0, 105, 0.65, 'epson-e-796-lm', '0', 'http://tonersales,eu/shop/1571/epson-e-796-lm,jpg', 0, '0', '<p>17 ml</p>', '<p>17 ml,     Epson Stylus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1485, '1', ' EPSON FULL SET E-791BK,E-792C,E-793M,E-794Y, E-795LC,E-796LM', 53, 12.02, 0, 104, 0.65, 'epson-full-set-e-791bke-792ce-793me-794y-e-795lce-796lm', '0', 'http://tonersales,eu/shop/1572/epson-full-set-e-791bke-792ce-793me-794y-e-795lce-796lm,jpg', 0, '0', '<p>17 ml</p>', '<p>17 ml,     Epson Stylus Photo 1400/P50/PX650/PX660/PX700W/PX710W/PX720WD/PX800FW/PX810FW/PX820FWD</p>'),
	(1486, '1', ' RICOH RT-SP201', 53, 28.23, 0, 99, 0.65, 'ricoh-rt-sp201', '0', 'http://tonersales,eu/shop/1573/ricoh-rt-sp201,jpg', 0, '0', '<p>SP200/N/S/SF, SP201N/S/NW/SF, SP202SF, SP203S, SP204SN,SF,SFN,SFNW, SP211</p>', '<p>2600  ,     : SP200/N/S/SF, SP201N/S/NW/SF, SP202SF, SP203S, SP204SN,SF,SFN,SFNW, SP211</p>'),
	(1487, '1', ' BROTHER  DR2000, DR350, DR2005 DRUM UNIT', 53, 16.94, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1574/-brother-dr2000-dr350-dr2005-drum-unit,jpg', 0, '0', '<p>Brother HL2020, HL2030, HL2040, HL2050, HL2070N, FAX2920, DCP7010, DCP7010L, DCP7020, DCP7025, FAX2820, FAX2825, MFC7220, MFC7225N, MFC7420, MFC7820, MFC7820N</p>', '<p>12000    5%     :BrotherHL2020, HL2030, HL2040, HL2050, HL2070N, FAX2920, DCP7010, DCP7010L, DCP7020, DCP7025, FAX2820, FAX2825, MFC7220, MFC7225N, MFC7420, MFC7820, MFC7820N</p>'),
	(1488, '1', ' HP Q5942X (HP 42X BLACK)', 53, 34.27, 0, 103, 0.65, '-hp-q5942x-hp-42x-black', '0', 'http://tonersales,eu/shop/1575/-hp-q5942x-hp-42x-black,jpg', 0, '0', '<p><span>HP LaserJet</span>4240n, 4250, 4250dtn, 4350n, 4350dtnsl, 4250n, 4250dtnsl, 4350tn, 4250tn, 4350, 4350dtn</p>', '<p><span>20000     5%     :4240n, 4250, 4250dtn, 4350n, 4350dtnsl, 4250n, 4250dtnsl, 4350tn, 4250tn, 4350, 4350dtn</span></p>'),
	(1489, '1', ' HP 302XL COLOUR', 53, 14.44, 0, 111, 0.65, '-hp-302xl-colour', '0', 'http://tonersales,eu/shop/2303/-hp-302xl-colour,jpg', 0, '0', '<p><span>Officejet : 3800 Series, 4650, 4654, 3834, 3830, 3831 Serie, 3833 Serie, 3834 Serie, 3835 Serie, 4654 Serie, 4655 Serie, 4656 Serie, 4657 Serie, 4658 Serie,Deskjet AiO : 2132, 2134, 3832,Deskjet : 3630, 1110, 2130, 3631 Serie, 3632 Serie,3633 Serie, 3634 Serie, 3636 Serie, 3637 Serie,Envy e-All-in-One : 4520, 4524, 4521 Serie, 4522 Serie,4524 Serie, 4525 Serie, 4527 Serie, 4528 Serie</span></p>', '<p><span>500   <span>  5%</span>    : HP Officejet 3800 Series, 4650, 4654, 3834, 3830, 3831 Serie, 3833 Serie, 3834 Serie,3835 Serie, 4654 Serie, 4655 Serie, 4656 Serie, 4657 Serie, 4658 Serie,Deskjet AiO : 2132, 2134, 3832,Deskjet : 3630, 1110, 2130, 3631 Serie, 3632 Serie,3633 Serie, 3634 Serie, 3636 Serie, 3637 Serie,Envy e-All-in-One : 4520, 4524, 4521 Serie, 4522 Serie,4524 Serie, 4525 Serie, 4527 Serie, 4528 Serie</span></p>'),
	(1490, '1', ' HP 49 (51649A) TRI-COLOR', 53, 12.1, 0, 101, 0.65, 'hp-49-51649a-tri-color', '0', 'http://tonersales,eu/shop/1577/hp-49-51649a-tri-color,jpg', 0, '0', '0', '0'),
	(1491, '1', ' HP 20 BLACK', 53, 10.48, 0, 102, 0.65, 'hp-20-black', '0', 'http://tonersales,eu/shop/1578/hp-20-black,jpg', 0, '0', '0', '0'),
	(1492, '1', ' HP CF228A BK', 53, 55.65, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1579/-hp-cf228a-bk,jpg', 0, '0', '<h4><strong>  : HP LaserJet PRO M403/ M427 MFP</strong></h4>', '<p><span>3000 , ,     : HP LaserJet PRO M403/ M427 MFP</span></p>'),
	(1493, '1', ' HP CF228X BK', 53, 63.71, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1580/-hp-cf228x-bk,jpg', 0, '0', '<p><span>    : HP LaserJet PRO M403/ M427 MFP</span></p>', '<p><span>9200 , ,    : HP LaserJet PRO M403/ M427 MFP</span></p>'),
	(1494, '1', ' HP CF410X BK', 53, 28.23, 0, 107, 0.65, 'hp-cf410x-bk', '0', 'http://tonersales,eu/shop/1581/hp-cf410x-bk,jpg', 0, '0', '<p><span><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span><br /></span></p>', '<p>6500 , ,     :<span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>'),
	(1495, '1', ' HP CF411X CYAN', 53, 29.74, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1582/-hp-cf411x-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M452dw , Color LaserJet Pro MFP M477fnw , M477fdn , M477fdw</span></p>', '<p>5000 , ,     :HP Color LaserJet Pro M452dw , Color LaserJet Pro MFP M477fnw , M477fdn , M477fdw</p>'),
	(1497, '1', ' HP CF412X YELLOW', 53, 29.74, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1583/-hp-cf412x-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M452dw , Color LaserJet Pro MFP M477fnw , M477fdn , M477fdw</span></p>', '<p>5000  ,     :<span>HP Color LaserJet Pro M452dw , Color LaserJet Pro MFP M477fnw , M477fdn , M477fdw</span></p>'),
	(1498, '1', ' HP CF413X MAGENTA', 53, 29.74, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1584/-hp-cf413x-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M452dw , Color LaserJet Pro MFP M477fnw , M477fdn , M477fdw</span></p>', '<p>5000 , ,     :<span>HP Color LaserJet Pro M452dw , Color LaserJet Pro MFP M477fnw , M477fdn , M477fdw</span></p>'),
	(1499, '1', ' HP CF210X (HP 131X BLACK)', 53, 15.73, 0, 112, 0.65, '-hp-cf210x-hp-131x-black', '0', 'http://tonersales,eu/shop/1585/-hp-cf210x-hp-131x-black,jpg', 0, '0', '<p><span>HP Color LaserJet</span>Pro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</p>', '<p>2400 , ,     :HP Color LaserJetPro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</p>'),
	(1500, '1', ' HP CF211A (HP 131A CYAN)', 53, 15.73, 0, 121, 0.65, '-hp-cf211a-hp-131a-cyan', '0', 'http://tonersales,eu/shop/1586/-hp-cf211a-hp-131a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet</span><span>Pro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</span></p>', '<p><span>1800 , ,     :<span>HP Color LaserJet</span><span>Pro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</span></span></p>'),
	(1501, '1', ' SAMSUNG MLT-R116 DRUM UNIT', 53, 14.44, 0, 102, 0.65, 'samsung-mlt-r116-drum-unit', '0', 'http://tonersales,eu/shop/1587/samsung-mlt-r116-drum-unit,jpg', 0, '0', '<p><span>SAMSUNG M2625 , M2626D , M2675 , M2676N , M2676FH , M2825 , M2826ND , M2835 , M2875 , M2876HN , M2885</span></p>', '<p><span>9000     5%     : SAMSUNG M2625 , M2626D , M2675 , M2676N , M2676FH , M2825 , M2826ND , M2835 , M2875 , M2876HN , M2885</span></p>'),
	(1502, '1', ' HP CF212A (HP 131A YELLOW)', 53, 15.73, 0, 122, 0.65, '-hp-cf212a-hp-131a-yellow', '0', 'http://tonersales,eu/shop/1588/-hp-cf212a-hp-131a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet</span>Pro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</p>', '<p><span>1800 , ,     :HP Color LaserJetPro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</span></p>'),
	(1503, '1', ' HP CF213A (HP 131A MAGENTA)', 53, 15.73, 0, 118, 0.65, '-hp-cf213a-hp-131a-magenta', '0', 'http://tonersales,eu/shop/1589/-hp-cf213a-hp-131a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet</span><span>Pro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</span></p>', '<p><span>1800 , ,     :<span>HP Color LaserJet</span><span>Pro 200 M251nw, Pro 200 M276n, Pro 200 M251n, Pro 200 M276nw</span></span></p>'),
	(1505, '1', ' HP CE321A C', 53, 18.55, 0, 108, 0.65, 'hp-ce321a-c', '0', 'http://tonersales,eu/shop/1591/hp-ce321a-c,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>', '<p><span>1300 , ,     : HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>'),
	(1506, '1', ' HP CE322A Y', 53, 18.55, 0, 108, 0.65, 'hp-ce322a-y', '0', 'http://tonersales,eu/shop/1592/hp-ce322a-y,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>', '<p><span>1300 , ,     : HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>'),
	(1507, '1', ' HP CE323A M', 53, 18.55, 0, 109, 0.65, 'hp-ce323a-m', '0', 'http://tonersales,eu/shop/1593/hp-ce323a-m,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>', '<p><span>1300 , ,     : HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>'),
	(1508, '1', ' HP CE255A BK (HP 55A BLACK)', 53, 20.16, 0, 110, 0.65, '-hp-ce255a-bk-hp-55a-black', '0', 'http://tonersales,eu/shop/1594/-hp-ce255a-bk-hp-55a-black,jpg', 0, '0', '<p><span>HP LaserJet Enterprise P3015, Enterprise P3015dn, Enterprise M525c, Enterprise 500 M525f, Pro M521dw, Enterprise P3010, Enterprise P3015d, Enterprise P3015x, Enterprise 500 M525dn, Pro M521dn</span></p>', '<p>6000 , ,     :<span>HP LaserJet Enterprise P3015, Enterprise P3015dn, Enterprise M525c, Enterprise 500 M525f, Pro M521dw, Enterprise P3010, Enterprise P3015d, Enterprise P3015x, Enterprise 500 M525dn, Pro M521dn</span></p>'),
	(1509, '1', ' C-35 CANON INK BK', 53, 6.45, 0, 104, 0.65, 'c-35-canon-ink-bk', '0', 'http://tonersales,eu/shop/1595/c-35-canon-ink-bk,jpg', 0, '0', '<p>CANON PIXMA iP 100, PIXMA iP110</p>', '<p>12 ml,     : CANON PIXMA iP100, PIXMA iP110</p>'),
	(1510, '1', ' C-36 CANON INK COLOUR', 53, 7.26, 0, 104, 0.65, '-c-36-canon-ink-colour', '0', 'http://tonersales,eu/shop/1596/-c-36-canon-ink-colour,jpg', 0, '0', '<p><span>CANON PIXMA iP 100, PIXMA iP110</span></p>', '<p><span>12 ml,     : CANON PIXMA iP100, PIXMA iP110</span></p>'),
	(1511, '1', ' SAMSUNG MLT-D115L', 53, 28.15, 0, 106, 0.65, 'samsung-mlt-d115l', '0', 'http://tonersales,eu/shop/1597/samsung-mlt-d115l,jpg', 0, '0', '<p>M2820DW/M2870FW</p>', '<p>3000 , ,    :M2820DW/M2870FW</p>'),
	(1512, '1', ' SAMSUNG CLT-K404S Black', 53, 26.61, 0, 105, 0.65, '0', '0', '0', 0, '0', '<div>Samsung Xpress C430W, Samsung Xpress C480W,</div>', '0'),
	(1513, '1', ' SAMSUNG CLT-K404S Cyan', 53, 26.61, 0, 106, 0.65, '0', '0', '0', 0, '0', '<div>Samsung Xpress C430W, Samsung Xpress C480W,</div>', '0'),
	(1514, '1', ' SAMSUNG CLT-K404S Magenta', 53, 26.61, 0, 106, 0.65, '0', '0', '0', 0, '0', '<div>Samsung Xpress C430W, Samsung Xpress C480W,</div>', '0'),
	(1515, '1', ' SAMSUNG CLT-K404S Yellow', 53, 26.61, 0, 106, 0.65, '0', '0', '0', 0, '0', '<div>Samsung Xpress C430W, Samsung Xpress C480W,</div>', '0'),
	(1516, '1', ' HP CE320A BK', 53, 18.55, 0, 108, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1605/-hp-ce320a-bk,jpg', 0, '0', '<p><span>HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>', '<p>2200<span>, ,     : HP Color LaserJet Pro CP1525N/1525NW, Cm1415/1415FN/1415FNW</span></p>'),
	(1517, '1', ' LEXMARK C522 M', 53, 31.45, 0, 102, 0.65, 'lexmark-c522-m', '0', 'http://tonersales,eu/shop/1606/lexmark-c522-m,jpg', 0, '0', '<p><span>Lexmark </span><span>C522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>', '<p>3000 , ,     :LexmarkC522n, C524dtn, C524dn, C532n, C532dn, C534dn</p>'),
	(1518, '1', ' LEXMARK C522 Y', 53, 31.45, 0, 102, 0.65, 'lexmark-c522-y', '0', 'http://tonersales,eu/shop/1607/lexmark-c522-y,jpg', 0, '0', '<p><span>Lexmark</span><span>C522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>', '<p><span>3000 , ,     :LexmarkC522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>'),
	(1519, '1', ' LEXMARK C522 C', 53, 31.45, 0, 102, 0.65, 'lexmark-c522-c', '0', 'http://tonersales,eu/shop/1608/lexmark-c522-c,jpg', 0, '0', '<p><span>Lexmark</span><span>C522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>', '<p><span>3000 , ,     :LexmarkC522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>'),
	(1520, '1', ' LEXMARK C522 BK', 53, 33.87, 0, 1, 0.65, 'lexmark-c522-bk', '0', 'http://tonersales,eu/shop/1609/lexmark-c522-bk,jpg', 0, '0', '<p><span>Lexmark</span><span>C522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>', '<p>4000<span>, ,     :LexmarkC522n, C524dtn, C524dn, C532n, C532dn, C534dn</span></p>'),
	(1521, '1', ' LEXMARK C734A Black', 53, 32.18, 0, 102, 0.65, 'lexmark-c734a-black', '0', 'http://tonersales,eu/shop/1610/lexmark-c734a-black,jpg', 0, '0', '<div>Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</div>', '<p>8000 , ,     :Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</p>'),
	(1522, '1', ' LEXMARK C734A  Cyan', 53, 33.79, 0, 102, 0.65, 'lexmark-c734a-cyan', '0', 'http://tonersales,eu/shop/1611/lexmark-c734a-cyan,jpg', 0, '0', '<p><span>Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</span></p>', '<p><span>6000 , ,     :Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</span></p>'),
	(1523, '1', ' LEXMARK C734A Magenta', 53, 33.79, 0, 102, 0.65, 'lexmark-c734a-magenta', '0', 'http://tonersales,eu/shop/1612/lexmark-c734a-magenta,jpg', 0, '0', '<p><span>Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</span></p>', '<p><span>6000 , ,     :Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</span></p>'),
	(1524, '1', ' LEXMARK C734A Yellow', 53, 33.79, 0, 102, 0.65, 'lexmark-c734a-yellow', '0', 'http://tonersales,eu/shop/1613/lexmark-c734a-yellow,jpg', 0, '0', '<p><span>Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</span></p>', '<p><span>6000 , ,     :Lexmark C734n, C734dtn, C734dw, C736n, C736dn, C738n, C738dtn, X736, X738</span></p>'),
	(1525, '1', ' LEXMARK No 80 colour', 53, 13.71, 0, 101, 0.65, '0', '0', '0', 0, '0', '<p><span>Lexmark Z11/Z31, SERIES 3200/5000/5700/7000/7200, OPTRA COLOR 40,45</span></p>', '0'),
	(1526, '1', ' LEXMARK  NO 17 Black', 53, 14.44, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1615/-lexmark-no-17-black,jpg', 0, '0', '<p>Lexmark i3, X74, X75, Z13, Z23, Z25, Z33, Z35, Z600, X1100</p>', '<p>210 , ,     : Lexmark i3, X74, X75, Z13, Z23, Z25, Z33, Z35, Z600, X1100</p>'),
	(1527, '1', ' LEXMARK L-C540CR', 53, 28.23, 0, 101, 0.65, '-lexmark-l-c540cr', '0', 'http://tonersales,eu/shop/1616/-lexmark-l-c540cr,jpg', 0, '0', '<p>Lexmark<span>C540N,</span><span>C543DN, C544DN, C544DTN, C544DW, C546DTN,</span><span>X543,</span><span>X544, X546DTN, X548DE, X548DTE</span></p>', '<p>2000 , ,     :LexmarkC540N,C543DN, C544DN, C544DTN, C544DW, C546DTN,X543,X544, X546DTN, X548DE, X548DTE</p>'),
	(1528, '1', ' LEXMARK T610 12A5845 Black', 53, 79.84, 0, 101, 0.65, 'lexmark-t610-12a5845-black', '0', 'http://tonersales,eu/shop/1617/lexmark-t610-12a5845-black,jpg', 0, '0', '<p><span>Lexmark OPTRA T610 / T612 / T614 / T616</span></p>', '<p>28,000 , ,     :Lexmark OPTRA T610 / T612 / T614 / T616</p>'),
	(1529, '1', ' XEROX 6250 CXL (106R00672)', 53, 47.58, 0, 101, 0.65, 'xerox-6250-cxl-106r00672', '0', 'http://tonersales,eu/shop/1618/xerox-6250-cxl-106r00672,jpg', 0, '0', '<p><span>Phaser 6250</span></p>', '<p>8000 , ,     : Xerox Phaser 6250</p>'),
	(1530, '1', ' XEROX 6250 BXL (106R00675)', 53, 39.52, 0, 101, 0.65, 'xerox-6250-bxl-106r00675', '0', 'http://tonersales,eu/shop/1619/xerox-6250-bxl-106r00675,jpg', 0, '0', '<p><span>Phaser 6250</span></p>', '<p><span>8000 , ,     : Xerox Phaser 6250</span></p>'),
	(1531, '1', ' EPSON C4100B (S050149)', 53, 21.77, 0, 101, 0.65, 'epson-c4100b-s050149', '0', 'http://tonersales,eu/shop/1621/epson-c4100b-s050149,jpg', 0, '0', '<p><span>Epson Laserjet C4100</span></p>', '<p>8000 , ,     :<span>Epson Laserjet C4100</span></p>'),
	(1532, '1', ' EPSON C4100M (S050147)', 53, 39.52, 0, 102, 0.65, 'epson-c4100m-s050147', '0', 'http://tonersales,eu/shop/1622/epson-c4100m-s050147,jpg', 0, '0', '<p><span>Epson Laserjet C4100</span></p>', '<p><span>8000 , ,     :</span><span>Epson Laserjet C4100</span></p>'),
	(1533, '1', ' EPSON C4100C (S050146)', 53, 39.52, 0, 102, 0.65, 'epson-c4100c-s050146', '0', 'http://tonersales,eu/shop/1623/epson-c4100c-s050146,jpg', 0, '0', '<p><span>Epson Laserjet C4100</span></p>', '<p><span>8000 , ,     :</span><span>Epson Laserjet C4100</span></p>'),
	(1534, '1', ' EPSON C4100Y (S050148)', 53, 39.52, 0, 102, 0.65, 'epson-c4100y-s050148', '0', 'http://tonersales,eu/shop/1624/epson-c4100y-s050148,jpg', 0, '0', '<p><span>Epson Laserjet C4100</span></p>', '<p><span>8000 , ,     :</span><span>Epson Laserjet C4100</span></p>'),
	(1535, '1', ' EPSON T040 BK', 53, 9.68, 0, 101, 0.2, 'epson-t040-bk', '0', 'http://tonersales,eu/shop/1626/epson-t040-bk,jpg', 0, '0', '<p><span>Stylus C62 / Stylus CX3200</span></p>', '<p><span>420 , ,    : Epson Stylus C62, CX3200</span></p>'),
	(1536, '1', ' EPSON T041 COLOUR', 53, 9.6, 0, 101, 0.2, 'epson-t041-colour', '0', 'http://tonersales,eu/shop/1627/epson-t041-colour,jpg', 0, '0', '<p><span>Stylus C62 / Stylus CX3200</span></p>', '<p><span>300 , ,    : Epson Stylus C62, CX3200</span></p>'),
	(1541, '1', 'ORIGINAL OKI C 5250/5450/5510/5540 MFP CYAN', 53, 88.63, 0, 101, 0.65, '0', '0', '0', 0, '0', '<div class="printshow"><dl><dt>C5150n, 5250dn, 5250n, 5450dn, 5450n, 5500n, 5510 MFP, 5510n MFP, 5540 MFP</dt></dl><p></p>', '0'),
	(1542, '1', '  PANASONIC KX-FA55 50M', 53, 7.66, 0, 101, 0.65, '-panasonic-kx-fa55-50m', '0', 'http://tonersales,eu/shop/1636/-panasonic-kx-fa55-50m,jpg', 0, '0', '<p class="color_dark fw_medium m_bottom_10">Panasonic KX-FA55 50M (2 )</p>', '<p><span>    : PANASONIC KX-FPG371 / 175 / 381 / 372 / 176, KX-FPC 195 / 96 / 161 / 91, KX-FP181 PR189 / 181 / 152 / 150 / 185 / 151 / 155 / 155G / 155C / 80 / 81 / 85</span></p>'),
	(1543, '1', '  PANASONIC KX-FA136A 100M', 53, 11.69, 0, 101, 0.65, '-panasonic-kx-fa136a-100m', '0', 'http://tonersales,eu/shop/1637/-panasonic-kx-fa136a-100m,jpg', 0, '0', '<p class="color_dark fw_medium m_bottom_10">Panasonic KX-FA136 - 100M (2 )</p>', '<p class="m_bottom_10">    : PANASONIC KX-PM210, KX-FP278 / 200 / 195 / 245 / 250 / 330 / 320 / 300 / 258 / 265 / 270, KX-FM330 / 210 / 260 / 255, KX-FMC230 / 230 / 220 / 206</p>'),
	(1544, '1', '  PANASONIC KX-P170', 53, 11.29, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1638/-panasonic-kx-p170,jpg', 0, '0', '<p>Panasonic KX-P 3696/ 3626/ 3696/ 3624/ 2868/ 1694</p>', '<p><span>    : Panasonic KX-P 3696/ 3626/ 3696/ 3624/ 2868/ 1694</span></p>'),
	(1546, '1', '  PANASONIC KX-FA134', 53, 14.11, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1640/-panasonic-kx-fa134,jpg', 0, '0', '<p>PANASONIC KX-FA134 (2 )</p>', '<p>    : KX-FA 929/ 1000/ 1006/ 1020/ 1050/ 1070/ 1100/ 1150/ 1200</p>'),
	(1547, '1', '  PANASONIC KX-FA92/54 35M', 53, 8.23, 0, 106, 0.65, '-panasonic-kx-fa9254-35m', '0', 'http://tonersales,eu/shop/1641/-panasonic-kx-fa9254-35m,jpg', 0, '0', '<p>PANASONIC KX-FA92/54 35M (2 )</p>', '<p>    :<span>PANASONIC KX-FP141, PANASONIC KX-145, PANASONIC KX-141G, PANASONIC KX-145G, PANASONIC , PANASONIC KX-145E, , PANASONIC KX-FC235, PANASONIC KX-245, PANASONIC KX-G2, PANASONIC KX-245G, PANASONIC KX-245, PANASONIC KX-235G</span></p>'),
	(1548, '1', '  PANASONIC KX-FA52 30M', 53, 5.73, 0, 102, 0.65, '-panasonic-kx-fa52-30m', '0', 'http://tonersales,eu/shop/1642/-panasonic-kx-fa52-30m,jpg', 0, '0', '<p>PANASONIC KX-FA52 30M (2 )</p>', '<p>    :<span>KX-FP205G-S/ 205/ 215/ 215G-S/</span>KX-FC226G-S/ 255G-S/ 225G-S/ 225/ 226/ 256</p>'),
	(1549, '1', '  PANASONIC KX-P1124', 53, 4.11, 0, 110, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1643/-panasonic-kx-p1124,jpg', 0, '0', '<p>Pan KX-P1124</p>', '<p>    :<span>KX-P1121/1123/1124/1124I/1140/1170/1191/1395/2023</span></p>'),
	(1550, '1', '  PANASONIC 2130', 53, 4.44, 0, 110, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1644/-panasonic-2130,jpg', 0, '0', '<p>Pan 2130</p>', '<p>    : KX -P2130/ KX-P2135</p>'),
	(1552, '1', '  PANASONIC KX-P1090', 53, 7.66, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1645/-panasonic-kx-p1090,jpg', 0, '0', '<p>KX-P1090</p>', '<p><span>    : KX-1080 / KX-1090 / KX-1082 / KX-1083 / KX-1091 / KX-1092 / KX-1180 / KX-1191 / KX-1191</span></p>'),
	(1553, '1', '  EPSON LX-300', 53, 4.03, 0, 113, 0.1, '#NAME?', '0', 'http://tonersales,eu/shop/1646/-epson-lx-300,jpg', 0, '0', '<p>EPSON LX-300</p>', '<p><span>    : MX80/FX800/fx850/fx870/fx880/LX300/lx400/lx800/lx850</span></p>'),
	(1554, '1', '  EPSON LQ1000', 53, 3.95, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1647/-epson-lq1000,jpg', 0, '0', '<p>LQ 1000</p>', '<p><span>    : EPSON LQ1000 C13S015022, ERC-20, LQ1050, LQ1010, LQ1070, LQ1000, LQ100K, LQ1170, LQ1600, LQ1600K, LQ1800K, LQ1900K, LQ1600KII, OLYMPIA NP136-24, NP136SE, EX1800, CITIZEN 224, 224S, HPQ45, STONE MS2406, SHINWA EL-2415, SIEMENS PT89, AMT ACCEL 244,294, ACTIONWRITER 4500, 5500, 5550</span></p>'),
	(1555, '1', '  EPSON FX2190', 53, 10.4, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1648/-epson-fx2190,jpg', 0, '0', '<p>FX2190</p>', '<p>    :<span>FX-2190, FX-2190N</span></p>'),
	(1556, '1', '  EPSON MX80', 53, 4.44, 0, 101, 0.65, '0', '0', '0', 0, '0', '<p>MX80</p>', '<p>    : CITIZEN MSP 10, CITIZEN MSP 10E, CITIZEN MSP 20, CITIZEN MSP 40,</p>'),
	(1557, '1', '  EPSON ERC30/34/38 BR', 53, 3.95, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1650/-epson-erc303438-br,jpg', 0, '0', '<p>ERC30/34/38 BR</p>', '<p>    :<span>EPSON TMU 200, 270, 300, 375, 270, 300A, 300B, 300D, 370</span></p>'),
	(1558, '1', '  OKI 182', 53, 2.82, 0, 133, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1651/-oki-182,jpg', 0, '0', '<p>OKI ML-182</p>', '<p><span>    : OKIDATA ML120/172/ML180/ML182/ML183/184/ML192/ML193/194/19 5/240/ML280/ML320/ML321/ML380/ML388/ML390/391/ML3320/ML3321/ML5320/ML5330/ML8320/ML8330/ML420/ML421 OKIDATA OKIMATE 120 OKIDATA 5320/5330/8320/8330 RADIO SHACK DMP2101/2103/300/302/442/2102 OKIDATA OKIPOS 425S/425D/SERIES 50/SERIES 90</span></p>'),
	(1559, '1', '  OKI ML 520/590', 53, 3.15, 0, 117, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1652/-oki-ml-520590,jpg', 0, '0', '<p>OKI ML 520/590</p>', '<p>    : OKI ML520/521/590</p>'),
	(1560, '1', '  OKI 5520/5590', 53, 3.95, 0, 106, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1653/-oki-55205590,jpg', 0, '0', '<p>OKI ML-5520/ML-5590</p>', '<p><span>    : OKI ML 5520/5521/5590/5591</span></p>'),
	(1561, '1', '  OKI 3410', 53, 12.02, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1654/-oki-3410,jpg', 0, '0', '<p>ML-3410</p>', '<p><span>    : OKI ML 393/395/3410</span></p>'),
	(1562, '1', '  PHILIPS PFA351 45M', 53, 12.82, 0, 101, 0.65, '-philips-pfa351-45m', '0', 'http://tonersales,eu/shop/1655/-philips-pfa351-45m,jpg', 0, '0', '<p>PFA351 45M</p>', '<p>    :<span>PPF620/EU01/ SAGEM PPF631/ PPF622/ PPF 632/ PPF636EPP/ PPF650/PPF675/PPF676/PPF685/PPF695/MAGIC 5 SERIES</span></p>'),
	(1563, '1', '  SEIKOSHA SK-2000', 53, 3.95, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1656/-seikosha-sk-2000,jpg', 0, '0', '<p>SP2000</p>', '<p>    : SP 800, 1000, 1200, 1600, 2000, 2400</p>'),
	(1564, '1', '  SEIKOSHA SK-10', 53, 9.6, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1657/-seikosha-sk-10,jpg', 0, '0', '<p>SBP-10</p>', '<p>    :<span>SBP-10 / BP-5780 / BP-7800 / FB-840 / BP-6000 / BP-9000</span></p>'),
	(1565, '1', '  CITIZEN DP600 PU', 53, 2.82, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1658/-citizen-dp600-pu,jpg', 0, '0', '<p>DP600 PU</p>', '<p><span>    : Citizen CBM 600/700series DP 700series LM 300/315/ 600/ 615/ 900/ 1200/1600 IDP 3500/4500series</span></p>'),
	(1566, '1', '  STAR ST-200', 53, 4.76, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/1659/-star-st-200,jpg', 0, '0', '<p>SP200</p>', '<p>    : SP200, 212F, 800, MP200</p>'),
	(1567, '1', '  SIEMENS-NIXDORF SN-77B', 53, 3.95, 0, 101, 0.65, '-siemens-nixdorf-sn-77b', '0', 'http://tonersales,eu/shop/1660/-siemens-nixdorf-sn-77b,jpg', 0, '0', '<p>ND77</p>', '<p><span>  : Siemens/Nixdorf ND77 Ribbon Cartridge</span></p>'),
	(1568, '1', ' HP 903XL BLACK', 53, 11.6, 0, 110, 0.65, '-hp-903xl-black', '0', 'http://tonersales,eu/shop/1670/-hp-903xl-black,jpg', 0, '0', '<p><span>HP OfficeJet Pro 6950, 6960, 6970</span></p>', '<p><span>20ml </span><span></span><span></span><span></span><span>: HP OfficeJet Pro 6950, 6960, 6970</span></p>'),
	(1569, '1', ' HP 903XL CYAN', 53, 11.6, 0, 110, 0.65, '-hp-903xl-cyan', '0', 'http://tonersales,eu/shop/1671/-hp-903xl-cyan,jpg', 0, '0', '<p><span>HP OfficeJet Pro 6950, 6960, 6970</span></p>', '<p><span>13,5ml</span><span></span><span></span><span></span><span></span><span></span><span>:<span>HP OfficeJet Pro 6950, 6960, 6970</span></span></p>'),
	(1570, '1', ' HP 903XL YELLOW', 53, 11.6, 0, 110, 0.65, '-hp-903xl-yellow', '0', 'http://tonersales,eu/shop/1672/-hp-903xl-yellow,jpg', 0, '0', '<p><span>HP OfficeJet Pro 6950, 6960, 6970</span></p>', '<p><span>13,5ml</span><span></span><span></span><span></span><span></span><span></span><span>:<span>HP OfficeJet Pro 6950, 6960, 6970</span></span></p>'),
	(1571, '1', ' HP 903XL MAGENTA', 53, 11.6, 0, 110, 0.65, '-hp-903xl-magenta', '0', 'http://tonersales,eu/shop/1673/-hp-903xl-magenta,jpg', 0, '0', '<p><span>HP OfficeJet Pro 6950, 6960, 6970</span></p>', '<p><span>13,5ml</span><span></span><span></span><span></span><span></span><span></span><span>:<span>HP OfficeJet Pro 6950, 6960, 6970</span></span></p>'),
	(1572, '1', '  HP CE320A BK, CE321A C, CE322A Y, CE323A M', 53, 57.02, 0, 106, 0.65, '0', '0', '0', 0, '0', '<p>4 </p>', '0'),
	(1574, '1', 'ORIGINAL XEROX WorkCentre Pro 555/575', 53, 71.77, 0, 101, 0.65, 'original-xerox-workcentre-pro-555575', '0', 'http://tonersales,eu/shop/1866/original-xerox-workcentre-pro-555575,jpg', 0, '0', '<p>WorkCentre Pro 555, WorkCentre Pro 575</p>', '<p>    :WorkCentre Pro 555, WorkCentre Pro 575</p>'),
	(1575, '1', ' RICOH SP 150', 53, 27.02, 0, 1, 0.65, '0', '0', '0', 0, '0', '<p>SP150, SP150W, SP150SU, SP150SUW</p>', '0'),
	(1576, '1', ' PANASONIC KX-FAD84E DRUM UNIT', 53, 49, 0, 1, 0.65, '0', '0', '0', 0, '0', '<p>KX-FL511/KX-FL540/511G/KX-FL541/540G/KX-FL611/611G, KX-FLM651/KX-FLM551GR</p>', '<p>10000  ,     : PANASONIC KX-FL511/KX-FL540/511G/</p>'),
	(1579, '1', ' HP CB435A (HP 35A BLACK)', 53, 7.98, 0, 129, 0.65, '-hp-cb435a-hp-35a-black', '0', 'http://tonersales,eu/shop/2216/-hp-cb435a-hp-35a-black,jpg', 0, '0', '<p><span>HP LaserJet</span>P1005, P1007, P1009, P1006, P1008</p>', '<p><span>2000     5%     : HP LaserJetP1005, P1007, P1009, P1006, P1008</span></p>'),
	(1580, '1', ' HP CB436A (HP 36A BLACK)', 53, 6.85, 0, 126, 0.65, '-hp-cb436a-hp-36a-black', '0', 'http://tonersales,eu/shop/2217/-hp-cb436a-hp-36a-black,jpg', 0, '0', '<p><span>HP LaserJet</span>P1505, M1120, M1522, M1522nf MFP, P1505n, M1120n MFP, M1522n MFP</p>', '<p><span>2000     5%     : HP LaserJet</span>P1505, M1120, M1522, M1522nf MFP, P1505n, M1120n MFP, M1522n MFP</p>'),
	(1581, '1', ' CANON 712', 53, 7.58, 0, 130, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2218/-canon-712,jpg', 0, '0', '<p>CANON I-SENSYSLPB-3010, I-SENSYSLPB-3100</p>', '<p><span>2000     5%     :CANON I-SENSYSLPB-3010,I-SENSYSLPB-3100</span></p>'),
	(1582, '1', ' CANON 713', 53, 7.58, 0, 130, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2219/-canon-713,jpg', 0, '0', '<p>CANON LBP3240, LBP3250</p>', '<p><span>2000     5%     :CANON</span>LBP3240, LBP3250</p>'),
	(1583, '1', ' CANON CLI 8BK', 53, 2.23, 0, 110, 0.2, '-canon-cli-8bk', '0', 'http://tonersales,eu/shop/2224/-canon-cli-8bk,jpg', 0, '0', '<p><span>CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</span></p>', '<p><span>14 ml     : CANON PIXMA iP3300 , iP3500 , iP4200 , iP4200Refurbished , iP4300 , iP4500 , iP5200 , iP5200R , IP5300 , iP6600D , iP6700D , iX4000 , iX5000 PIXMA MP500 , MP510 , MP520 , MP530 , MP600 , MP610 , MP800 , MP800R , MP810 , MP830 , MP950 , MP960 , MP970 , MX700 , MX850 CANON PIXMA Pro9000</span></p>'),
	(1584, '1', ' EPSON T2431XL BK', 53, 3.95, 0, 110, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2225/-epson-t2431xl-bk,jpg', 0, '0', '<p><span>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>', '<p>15 ml     :<span>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>'),
	(1585, '1', ' EPSON T2432XL C', 53, 3.95, 0, 110, 0.65, '-epson-t2432xl-c', '0', 'http://tonersales,eu/shop/2226/-epson-t2432xl-c,jpg', 0, '0', '<p>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</p>', '<p>10 ml     :EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</p>'),
	(1586, '1', ' EPSON T2433XL MG', 53, 3.95, 0, 109, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2227/-epson-t2433xl-mg,jpg', 0, '0', '<p><span>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>', '<p><span>10 ml     :EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>'),
	(1587, '1', ' EPSON T2434XL Y', 53, 3.95, 0, 110, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2228/-epson-t2434xl-y,jpg', 0, '0', '<p><span>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>', '<p><span>10 ml     :EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>'),
	(1588, '1', ' EPSON T2435XL LC', 53, 3.95, 0, 107, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2229/-epson-t2435xl-lc,jpg', 0, '0', '<p><span>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>', '<p><span>10 ml     :EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>'),
	(1589, '1', ' EPSON T2436XL LMG', 53, 3.95, 0, 107, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2230/-epson-t2436xl-lmg,jpg', 0, '0', '<p><span>EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>', '<p><span>10 ml     :EPSON EXPRESSION PHOTO XP750, EPSON EXPRESSION PHOTO XP850</span></p>'),
	(1590, '1', ' EPSON T2991 BK', 53, 5.56, 0, 119, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2231/-epson-t2991-bk,jpg', 0, '0', '<p><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>', '<p>15 ml     :<span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>'),
	(1591, '1', ' EPSON T2992 C', 53, 5.56, 0, 119, 0.2, '-epson-t2992-c', '0', 'http://tonersales,eu/shop/2232/-epson-t2992-c,jpg', 0, '0', '<p><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>', '<p><span>15 ml     :</span><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>'),
	(1592, '1', ' EPSON T2993 MG', 53, 5.56, 0, 119, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2233/-epson-t2993-mg,jpg', 0, '0', '<p><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>', '<p><span>15 ml     :</span><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>'),
	(1593, '1', ' EPSON T2994 Y', 53, 5.56, 0, 119, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2234/-epson-t2994-y,jpg', 0, '0', '<p><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>', '<p><span>15 ml     :</span><span>Epson Expression XP-235, Epson Expression XP-332, Epson Expression XP-335, Epson Expression XP-432, Epson Expression XP-435</span></p>'),
	(1594, '1', ' EPSON T038 BLACK', 53, 6.37, 0, 101, 0.2, '0', '0', '0', 0, '0', '<p>STYLUS C41UX, C43UX</p>', '0'),
	(1595, '1', ' EPSON T039 COLOUR', 53, 10.4, 0, 101, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2236/-epson-t039-colour,jpg', 0, '0', '<p><span>STYLUS C41UX, C43UX</span></p>', '<p><span>    : EPSON STYLUS C41UX, C43UX</span></p>'),
	(1596, '1', ' HP NO 364XL PB XL CB322E', 53, 4.76, 0, 100, 0.2, '-hp-no-364xl-pb-xl-cb322e', '0', 'http://tonersales,eu/shop/2237/-hp-no-364xl-pb-xl-cb322e,jpg', 0, '0', '<p><span>HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</span></p>', '<p><span>15 ml     : HP Photosmart B8550 , C5324 , C5380 , C6324 , C6380 , D5460 , 5510 , 5515 , 6510 , 7510 , B010a , b109a , B109n , B110a , C311a HP Photosmart Plus All-in-One B209a , B209c , B210a HP Photosmart Premium C309a , C309n , C309g , C310a HP Photosmart Premium Fax C3909a , C410b HP Deskjet 3070A HP Officejet 4620 e-All-in-One</span></p>'),
	(1597, '1', ' EPSON T3361XL BLACK', 53, 6.37, 0, 120, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2238/-epson-t3361xl-black,jpg', 0, '0', '<p><span>XP530 , XP540 , XP630 , XP635 , XP640 , XP645 , XP830 , XP900</span></p>', '<p>12ml     :<span>Epson<span>XP530 , XP540 , XP630 , XP635 , XP640 , XP645 , XP830 , XP900</span></span></p>'),
	(1598, '1', ' EPSON T3362XL CYAN', 53, 6.37, 0, 120, 0.2, '0', '0', '0', 0, '0', '<div id="short_description_block">', '0'),
	(1599, '1', ' EPSON T3363XL MAGENTA', 53, 6.37, 0, 120, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2241/-epson-t3363xl-magenta,jpg', 0, '0', '<p><span>XP530 , XP540 , XP630 , XP635 , XP640 , XP645 , XP830 , XP900</span></p>', '<p><span>12ml     :<span>Epson<span>XP530 , XP540 , XP630 , XP635 , XP640 , XP645 , XP830 , XP900</span></span></span></p>'),
	(1600, '1', ' EPSON T3364XL YELLOW', 53, 6.37, 0, 120, 0.2, '0', '0', '0', 0, '0', '<div id="short_description_block">', '0'),
	(1601, '1', ' HP CE505A (HP 05A BLACK)', 53, 9.92, 0, 116, 0.65, '0', '0', '0', 0, '0', '<p>Hp LaserJet P2033d, P2034d, P2035, P2055d, P2055x, P2057d, P2035n, P2036n, P2037d, P2050, P2053, P2055dn</p>', '0'),
	(1602, '1', ' PANASONIC KX-FAT92', 53, 5.97, 0, 105, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2244/-panasonic-kx-fat92,jpg', 0, '0', '<p>Panasonic KX-MB262/263/271/772/773/781/783/788/883</p>', '<p><span>2000     5%     : PanasonicKX-MB262/263/271/772/773/781/783/788/883</span></p>'),
	(1603, '1', ' SAMSUNG INK M215 BLACK', 53, 4.92, 0, 105, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2245/-samsung-ink-m215-black,jpg', 0, '0', '<p><span>Samsung CJX 1000/1050W/2000</span></p>', '<p>20 ml<span>    :Samsung CJX 1000/1050W/2000</span></p>'),
	(1604, '1', ' SAMSUNG INK M210 COLOR', 53, 6.05, 0, 105, 0.2, '#NAME?', '0', 'http://tonersales,eu/shop/2246/-samsung-ink-m210-color,jpg', 0, '0', '<p><span>Samsung CJX 1000/1050W/2000</span></p>', '<p><span>40 ml</span><span>    :Samsung CJX 1000/1050W/2000</span></p>'),
	(1605, '1', ' HP Q7551A (HP 51A BLACK)', 53, 20.08, 0, 103, 0.65, '-hp-q7551a-hp-51a-black', '0', 'http://tonersales,eu/shop/2247/-hp-q7551a-hp-51a-black,jpg', 0, '0', '<p><span>HP LaserJet</span>M302, M3027, M3035xs, P3005dn, M302mfp, M3027x, P3005, P3005n, M3035, P3005d, P3005x</p>', '<p><span>6500     5%     :HP LaserJetM302, M3027, M3035xs, P3005dn, M302mfp, M3027x, P3005, P3005n, M3035, P3005d, P3005x</span></p>'),
	(1606, '1', 'OKI B432 BK', 53, 47.3, 0, 103, 0.65, 'oki-b432-bk', '0', 'http://tonersales,eu/shop/2248/oki-b432-bk,jpg', 0, '0', '<p>OKI MB492dn, MB432dn, B512dn, MB562dnw</p>', '<p>12000<span>    5%     : OKIMB492dn, MB432dn, B512dn, MB562dnw</span></p>'),
	(1607, '1', ' OKI B410/420/430/440/MB460/470/480 DRUM UNIT BK', 53, 39.92, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2249/-oki-b410420430440mb460470480-drum-unit-bk,jpg', 0, '0', '<p>OKI B410/420/430/440/MB460/470/480</p>', '<p>25000<span>    5%     :OKI B410/420/430/440/MB460/470/480</span></p>'),
	(1608, '1', ' OKI B401/411/431/MB461/471/491 DRUM UNIT BK', 53, 45.36, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2250/-oki-b401411431mb461471491-drum-unit-bk,jpg', 0, '0', '<p>OKI B401/411/431/MB461/471/491</p>', '<p><span>25000</span><span>    5%     :OKI B401/411/431/MB461/471/491</span></p>'),
	(1609, '1', ' OKI B4400/4500/4550/4600 DRUM UNIT BK', 53, 45.08, 0, 102, 0.65, '#ERROR!', '0', 'http://tonersales,eu/shop/2251/-oki-b4400450045504600-drum-unit-bk,jpg', 0, '0', '<p>OKI B4400/4500/4550/4600</p>', '<p><span>25000</span><span>    5%     :OKI B4400/4500/4550/4600</span></p>'),
	(1610, '1', ' OKI B4100/4200/4250/4300/4350 DRUM UNIT BK', 53, 45.97, 0, 102, 0.65, '#ERROR!', '0', 'http://tonersales,eu/shop/2252/-oki-b41004200425043004350-drum-unit-bk,jpg', 0, '0', '<p>OKI B4100/4200/4250/4300/4350</p>', '<p><span>25000</span><span>    5%     :OKI B4100/4200/4250/4300/4350</span></p>'),
	(1611, '1', ' BROTHER TN620, TN3230, TN3240 BLACK', 53, 16.53, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2253/-brother-tn620-tn3230-tn3240-black,jpg', 0, '0', '<p><span>BROTHER DCP 8060, BROTHER DCP 8065DN, BROTHER MFC 8460N, BROTHER MFC 8660DN, BROTHER MFC 8860DN, BROTHER MFC 8870DWDCP 8080DN, BROTHER DCP 8085DN, BROTHER MFC 8370 , BROTHER MFC 8480DN, BROTHER MFC 8680DN, BROTHER MFC 8880DN, BROTHER MFC 8890DW, BROTHER HL 5340D, BROTHER HL 5350DN, BROTHER HL 5350DNLT, BROTHER HL 5370DW, BROTHER HL 5370DWT, BROTHER HL 5380DN, BROTHER HL HL 5240, BROTHER HL HL 5250DN, BROTHER HL HL 5250DNT, BROTHER HL HL 5270DN, BROTHER HL HL 5280DW</span></p>', '<p><span>3000 <span>    5%     :</span>BROTHER DCP 8060, BROTHER DCP 8065DN, BROTHER MFC 8460N, BROTHER MFC 8660DN, BROTHER MFC 8860DN, BROTHER MFC 8870DWDCP 8080DN, BROTHER DCP 8085DN, BROTHER MFC 8370 , BROTHER MFC 8480DN, BROTHER MFC 8680DN, BROTHER MFC 8880DN, BROTHER MFC 8890DW, BROTHER HL 5340D, BROTHER HL 5350DN, BROTHER HL 5350DNLT, BROTHER HL 5370DW, BROTHER HL 5370DWT, BROTHER HL 5380DN, BROTHER HL HL 5240, BROTHER HL HL 5250DN, BROTHER HL HL 5250DNT, BROTHER HL HL 5270DN, BROTHER HL HL 5280DW</span></p>'),
	(1613, '1', ' HP CC364A (HP 64A BLACK)', 53, 28.95, 0, 102, 0.65, '-hp-cc364a-hp-64a-black', '0', 'http://tonersales,eu/shop/2255/-hp-cc364a-hp-64a-black,jpg', 0, '0', '<p><span>HP LaserJet</span>P4000, P4014, P4015dn, P4015x, P4515x, P4014n, P4015n, P4515n, P4515xm, P4014dn, P4015tn, P4515tn</p>', '<p><span>10000     5%     : HP LaserJetP4000, P4014, P4015dn, P4015x, P4515x, P4014n, P4015n, P4515n, P4515xm, P4014dn, P4015tn, P4515tn</span></p>'),
	(1614, '1', ' HP Q6511A (HP 11A BLACK)', 53, 21.77, 0, 102, 0.65, '-hp-q6511a-hp-11a-black', '0', 'http://tonersales,eu/shop/2256/-hp-q6511a-hp-11a-black,jpg', 0, '0', '<p>Hp LaserJet2410, 2420d, 2430n, 2430dtn, 2420, 2420dn, 2430t, 2420n, 2430, 2430tn</p>', '<p><span>6000     5%     : HP LaserJet2410, 2420d, 2430n, 2430dtn, 2420, 2420dn, 2430t, 2420n, 2430, 2430tn</span></p>'),
	(1615, '1', ' HP DR2500 (C9704A/Q3964A) DRUM UNIT', 53, 63.71, 0, 102, 0.65, '-hp-dr2500-c9704aq3964a-drum-unit', '0', 'http://tonersales,eu/shop/2258/-hp-dr2500-c9704aq3964a-drum-unit,jpg', 0, '0', '<p>HP LaserJet 1500/2500, ColorLaserJet 2820/2550L/2840</p>', '<p><span>20000</span><span>    5%     :HP LaserJet 1500/2500, ColorLaserJet 2820/2550L/2840</span></p>'),
	(1616, '1', ' OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400 BK', 53, 20.16, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2261/-oki-c5100-3000-3200-5150-5200-5250-5300-5400-bk,jpg', 0, '0', '<p>OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400</p>', '<p><span>5000     5%     :<span>OKI C5100N, OKI C5150N, OKI C5200N, OKI C5300N, OKI C5400, OKI C5400DN, OKI C5400DTN, OKI C5400N, OKI C5400TN, OKI C5510N MFP</span></span></p>'),
	(1617, '1', ' OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400 C', 53, 20.16, 0, 102, 0.65, '-oki-c5100-3000-3200-5150-5200-5250-5300-5400-c', '0', 'http://tonersales,eu/shop/2260/-oki-c5100-3000-3200-5150-5200-5250-5300-5400-c,jpg', 0, '0', '<p>OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400</p>', '<p><span>5000     5%     :</span><span>OKI C5100N, OKI C5150N, OKI C5200N, OKI C5300N, OKI C5400, OKI C5400DN, OKI C5400DTN, OKI C5400N, OKI C5400TN, OKI C5510N MFP</span></p>'),
	(1618, '1', ' OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400 MG', 53, 20.16, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2262/-oki-c5100-3000-3200-5150-5200-5250-5300-5400-mg,jpg', 0, '0', '<p>OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400</p>', '<p><span>5000     5%     :</span><span>OKI C5100N, OKI C5150N, OKI C5200N, OKI C5300N, OKI C5400, OKI C5400DN, OKI C5400DTN, OKI C5400N, OKI C5400TN, OKI C5510N MFP</span><span></span></p>'),
	(1619, '1', ' OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400 Y', 53, 20.16, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2263/-oki-c5100-3000-3200-5150-5200-5250-5300-5400-y,jpg', 0, '0', '<p>OKI C5100, 3000, 3200, 5150, 5200, 5250, 5300, 5400</p>', '<p><span>5000     5%     :</span><span>OKI C5100N, OKI C5150N, OKI C5200N, OKI C5300N, OKI C5400, OKI C5400DN, OKI C5400DTN, OKI C5400N, OKI C5400TN, OKI C5510N MFP</span></p>'),
	(1620, '1', ' OKI C5600 , C5700 BK', 53, 16.31, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2264/-oki-c5600-c5700-bk,jpg', 0, '0', '<p><span>OKIDATA C5600 , C5700</span></p>', '<p><span>6000     5%     :</span><span>Okidata C5600, Okidata C5600n, Okidata C5700, Okidata C5700ndn</span></p>'),
	(1621, '1', ' OKI C3300 BK DRUM UNIT', 53, 41.94, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2265/-oki-c3300-bk-drum-unit,jpg', 0, '0', '<p>OKI C3300 Series</p>', '<p><span>15000</span><span>    5%     :OKI C3300 Series</span></p>'),
	(1622, '1', ' OKI C3300 CY DRUM UNIT', 53, 41.94, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2266/-oki-c3300-cy-drum-unit,jpg', 0, '0', '<p><span>OKI C3300 Series</span></p>', '<p><span>15000</span><span>    5%     :OKI C3300 Series</span></p>'),
	(1623, '1', ' OKI C3300 MG DRUM UNIT', 53, 41.94, 0, 102, 0.65, '0', '0', '0', 0, '0', '<div id="short_description_block">', '0'),
	(1624, '1', ' OKI C3300 YL DRUM UNIT', 53, 41.94, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2268/-oki-c3300-yl-drum-unit,jpg', 0, '0', '<p><span>OKI C3300 Series</span></p>', '<p><span>15000</span><span>    5%     :OKI C3300 Series</span></p>'),
	(1625, '1', ' SAMSUNG CLT407DR/409DR BK DRUM UNIT', 53, 56.45, 0, 102, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2269/-samsung-clt407dr409dr-bk-drum-unit,jpg', 0, '0', '<p>SAMSUNG CLP 320, CLP 325N, CLP 326, CLX 3185FN, CLP 320N, CLP 325W, CLX 3185FW, CLP 320K, CLP 325, CLX 3185, CLX 3185N</p>', '<p><span>24000     5%     :SAMSUNG CLP 320, CLP 325N, CLP 326, CLX 3185FN, CLP 320N, CLP 325W, CLX 3185FW, CLP 320K, CLP 325, CLX 3185, CLX 3185N</span></p>'),
	(1626, '1', ' BROTHER DR1050 BK DRUM UNIT', 53, 19.35, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2270/-brother-dr1050-bk-drum-unit,jpg', 0, '0', '<p>BROTHER HL-1110, HL-1112E, DCP-1512, MFC-1810, MFC-1910, HL-1110E, HL-1111, HL-1212, DCP-1512R, MFC-1818, HL-1112, HL-1210, HL-1118, DCP-1510, DCP-1518</p>', '<p><span>10000     5%     :BROTHER HL-1110, HL-1112E, DCP-1512, MFC-1810, MFC-1910, HL-1110E, HL-1111, HL-1212, DCP-1512R, MFC-1818, HL-1112, HL-1210, HL-1118, DCP-1510, DCP-1518</span></p>'),
	(1627, '1', ' BROTHER DR570, DR3000, DR6000, DR7000 BK DRUM UNIT', 53, 17.06, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2271/-brother-dr570-dr3000-dr6000-dr7000-bk-drum-unit,jpg', 0, '0', '<p>BROTHERDR570, DR3000, DR6000, DR7000</p>', '<p><span>20000    5%     :<span>BROTHER HL5040, HL5130, HL5140, HL5150, HL5170DN, HL1030, HL1230, HL1240, HL1250, HL1270N, HL1430, HL1440, HL1450, HL1470, HL1470N, HLP2500, BROTHER FAX4750, BROTHER FAX5750, BROTHER FAX8350P, BROTHER FAX8360P, BROTHER FAX8750P, MFC300J, MFC8500J, MFC8600, MFC9650, MFC9660, MFC9600, MFC9750, MFC9760, MFC9850, MFC9860, MFC9870, MFC9880, MFC9800J, Lenovo LJ2800, Lenovo LJ2800W, Lenovo M7210</span></span></p>'),
	(1628, '1', ' BROTHER DR2300, DR630 BK DRUM UNIT', 53, 16.94, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2272/-brother-dr2300-dr630-bk-drum-unit,jpg', 0, '0', '<p>BROTHER DR2300, DR630</p>', '<p><span><span>12000    5%     :<span>BROTHER HL-L2300D, BROTHER HL-L2320D, BROTHER HL-L2340DW, BROTHER HL-L2360DW, BROTHER HL-L2360DN, BROTHER HL-L2365DW, BROTHER HL-L2380DW, BROTHER DCP-L2500D, BROTHER DCP-L2520D, BROTHER DCP-L2520DW, BROTHER DCP-L2540DN, BROTHER DCP-L2540DW, BROTHER DCP-L2560DW, BROTHER MFC-L2700DW, BROTHER MFC-L2700D, BROTHER MFC-L2720DW , BROTHER MFC-L2740DW</span></span></span></p>'),
	(1629, '1', ' BROTHER DR3400 BK DRUM UNIT', 53, 24.11, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2273/-brother-dr3400-bk-drum-unit,jpg', 0, '0', '<p>BROTHER DR3400</p>', '<p><span><span>30000    5%     :<span>BROTHER HL-L5000D,</span><span>HL-L5100DN,</span><span>HL-L5100DNT,</span><span>HL-L5200DW,</span><span>HL-L5200DWT,</span><span>HL-L6250DN,</span><span>HL-L6300DW,</span><span>HL-L6300DWT,</span><span>HL-L6400DW,</span><span>HL-L6400DWT,</span><span>DCP-L5500DN,</span><span>DCP-L6600DW,</span><span>MFC-L5700DN,</span><span>MFC-L5750DW,</span><span>MFC-L6800DW,</span><span>MFC-L6800DWT,</span><span>MFC-L6900DW,</span><span>MFC-L6900DWT</span></span></span></p>'),
	(1630, '1', ' BROTHER DR130 BK DRUM UNIT', 53, 112.9, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2274/-brother-dr130-bk-drum-unit,jpg', 0, '0', '<p><span>Brother HL-4040, Brother HL-4050, Brother HL-4070, Brother HL-4150, Brother HL-4570, Brother DCP-9040, Brother DCP-9042, Brother DCP-9045, Brother MFC-9440, Brother MFC-9460, Brother MFC-9560, Brother MFC-9840, Brother MFC-9450, Brother MFC-9970</span></p>', '<p><span>12000    5%     :Brother HL-4040, Brother HL-4050, Brother HL-4070, Brother HL-4150, Brother HL-4570, Brother DCP-9040, Brother DCP-9042, Brother DCP-9045, Brother MFC-9440, Brother MFC-9460, Brother MFC-9560, Brother MFC-9840, Brother MFC-9450, Brother MFC-9970</span></p>'),
	(1631, '1', ' BROTHER DR2120, DR360, DR2100 BK DRUM UNIT', 53, 15.32, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2275/-brother-dr2120-dr360-dr2100-bk-drum-unit,jpg', 0, '0', '<p>BROTHER HL2140, HL2150N, HL 2170W, DCP 7045N, DCP7030, DCP7040, MFC 7840W, MFC 7320, MFC 7440N, MFC 7340</p>', '<p><span>12000     5%     :BROTHER HL2140, HL2150N, HL 2170W, DCP 7045N, DCP7030, DCP7040, MFC 7840W, MFC 7320, MFC 7440N, MFC 7340</span></p>'),
	(1632, '1', ' BROTHER DR2220, DR450, DR2200, DR2255 BK DRUM UNIT', 53, 12.1, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2276/-brother-dr2220-dr450-dr2200-dr2255-bk-drum-unit,jpg', 0, '0', '<p>BROTHER HL2130, HL2240, HL2240D, HL2240L, HL2250DN, HL2270DW, HL2310, DCP7055, DCP7057, DCP7060D, DCP7065DN, DCP7070DW, MFC7360N, MFC7460DN, MFC7860DW, FAX 2840/2940</p>', '<p><span>12000    5%     :BROTHER HL2130, HL2240, HL2240D, HL2240L, HL2250DN, HL2270DW, HL2310, DCP7055, DCP7057, DCP7060D, DCP7065DN, DCP7070DW, MFC7360N, MFC7460DN, MFC7860DW, FAX 2840/2940</span></p>'),
	(1633, '1', ' BROTHER DR3100, DR3200, DR3170, DR3280, DR580, DR520 BK DRUM UNIT', 53, 18.55, 0, 101, 0.65, '#NAME?', '0', 'http://tonersales,eu/shop/2277/-brother-dr3100-dr3200-dr3170-dr3280-dr580-dr520-bk-drum-unit,jpg', 0, '0', '<p>BROTHER HL3140, HL5200, HL5250DN, HL5280DW, MFC8860N, DCP8065DN, HL5240, HL5250DNHY, MFC8460N, MFC8480DN, MFC8870DW, HL5240L, HL5270DN, MFC8670DN, MFC8860DN, DCP8060</p>', '<p><span>25000     5%     :BROTHER HL3140, HL5200, HL5250DN, HL5280DW, MFC8860N, DCP8065DN, HL5240, HL5250DNHY, MFC8460N, MFC8480DN, MFC8870DW, HL5240L, HL5270DN, MFC8670DN, MFC8860DN, DCP8060</span></p>'),
	(1635, '1', ' HP Q7553A (HP 53A BLACK)', 53, 10.32, 0, 109, 0.65, '-hp-q7553a-hp-53a-black', '0', 'http://tonersales,eu/shop/2279/-hp-q7553a-hp-53a-black,jpg', 0, '0', '<p>HP LaserJet 2012, P2014, P2015, P2015dn, M2727nfs, 2013, P2014d, P2015n, P2015x, P2014dn, P2015d, M2727nf</p>', '<p><span>3000     5%     :HP LaserJet2012, P2014, P2015, P2015dn, M2727nfs, 2013, P2014d, P2015n, P2015x, P2014dn, P2015d, M2727nf</span></p>'),
	(1636, '1', ' HP Q2613X (HP 13X BLACK)', 53, 12.01, 0, 112, 0.65, '-hp-q2613x-hp-13x-black', '0', 'http://tonersales,eu/shop/2280/-hp-q2613x-hp-13x-black,jpg', 0, '0', '<p>HP LaserJet 1300, 1300xi, 1300n, 1300t</p>', '<p><span>4000     5%     :HP LaserJet 1300, 1300xi, 1300n, 1300t</span></p>'),
	(1637, '1', ' HP C7115X (HP 15X BLACK)', 53, 12.01, 0, 112, 0.65, '-hp-c7115x-hp-15x-black', '0', 'http://tonersales,eu/shop/2281/-hp-c7115x-hp-15x-black,jpg', 0, '0', '<p>HP LaserJet 1000, 1200n, 1220se, 3310mfp, 3320n, 3330mfp, 1005, 1200se, 3300, 3320, 3320nmfp, 3380, 1200, 1220, 3310, 3320mfp, 3330</p>', '<p><span>4000     5%     :HP LaserJet 1000, 1200n, 1220se, 3310mfp, 3320n, 3330mfp, 1005, 1200se, 3300, 3320, 3320nmfp, 3380, 1200, 1220, 3310, 3320mfp, 3330</span></p>'),
	(1638, '1', ' CANON CRG308/508/708, CRG315/715', 53, 13.66, 0, 50, 0.65, '0', '0', '0', 0, '0', '<div id="short_description_block">', '0'),
	(1639, '1', ' HP CF217A (HP 17A BLACK) with new CHIP', 53, 24.11, 0, 110, 0, '0', '0', '0', 0, '0', '<p>HP LaserJet Pro M102 Series, M102a, M102w, MFP M130 Series, MFP M130a, MFP M130fn, MFP M130fw, MFP M130nw, MFP M132 Series, MFP M132a, MFP M132fn, MFP M132fw, MFP M132fp, MFP M132nw, MFP M132snw, MFP M134 Series</p>', '<p><span><span>1,600     5%     :HP LaserJet Pro M102 Series, M102a, M102w, MFP M130 Series, MFP M130a, MFP M130fn, MFP M130fw, MFP M130nw, MFP M132 Series, MFP M132a, MFP M132fn, MFP M132fw, MFP M132fp, MFP M132nw, MFP M132snw, MFP M134 Series</span></span></p>'),
	(1640, '1', 'OKI B412 BK', 53, 45.36, 0, 100, 0, 'oki-b412-bk', '0', 'http://tonersales,eu/shop/2287/oki-b412-bk,jpg', 0, '0', '<p>OKI B412DN, B432DN, B512DN, MB492DN, MB492DNW</p>', '<p>7000<span>    5%     :OKI B412DN, B432DN, B512DN, MB492DN, MB492DNW</span></p>'),
	(1641, '1', ' BROTHER TN650/TN3290/TN3280/TN3170 BLACK', 53, 13.23, 0, 110, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2291/-brother-tn650tn3290tn3280tn3170-black,jpg', 0, '0', '<p>DCP 8060/ DCP 8065DN/ MFC 8460N/ MFC 8660DN/ MFC 8860DN/ MFC 8870DW/ DCP 8080DN/ DCP 8085DN/ MFC 8370/ MFC 8480DN/ MFC 8680DN/ MFC 8880DN/ MFC 8890DW/ BROHL 5340D/ 5350DN/ 5350DNLT/ 5370DW/ 5370DWT/ 5380DN/ HL 5240/ HL 5250DN/ HL 5250DNT/ HL 5270DN/ HL 5280DW</p>', '<p><span>8000</span><span>    5%     : BROTHER</span>DCP 8060/ DCP 8065DN/ MFC 8460N/ MFC 8660DN/ MFC 8860DN/ MFC 8870DW/ DCP 8080DN/ DCP 8085DN/ MFC 8370/ MFC 8480DN/ MFC 8680DN/ MFC 8880DN/ MFC 8890DW/ BROHL 5340D/ 5350DN/ 5350DNLT/ 5370DW/ 5370DWT/ 5380DN/ HL 5240/ HL 5250DN/ HL 5250DNT/ HL 5270DN/ HL 5280DW</p>'),
	(1643, '1', ' CANON PG-545XL BLACK', 53, 16.76, 0, 105, 0, '-canon-pg-545xl-black', '0', 'http://tonersales,eu/shop/2297/-canon-pg-545xl-black,jpg', 0, '0', '<p><span>Canon Pixma MG 2450 , MG 2400 Series , MG 2950, MG 2455 , IP 2800 Series ,</span><span>MG 2555 , MG 2900 Series , IP 2850 , MG 2500 Series , MG 2550 , MX 495 Serie ,</span><span>MG 2540 Serie , MG 2550 Serie , MG 2555 Serie , MG 2940 Serie , MG 3000 Serie</span><span>, MG 3050 Serie , MG 3051 Serie , MG 3052 Serie , MG 3053 Serie , MX 490 Serie ,</span><span>MX 494 Serie</span></p>', '<p><span>30 ml     :Canon Pixma MG 2450 , MG 2400 Series , MG 2950, MG 2455 , IP 2800 Series ,MG 2555 , MG 2900 Series , IP 2850 , MG 2500 Series , MG 2550 , MX 495 Serie ,MG 2540 Serie , MG 2550 Serie , MG 2555 Serie , MG 2940 Serie , MG 3000 Serie, MG 3050 Serie , MG 3051 Serie , MG 3052 Serie , MG 3053 Serie , MX 490 Serie ,MX 494 Serie</span></p>'),
	(1644, '1', ' CANON CL-546XL COLOUR', 53, 23.41, 0, 105, 0, '-canon-cl-546xl-colour', '0', 'http://tonersales,eu/shop/2298/-canon-cl-546xl-colour,jpg', 0, '0', '<p><span>Canon Pixma MG 2450 , MG 2400 Series , MG 2950, MG 2455 , IP 2800 Series ,</span><span>MG 2555 , MG 2900 Series , IP 2850 , MG 2500 Series , MG 2550 , MX 495 Serie ,</span><span>MG 2540 Serie , MG 2550 Serie , MG 2555 Serie , MG 2940 Serie , MG 3000 Serie</span><span>, MG 3050 Serie , MG 3051 Serie , MG 3052 Serie , MG 3053 Serie , MX 490 Serie ,</span><span>MX 494 Serie</span></p>', '<p><span>24ml<span>    :Canon Pixma MG 2450 , MG 2400 Series , MG 2950, MG 2455 , IP 2800 Series ,MG 2555 , MG 2900 Series , IP 2850 , MG 2500 Series , MG 2550 , MX 495 Serie ,MG 2540 Serie , MG 2550 Serie , MG 2555 Serie , MG 2940 Serie , MG 3000 Serie, MG 3050 Serie , MG 3051 Serie , MG 3052 Serie , MG 3053 Serie , MX 490 Serie ,MX 494 Serie</span></span></p>'),
	(1645, '1', ' CANON PG-540XL BLACK', 53, 16.76, 0, 105, 0, '-canon-pg-540xl-black', '0', 'http://tonersales,eu/shop/2300/-canon-pg-540xl-black,jpg', 0, '0', '<p>CANON PIXMA MG2140, MG2150, MG2250, MG3140, MG3150, MG3250, MG4140, MG4150, MG4250, MX375, MX435, MX515</p>', '<p>30ml<span>    : CANON PIXMA MG2140, MG2150, MG2250, MG3140, MG3150, MG3250, MG4140, MG4150, MG4250, MX375, MX435, MX515</span></p>'),
	(1646, '1', ' CANON CL541XL COLOUR', 53, 20.51, 0, 105, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2301/-canon-cl541xl-colour,jpg', 0, '0', '<p><span>CANON PIXMA MG2140, MG2150, MG2250, MG3140, MG3150, MG3250, MG4140, MG4150, MG4250, MX375, MX435, MX515</span></p>', '<p><span>24ml</span><span>    :CANON PIXMA MG2140, MG2150, MG2250, MG3140, MG3150, MG3250, MG4140, MG4150, MG4250, MX375, MX435, MX515</span></p>'),
	(1647, '1', ' HP 302XL BLACK', 53, 13.87, 0, 110, 0, '-hp-302xl-black', '0', 'http://tonersales,eu/shop/2302/-hp-302xl-black,jpg', 0, '0', '<p>Officejet : 3800 Series, 4650, 4654, 3834, 3830, 3831 Serie, 3833 Serie, 3834 Serie, 3835 Serie, 4654 Serie, 4655 Serie, 4656 Serie, 4657 Serie, 4658 Serie,Deskjet AiO : 2132, 2134, 3832,Deskjet : 3630, 1110, 2130, 3631 Serie, 3632 Serie,3633 Serie, 3634 Serie, 3636 Serie, 3637 Serie,Envy e-All-in-One : 4520, 4524, 4521 Serie, 4522 Serie,4524 Serie, 4525 Serie, 4527 Serie, 4528 Serie</p>', '<p>520   <span>  5%</span>    : HP Officejet : 3800 Series, 4650, 4654, 3834, 3830, 3831 Serie, 3833 Serie, 3834 Serie,3835 Serie, 4654 Serie, 4655 Serie, 4656 Serie, 4657 Serie, 4658 Serie,Deskjet AiO : 2132, 2134, 3832,Deskjet : 3630, 1110, 2130, 3631 Serie, 3632 Serie,3633 Serie, 3634 Serie, 3636 Serie, 3637 Serie,Envy e-All-in-One : 4520, 4524, 4521 Serie, 4522 Serie,4524 Serie, 4525 Serie, 4527 Serie, 4528 Serie</p>'),
	(1648, '1', ' HP 304XL BLACK', 53, 16.76, 0, 110, 0, '-hp-304xl-black', '0', 'http://tonersales,eu/shop/2304/-hp-304xl-black,jpg', 0, '0', '<p>Deskjet 3720, 3730, 3721, 3723, 3724</p>', '<p>18ml, 320<span>  <span>  5%</span>    : HP Deskjet 3720, 3730, 3721, 3723, 3724</span></p>'),
	(1649, '1', ' HP 304XL COLOUR', 53, 18.21, 0, 110, 0, '-hp-304xl-colour', '0', 'http://tonersales,eu/shop/2305/-hp-304xl-colour,jpg', 0, '0', '<p><span>Deskjet 3720, 3730, 3721, 3723, 3724</span></p>', '<p><span>18ml, 320</span><span> <span>  5%</span>     : HP Deskjet 3720, 3730, 3721, 3723, 3724</span></p>'),
	(1650, '1', ' HP 62XL BLACK', 53, 18.21, 0, 110, 0, '-hp-62xl-black', '0', 'http://tonersales,eu/shop/2306/-hp-62xl-black,jpg', 0, '0', '<p><span>HP Officejet 5740, 5742, 5745, 8040, 8045, ENVY 5640, 5660, 5665, 7640, 7645, 8000, 8005</span></p>', '<p><span>600</span><span>  <span>  5%</span>    :</span>HP Officejet 5740, 5742, 5745, 8040, 8045, ENVY 5640, 5660, 5665, 7640, 7645, 8000, 8005</p>'),
	(1651, '1', ' HP 62XL COLOUR', 53, 19.66, 0, 110, 0, '-hp-62xl-colour', '0', 'http://tonersales,eu/shop/2307/-hp-62xl-colour,jpg', 0, '0', '<p><span>HP Officejet 5740, 5742, 5745, 8040, 8045, ENVY 5640, 5660, 5665, 7640, 7645, 8000, 8005</span></p>', '<p><span>415</span><span> <span>  5%</span>     :</span><span>HP Officejet 5740, 5742, 5745, 8040, 8045, ENVY 5640, 5660, 5665, 7640, 7645, 8000, 8005</span></p>'),
	(1652, '1', ' EPSON T3351XL BLACK', 53, 7.18, 0, 110, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2308/-epson-t3351xl-black,jpg', 0, '0', '<p><span>XP530 , XP540 , XP630 , XP635 , XP640 , XP645 , XP830 , XP900</span></p>', '<p>24ml     : EPSON XP530 , XP540 , XP630 , XP635 , XP640 , XP645 , XP830 , XP900</p>'),
	(1654, '1', ' CANON PG-570XL BLACK', 53, 4.76, 0, 110, 0, '-canon-pg-570xl-black', '0', 'http://tonersales,eu/shop/2310/-canon-pg-570xl-black,jpg', 0, '0', '<p><span>CANON Pixma MG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>', '<p>25ml     :<span>CANON PIXMAMG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>'),
	(1655, '1', ' CANON CL-571XL BLACK', 53, 3.95, 0, 110, 0, '-canon-cl-571xl-black', '0', 'http://tonersales,eu/shop/2311/-canon-cl-571xl-black,jpg', 0, '0', '<p><span>CANON Pixma MG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>', '<p><span>15ml     :</span><span>CANON PIXMAMG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>'),
	(1656, '1', ' CANON CL-571XL CYAN', 53, 3.95, 0, 110, 0, '-canon-cl-571xl-cyan', '0', 'http://tonersales,eu/shop/2312/-canon-cl-571xl-cyan,jpg', 0, '0', '<p><span>CANON Pixma MG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>', '<p><span>15ml     :</span><span>CANON PIXMAMG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>'),
	(1657, '1', ' CANON CL-571XL MAGENTA', 53, 3.95, 0, 110, 0, '-canon-cl-571xl-magenta', '0', 'http://tonersales,eu/shop/2313/-canon-cl-571xl-magenta,jpg', 0, '0', '<p><span>CANON Pixma MG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>', '<p><span>15ml     :</span><span>CANON PIXMAMG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>'),
	(1658, '1', ' CANON CL-571XL YELLOW', 53, 3.95, 0, 110, 0, '-canon-cl-571xl-yellow', '0', 'http://tonersales,eu/shop/2314/-canon-cl-571xl-yellow,jpg', 0, '0', '<p><span>CANON Pixma MG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>', '<p><span>15ml     :</span><span>CANON PIXMAMG5700, MG5750, MG5751, MG5752, MG5753, MG6800, MG6850, MG6851, MG6852, MG6853, MG7700, MG7750, MG7751, MG7752, MG7753</span></p>'),
	(1659, '1', ' EPSON 34XL T3471XL BK', 53, 13.91, 0, 105, 0, '-epson-34xl-t3471xl-bk', '0', 'http://tonersales,eu/shop/2315/-epson-34xl-t3471xl-bk,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF</span></p>', '<p><span>    :<span>Epson WorkForce Pro WF-3720DWF, WF3725DWF,</span></span></p>'),
	(1660, '1', ' EPSON 34XL T3472XL CYAN', 53, 9.88, 0, 105, 0, '-epson-34xl-t3472xl-cyan', '0', 'http://tonersales,eu/shop/2316/-epson-34xl-t3472xl-cyan,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF</span></p>', '<p><span>    :</span><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF,</span></p>'),
	(1661, '1', ' EPSON 34XL T3473XL MAGENTA', 53, 9.88, 0, 105, 0, '-epson-34xl-t3473xl-magenta', '0', 'http://tonersales,eu/shop/2317/-epson-34xl-t3473xl-magenta,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF</span></p>', '<p><span>    :</span><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF,</span></p>'),
	(1662, '1', ' EPSON 34XL T3474XL YELLOW', 53, 9.88, 0, 105, 0, '-epson-34xl-t3474xl-yellow', '0', 'http://tonersales,eu/shop/2318/-epson-34xl-t3474xl-yellow,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF</span></p>', '<p><span>    :</span><span>Epson WorkForce Pro WF-3720DWF, WF3725DWF,</span></p>'),
	(1663, '1', ' EPSON 35XL T3591XL BK', 53, 18.75, 0, 105, 0, '-epson-35xl-t3591xl-bk', '0', 'http://tonersales,eu/shop/2319/-epson-35xl-t3591xl-bk,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>', '<p><span>    :Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>'),
	(1664, '1', ' EPSON 35XL T3592XL CYAN', 53, 13.31, 0, 105, 0, '-epson-35xl-t3592xl-cyan', '0', 'http://tonersales,eu/shop/2320/-epson-35xl-t3592xl-cyan,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>', '<p><span>    :Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>'),
	(1665, '1', ' EPSON 35XL T3593XL MAGENTA', 53, 13.31, 0, 105, 0, '-epson-35xl-t3593xl-magenta', '0', 'http://tonersales,eu/shop/2321/-epson-35xl-t3593xl-magenta,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>', '<p><span>    :Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>'),
	(1666, '1', ' EPSON 35XL T3594XL YELLOW', 53, 13.31, 0, 105, 0, '-epson-35xl-t3594xl-yellow', '0', 'http://tonersales,eu/shop/2322/-epson-35xl-t3594xl-yellow,jpg', 0, '0', '<p><span>Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>', '<p><span>    :Epson WorkForce Pro WF-4720DWF, WF-4725DWF, WF-4730DTWF, WF-4740DTWF</span></p>'),
	(1667, '1', ' BROTHER LC3219XL BK', 53, 11.9, 0, 105, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2323/-brother-lc3219xl-bk,jpg', 0, '0', '<p>Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</p>', '<p><span>    :Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>'),
	(1668, '1', ' BROTHER LC3219XL CYAN', 53, 9.27, 0, 105, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2324/-brother-lc3219xl-cyan,jpg', 0, '0', '<p><span>Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>', '<p><span>    :Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>'),
	(1669, '1', ' BROTHER LC3219XL MAGENTA', 53, 9.27, 0, 105, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2325/-brother-lc3219xl-magenta,jpg', 0, '0', '<p><span>Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>', '<p><span>    :Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>'),
	(1670, '1', ' BROTHER LC3219XL YELLOW', 53, 9.27, 0, 105, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2326/-brother-lc3219xl-yellow,jpg', 0, '0', '<p><span>Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>', '<p><span>    :Brother MFC-J6930DW, MFC-J6530DW, MFC-J6935DW, MFC-J5730DW, MFC-J5330DW, MFC-J5930DW, MFC-J5335DW</span></p>'),
	(1671, '1', ' HP CF230X (HP 30X BLACK)', 53, 34.48, 0, 109, 0, '-hp-cf230x-hp-30x-black', '0', 'http://tonersales,eu/shop/2327/-hp-cf230x-hp-30x-black,jpg', 0, '0', '<p><span>HP LaserJet M203d,<span>M203dn,<span>M203dw,<span>MFP M227sdn,Pro MFP M227d,<span>Pro MFP M227fdn,<span>Pro MFP M227fdw</span></span></span></span></span></span></p>', '<p><span>3500     5%     :HP LaserJet M203d,M203dn,M203dw,MFP M227sdn,Pro MFP M227d,Pro MFP M227fdn,Pro MFP M227fdw</span></p>'),
	(1672, '1', 'HP 953XL BLACK', 53, 19.19, 0, 110, 0, 'hp-953xl-black', '0', 'http://tonersales,eu/shop/2329/hp-953xl-black,jpg', 0, '0', '<p>HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</p>', '<p><span>50ml     :HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</span></p>'),
	(1673, '1', 'HP 953XL CYAN', 53, 17.46, 0, 110, 0, 'hp-953xl-cyan', '0', 'http://tonersales,eu/shop/2330/hp-953xl-cyan,jpg', 0, '0', '<p><span>HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</span></p>', '<p><span>26ml     :HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</span></p>'),
	(1674, '1', 'HP 953XL MAGENTA', 53, 17.46, 0, 110, 0, 'hp-953xl-magenta', '0', 'http://tonersales,eu/shop/2331/hp-953xl-magenta,jpg', 0, '0', '<p><span>HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</span></p>', '<p><span>26ml     :HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</span></p>'),
	(1675, '1', 'HP 953XL YELLOW', 53, 17.46, 0, 110, 0, '0', '0', '0', 0, '0', '<p><span>HP OfficeJet Pro 7740, 8210, 8710, 8715, 8720, 8725, 8728, 8730, 8740</span></p>', '<div class="rte">'),
	(1676, '1', ' HP CF411A CYAN', 53, 23.65, 0, 110, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2333/-hp-cf411a-cyan,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>', '<p><span>2300 , ,     :</span><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>'),
	(1677, '1', ' HP CF412A YELLOW', 53, 23.65, 0, 110, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2334/-hp-cf412a-yellow,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>', '<p><span>2300 , ,     :</span><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>'),
	(1678, '1', ' HP CF413A MAGENTA', 53, 23.65, 0, 110, 0, '#NAME?', '0', 'http://tonersales,eu/shop/2335/-hp-cf413a-magenta,jpg', 0, '0', '<p><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>', '<p><span>2300 , ,     :</span><span>HP Color LaserJet Pro M450 Series, HP Color LaserJet Pro M452, HP Color LaserJet Pro M452 dn, HP Color LaserJet Pro M452 dw, HP Color LaserJet Pro M452 nw, HP Color LaserJet Pro M470 Series, HP Color LaserJet Pro MFP M377 dw, HP Color LaserJet Pro MFP M477 fdn HP Color LaserJet Pro MFP M477 fdw HP Color LaserJet Pro MFP M477 fnw</span></p>');
/*!40000 ALTER TABLE `products` ENABLE KEYS */;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IF(@OLD_FOREIGN_KEY_CHECKS IS NULL, 1, @OLD_FOREIGN_KEY_CHECKS) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
